/*
	File: AcquireUtilites.h

	Copyright 1994-95 by Adobe Systems, Inc.  All rights reserved.

	Utilities for acquire modules.
*/

#ifndef __AcquireUtilities__
#define __AcquireUtilities__

#include "PITypes.h"
#include "PIGeneral.h"
#include "PIAcquire.h"

/*****************************************************************************/

/* The region of the image being acquired (an area and a range of planes).   */

typedef struct AcquireRegion
	{
	Rect rect;
	int16 loPlane;
	int16 hiPlane;
	}
AcquireRegion;

/* The layout of the data.                                                   */

typedef struct AcquireDataLayout
	{
	int32 rowBytes;
	int32 colBytes;
	int32 planeBytes;
	}
AcquireDataLayout;
	
/*****************************************************************************/

OSErr StoreData (AcquireRecord *stuff,
				 void *data,
				 AcquireRegion *region,
				 AcquireDataLayout *layout);

OSErr FetchData (AcquireRecord *stuff,
				 void *data,
				 AcquireRegion *region,
				 AcquireDataLayout *layout);

/*****************************************************************************/

#endif
