/*
	File: ExportUtilites.h

	Copyright 1994-95 by Adobe Systems, Inc.  All rights reserved.

	Utilities for Export modules.
*/

#ifndef __ExportUtilities__
#define __ExportUtilities__

#include "PITypes.h"
#include "PIGeneral.h"
#include "PIExport.h"

/*****************************************************************************/

/* The region of the image being exported (an area and a range of planes).   */

typedef struct ExportRegion
	{
	Rect rect;
	int16 loPlane;
	int16 hiPlane;
	}
ExportRegion;

/*****************************************************************************/

OSErr FetchData (ExportRecord *stuff /* in/out */,
				 ExportRegion *region /* in */,
				 void *data /* out */,
				 int32 *rowBytes /* out */);

/*****************************************************************************/

void MarkExportFinished (ExportRecord *stuff);

/*****************************************************************************/

#endif
