/* Copyright 1992-95 by Adobe Systems, Inc.  All rights reserved. */

#ifndef __PITypes__
#define __PITypes__

/* Here are the type definitions used in the interface files.       */

/******************************************************************************/

/* Set up the preprocessor flags to indicate the target platform.	*/

#if defined(macintosh) || defined(__powerc) || defined(__MWERKS__)
#define Macintosh 1
#endif

#ifdef THINK_C
#define Macintosh 1
#endif

#ifdef MSDOS
#undef  MSWindows
#define MSWindows 1
#endif

#ifdef WIN32
#undef MSWindows
#define MSWindows   1
#endif

#ifndef Macintosh
#define Macintosh 0
#endif

#ifndef MSWindows
#define MSWindows 0
#endif

#if defined (__BORLANDC__)
#pragma option -a-
#endif

/******************************************************************************/

/* Set up the flags for the Adobe Graphics Manager.	*/

#ifdef MAC_ENV
#undef MAC_ENV
#endif

#ifdef WIN_ENV
#undef WIN_ENV
#endif

#if Macintosh
#define MAC_ENV	1
#endif

#if MSWindows
#define WIN_ENV	1
#if WIN32
#define WINNT_ENV   1
#endif
#endif

/******************************************************************************/

#if Macintosh

#ifndef __PSWorld__

#include <Types.h>
#include <Memory.h>
#include <Resources.h>
#include <Quickdraw.h>
#include <Dialogs.h>
#include <OSUtils.h>
#include <ToolUtils.h>
#include <Packages.h>
#include <Errors.h>
#include <Files.h>

#endif

#ifndef TRUE
#define TRUE	true
#endif

#ifndef FALSE
#define FALSE	false
#endif

#ifndef MACPASCAL
#define MACPASCAL pascal
#endif

#ifndef WINPASCAL
#define WINPASCAL
#endif

#ifndef __MWERKS__
#ifndef far
#define far
#endif
#endif

#ifndef huge
#define huge
#endif

#ifndef __cplusplus
#define const
#endif

#ifndef __PSWorld__

typedef signed long  int32;
typedef signed short int16;
typedef signed char  int8;

typedef unsigned long  unsigned32;
typedef unsigned short unsigned16;
typedef unsigned char  unsigned8;

/* The following types are used by AGM and we arrange to define them so that */
/* we won't have conflicts when working with AGM.							 */

typedef unsigned char	uint8;
typedef unsigned short	uint16;
typedef unsigned long	uint32;

typedef unsigned char	Bool8;
typedef unsigned long	Bool32;

#define OTHER_AGM_BASIC_H "PITypes.h"

typedef unsigned8 LookUpTable [256];

typedef struct
	{
	LookUpTable R;
	LookUpTable G;
	LookUpTable B;
	} RGBLookUpTable;
	
#endif

typedef struct PlatformData {

	short dummy;                    /* dummy variable required for some compilers. */

	} PlatformData;

#endif    /* Macintosh */

/******************************************************************************/

#if MSWindows

#define MACPASCAL
#define WINPASCAL pascal 

#ifndef __PSWorld__
#include <windows.h>

/* Error codes. */
#define memFullErr (-108)
#define userCanceledErr 1
#define noErr 0
#define writErr (-20)
#define openErr (-23)
#define ioErr	(-36)
#define readErr	(-19)
#define memWZErr (-111)
#define nilHandleErr (-109)
#define dskFulErr	(-34)
#define eofErr		(-39)
#define fnfErr (-43)
#define vLckdErr (-46)
#define fLckdErr (-45)


#define nil		   NULL
#define true       TRUE
#define false      FALSE

#ifndef __cplusplus
#define const
#endif

typedef signed long  int32;
typedef signed short int16;

typedef unsigned long  unsigned32;
typedef unsigned short unsigned16;
typedef unsigned char  unsigned8;

typedef long Fixed;
typedef long Fract;
typedef long (*ProcPtr)();

#ifndef __GEOMETRY__
typedef struct
   {
	  short v;
	  short h;
   } Point;

typedef struct
   {
	  short top;
	  short left;
	  short bottom;
	  short right;
   } Rect;
#endif

#ifndef __QUICKDRAW__
typedef struct
   {
	  WORD red;        /* Magnitude of red   component, 16 bit significant.*/
	  WORD green;      /* Magnitude of green component, 16 bit significant.*/
	  WORD blue;       /* Magnitude of blue  component, 16 bit significant.*/
   } RGBColor;
#endif

typedef LPSTR Ptr;
typedef LPSTR *Handle;
typedef BYTE  Boolean;
typedef DWORD OSType;
typedef short OSErr;
typedef unsigned long ResType;

typedef unsigned char Str255[256];  /*  first byte length of string. The string is zero terminated. */
typedef const unsigned char *ConstStr255Param;

typedef unsigned8 LookUpTable [256];

typedef struct
	{
	LookUpTable R;
	LookUpTable G;
	LookUpTable B;
	} RGBLookUpTable;
	
typedef struct
	{
	short vRefNum;
	long parID;
	Str255 name;	/* Pascal String, for Windows files. */
	} FSSpec;

#endif

typedef struct PlatformData {

	long hwnd;        /* window to own dialogs. */

	} PlatformData;
	
void ShowAlert (short stringID); // Developer implements this 
	
#endif    /* Windows */

/******************************************************************************/

#ifndef __PSWorld__

#ifndef __GEOMETRY__

typedef Rect CRect;

#endif

#ifndef __UGEOMETRY__
typedef struct
	{
	int32 top;
	int32 left;
	int32 bottom;
	int32 right;
	} VRect;
	
typedef struct VPoint
	{
	int32 v;
	int32 h;
	} VPoint;
#endif

#if Macintosh

typedef char TVolumeName [32];

#else

typedef char TVolumeName [256];

#endif
	
#endif

/******************************************************************************/

typedef struct {
    unsigned8   c;
    unsigned8   m;
    unsigned8   y;
    unsigned8   k;
} CMYKtuple;

typedef struct {
    unsigned8   alpha;
    unsigned8   r;
    unsigned8   g;
    unsigned8   b;
} RGBtuple;

typedef struct {
    unsigned8   alpha;
    unsigned8   h;
    unsigned8   s;
    unsigned8   l;
} HSLtuple;

typedef struct {
    unsigned8   alpha;
    unsigned8   h;
    unsigned8   s;
    unsigned8   b;
} HSBtuple;

typedef struct {
    unsigned8   alpha;
    unsigned8   L;
    unsigned8   a;
    unsigned8   b;
} LABtuple;

typedef unsigned8   inverseCLUT [32][32][32];
typedef unsigned32  histogram3 [][32][32];

typedef int16            HueSatTable [1536];
typedef LookUpTable      HueSatMaps[4];     /* general form of RGBLookUpTable */

/******************************************************************************/
#if defined (__BORLANDC__)   
#pragma option -a.
#endif

#endif
