/*
	GEWorldManager.h
	
	A part of the Graphic Elements system.
	
	Copyright 1994 by Al Evans. All rights reserved.
	
	Use when multiple GEWorlds are running concurrently.
	
	Assures:
	
	1) That all worlds are updated on each call to DoWorldUpdate();
	
	2) That MouseDowns are dispatched to the appropriate sensor in the appropriate world;
	
	3) That all worlds affected by an overlapping world are covered and uncovered
	   appropriately.
	   
	9/23/94
	
*/

#ifndef GEWMANAGER
#define GEWMANAGER

#include "Defs.h"


extern GETMgrRec	geWorldListTime;


#ifdef __cplusplus
extern "C" {
#endif

// In general, this is the only World Manager routine called
// by the application program

Boolean AddToWorldList(GEWorldPtr world, Boolean shareTimer);


// These routines are used only by the Display Controller

void DeleteFromWorldList(GEWorldPtr world);

void DoWorldListUpdate(Boolean invalidate);

void WorldOnListMoved(GEWorldPtr world);

Boolean MouseDownInListWorld(Point gMousePt);



#ifdef __cplusplus
}
#endif

#endif