// Copyright  1994-95 by Apple Computer, Inc. All rights reserved.
// UPictShape.h

#ifndef __UPICTSHAPE__
#define __UPICTSHAPE__

#ifndef __UDIALOG__
#include <UDialog.h>
#endif

#ifndef __USHAPES__
#include "UShapes.h"
#endif

//----------------------------------------------------------------------------------------
// TDocPicture: Version of TPicture that works for picture handles that are part of the
// document (not resources). 
//----------------------------------------------------------------------------------------

class TDocPicture : public TPicture
{
	MA_DECLARE_CLASS;
	
public:
	TDocPicture();
		// Constructor
		
	virtual void ReleasePicture(); // override
		// Releases the PICT by disposing of fDataHandle.
};


//--------------------------------------------------------------------------------------------------
// CLASS TPictShape
//--------------------------------------------------------------------------------------------------

class TPictShape : public TShape
{
	MA_DECLARE_CLASS;

  public:
	TPictShape();
	void IPictShape(const CRect& itsExtent, short itsID);
	
	virtual void DoInitialState(TShapeView* itsView); // Override

	void CreatePicture(TView* itsView);
	void SetPictureFrame();

	virtual TObject* Clone();	// Override

	virtual void Free();	// Override
	
	virtual void ReadFrom(TStream* aStream);	// Override
	virtual void WriteTo(TStream* aStream);		// Override

	void SetPicture(PicHandle pictData);
	
	virtual void BeInView(TShapeView* itsView);	// Override

	virtual void Draw();	// Override
	void DrawInsides(const CRect& extent);
	void DrawOutline();

	virtual void SetFrame(const CRect& extentRect); // override

  private:
	TDocPicture*	fPicture;
	PicHandle		fPictData;
};

#endif
