// Copyright  1994-95 by Apple Computer, Inc. All rights reserved.
// UTextShape.h

#ifndef __UTEXTSHAPE__
#define __UTEXTSHAPE__

#ifndef __USHAPES__
#include "UShapes.h"
#endif

//--------------------------------------------------------------------------------------------------

class TEditText;

//--------------------------------------------------------------------------------------------------
// CLASS TTextShape
//--------------------------------------------------------------------------------------------------

class TTextShape : public TShape
{
	MA_DECLARE_CLASS;

  public:
	TTextShape();
	void ITextShape(const CRect& itsExtent, short itsID);
	
	virtual void DoInitialState(TShapeView* itsView); // Override

	void CreateEditText(TView* itsView);
	void SetEditTextFrame();

	virtual TObject* Clone();	// Override

	virtual void Free();	// Override
	
	virtual void ReadFrom(TStream* aStream);	// Override
	virtual void WriteTo(TStream* aStream);		// Override

	void SetText(Handle text);
	
	virtual void BeInView(TShapeView* itsView);	// Override

	virtual void Draw();	// Override
	void DrawInsides(const CRect& extent);
	void DrawOutline();

	virtual void SetFrame(const CRect& extentRect); // override

  private:
	TEditText*		fEditText;
	Handle			fText;
};

#endif
