/* Macintosh headers */
#include "MSWindows.h"

/* Standard C headers */
#include	<stdio.h>
#include	<ioctl.h>
#include	<string.h>
#include	<strings.h>

/* Windows BMP headers */
#include "BMP.h"

FILE		*infile;
char		filename[64];
BMPFILE		bmpfile;

extern RGBColor	gBlack, gWhite;

long
MSDWord(long dword)
{
	long	result;
	Ptr 	pword,presult;
	
	pword = (Ptr)&dword;
	presult = (Ptr)&result;
	presult[0] = pword[3];
	presult[1] = pword[2];
	presult[2] = pword[1];
	presult[3] = pword[0];
	return(result);
}

short
MSWord(short dword)
{
	short	result;
	Ptr 	pword,presult;
	
	pword = (Ptr)&dword;
	presult = (Ptr)&result;
	presult[0] = pword[1];
	presult[1] = pword[0];
	return(result);
}

Boolean
getdoc(char *filename)
{
	SFTypeList	typeList;		/* typelist for SF */
	SFReply		reply;
	Point		pt;
	
	typeList[0] = 'BINA';
	typeList[1] = 'TEXT';
	pt.h = pt.v = 82;		/* topleft is in (82,82) */

	SFGetFile(pt, 0, 0, 1, &typeList, 0, &reply);
	if (!reply.good)
		return(false);

	SetVol(0, reply.vRefNum);
	strcpy(filename, p2cstr(&reply.fName));
	return(true);
}

Boolean
getfile(char *name,char *filename)
{
	short	sz;
	
	if (name) {
		sz = *name++;
		while (sz--)
			*filename++ = *name++;
		*filename++ = '.';
		*filename++ = 'B';
		*filename++ = 'M';
		*filename++ = 'P';
		*filename++ = 0;
		return(true);
	}
	return(false);
}

void
ReadColor(RGBColor *RGB,Boolean quad)
{
	Ptr	rgb;
	
	rgb = (Ptr)RGB;
	rgb[4] = fgetc(infile);	// rev
	rgb[2] = fgetc(infile);
	rgb[0] = fgetc(infile);
	if (quad) fgetc(infile);	// eat the 4th one
}

void
InitBMPGWorld(short h,short v,short pixSize,CTabHandle	pmTable)
{
	Rect drawRect;
	
	SetRect(&drawRect,0,0,h,v);
	InitBkgndGWorld(&drawRect,pixSize,pmTable);
}

CTabHandle
InitPixColors(short colors,short offset,Boolean quad)
{
	short c;
	RGBColor	rgb;
	CTabHandle	pmTable;
		
	c = sizeof(ColorTable) + (colors - 1) * sizeof(ColorSpec);
	pmTable = (CTabHandle)NewHandleClear(c); /* new color map for this pixMap*/

	(*pmTable)->ctSeed = GetCTSeed();		/* safe, doesn't move or purge memory */
	(*pmTable)->ctFlags = 0x4000;			/*high bit: 0 = PixMap; 1 = device*/
	(*pmTable)->ctSize = colors - 1;		/*number of entries in CTTable*/
	rewind(infile);
	fseek(infile,offset,1);
	rgb = gBlack;
	for (c = 0; c < colors; c++) {
		ReadColor(&rgb,quad);
		(*pmTable)->ctTable[c].value = c;
		(*pmTable)->ctTable[c].rgb = rgb;
	}
	return(pmTable);
}

void
InitBkgndPixData(Ptr baseAddr,long rowBytes,long rows,long inBytes,long offset)
{
	long	sz;
	Ptr		pRow;
	
	rewind(infile);
	fseek(infile,offset,1);

	sz = rows * rowBytes;
	pRow = baseAddr;
	while (sz--)
		*pRow++ = 0;
	
	pRow = baseAddr + rows * rowBytes;
	while (rows--) {
		pRow -= rowBytes;		// rows are stored bottom to top of image
		fread(pRow,1,inBytes,infile);	// rowbytes is short by 1 !!
	}
}

Boolean
GetBitMap(PBITMAP bm)
{
	short 	h,v,pixSize,rowBytes;
	short	colors,colorOffset;
	CTabHandle	pmTable;
	
	h = MSWord(bm->bmWidth);
	v = MSWord(bm->bmHeight);
	rowBytes = MSWord(bm->bmWidthBytes);
	pixSize = bm->bmBitsPixel;
				
	switch (pixSize) {
		case 1:
			colors = 2;
			break;
		case 4:
			colors = 16;
			break;
		case 8:
			colors = 256;
			break;
		default:
			return(false);		// we don't support 24 bit formats, yet...
	}
	
	colorOffset = sizeof(BITMAP);
//	pmTable = InitPixColors(colors,colorOffset,false);
	pmTable = nil;
	InitBMPGWorld(h,v,pixSize,pmTable);
	FillBMPGWorld(MSDWord(bm->bmBits),rowBytes);
	return(true);
}

Boolean
GetBitCore(PBITMAPCOREHEADER bc)
{
	long 	h,v,pixSize,rowBytes;
	short	colors,colorOffset;
	CTabHandle	pmTable;
	
	h = MSWord(bc->bcWidth);
	v = MSWord(bc->bcHeight);
	pixSize = MSWord(bc->bcBitCount);
				
	switch (pixSize) {
		case 1:
			colors = 2;
			rowBytes = ((h + 31) / 32) * 4;
			break;
		case 4:
			colors = 16;
			rowBytes = ((h + 7) / 8) * 4;
			break;
		case 8:
			colors = 256;
			rowBytes = ((h + 3) / 4) * 4;
			break;
		default:
			return(false);		// we don't support 24 bit formats, yet...
	}
	colorOffset = sizeof(BITMAPFILEHEADER) + MSDWord(bc->bcSize);
	pmTable = InitPixColors(colors,colorOffset,false);
	InitBMPGWorld(h,v,pixSize,pmTable);
//	rowBytes = (MSDWord(bmpfile.bc.bf.bfSize) - colorOffset - colors * sizeof(RGBTRIPLE)) / v;
	FillBMPGWorld(MSDWord(bmpfile.bc.bf.bfOffBits),rowBytes);
	return(true);
}

Boolean
GetBitInfo(PBITMAPINFOHEADER bi)
{
	long 	h,v,pixSize,rowBytes;
	short	c,colors,colorOffset;
	CTabHandle	pmTable;
	
	if (MSDWord(bi->biCompression))	// we don't support compression, yet...
		return(false);
	h = MSDWord(bi->biWidth);
	v = MSDWord(bi->biHeight);
	pixSize = MSWord(bi->biBitCount);
				
	switch (pixSize) {
		case 1:
			colors = 2;
			rowBytes = ((h + 31) / 32) * 4;
			break;
		case 4:
			colors = 16;
			rowBytes = ((h + 7) / 8) * 4;
			break;
		case 8:
			colors = 256;
			rowBytes = ((h + 3) / 4) * 4;
			break;
		default:
			return(false);		// we don't support 24 bit formats, yet...
	}
	if (c = MSDWord(bi->biClrImportant))
		colors = c;
	else
	if (c = MSDWord(bi->biClrUsed))
		colors = c;

	colorOffset = sizeof(BITMAPFILEHEADER) + MSDWord(bi->biSize);
	pmTable = InitPixColors(colors,colorOffset,true);
	InitBMPGWorld(h,v,pixSize,pmTable);
//	rowBytes = (MSDWord(bmpfile.bi.bf.bfSize) - colorOffset - colors * sizeof(RGBQUAD)) / v;
	FillBMPGWorld(MSDWord(bmpfile.bi.bf.bfOffBits),rowBytes);
	return(true);
}

Boolean
ReadBMP(StringPtr name)
{
	long size;
	Boolean	result = false;

	if (getfile(name,filename) || getdoc(filename)) {
		infile = fopen(filename, "r");
		if (infile) {
			fread((Ptr)&bmpfile, 1, sizeof(bmpfile), infile);
			if (bmpfile.bm.bmType == nil)
				result = GetBitMap(&bmpfile.bm);
			else
			if (bmpfile.bi.bf.bfType == 'BM') {
				size = MSDWord(bmpfile.bc.bc.bcSize);
				if (size == sizeof(BITMAPCOREHEADER))
					result = GetBitCore(&bmpfile.bc.bc);
				else
				if (size == sizeof(BITMAPINFOHEADER))
					result = GetBitInfo(&bmpfile.bi.bi);
			}
			fclose(infile);
		}
	}
	return(result);
}

void
DrawBMP(WindowPtr window)
{
	DrawGWorld(window);
}

Ptr
movePtoP(Ptr p1,Ptr p2)
{
	long i;
	
	for (i = (*p1) + 1; i > 0; i--)
		*p2++ = *p1++;
	return(p2);
}

Handle
FindBMPFiles(short vRefNum)
{
	long	dirinx=1;
	Str255	theName;		/* name of default volume */
	HFileParam	pb;
	Handle	filelist;
	long	listinx = 1;
	OSErr	result;
	short	svRefNum;		/* saved volume ref num */

	/*	Save the current default volume ref num and the current rsrc file ref num. */
	GetVol(&theName, &svRefNum);
	/*	Set the default volume to the requested folder. */
	SetVol(nil, vRefNum);
	filelist = NewHandleClear(1);
	do {
		pb.ioCompletion = 0;
		pb.ioNamePtr = theName;
		pb.ioVRefNum = svRefNum;
		pb.ioFVersNum = 0;
		pb.ioFDirIndex = dirinx++;
		pb.ioDirID = 0;
	
		result = PBHGetFInfo((HParmBlkPtr)&pb,false);
		if (result != 0) break;
		if ((pb.ioFlFndrInfo.fdType == kBMPType) &&
			(pb.ioFlFndrInfo.fdCreator == kCreator)) {
			SetHandleSize(filelist,listinx + theName[0] + 1);
			movePtoP(theName,&(*filelist)[listinx]);
			listinx += theName[0] + 1;
			(*filelist)[0]++;
		}
	} while (dirinx < 1000);
	/*	Restore the default volume ref num and the current rsrc file ref num. */	
	SetVol(nil,svRefNum);
	return(filelist);
}
