// Windows Bitmap *.BMP file format definition

// Windows types
typedef	short	WORD;
typedef	short	SWORD;
typedef	long	DWORD;
typedef	unsigned char	BYTE;
typedef	long	LPSTR;

/* Bitmap Header Definition */
//	Old style windows file structure
typedef struct tagBITMAP
  {
	SWORD	bmType;
	SWORD	bmWidth;
	SWORD	bmHeight;
	SWORD	bmWidthBytes;
	BYTE	bmPlanes;
	BYTE	bmBitsPixel;
	LPSTR   bmBits;
  } BITMAP;
typedef BITMAP	*PBITMAP;

typedef struct tagRGBTRIPLE {
	BYTE	rgbtBlue;
	BYTE	rgbtGreen;
	BYTE	rgbtRed;
} RGBTRIPLE;

typedef struct tagRGBQUAD {
	BYTE	rgbBlue;
	BYTE	rgbGreen;
	BYTE	rgbRed;
	BYTE	rgbReserved;
} RGBQUAD;

/* structures for defining DIBs */
typedef struct tagBITMAPCOREHEADER {
	DWORD   bcSize;	/* used to get to color table */
	WORD	bcWidth;
	WORD	bcHeight;
	WORD	bcPlanes;
	WORD	bcBitCount;
} BITMAPCOREHEADER;
typedef BITMAPCOREHEADER *PBITMAPCOREHEADER;

typedef struct tagBITMAPINFOHEADER{
	DWORD	biSize;
	DWORD	biWidth;
	DWORD	biHeight;
	WORD	biPlanes;
	WORD	biBitCount;

	DWORD	biCompression;
	DWORD	biSizeImage;
	DWORD	biXPelsPerMeter;
	DWORD	biYPelsPerMeter;
	DWORD	biClrUsed;
	DWORD	biClrImportant;
} BITMAPINFOHEADER;

typedef BITMAPINFOHEADER *PBITMAPINFOHEADER;

/* constants for the biCompression field */
#define BI_RGB	0L
#define BI_RLE8	1L
#define BI_RLE4	2L

typedef struct tagBITMAPINFO {
	BITMAPINFOHEADER bmiHeader;
	RGBQUAD bmiColors[1];
} BITMAPINFO;
typedef BITMAPINFO *PBITMAPINFO;

typedef struct tagBITMAPCOREINFO {
	BITMAPCOREHEADER bmciHeader;
	RGBTRIPLE  bmciColors[1];
} BITMAPCOREINFO;
typedef BITMAPCOREINFO *PBITMAPCOREINFO;

typedef struct tagBITMAPFILEHEADER {
	WORD	bfType;
	DWORD   bfSize;
	WORD	bfReserved1;
	WORD	bfReserved2;
	DWORD   bfOffBits;
} BITMAPFILEHEADER;
typedef BITMAPFILEHEADER *PBITMAPFILEHEADER;

//	OS/2 file structure
typedef struct tagBITMAPCOREFILE {
	BITMAPFILEHEADER	bf;
	BITMAPCOREHEADER  	bc;
} BITMAPCOREFILE;
typedef BITMAPCOREFILE *PBITMAPCOREFILE;

//	Windows file structure
typedef struct tagPBITMAPINFOFILE {
	BITMAPFILEHEADER	bf;
	BITMAPINFOHEADER	bi;
} BITMAPINFOFILE;
typedef BITMAPINFOFILE *PBITMAPINFOFILE;

typedef union {
	BITMAP			bm;
	BITMAPCOREFILE	bc;
	BITMAPINFOFILE	bi;
} BMPFILE;
