/*
**	dialog.c
**
*/


#include "MSWindows.h"

typedef void (*myDialogProcPtr)(GamePrefsEntry *pPrefs,DialogPtr theDialog);


/* my globals */

extern GamePrefsEntry	gPrefs;
extern short			gGameType;

Str255	gPlayer = {"\pAnonymous"};

/*
**	Draw the ring around the OK button, the way that alert boxes get it.
**	This procedure is only called by the Dialog Manager for update events.
*/
pascal void
DrawOKDefault(DialogPtr theDialog,short theItem)
{
#define kButtonFrameSize	 3		/* button frame's pen size */
#define kButtonFrameInset	-4		/* inset rectangle adjustment around button */
#define kButtonOval			16		/* button oval corner rounding */

	short		itemType;
	Handle		itemHandle;
	Rect		itemRect;
	PenState	savePen;
	Pattern		dkGray;	/** = {0x55,0xAA,0x55,0xAA,0x55,0xAA,0x55,0xAA};	**/
	long		*pPattern;
	
	pPattern = (long*)&dkGray;
	*pPattern++ = 0x55AA55AA;
	*pPattern++ = 0x55AA55AA;

	GetPenState(&savePen); 							/* save the old pen state */
	GetDItem(theDialog,iOK,&itemType,&itemHandle,&itemRect); /* get the OK button's state */
//	if ((*(ControlHandle)itemHandle)->contrlHilite == 255)
//		PenPat((ConstPatternParam)dkGray);	/** 3.3 **/
	PenSize(kButtonFrameSize,kButtonFrameSize);		/* make the pen fatter */
	GetDItem(theDialog,theItem,&itemType,&itemHandle,&itemRect); /* get the items rect */	
	FrameRoundRect(&itemRect,kButtonOval,kButtonOval);/* draw the ring */
	SetPenState(&savePen);							/* restore the pen state */
}

/*
**	This routine allows the default button to be outlined by the Dialog Manger.
**	Move our default-OK-button userItem to around the OK button, and set its
**	item handle to be a pointer to our other drawing procedure.
*/
pascal void
OutlineOKitem(DialogPtr theDialog)
{
	short		itemType;
	Handle		itemHandle;
	Rect		itemRect;

	GetDItem(theDialog,iOK,&itemType,&itemHandle,&itemRect); /* get the OK button's rect */
	InsetRect(&itemRect,kButtonFrameInset,kButtonFrameInset);/* make the rect a little bigger */
	SetDItem(theDialog,iOKring,userItem+itemDisable,(Handle)DrawOKDefault,&itemRect); /* set the draw proc */
}

/*	
**	Display a dialog box
*/
void
ShowDialog(short dialogID)
{
	DialogPtr	theDialog;
	short		itemHit;

	SetCursor(*GetCursor(kArrowCursor));
	theDialog = GetNewDialog(dialogID, nil, (WindowPtr) -1);
	PositionWindow( (WindowPtr) theDialog);
	ShowWindow((WindowPtr)theDialog);
	OutlineOKitem(theDialog);
	ModalDialog(nil,&itemHit);
	DisposDialog(theDialog);
	if (itemHit != iOK)
		ShowDialog(rRegister);	// About Windows calls Resistration
}

/*
** Run a complex dialog
*/
void
runDialog(short theDialogId,myDialogProcPtr setProc,
			myDialogProcPtr getProc,GamePrefsEntry *thePrefs)
{
	Boolean		itemChanged = 0;
	short		kind,item,itemHit,itemValue;
	Rect		dRect;
	Handle		theItem;
	DialogPtr	theDialog;
	GrafPtr		savePort;
	GamePrefsEntry prefs;

	GetPort(&savePort);
//	thePrefs->theDialogID = theDialogId;
	theDialog = GetNewDialog(theDialogId, nil, (WindowPtr) -1);
	SetPort((GrafPtr)theDialog);
		/* get a new copy of old prefs in case we 'Cancel' */
	BlockMove((Ptr)thePrefs,(Ptr)&prefs,sizeof(GamePrefsEntry));
	setProc(&prefs,theDialog);
	PositionWindow( (WindowPtr) theDialog);
	ShowWindow(theDialog);
	OutlineOKitem(theDialog);
	SetWRefCon((WindowPtr)theDialog,(long)&prefs);
retry:
	do {
		ModalDialog(nil,&itemHit);
		itemValue = itemHit >> 8;
		itemHit = itemHit & 0xFF;
		if (itemHit > iOK) {
			itemChanged = true;
			GetDItem(theDialog,itemHit,&kind,&theItem,&dRect);
			switch (kind) {
			case ctrlItem+chkCtrl:
					SetCtlValue((ControlHandle)theItem,
						!GetCtlValue((ControlHandle)theItem));
				break;
			case ctrlItem+btnCtrl:
				if ((theDialogId == rBestTimes) && (itemHit == iReset)) {
					ResetGameGlobals(&prefs);	// does data reset
					setProc(&prefs,theDialog);
					BlockMove((Ptr)&prefs,(Ptr)thePrefs,sizeof(GamePrefsEntry));
					itemHit = 0;	// continue looping
				}
				break;
			default:
				break;
			} /* kind */
		}
	} while ((itemHit != iOK) && (itemHit != iCancel));
	if ((itemHit == iOK) &&	(itemChanged)) {	/* apply changes */
		getProc(&prefs,theDialog);
		if (theDialogId == rCustom) {
			if ((item = InitCustomGame(&prefs)) == 0) {
				BlockMove((Ptr)&prefs,(Ptr)thePrefs,sizeof(GamePrefsEntry));
			} else {
				SelIText(theDialog,item,0,100);		/* select the item in error */
				SysBeep(4);
				goto retry;
			}
		} else
		if (theDialogId == rPlayer)
			BlockMove((Ptr)&prefs,(Ptr)thePrefs,sizeof(GamePrefsEntry));
	}
	DisposDialog(theDialog);
	SetPort(savePort);
}

void
SetCheckFlag(GamePrefsEntry *pPrefs,DialogPtr theDialog,short item,long flag)
{				/* set a checkbox flag */
	Rect		rect;
	short		kind;
	Handle		theItem;

	GetDItem(theDialog,item,&kind,&theItem,&rect);
	SetCtlValue((ControlHandle)theItem,pPrefs->flags & flag);
}

void
GetCheckFlag(GamePrefsEntry *pPrefs,DialogPtr theDialog,short item,long flag)
{				/* get a checkbox flag */
	Rect		rect;
	short		kind;
	Handle		theItem;

	GetDItem(theDialog,item,&kind,&theItem,&rect);
	if (GetCtlValue((ControlHandle)theItem))
		pPrefs->flags |= flag;
	else
		pPrefs->flags &= ~flag;
}

void
SetTxt(DialogPtr theDialog,short item,Str255 value)
{				/* set a text value */
	Rect		rect;
	short		kind;
	Handle		theItem;

	GetDItem(theDialog,item,&kind,&theItem,&rect);
	SetIText(theItem,value);			/* set the string */
}

void
GetTxt(DialogPtr theDialog,short item,StringPtr value)
{				/* get a text value */
	Rect		rect;
	short		kind;
	Handle		theItem;

	GetDItem(theDialog,item,&kind,&theItem,&rect);
	GetIText(theItem,value);			/* get the string */
}

void
SetNum(DialogPtr theDialog,short item,short *value)
{				/* set a numeric value */
	Rect		rect;
	short		kind;
	Handle		theItem;
	Str255		theText;

	GetDItem(theDialog,item,&kind,&theItem,&rect);
	NumToString(*value,theText);
	SetIText(theItem,theText);			/* set the string */
}

void
GetNum(DialogPtr theDialog,short item,short *value)
{				/* get a numeric value */
	Rect		rect;
	short		kind;
	Handle		theItem;
	long		i,v;
	Ptr			p1,p2;
	Str255		theText;

	GetDItem(theDialog,item,&kind,&theItem,&rect);
	p1 = &theText[1];
	p2 = *theItem;
	theText[0] = i = GetHandleSize(theItem);
	while (i--)
		*p1++ = *p2++;
	StringToNum(theText,&v);
	*value = v;
}

void
SetCustom(GamePrefsEntry *pPrefs,DialogPtr theDialog)
{
	SetNum(theDialog,iRows,&pPrefs->rows);
	SetNum(theDialog,iCols,&pPrefs->cols);
	SetNum(theDialog,iMines,&pPrefs->mines);
//	SetCheckFlag(pPrefs,theDialog,iScale,vScale);
}

void
GetCustom(GamePrefsEntry *pPrefs,DialogPtr theDialog)
{
	GetNum(theDialog,iRows,&pPrefs->rows);
	GetNum(theDialog,iCols,&pPrefs->cols);
	GetNum(theDialog,iMines,&pPrefs->mines);
//	GetCheckFlag(pPrefs,theDialog,iScale,vScale);
}

void
SetBestTimes(GamePrefsEntry *pPrefs,DialogPtr theDialog)
{
	short i;
	
	for (i=0; i < kMaxTimes-1; i++) {
		SetNum(theDialog, iTime + i, &pPrefs->mintimes[i]);
		SetTxt(theDialog, iPlayer + i, &pPrefs->players[i]);
	}
}

void
GetBestTimes(GamePrefsEntry *pPrefs,DialogPtr theDialog)
{
#pragma unused (pPrefs,theDialog)

}

void
SetPlayer(GamePrefsEntry *pPrefs,DialogPtr theDialog)
{
#pragma unused (pPrefs)
	SetTxt(theDialog, iName, gPlayer);
	SelIText(theDialog, iName, 0, 999);		/* select the string */
}

void
GetPlayer(GamePrefsEntry *pPrefs,DialogPtr theDialog)
{
	GetTxt(theDialog, iName, gPlayer);
	BlockMove(gPlayer, pPrefs->players[gGameType], gPlayer[0]+1);
}

void
doDialog(short theDialogId)	/* adjust globals from a dialog */
{
	switch (theDialogId) {
		case rAbout:
			ShowDialog(rAbout);
			break;
		case rAboutMines:
			ShowDialog(rAboutMines);
			break;
		case rBestTimes:
			runDialog(rBestTimes,SetBestTimes,GetBestTimes,&gPrefs);
			break;
		case rCustom:
			runDialog(rCustom,SetCustom,GetCustom,&gPrefs);
			break;
		case rPlayer:
			runDialog(rPlayer,SetPlayer,GetPlayer,&gPrefs);
			break;
	}
}
