#include "MSWindows.h"

/* Globals */

RGBColor		gBlack,gWhite,gGray,gLtGray,gDkGray,gBlue;
MSWindowPtr		gPMWindow;
MSWindowPtr		gPMHelp;
MSWindowPtr		gMineWindow;
MSWindowPtr		gMineHelp;
MSWindowPtr		gAlertWindow;
MSWindowPtr		gBkgndWindow;
MSWindowPtr		gHelpWindow;

MSChildPtr		gPMChild;
ChildParams		gPMChildParams;
MSMenuPtr		gPMWindowMenu;
MSIconPtr		gGameIcon = nil;

short			gSound = true;			/* use sound blaster */
short			gDouble = false;		/* don't double background pixels */

SndChannelPtr	gSoundChannnel;
Handle			gSndHdl[kSndCount + 1];

short			gOptions[] = { 0, 1, 0, 1, 0, 0, 0, 0 };	/* Options menu items (base 0) */
short			gWindowMode;
MSChildPtr		gChild[iMaxChild + 1];

RgnHandle		gUpRgn,gRightRgn,gURightRgn,gDRightRgn,gArrowRgn;
RgnHandle		gcUpRgn,gcRightRgn,gcURightRgn,gcDRightRgn,gcArrowRgn;
RgnHandle		gClipRgn,gViewRgn,gDrawRgn,gFrameRgn,gBaseFrameRgn;
RgnHandle		gMineRgn,gNoMineRgn;

PicHandle		*gPicts;
Str31			*gPictText;
Str63			BMPName;

short			gOkBoxID[kMaxOkBox + 1];
Rect			gOkBox[kMaxOkBox + 1];

short			gButtonBarHeight;
short			gButtonBarID[kMaxButtonBar + 1];
Rect			gButtonBar[kMaxButtonBar + 1];

short			gHelpInx,gHelpID[kMaxHelpInx + 1];

PixMapHandle	svPortPixMap;
CGrafPort		gScreen;

GDHandle		gMaxDev;

extern Boolean		gDone;
extern RGBColor		gMagicColor;
extern char			gMagicStr[];
extern Boolean		gEmptyGame;
extern short 		gGameType;
extern Boolean		gMarks;
extern MenuHandle	gMenus[];
extern short		gClicks;		/* Click counter, = 1 single click	*/
									/*                = 2 double click	*/
									/*    etc.							*/
#pragma segment TheApp

Boolean	IsPMWindow(MSChildPtr MSChild)
{
	return(MSChild->iconList != nil);	// assume we always have a member in the group
}

void HideIcon(MSIconPtr icon)
{
	MSChildPtr MSGroup;
	
	MSGroup = icon->group;
	SetPort((WindowPtr)MSGroup->window);
	SetOrigin( -MSGroup->origin.h, -MSGroup->origin.v);
	EraseRect(&icon->iconBox);
	DoInvalRect(&icon->iconBox);
	OffsetRect(&icon->iconBox,kOffscreenOffset,0);
	EraseRect(&icon->textBox);
	DoInvalRect(&icon->textBox);
	OffsetRect(&icon->textBox,kOffscreenOffset,0);
	SetOrigin(0,0);
}

void ShowIcon(MSIconPtr icon)
{
	MSChildPtr MSGroup;
	
	MSGroup = icon->group;
	SetPort((WindowPtr)MSGroup->window);
	SetOrigin( -MSGroup->origin.h, -MSGroup->origin.v);
	OffsetRect(&icon->iconBox,-kOffscreenOffset,0);
	DoInvalRect(&icon->iconBox);
	OffsetRect(&icon->textBox,-kOffscreenOffset,0);
	DoInvalRect(&icon->textBox);
	SetOrigin(0,0);
}

MSChildPtr NewMSChild(MSWindowPtr window,StringPtr title,
		short x,short y,short h,short v,short grow,short minmax)
{
	MSChildPtr	MSChild;
	
	MSChild = (MSChildPtr)NewPtrClear(sizeof(MSChildRecord));
	MSChild->window = window;
	MSChild->next = window->child;
	window->child = MSChild;
	BlockMove((Ptr)title,(Ptr)MSChild->title,title[0]+1);
	MSChild->origin.h = x;
	MSChild->origin.v = y;
	SetRect(&MSChild->portRect, 0, 0, h * kIconStepH + 2 * kGrowBorder,
				v * kIconStepV + kPictHeight + kIconHdr + 2 * kGrowBorder);
	MSChild->growBorder = grow;
	MSChild->minmax = minmax;
	SizeMSWindow(MSChild,false);
	return(MSChild);
}

MSWindowPtr NewMSWindow(StringPtr title,short x,short y,short h,short v,short grow)
// if x and y are 0,0, then find the max device and center on it
// otherwise, x and y are offsets from the topleft of gPMWindow
{
#pragma unused (grow)
	WindowPtr	window;
	Point		pt;
	
	window = GetNewCWindow(rWindow, NewPtrClear(sizeof(MSWindowRecord)), (WindowPtr) -1);
	SizeWindow(window, h * kIconStepH + 2 * kGrowBorder,
				v * kIconStepV + kPictHeight + kIconHdr + 2 * kGrowBorder,true);	// fUpdate
//	if (0 < title[0])		// its not the background window
//		CreateGWorld(window);
	
	if ((x == 0) && (y == 0)) {	// for gPMWindow or gHelpWindow
		gMaxDev = GetMaxDevice( &(**GetGrayRgn()).rgnBBox );
		pt = CenterWithin( &window->portRect, &(**gMaxDev).gdRect );
	} else {
		pt.h = x; pt.v = y;
		SetPort((GrafPtr)gPMWindow);	// will have been made by now
		LocalToGlobal(&pt);
	}
	MoveWindow(window,pt.h,pt.v,true);	// front
	SetWTitle(window,title);
				
	return(MSWindow);
}

void HideMSWindow(WindowPtr window)
{
	if (window == gHelpWindow)	// clear help stack
		gHelpInx = 0;
	HideWindow(window);
}

MSMenuPtr NewMSMenu(MSChildPtr MSChild,short id)
{
	MSMenuPtr	MSMenu,lastMSMenu;
	short		i,sz;
	StringPtr	text;
	
	MSChild->menuBarRect.bottom = MSChild->menuBarRect.top + kMenuHeight;
	MSMenu = (MSMenuPtr)NewPtrClear(sizeof(MSMenuRecord));

	lastMSMenu = (MSMenuPtr)(&MSChild->MSMenu);
	while (lastMSMenu->next != nil)
		lastMSMenu = lastMSMenu->next;
	lastMSMenu->next = MSMenu;

	MSMenu->menu = GetMenu(id);
	InsertMenu(MSMenu->menu,-1); 	/* install popup menu */
	text = (*(MSMenu->menu))->menuData;
	sz = text[0];
	if (sz > 31) sz = 31;
	MSMenu->title[0] = sz;
	for (i = 1; i <= sz; i++)
		MSMenu->title[i] = text[i];
	return(MSMenu);
}

void SetMSMenu(MSChildPtr MSChild)
{
	Rect		box;
	MSMenuPtr	MSMenu;
	
	box = MSChild->menuBarRect;
	box.right = 10;
	MSMenu = MSChild->MSMenu;
	while (MSMenu) {
		box.left = box.right;
		box.right += 2*10 + StringWidth((StringPtr)(MSMenu->title));
		MSMenu->titleBox = box;
		MSMenu = MSMenu->next;
	}
}

MSIconPtr NewMSIcon(MSChildPtr MSChild, short id,
				short x, short y, short action, long refCon)
{
	MSIconPtr icon;
	
	icon = (MSIconPtr)NewPtrClear(sizeof(MSIconRecord));
	icon->next = MSChild->iconList;
	MSChild->iconList = icon;
	icon->id = id;
	if (x < 0)
		x = -x;
	else
		x = x * kIconStepH + kIconXOffset;
	if (y < 0)
		y = -y;
	else
		y = y * kIconStepV + kPictHeight + kIconHdr;
	icon->iconBox = (*gPicts[icon->id])->picFrame;
	OffsetRect(&icon->iconBox,x,y);
	icon->group = MSChild;
	icon->action = action;
	icon->refCon = refCon;
	return(icon);
}

MSChildPtr BuildPMChild(MSChildPtr PMChild, StringPtr childName, 
				ChildParamPtr childParams)
{
	MSChildPtr	MSChild;
	Str255		windowMenuName;

	if (iMaxChild < childParams->childInx) {
		DoMSAlert(kCaution,kTooManyChildren);
		return(nil);
	}
	MSChild = NewMSChild(gPMWindow, childName, 
					childParams->xOffset, childParams->yOffset,
					childParams->maxCols, childParams->maxRows, 
					kGrowBorder, kMinMax);
	windowMenuName[0] = 3 + childName[0];
	windowMenuName[1] = '&';
	windowMenuName[2] = childParams->windInx + ((childParams->windInx < 10) ? '0' : 'A' - 10);
	windowMenuName[3] = ' ';
	BlockMove(&childName[1],&windowMenuName[4],childName[0]);
	AppendMenu(gPMWindowMenu->menu, windowMenuName);

	gChild[childParams->childInx++] = MSChild;
	MSChild->icon = NewMSIcon(PMChild, childParams->iconID++, 
			childParams->minimizeCol++, childParams->minimizeRow, 0, 0);
	PMChild->iconList->selected = false;
	HideIcon(MSChild->icon);
	childParams->h = childParams->v = 0;
	childParams->iconSelected = true;
	childParams->windInx++;
	return(MSChild);
}

void BuildPMIcon(MSChildPtr PMChild, MSChildPtr MSChild, IconPtr pIcon, ChildParamPtr childParams)
{
	NewMSIcon(MSChild, childParams->iconID++, childParams->h++, childParams->v, 
				pIcon->actionType, pIcon->refCon);
	if (pIcon->actionType == kGameAction) {
		PMChild->iconList->selected = true;	// select the game window
		gGameIcon = MSChild->iconList;
	}
	MSChild->iconList->selected = childParams->iconSelected;
	childParams->iconSelected = false;
	if (childParams->maxCols <= childParams->h) {
		childParams->h = 0; childParams->v++;
	}
}

void BuildPMChildren(MSChildPtr PMChild, short minimizeRow)
{
	MSChildPtr	MSChild;
	ChildHnd	hChild;
	IconHnd		hIcon;
	ResType		childType;
	Str255		childName;

	gPMChildParams.windInx = 1;
	gPMChildParams.childInx = iMain;
	gPMChildParams.minimizeCol = 0;
	gPMChildParams.minimizeRow = minimizeRow;
	while (hChild = (ChildHnd)GetIndResource('wind',gPMChildParams.windInx)) {
		GetResInfo((Handle)hChild, &gPMChildParams.iconID, &childType, childName);
		gPMChildParams.xOffset = (*hChild)->xOffset;
		gPMChildParams.yOffset = (*hChild)->yOffset;
		gPMChildParams.maxCols = (*hChild)->maxCols;
		gPMChildParams.maxRows = (*hChild)->maxRows;
		MSChild = BuildPMChild(PMChild, childName, &gPMChildParams);
		while (hIcon = (IconHnd)GetResource('icon',gPMChildParams.iconID)) {
			MoveHHi((Handle)hIcon); HLock((Handle)hIcon);
			BuildPMIcon(PMChild, MSChild, *hIcon, &gPMChildParams);
			HUnlock((Handle)hIcon);
		}
		SizeMSWindow(MSChild,true);
	}
	gPMChildParams.xOffset = 0;
	gPMChildParams.yOffset = 40;
}

void LoadSnds()
{
	short	i;

	for (i = 0; i < kSndCount; i++) {
		gSndHdl[i] = Get1Resource('snd ',i + kBaseSnd);
		MoveHHi(gSndHdl[i]); HLock(gSndHdl[i]);		// Who need memory management !!
	}
}

void LoadPicts()
{
	Handle	pict;
	short	inx, id;
	ResType	type;
	Str255	text;
	Handle	h;

	h = NewHandleClear(kMaxPict * sizeof(PicHandle));
	MoveHHi(h);  HLock(h);  gPicts = (PicHandle*)*h;
	h = NewHandleClear(kMaxPict * sizeof(Str31));
	MoveHHi(h);  HLock(h);  gPictText = (Str31*)*h;

	inx = 1;
	while (pict = Get1IndResource('PICT',inx++)) {	// Preload the PICTs
		GetResInfo(pict,&id,&type,text);
		if (id < kMaxPict) {
			BlockMove(text,gPictText[id],text[0]+1);		
			DetachResource(pict);
			gPicts[id] = (PicHandle)pict;
			MoveHHi(pict); HLock(pict);		// Who need memory management !!
		} else {
			SysBeep(4);
		}
	}
}

MSChildPtr AddPMChild(MSChildPtr PMChild, StringPtr childName)
{
	MSChildPtr MSChild;
	if ((40 + 9 * 20) < gPMChildParams.xOffset) {
		gPMChildParams.xOffset = 0;
		gPMChildParams.yOffset = 40;
	}
	gPMChildParams.xOffset += 20;
	gPMChildParams.yOffset += 10;
	gPMChildParams.maxCols = kMaxChildCols;
	gPMChildParams.maxRows = kMaxChildRows;
	MSChild = BuildPMChild(PMChild, childName, &gPMChildParams);
	return(MSChild);
}

void AddPict(short id, Handle pict, StringPtr text)
{
	if (id < kMaxPict) {
		BlockMove(text,gPictText[id],text[0]+1);		
		gPicts[id] = (PicHandle)pict;
		MoveHHi(pict); HLock(pict);		// Who need memory management !!
	}
}

void AddPMIcon(MSChildPtr PMChild, MSChildPtr MSChild, 
			short action, long refCon)
{
	IconRec iconRec;

	iconRec.actionType = action;
	iconRec.refCon = refCon;
	BuildPMIcon(PMChild, MSChild, &iconRec, &gPMChildParams);
}

#pragma segment Initialize

Boolean InitializeApp(void)
{
	MSChildPtr	BgndChild,MSChild;
	
	gUpRgn = NewRgn();			// some cursor regions
	gRightRgn = NewRgn();
	gURightRgn = NewRgn();
	gDRightRgn = NewRgn();
	gArrowRgn = NewRgn();

	gcUpRgn = NewRgn();			// more child cursor regions
	gcRightRgn = NewRgn();
	gcURightRgn = NewRgn();
	gcDRightRgn = NewRgn();
	gcArrowRgn = NewRgn();

	gClipRgn = NewRgn();		// some clipping regions
	gViewRgn = NewRgn();
	gDrawRgn = NewRgn();
	gFrameRgn = NewRgn();
	gBaseFrameRgn = NewRgn();

	gMineRgn = NewRgn();		// magic mine regions
	gNoMineRgn = NewRgn();

//	SndNewChannel(&gSoundChannnel,sampledSynth,0,nil);
	
	LoadSnds();
	LoadPicts();

	/*	Create the windows	*/
	gBkgndWindow = NewMSWindow("\p",0,0,7,7,0);
	gBkgndWindow->DrawProc = DrawBkgndWindow;

	BgndChild = NewMSChild(gBkgndWindow,"\p",0,0,7,7,0,kNoMinMax);
	BgndChild->base = true;
	
	gPMWindow = NewMSWindow("\pProgram Manager",0,0,7,5,kGrowBorder);
	gPMWindow->DrawProc = DrawMSWindow;

	MSChild = NewMSChild(gPMWindow,"\pProgram Manager",0,0,7,5,kGrowBorder,kMinMax);
	gPMChild = MSChild;
	MSChild->base = true;
	NewMSMenu(MSChild,mWinFile);
	NewMSMenu(MSChild,mOptions);
	gPMWindowMenu = NewMSMenu(MSChild,mWindow);
	NewMSMenu(MSChild,mHelp);
	SetMSMenu(MSChild);
	MSChild->icon = NewMSIcon(BgndChild,kProgramManager,0,6,
						kWindowAction,(long)gPMWindow);
	HideIcon(MSChild->icon);
	BuildPMChildren(MSChild, 4);

	gMineWindow = NewMSWindow("\pMinesweeper",160,20,0,0,0);
	gMineWindow->DrawProc = DrawMineWindow;
	MSChild = NewMSChild(gMineWindow,"\pMinesweeper",0,0,0,0,0,kMinMax);
	MSChild->base = true;
	NewMSMenu(MSChild,mMines);
	NewMSMenu(MSChild,mMineHelp);
	SetMSMenu(MSChild);
	MSChild->icon = NewMSIcon(BgndChild,kMinesweeper,1,6,
						kGameAction,(long)gMineWindow);
	HideIcon(MSChild->icon);
	gGameIcon->action = kGameAction;
	gGameIcon->refCon = (long)gMineWindow;
	
	gAlertWindow = NewMSWindow("\pInvalid Path",90,120,4,2,0);
	gAlertWindow->DrawProc = DrawAlertWindow;
	MSChild = NewMSChild(gAlertWindow,"\pInvalid Path",0,0,4,2,0,kNoMinMax);
	MSChild->base = true;
	NewMSMenu(MSChild,mControl);
	MSChild->menuBarRect.bottom = MSChild->menuBarRect.top;		// no MS menubar
	NewMSIcon(MSChild,kInfoIcon,-(kIconHdr+kGrowBorder),-50,0,0);

	gHelpWindow = NewMSWindow("\pMinesweeper Help",0,0,5,5,kGrowBorder);
	gHelpWindow->DrawProc = DrawHelpWindow;
	MSChild = NewMSChild(gHelpWindow,"\pMinesweeper Help",0,0,5,5,kGrowBorder,kMinMax);
	MSChild->base = true;
	NewMSMenu(MSChild,mHelpFile);
	NewMSMenu(MSChild,mHelpEdit);
	NewMSMenu(MSChild,mHelpBookmark);
	NewMSMenu(MSChild,mHelpHelp);
	SetMSMenu(MSChild);
	MSChild->icon = NewMSIcon(BgndChild,kHelpIcon,2,6,
						kWindowAction,(long)gHelpWindow);
	HideIcon(MSChild->icon);
	DoNewHelp((WindowPtr)gHelpWindow,kHelpHelp);

	gBlack.red	= gBlack.green	= gBlack.blue	= vBLACK;
	gWhite.red	= gWhite.green	= gWhite.blue	= vWHITE;
	gLtGray.red = gLtGray.green	= gLtGray.blue	= vLTGRAY;
	gGray.red	= gGray.green	= gGray.blue	= vGRAY;
	gDkGray.red = gDkGray.green	= gDkGray.blue	= vDKGRAY;
	gBlue.red	= vDKGRAY; gBlue.green = vGRAY; gBlue.blue = vWHITE;

	InitGameGlobals();

	MoveWindow((WindowPtr)gBkgndWindow,(*gMaxDev)->gdRect.left,(*gMaxDev)->gdRect.top+kMenuHeight,true);
	SizeWindow((WindowPtr)gBkgndWindow,(*gMaxDev)->gdRect.right - (*gMaxDev)->gdRect.left,
									(*gMaxDev)->gdRect.bottom - ((*gMaxDev)->gdRect.top+kMenuHeight),true);
	ShowWindow((WindowPtr)gBkgndWindow);
	ShowWindow((WindowPtr)gPMWindow);
	SelectWindow((WindowPtr)gPMWindow);

	SetCursorRgns();
	return(true);
}


#pragma segment TheApp

void SizeMSWindow(MSChildPtr MSChild, Boolean arrangeIcons)
{
	short		i, x, y, x1, y1, x2, y2;
	Rect		box;
	MSIconPtr	icon;

	if (arrangeIcons && !MSChild->base) {
		i = 0;
		icon = MSChild->iconList;
		while (icon) {
			i++;
			icon = icon->next;
		}
		if (1 < i) {
			x = 2;
			y = 1; 
			while ((x * y) < i) {
				x++; y++;
			}
			y = (i - 1) / x + 1;
			icon = MSChild->iconList;
			while (icon) {
				i--;
				x1 = (i % x) * kIconStepH + kIconXOffset;
				y1 = (i / x) * kIconStepV + kPictHeight + kIconHdr;
				x2 += icon->textBox.left - icon->iconBox.left;
				y2 += icon->textBox.top - icon->iconBox.top;
				SetRect(&icon->iconBox, x1, y1,
						x1 + (icon->iconBox.right - icon->iconBox.left),
						y1 + (icon->iconBox.bottom - icon->iconBox.top));
				SetRect(&icon->textBox, x2, y2,
						x2 + (icon->textBox.right - icon->textBox.left),
						y2 + (icon->textBox.bottom - icon->textBox.top));
				icon = icon->next;
			}
		} else {
			x = 2;
			y = 1;
		}
		SetRect(&MSChild->portRect, 0, 0, x * kIconStepH + 2 * kGrowBorder,
					y * kIconStepV + kPictHeight + kIconHdr + 2 * kGrowBorder);
	}
	box = MSChild->portRect;
	box.bottom = kPictHeight;
	box.left = box.right - kPictWidth;
	MSChild->maximizeBox = box;
	box.right = box.left;
	box.left = box.right - kPictWidth2;
	MSChild->minimizeBox = box;
	box.right = kPictWidth;
	box.left = 0;
	MSChild->controlMenuBox = box;
	box.right = 0;
	MSChild->controlMenuRect = box;
	box = MSChild->portRect;
	box.top = kPictHeight;
	box.bottom = box.top + 
		((MSChild->menuBarRect.top < MSChild->menuBarRect.bottom) ? kMenuHeight : 0);
	InsetRect(&box,MSChild->growBorder,0);
	MSChild->menuBarRect = box;
	SetCursorRgns();
	if (MSChild->window == gHelpWindow)
		DoResizeHelp((WindowPtr)MSChild->window);
}

void
DrawIconText(MSIconPtr icon,short active)
{
	EraseRect(&icon->textBox);
	if (active && icon->selected) {
		RGBForeColor(&gBlue);	// the text hilite color
		PaintRect(&icon->textBox);
		RGBForeColor(&gBlack);
	}
	MoveTo((icon->textBox.left + icon->textBox.right - 
			StringWidth(icon->text1)) / 2,
			icon->textBox.bottom - kIconTextInset - 
			((icon->text2[0] ? kIconLineHeight : 0)));
	DrawString(icon->text1);
	if (icon->text2[0]) {
		MoveTo((icon->textBox.left + icon->textBox.right - 
				StringWidth(icon->text2)) / 2,
				icon->textBox.bottom - kIconTextInset);
		DrawString(icon->text2);
	}
}

void
DrawPictBox(short id,Rect *box)
{
	PicHandle pict;
	
	if (pict = gPicts[id])
		DrawPicture(pict,box);
}

void
DrawIcon(MSIconPtr icon,short active)
{
	PicHandle	pict;
	short		x, x1, x2, x3, w, lines;
	Rect 		box;
	StringPtr	text;
	
	if (pict = gPicts[icon->id]) {
		box = icon->iconBox;
		DrawPicture(pict,&box);
		TextSize(kIconTextSize);
		text = gPictText[icon->id];
		x = 0;
		if (14 < text[0]) {
			for (x1 = x2 = text[0] / 2; 0 < x1; x1--, x2++) {
					if (text[x1] == ' ') {
						x = x1; break;
					}
					if (text[x2] == ' ') {
						x = x2; break;
					}
				if (5 < (x2 - x1)) {
					if (text[x1 + 3] < ' ') {
						x = x1 + 3; break;
					}
					if (text[x2 - 3] < ' ') {
						x = x2 - 3; break;
					}
				}
			}
		}
		if (x) {
			char c;

			x1 = x2 = x - 1;
			x3 = text[x] - x;
			if (text[x] == ' ') {
				x2++; x3--;
			}
			c = text[0];
			text[0] = x1;
			BlockMove(text,&icon->text1,text[0]+1);
			text[0] = c;
			c = text[x2];
			text[x2] = x3;
			BlockMove(&text[x2],&icon->text2,text[x2]+1);
			text[x2] = c;
			x1 = StringWidth(icon->text1);
			x2 = StringWidth(icon->text2);
			w = (x1 > x2) ? x1 : x2;
			lines = 2;
		} else {
			BlockMove(text,&icon->text1,text[0]+1);
			w = StringWidth(icon->text1);
			icon->text2[0] = 0;
			lines = 1;
		}
		if (w) {
			box.left += (kIconSize - w) / 2;
			box.right = box.left + w;
			box.bottom = icon->iconBox.bottom + lines * kIconLineHeight;
			InsetRect(&box,-kIconTextInset,-kIconTextInset);
			box.top = icon->iconBox.bottom;
			icon->textBox = box;
			DrawIconText(icon,active);
		}
		TextSize(12);
	}
}

Boolean TrackTextBox(Rect *box)
{
	Point	where;
	
reclick:
	do {
		if (PtInRect(where,box)) {
			InvertRect(box);
			while (StillDown()) {
				GetMouse(&where);
				if (!PtInRect(where,box)) {	// dragged out of the box
					InvertRect(box);
					goto reclick;					// try again
				}
			}
			InvertRect(box);
			return(true);
		}
		GetMouse(&where);
	} while (StillDown());
	return(false);
}

Boolean TrackButton(short id,Rect *box)
{
	Point	where;
	
reclick:
	do {
		if (PtInRect(where,box)) {
			DrawCell(id+kPressOffset,box);
			while (StillDown()) {
				GetMouse(&where);
				if (!PtInRect(where,box)) {	// dragged out of the box
					DrawCell(id,box);
					goto reclick;					// try again
				}
			}
			DrawCell(id,box);
			return(true);
		}
		GetMouse(&where);
	} while (StillDown());
	return(false);
}

void ClickIcon(MSChildPtr MSChild, Point where, long modifiers)
{
#pragma unused (modifiers)
	MSIconPtr	icon,lasticon;
	
	icon = MSChild->iconList;
	TextSize(kIconTextSize);
	while (icon) {
		if (PtInRect(where,&icon->iconBox) ||
			PtInRect(where,&icon->textBox)) {
			lasticon = MSChild->iconList;
			while (lasticon) {
				if (lasticon->selected) {	// bug, we don't drag multi clicks
					if (icon == lasticon) {
						TextSize(12);
						if (gClicks == 2)
							DoubleClickIcon(MSChild,icon);
						return;
					}
					DrawIconText(lasticon,lasticon->selected = false);
					goto select;	// clear selection drawn below
				}
				lasticon = lasticon->next;
			}
			break;	// a hit
		}
		icon = icon->next;
	}
	goto exit;		// no hit
	
reclick:
	do {
		if (PtInRect(where,&icon->iconBox) ||
			PtInRect(where,&icon->textBox)) {
select:
			DrawIconText(icon,icon->selected = true);
			while (StillDown()) {
				GetMouse(&where);
				if (!(PtInRect(where,&icon->iconBox) ||
					  PtInRect(where,&icon->textBox))) {	// dragged out of the box
					DrawIconText(icon,icon->selected = false);
					goto reclick;					// turn off and try again
				}
			}
			goto exit;		// good hit
		}
		GetMouse(&where);
	} while (StillDown());
	DrawIconText(lasticon,lasticon->selected = true);	// restore last one
exit:
	TextSize(12);
}

void DoMSCommand(MSChildPtr MSChild,short command)
{
	short		x, y, h, v, windows = 0;
	Point		base,pt;
	Rect		view;
	WindowPtr	window;
	MSChildPtr	MSBase;

	window = (WindowPtr)MSChild->window;
	SetPort(window);				/* the window must be the current port... */
	SetOrigin(0,0);
	MSBase = MSWindow->child;
	while (! MSBase->base) {
		windows++;
		MSBase = MSBase->next;
	}
	switch (command) {
	case vMinimize:
			if (MSChild->base) {
				HideWindow(window);	
				window = FrontWindow();
				SetPort(window);
			} else {
				view = MSChild->portRect;
				OffsetRect(&view,MSChild->origin.h,MSChild->origin.v);
				EraseRect(&view);		// disappear
				DoInvalRect(&view);
				MSChild->icon->restore = MSChild;
				HideChild(MSChild);
				SetActive(window,true);
			}
			ShowIcon(MSChild->icon);
			MSChild = MSWindow->child;	// the new front window
			goto clearwindow;

	case vRestore:
			if (!MSChild->maximized) {
				if (gSound) SysBeep(4);
			} else
			if (IsPMWindow(MSChild)) {	// PM windows only !!
				view = MSChild->portRect;
				OffsetRect(&view,MSChild->origin.h,MSChild->origin.v);
				EraseRect(&view);		// disappear
				DoInvalRect(&view);
				MSChild->portRect = MSChild->restoreRect;
				MSChild->origin = MSChild->restoreOrigin;
				if (MSChild->base) {	// base child
					MoveWindow(window,MSWindow->origin.h,MSWindow->origin.v,true);	// menusize
					SizeWindow(window,MSChild->portRect.right,MSChild->portRect.bottom,true);
//					CreateGWorld(window);
				}
				SizeMSWindow(MSChild,false);
				MSChild->maximized = false;
			}
			break;
	case vMaximize:
			if (MSChild->maximized) { 
				if (gSound) SysBeep(4);
			} else 
			if (IsPMWindow(MSChild)) {	// PM windows only !!
				MSChild->restoreRect = MSChild->portRect;
				MSChild->restoreOrigin = MSChild->origin;
				if (MSChild->base) {	// base child
					MSWindow->origin.h = 0;
					MSWindow->origin.v = 0;
					LocalToGlobal(&MSWindow->origin);	// save my location
					MoveWindow(window,0,GetMBarHeight(),true);
					SizeWindow(window,qd.screenBits.bounds.right,
						qd.screenBits.bounds.bottom - kMenuHeight,true);
//					CreateGWorld(window);
					MSChild->portRect = window->portRect;
				} else {
					MSChild->portRect = MSBase->portRect;
					MSChild->portRect.bottom -= MSBase->menuBarRect.bottom;
					MSChild->origin.h = 0;
					MSChild->origin.v = MSBase->menuBarRect.bottom;
				}
				SizeMSWindow(MSChild,false);
				MSChild->maximized = true;
				goto clearwindow;
			}
			break;
	case vCascade:
			view = MSBase->portRect;
			base.h = kGrowBorder;
			base.v = MSBase->menuBarRect.bottom;
			MSChild = MSWindow->child;
				while (! MSChild->base) {
				windows--;
				pt.h = base.h + (3 * (windows / 8) + (windows % 8)) * kPictHeight;
				pt.v = base.v + ((windows / 8) + (windows % 8)) * kPictHeight;
				MSChild->origin = pt;
				MSChild = MSChild->next;
			}
			goto clearwindow;
			break;
	case vTile:
			x = 1; y = 1;
			while (windows > (x * y)) {
				if (x == y)
					y++;
				else
					x++;
			}
			base.h = kGrowBorder;
			base.v = MSBase->menuBarRect.bottom;
			view.top = view.left = 0;
			view.right = h = (MSBase->portRect.right - base.h - kGrowBorder) / x;
			view.bottom = v = (MSBase->portRect.bottom - base.v - kGrowBorder) / y;
			MSChild = MSWindow->child;
			while (! MSChild->base) {
				MSChild->portRect = view;
				windows--;
				pt.h = base.h + h * (windows % x);
				pt.v = base.v + v * (windows / x);
				MSChild->origin = pt;
				SizeMSWindow(MSChild,false);
				MSChild = MSChild->next;
			}
clearwindow:view = MSChild->portRect;
			OffsetRect(&view,MSChild->origin.h,MSChild->origin.v);
			EraseRect(&view);		// clear full window
			DoInvalRect(&view);
			SetCursorRgns();
			break;

		case vMove:
			gWindowMode = kMoveMode;
			SetCursor(*GetCursor(kMoveCursor));
			break;
	}
}

void DrawMSMenu(WindowPtr window)
{
	menuProcPtr	theMenuProc;
	MenuHandle	menu;
	Rect		menuRect,frameRect;
	Point		pt;

	menu = MSWindow->MSMenu->menu;
	(Ptr)theMenuProc = *(*menu)->menuProc;
	menuRect = MSWindow->MSMenu->menuRect;
	EraseRect(&menuRect);
	frameRect = menuRect;
	InsetRect(&frameRect,-1,-1);
	FrameRect(&frameRect);
	MoveTo(frameRect.left + 4,frameRect.bottom);	// shadow
	LineTo(frameRect.right,frameRect.bottom);
	LineTo(frameRect.right,frameRect.top + 3);
	pt.h = pt.v = 0; 
	TextFont(systemFont);
	(*theMenuProc)(mDrawMsg,menu,&menuRect,pt,&MSWindow->MSMenu->menuItem);
	TextFont(applFont);
}

void OpenMSMenu(WindowPtr window,MSMenuPtr MSMenu,Point pt)
{
	menuProcPtr	theMenuProc;
	MenuHandle	menu;

	TextFont(systemFont);
	MSWindow->MSMenu = MSMenu;
	menu = MSMenu->menu;
	(Ptr)theMenuProc = *(*menu)->menuProc;
	(*theMenuProc)(mSizeMsg,menu,&MSMenu->menuRect,pt,&MSMenu->menuItem);
	SetRect(&MSMenu->menuRect,pt.h,pt.v,
			pt.h + (*menu)->menuWidth,pt.v + (*menu)->menuHeight);
	DrawMSMenu(window);
	TextFont(systemFont);
}

void CloseMSMenu(WindowPtr window)
{
	MSMenuPtr	MSMenu;
	
	MSMenu = MSWindow->MSMenu;
	MSWindow->MSMenu = nil;
	MSMenu->menuItem = 0;
	MSMenu->menuRect.left -= 1;			// clear the border and shadow
	MSMenu->menuRect.right += 2;
	MSMenu->menuRect.bottom += 2;
	InvertRect(&MSMenu->titleBox);
	EraseRect(&MSMenu->menuRect);
	DoInvalRect(&MSMenu->menuRect);		// slow, need to save these bits
	DrawMSMenuBar(window);
}

short TrackMSPopup(WindowPtr window)
{
	menuProcPtr	theMenuProc;
	MenuHandle	menu;
	short		item;
	Point		hitPt;
	MSMenuPtr	MSMenu;
	
	MSMenu = MSWindow->MSMenu;
	menu = MSMenu->menu;
	(Ptr)theMenuProc = *(*menu)->menuProc;
	item = MSMenu->menuItem;	// last hilited item
	while (StillDown()) {
		GetMouse(&hitPt);
		(*theMenuProc)(mChooseMsg,menu,&MSMenu->menuRect,hitPt,&item);
	}
	if ((0 < item) || (!PtInRect(hitPt,&MSMenu->titleBox)))
		CloseMSMenu(window);	// close if choice or not in titleRect
	else {
		MSMenu->menuItem = 1;	// hilite 1st item ??
		(*theMenuProc)(mChooseMsg,menu,&MSMenu->menuRect,hitPt,&MSMenu->menuItem);
		item = -1;				// keep it open flag
	}
	return(item);
}

void DoControlMenu(MSChildPtr MSChild,Point where)
{
#pragma unused (where)
	short		item;
	Point		pt;
	MSMenuPtr	MSMenu;
	MenuHandle	menu;
	
	pt.h = MSChild->controlMenuBox.left + kGrowBorder;
	pt.v = MSChild->controlMenuBox.bottom;
	MSMenu = gAlertWindow->child->MSMenu;		// tricky, its the one for all
	menu = MSMenu->menu;
	if ( MSChild->window == gAlertWindow ) {
		DisableItem(menu, iMinimize);		/* the alert doesn't minimize */
		DisableItem(menu, iMaximize);
	} else {
		EnableItem(menu, iMinimize);
		EnableItem(menu, iMaximize);
	}
	SetOrigin(0,0);
	pt.h += MSChild->origin.h;
	pt.v += MSChild->origin.v;
	MSMenu->titleBox = MSChild->controlMenuBox;
	OffsetRect(&MSMenu->titleBox,MSChild->origin.h,MSChild->origin.v);
	OpenMSMenu((WindowPtr)MSChild->window,MSMenu,pt);
	item = TrackMSPopup((WindowPtr)MSChild->window);
	if (0 < item)
		DoMenuCommand(MSChild,menu,item);
}

void DoMenuBar(MSChildPtr MSChild,Point where)
{
	short		item;
	Point		pt;
	MSMenuPtr	MSMenu;
	
	pt = where;
	do {
		MSMenu = MSChild->MSMenu;
		while (MSMenu) {
			if (PtInRect(pt,&MSMenu->titleBox))	// hit a menu bar item
				break;
			MSMenu = MSMenu->next;
		}
		if (MSMenu) {
			InvertRect(&MSMenu->titleBox);
			pt.h = MSMenu->titleBox.left + 1;
			pt.v = MSMenu->titleBox.bottom + 1;
			OpenMSMenu((WindowPtr)MSChild->window,MSMenu,pt);
			item = TrackMSPopup((WindowPtr)MSChild->window);
			if (0 < item)
				DoMenuCommand(MSChild,MSMenu->menu,item);
		}
		GetMouse(&pt);
	} while (StillDown());
}

void SetOkBox(WindowPtr window)
{
	short		i, id, h[kMaxOkBox], v, x, y;
	PicHandle	pict;

	x = -20; y = 0;
	for (i = 0; i < kMaxOkBox; i++) {
		if ((id = gOkBoxID[i]) && (pict = gPicts[id])) {
			h[i] = (*pict)->picFrame.right - (*pict)->picFrame.left;
			v = (*pict)->picFrame.bottom - (*pict)->picFrame.top;
			if (y < v)
				y = v;
			x += h[i] + 20;
		}
	}

	gOkBox[0].left = (window->portRect.right - x) / 2;
	gOkBox[0].right = gOkBox[0].left + h[0];
	gOkBox[0].bottom = window->portRect.bottom - 18;
	gOkBox[0].top = gOkBox[0].bottom - y;

	for (i = 1; i < kMaxOkBox; i++) {
		if (gOkBoxID[i] != 0) {
			gOkBox[i] = gOkBox[i-1];
			gOkBox[i].left = gOkBox[i-1].right + 20;
			gOkBox[i].right = gOkBox[i].left + h[i];
		}
	}
}

void DrawOkBox()
{
	short		i, id;
	PicHandle	pict;

	for (i = 0; i < kMaxOkBox; i++) {
		if ((id = gOkBoxID[i]) && (pict = gPicts[id]))
			DrawPicture(pict,&gOkBox[i]);
	}
}

void DrawAlertText(short action,short *maxx,short *maxy)
{
	short		i,c,count,x,y,sz,maxsz;
	StringPtr	ptext,p;
	Str255		text;

	GetIndString(text,rTextStr,action);

	TextFont(systemFont);
	x = 60; y = 52;
	maxsz = 0;
	ptext = text;
	count = (*ptext) & 0xFF;
	text[count + 1] = 0;
	for (i = 0; i < count; i += c + 1) {
		p = ptext + 1;
		c = 0;
		while (((*p) & 0xFF) >= ' ') {
			p++;
			c++;
		}
		*ptext = c;
		if (maxx == nil) {	// do draw
			MoveTo(x,y);
			DrawString(ptext);
		}
		sz = StringWidth(ptext);
		if (maxsz < sz) maxsz = sz;
		y += 16;
		ptext = p;
	}
	TextFont(applFont);
	if (maxx != nil) {		// just compute draw size
		*maxx = x + maxsz;
		*maxy = y;
	}
}

void DrawAlertWindow(WindowPtr window)
{
	short		severity, item;
	MSChildPtr	MSChild;

	MSChild = MSWindow->child;
	severity = MSChild->iconList->action;
	item = MSChild->iconList->refCon;

	// Choose: kCautionIcon, kErrorIcon, or kYesNo
	MSChild->iconList->id = kInfoIcon + severity;
	
	switch (severity) {
	case 0:
	case 1:
		gOkBoxID[0] = kOKPict;
		gOkBoxID[1] = kCancelPict;
		gOkBoxID[2] = 0;
		break;
	case 2:
		gOkBoxID[0] = kOKPict;
		gOkBoxID[1] = 0;
		gOkBoxID[2] = 0;
		break;
	case 3:
		gOkBoxID[0] = kYesPict;
		gOkBoxID[1] = kNoPict;
		gOkBoxID[2] = kCancelPict;
		break;
	}

	DrawAlertText(item, nil, nil);
	
	DrawMSWindow(window);
	SetOkBox(window);
	DrawOkBox();
}

void DoMSAlert(short severity,short item)
{
	short		maxx,maxy;
	WindowPtr	window;
	MSChildPtr	MSChild;

	MSChild = gAlertWindow->child;
	MSChild->iconList->action = severity;
	MSChild->iconList->refCon = item;
	GetIndString(MSChild->title, rTitleStr, item);

	window = (WindowPtr)gAlertWindow;
	HideWindow(window);		// in case we are already in front, when quiting
	SetPort(window);

	DrawAlertText(item, &maxx, &maxy);

	MSChild->portRect.right = maxx + 20;	/* resize to fit text */
	MSChild->portRect.bottom = maxy + 50;
	SizeWindow(window, MSChild->portRect.right, MSChild->portRect.bottom, false);
//	CreateGWorld(window);
	SizeMSWindow(MSChild,false);
	ShowWindow(window);
	SelectWindow(window);

	if (gSound) SysBeep(4);
}

void ClickBkgndIcon(WindowPtr window,EventRecord *event)
{
	Point		where;
	MSChildPtr	MSChild;
	MSIconPtr	icon;

	CountClicks(event);		// count for double clicks
	where = event->where;
	GlobalToLocal(&where);
	MSChild = MSWindow->child;
	icon = MSChild->iconList;
	while (icon) {
		if (PtInRect(where,&icon->iconBox) ||
			PtInRect(where,&icon->textBox)) {
			if (gClicks == 2)
				DoubleClickIcon(MSChild,icon);
			break;
		}
		icon = icon->next;
	}
}

void DoubleClickIcon(MSChildPtr MSChild,MSIconPtr icon)
{
	WindowPtr	window;

	if (icon->restore) {
		MSChild = icon->restore;
		icon->restore = nil;
		window = (WindowPtr)MSChild->window;
		SetPort(window);
		SetOrigin(0,0);		// redundant ??
		if (icon->iconBox.right < kOffscreenOffset)	// for Window menu
			HideIcon(icon);
		BringChildFront(window,MSChild,MSChild->origin,false);
	} else
	switch (icon->action) {
	case kInfo:
	case kCaution:
	case kError:
	case kYesNo:
		DoMSAlert(icon->action,icon->refCon);
		break;

	case kGameAction:
	case kWindowAction:
		if (icon->refCon) {
			if (MSChild->base)		// the PM base group
				HideIcon(icon);
			else {
				gEmptyGame = true;	// ready for magic
				gMagicStr[0] = 0;
				NewGame(false);
			}
			window = (WindowPtr)icon->refCon;
			ShowWindow(window);			// was hidden, restore
			SelectWindow(window);
			SetPort(window);
		}
		break;

	case kLaunch:
		doLaunchApp((FSSpec*)icon->refCon);
		break;

	case kLaunchDoc:
		doLaunchFile((FSSpecs*)icon->refCon);
		break;
	}
}

void RestoreWindow(WindowPtr window)
{
	(&gScreen)->portPixMap = svPortPixMap;
	ClosePort((GrafPtr)&gScreen);
	SetPort(window);
	SetOrigin(0,0);
	EraseRect(&window->portRect);	// heavy handed ??
	DoInvalRect(&window->portRect);
}

void GetFrameClip(WindowPtr window,MSChildPtr MSChild,
			Boolean parent,Rect *clip,Rect *frame)
{
	Point		pt;
	GDHandle	gdev;
	
	if (parent) {
		SetPort(window);
		SetOrigin(0,0);
		*frame = window->portRect;
		pt.h = 0; pt.v = 0;
		LocalToGlobal(&pt);
		OffsetRect(frame,pt.h,pt.v);

		gdev = GetMaxDevice(&window->portRect);
		*clip = (*gdev)->gdRect;

		OpenCPort(&gScreen);
		svPortPixMap = (&gScreen)->portPixMap;
		(&gScreen)->portPixMap = (*gdev)->gdPMap;		// get a window of the screen
		SetPort((GrafPtr)&gScreen);
		clip->top += GetMBarHeight();	// don't allow moving too high
	} else {
		*clip = window->portRect;
		clip->top += kMenuHeight + kPictHeight;	// don't allow moving too high
		*frame = MSChild->portRect;
		OffsetRect(frame,MSChild->origin.h,MSChild->origin.v);
		RectRgn(gClipRgn,clip);
		SetClip(gClipRgn);
		SetPort(window);
	}
	SetOrigin(0,0);
}

Boolean DragResize(Point anchor,Point pt,Rect *clip,Rect *frame,
			Boolean hConstrain,Boolean vConstrain)
{
	Point	delta,px,lastpt;
	Rect	box;
	
	// constrain mouse to legal drag region
	PenSize(3,3);
	PenMode(srcXor);
	PenPat(&qd.gray);
	if (anchor.h == frame->left) {
		clip->left = anchor.h + (kIconStepH + 2*kGrowBorder);
		delta.h = frame->right - pt.h;
		pt.h = frame->right;
	} else {
		clip->right = anchor.h - (kIconStepH + 2*kGrowBorder);
		delta.h = pt.h - frame->left;
		pt.h = frame->left;
	}
	if (anchor.v == frame->top) {
		clip->top = anchor.v + (kPictHeight + kIconStepV + 2*kGrowBorder);
		delta.v = frame->bottom - pt.v;
		pt.v = frame->bottom;
	} else {
		clip->bottom = anchor.v - (kPictHeight + kIconStepV + 2*kGrowBorder);
		delta.v = pt.v - frame->top;
		pt.v = frame->top;
	}
	box = *frame;
	FrameRect(&box);
	while (StillDown()) {
		lastpt = pt;
		GetMouse(&px);
		if (!hConstrain) {
			pt.h = px.h + delta.h;
			if (pt.h < clip->left) pt.h = clip->left;
			if (pt.h > clip->right) pt.h = clip->right;
		}
		if (!vConstrain) {
			pt.v = px.v + delta.v;
			if (pt.v < clip->top) pt.v = clip->top;
			if (pt.v > clip->bottom) pt.v = clip->bottom;
		}
		if ((lastpt.h - pt.h) || (lastpt.v - pt.v)) {	// moved
			FrameRect(&box);
			if (anchor.h == frame->left)
				box.right = pt.h;
			else
				box.left = pt.h;
			if (anchor.v == frame->top)
				box.bottom = pt.v;
			else
				box.top = pt.v;
			FrameRect(&box);
		}
		SystemTask();		// do a better idle ??
	}
	FrameRect(&box);
	PenNormal();

	pt.h = (anchor.h == frame->left) ? (frame->right - box.right) : (frame->left - box.left);
	pt.v = (anchor.v == frame->top) ? (frame->bottom - box.bottom) : (frame->top - box.top);
	*frame = box;
	return ((((pt.h < 0) ? -pt.h : pt.h) + ((pt.v < 0) ? -pt.v : pt.v)) > 3);	// not a nudge
}

Boolean PtInResizeRgn(WindowPtr window,MSChildPtr MSChild,Point mouse)
{
	Boolean		parent,moved,result,hConstrain = false,vConstrain = false;
	Point		anchor;
	Rect		clip,frame;

	if (result = ! PtInRgn(mouse,gArrowRgn)) {
		if ( PtInRgn(mouse,gURightRgn) )
			parent = PtInRgn(mouse,gcURightRgn);
		else
		if ( PtInRgn(mouse,gDRightRgn) )
			parent = PtInRgn(mouse,gcDRightRgn);
		else
		if ( PtInRgn(mouse,gRightRgn) ) {
			parent = PtInRgn(mouse,gcRightRgn);
			vConstrain = true;
		} else
		if ( PtInRgn(mouse,gUpRgn) ) {
			parent = PtInRgn(mouse,gcUpRgn);
			hConstrain = true;
		}
		if (window == gHelpWindow)
			parent = true;		// just force this one ??
		if (parent)		// find base child
			while (MSChild->base == false)
				MSChild = MSChild->next;
		GetFrameClip(window,MSChild,parent,&clip,&frame);
		GlobalToLocal(&mouse);
		anchor.h = (mouse.h > (frame.left + kPictWidth)) ? frame.left : frame.right;
		anchor.v = (mouse.v > (frame.top + kPictHeight)) ? frame.top : frame.bottom;
		moved = DragResize(anchor,mouse,&clip,&frame,hConstrain,vConstrain);
		if (parent)
			RestoreWindow(window);
		ClipRect(&window->portRect);		// restore clip
		if (moved) {
			if ((parent) || (MSChild->base)) {	// base child
				SetPort(window);
				SetOrigin(0,0);
				MSChild->portRect.bottom = frame.bottom - frame.top;
				MSChild->portRect.right = frame.right - frame.left;
				MoveWindow(window,frame.left,frame.top,true);
				SizeWindow(window,MSChild->portRect.right,MSChild->portRect.bottom,true);
//				CreateGWorld(window);
			} else {
				clip = MSChild->portRect;
				OffsetRect(&clip,MSChild->origin.h,MSChild->origin.v);
				EraseRect(&clip);
				DoInvalRect(&clip);
				MSChild->portRect.bottom = frame.bottom - frame.top;
				MSChild->portRect.right = frame.right - frame.left;
				MSChild->origin = TopLeft(frame);
				EraseRect(&frame);
				DoInvalRect(&frame);
			}
			SizeMSWindow(MSChild,false);
		}
	}
	return(result);
} /* PtInResizeRgn */

/*	This is called when a mouse-down event occurs in the content of a window.
	Other applications might want to call FindControl, TEClick, etc., to
	further process the click. */

Boolean ContentClick(EventRecord *event,WindowPtr window)
{
	short		i,item;
	Point		pt;
	MSChildPtr	MSChild;
	MSMenuPtr	MSMenu;

	CountClicks(event);		// count for double clicks
	MSChild = MSWindow->child;
	MSMenu = MSWindow->MSMenu;
	if (MSMenu != nil) {	// there's a popped up menu
		pt = event->where;
		GlobalToLocal(&pt);
		if (PtInRect(pt,&MSMenu->menuRect)) {
			item = TrackMSPopup(window);
			if (item) {			// clicked down or a choice
				if (0 < item)	// a real choice
					DoMenuCommand(MSChild,MSMenu->menu,item);
				goto done;		// eat this click
			}
		}
		if (MSWindow->MSMenu != nil) {
			CloseMSMenu(window);
			goto done;		// eat this click
		}
	}
	if ((window == gMineWindow) || (! PtInResizeRgn(window,MSChild,event->where)))
	while (MSChild != nil) {
		SetOrigin( -MSChild->origin.h, -MSChild->origin.v);
		pt = event->where;
		GlobalToLocal(&pt);
		if (PtInRect(pt,&MSChild->portRect)) {	// can't hit hidden children way off screen
			if ((! MSChild->base) && (MSChild->window->child != MSChild)) {
				BringChildFront(window,nil,event->where,true);
				MSChild = MSWindow->child;
				SetOrigin( -MSChild->origin.h, -MSChild->origin.v);
				pt = event->where;
				GlobalToLocal(&pt);
			}
			if (gWindowMode == kMoveMode) {
				ClickIcon(MSChild,pt,event->modifiers);	// Move Icons
				gWindowMode = kNormalMode;
			} else
			if (PtInRect(pt,&MSChild->controlMenuRect))	// is the menu already up ?
				DoControlMenu(MSChild,pt);
			else
			if (PtInRect(pt,&MSChild->menuBarRect))	// is there a window menu bar ?
				DoMenuBar(MSChild,pt);
			else
			if (pt.v < kPictHeight) {
				if (PtInRect(pt,&MSChild->controlMenuBox)) {
					DrawCell(kMenuBox+kPressOffset,&MSChild->controlMenuBox);
					DoControlMenu(MSChild,pt);
					DrawCell(kMenuBox,&MSChild->controlMenuBox);
				} else
				if (PtInRect(pt,&MSChild->maximizeBox)) {
					if (TrackButton((MSChild->maximized) ? kRestoreBox : kMaximizeBox,&MSChild->maximizeBox))
						DoMSCommand(MSChild,(MSChild->maximized) ? vRestore : vMaximize);
				} else
				if (PtInRect(pt,&MSChild->minimizeBox)) {
					if (TrackButton(kMinimizeBox,&MSChild->minimizeBox))
						DoMSCommand(MSChild,vMinimize);
				} else {
					return(false);			// allow dragging
				}
			} else
			if (window == gMineWindow) {
//				if (MSWindow->MSMenu != nil) {
//					CloseMSMenu(window);	// and skip the rest
//				} else
				if (PtInGame(pt)) {
					SetPort(window);
					ClickGame(pt,event->modifiers);
				}
			} else
			if (window == gAlertWindow) {
				for (i = 0; i < kMaxOkBox; i++) {
					if ((PtInRect(pt,&gOkBox[i])) &&
						(TrackButton(gOkBoxID[i],&gOkBox[i]))) {
						if (gDone && (gOkBoxID[i] == kOKPict)) {
							Terminate();	// this is the end...
						} else {
							gDone = false;
							HideMSWindow(window);
						}
					}
				}
			} else
			if (window == gHelpWindow) {
				for (i = 0; i < kMaxButtonBar; i++) {
					if ((PtInRect(pt,&gButtonBar[i])) &&
						(gButtonBarID[i] < kHelpGreyPict) &&	/* its active */
						(TrackButton(gButtonBarID[i],&gButtonBar[i]))) {
						
						switch(gButtonBarID[i]) {
						case kHelpContentPict:
							DoGetHelp((gHelpID[gHelpInx] / 100) * 100);	// get the base help
							break;
						case kHelpSearchPict:
							SysBeep(4);
							break;
						case kHelpBackPict:
							if (1 < gHelpInx)
								DoGetHelp(gHelpID[gHelpInx -= 2]);	// DoGetHelp increments
							break;
						case kHelpHistoryPict:
							SysBeep(4);
							break;
						case kHelpPrevPict:
							DoGetHelp(gHelpID[gHelpInx] - 1);
							break;
						case kHelpNextPict:
							DoGetHelp(gHelpID[gHelpInx] + 1);
							break;
						}
						DoInvalRect(&window->portRect);
						break;
					}
				}
			} else {
				RgnHandle clipRgn;
				
				clipRgn = NewRgn();
				GetClip(clipRgn);
				ClipRect(&MSChild->portRect);	// inset ???
				ClickIcon(MSChild,pt,event->modifiers);
				SetClip(clipRgn);
				DisposeRgn(clipRgn);
			}
			break;
		} else {
			if (MSChild->base)
				break;
			MSChild = MSChild->next;
		}
	}
done:
	SetOrigin( 0, 0);
	return(true);
} /*ContentClick*/


void DrawMSMenuBar(WindowPtr window)
{
	short		sz;
	MSChildPtr	MSBase;
	MSMenuPtr	MSMenu;

	MSBase = MSWindow->child;
	while (! MSBase->base)
		MSBase = MSBase->next;
	if (MSBase->menuBarRect.bottom != MSBase->menuBarRect.top) {
		EraseRect(&MSBase->menuBarRect);
		TextFont(systemFont);
		MSMenu = MSBase->MSMenu;
		while (MSMenu) {
			MoveTo(MSMenu->titleBox.left + 10,MSMenu->titleBox.bottom - 4);
			DrawString((StringPtr)MSMenu->title);
			sz = CharWidth(MSMenu->title[1]);
			MoveTo(MSMenu->titleBox.left + 10,MSMenu->titleBox.bottom - 3);
			Line(sz - 1,0);
			MSMenu = MSMenu->next;
		}
		TextFont(applFont);
		MoveTo(MSBase->menuBarRect.left,MSBase->menuBarRect.bottom);
		LineTo(MSBase->menuBarRect.right,MSBase->menuBarRect.bottom);
	}
}

void ClipMenuFromView(MSMenuPtr MSMenu,RgnHandle clipRgn)
{
	Rect	r;
	
	r = MSMenu->menuRect;
	r.left -= 1;
	r.right += 2;
	r.bottom += 2;
	RectRgn(gViewRgn,&r);
	DiffRgn(clipRgn,gViewRgn,clipRgn);	// remove popup menu
}

void DrawMSWindow(WindowPtr	window)
{
	short		x,x1,y,vBorder;
	Rect		r,box;
	MSIconPtr	icon;
	MSChildPtr	MSBase,MSChild;
	MSMenuPtr	MSMenu;

	MSBase = MSWindow->child;
	while (! MSBase->base)
		MSBase = MSBase->next;
	MSChild = MSWindow->child;

	/* start with base's client area */
	r = MSBase->portRect;
	RectRgn(gBaseFrameRgn,&r);
	InsetRect(&r,kGrowBorder,kGrowBorder);
	r.top = MSBase->menuBarRect.bottom;
	RectRgn(gClipRgn,&r);
	DiffRgn(gBaseFrameRgn,gClipRgn,gBaseFrameRgn);	// find base frame region
	MSMenu = MSWindow->MSMenu;
	if (MSMenu != nil) {
		DrawMSMenu(window);
		ClipMenuFromView(MSMenu,gClipRgn);		// remove popup menu
	}
	while (MSChild != nil) {
		SetOrigin( -MSChild->origin.h, -MSChild->origin.v);
		OffsetRgn(gClipRgn, -MSChild->origin.h, -MSChild->origin.v);
		RectRgn(gViewRgn,&MSChild->portRect);
		SectRgn(gClipRgn,gViewRgn,gDrawRgn);		// find my clip
		if (MSChild == MSBase) {
			SetClip(gBaseFrameRgn);
			UnionRgn(gDrawRgn,gBaseFrameRgn,gDrawRgn);
		} else {
			r = MSChild->portRect;
			InsetRect(&r,kGrowBorder,kGrowBorder);
			r.top = MSChild->menuBarRect.bottom;
			RectRgn(gFrameRgn,&r);
			DiffRgn(gDrawRgn,gFrameRgn,gFrameRgn);	// find my client area
			DiffRgn(gClipRgn,gViewRgn,gClipRgn);	// subtract the drawn view
			OffsetRgn(gClipRgn, MSChild->origin.h, MSChild->origin.v);
			SetClip(gFrameRgn);
		}

		icon = MSChild->iconList;
		if (window != gMineWindow) {	// game has no grow boarder
			box = MSChild->portRect;
			FrameRect(&box);
			InsetRect(&box,1,1);
			if (MSChild->active)
				RGBForeColor(&gGray);
			else
				RGBForeColor(&gWhite);
			PenSize(2,2);
			FrameRect(&box);
			RGBForeColor(&gBlack);
			PenNormal();
			InsetRect(&box,2,2);
			FrameRect(&box);
			InsetRect(&box,1,1);
			RectRgn(gViewRgn,&box);
			SectRgn(gDrawRgn,gViewRgn,gDrawRgn);
		}
		x = 0;
		y = 0;
		vBorder = (MSChild->active) ? 0 : kInactiveOffset;
		DrawPict(kMenuBox + vBorder,&x,&y);
		for ( ; x < MSChild->portRect.right; )
			DrawPict(kTop + vBorder,&x,&y);

		x = (MSChild->portRect.right - StringWidth(MSChild->title)) / 2;
		if (MSChild->minmax)
			x -= 3*kPictWidth2/4;
		if (x < (kPictWidth + 1))
			x = kPictWidth + 1;
		MoveTo(x,kPictHeight - 6);	// -5 with 14pt
		TextFont(systemFont);
		if (MSChild->active) {
			RGBForeColor(&gWhite);
			DrawString(MSChild->title);
			RGBForeColor(&gBlack);
		} else
			DrawString(MSChild->title);
		TextFont(applFont);
	
		x = MSChild->portRect.right - kPictWidth;
		if (MSChild->minmax) {
			x -= kPictWidth2;
			DrawPict(kMinimizeBox + vBorder,&x,&y);
			DrawPict(((MSChild->maximized) ? kRestoreBox : kMaximizeBox) + vBorder,&x,&y);
		} else {
			MSChild->minimizeBox.right = MSChild->minimizeBox.left;
			MSChild->maximizeBox.right = MSChild->maximizeBox.left;
			DrawPict(kNoBox + vBorder,&x,&y);
		}
			
		if (window != gMineWindow) {	// game has no grow boarder
			x1 = MSChild->portRect.right - kPictWidth;
			x = 0;
			y = MSChild->portRect.bottom - kPictHeight;
			DrawPict(kBottomLeft + vBorder,&x,&y);
			x = x1;
			DrawPict(kBottomRight + vBorder,&x,&y);
			
			SetClip(gDrawRgn);
			while (icon) {
				DrawIcon(icon,MSChild->active && (MSChild->window->child == MSChild));
				icon = icon->next;
			}
		} else
			SetClip(gDrawRgn);

		if (MSChild->base)	// done
			break;
		MSChild = MSChild->next;
	}
	SetOrigin(0,0);
	/* restore a big rectangular region */
	SetRectRgn(gClipRgn, -8000, -8000, 8000, 8000);
	SetClip(gClipRgn);
	if ((MSChild != nil) && (MSChild->base))
		DrawMSMenuBar(window);
}

Boolean DragChild(WindowPtr window,Point where)
{
	Point		pt;
	long		xy;
	short		x,y;
	Rect		childRect,limitRect,slopRect;
	MSChildPtr	MSBase,MSChild;
	RgnHandle	rgn;
	
	SetPort(window);
	SetOrigin(0,0);	// redundant ??
	pt = where;
	GlobalToLocal(&pt);
	MSChild = MSWindow->child;
	while (! MSChild->base) {
		childRect = MSChild->portRect;
		OffsetRect(&childRect,MSChild->origin.h,MSChild->origin.v);
		if (PtInRect(pt,&childRect)) {	// can't hit hidden children
			rgn = NewRgn();
			RectRgn(rgn,&childRect);
			MSBase = MSChild->next;
			while (! MSBase->base)
				MSBase = MSBase->next;
			limitRect = MSBase->portRect;
			InsetRect(&limitRect,kGrowBorder + 1,kGrowBorder + 1);	// + 1 is slop ??
			limitRect.top = MSBase->menuBarRect.bottom + 1;
			slopRect = limitRect;
			InsetRect(&slopRect,-50,-50);
			xy = DragGrayRgn(rgn,pt,&limitRect,&slopRect,0,nil);
			x = LoWrd(xy);
			y = HiWrd(xy);
			xy = ((x < 0) ? -x : x) + ((y < 0) ? -y : y);
			if (xy > 3) {	// not a nudge
				EraseRect(&childRect);
				DoInvalRect(&childRect);
				OffsetRect(&childRect,x,y);
				EraseRect(&childRect);
				DoInvalRect(&childRect);
				MSChild->origin.h += x;
				MSChild->origin.v += y;
			}
			DisposeRgn(rgn);
			return(true);
		} 
		MSChild = MSChild->next;
	}
	return(false);
}

void DrawBkgndWindow(WindowPtr window)
{
	MSIconPtr	icon;
	MSChildPtr	MSChild;

	DrawBMP(window);

	MSChild = MSWindow->child;
	icon = MSChild->iconList;
	while (icon) {
		DrawIcon(icon,MSChild->active && (MSChild->window->child == MSChild));
		icon = icon->next;
	}
	GetCPixel(0,0,&gMagicColor);
}

/* Draw the contents of the application window.  */

extern Boolean gRunning;

void DrawWindow(WindowPtr window)
{
	switch (MSWindow->savebits) {
		case  kDoDraw:
		case  kDoSave:
			(*(MSWindow->DrawProc))(window);
			MSWindow->savebits = kDoSave;
			break;
		case  kDoCopy:
			DrawGWorld(window);
			if ((window == gMineWindow) && gRunning)
				DrawHdr();	// make sure time is OK
			break;
	}
} /*DrawWindow*/


/*
**	Read menu descriptions from resource file into memory 
**	and store handles in gMenus array.
**	Insert into MenuBar and draw.
*/
void
SetUpMenus(void)
{
	short		sz,inx;
	Handle		files;
	Ptr			pfile;
	Str255	theName;		/* name of default volume */
	short	vRefNum;		/* default volume ref num */
	
	gMenus[mAppleInx] = GetMenu(mApple); 	/* read menus from resource file */
	AddResMenu(gMenus[mAppleInx], 'DRVR');	/* add desk accessory names to Apple menu */
	gMenus[mFileInx] = GetMenu(mFile);
	gMenus[mEditInx] = GetMenu(mEdit);
	gMenus[mBMPInx] = GetMenu(mBMP);
	GetVol(&theName, &vRefNum);
	files = FindBMPFiles(vRefNum);
	inx = 1;
	MoveHHi(files); HLock(files);
	pfile = *files;
	while (pfile[0]--) {
		sz = pfile[inx] -= 4;
		if ((0 < sz) && (pfile[inx+sz+1] == '.') && (pfile[inx+sz+2] == 'B') && 
						(pfile[inx+sz+3] == 'M') && (pfile[inx+sz+4] == 'P'))
			AppendMenu(gMenus[mBMPInx],(StringPtr)(&pfile[inx]));
		inx += pfile[inx] + 5;
	}
	DisposHandle(files);
	
	InsertMenu(gMenus[mAppleInx], 0); 		/* install menus in menu bar */
	InsertMenu(gMenus[mFileInx], 0);
	InsertMenu(gMenus[mEditInx], 0);
	InsertMenu(gMenus[mBMPInx], 0);

	DrawMenuBar();							/* and draw menu bar */

	DoMenuCommand(nil,gMenus[mBMPInx],3);	// set initial background for gBkgndWindow
}

SetMBarHeight(short newheight)
{
	short *mBarHeight = (short*)0x0BAA;
	
	*mBarHeight = newheight;
}


/*	This is called when an item is chosen from the menu bar (after calling
	MenuSelect or MenuKey). It performs the right operation for each command.
	It is good to have both the result of MenuSelect and MenuKey go to
	one routine like this to keep everything organized. */

void
DoMenuCommand(MSChildPtr MSChild,MenuHandle hMenu,short theItem)
{
	int		temp;
	Boolean	dummy;
	GrafPtr	svPort;
	Str255	name;						/* menu item name */

	switch ((*hMenu)->menuID) {			/* switch on menu ID */

		case mApple:
			switch (theItem) {
			case iAbout:		/* bring up About Box */
				doDialog(rAbout);
				break;
			default:			/* all non-About items in this menu are DAs */
				GetItem(hMenu, theItem, name);
				temp = OpenDeskAcc(name);
				SetPort((WindowPtr)gMineWindow);
			}
			break;

		case mFile:
			switch (theItem) {			/* switch on menu item */
			case iSavePict:
				SavePict((WindowPtr)gBkgndWindow,BMPName);
				break;
			case iSound:
				CheckItem(hMenu,theItem,gSound = !gSound);
				break;
			case iQuit:
				goto logout;
			}
			break;

		case mEdit:
			dummy = SystemEdit(theItem - 1); /* Pass the command on to the Desk Manager. */
			break;

		case mBMP:
			switch (theItem) {	
			case iDouble:
				CheckItem(hMenu,theItem,gDouble = !gDouble);
				GetPort(&svPort);
				SetPort((WindowPtr)gBkgndWindow);
				DoInvalRect(&((WindowPtr)gBkgndWindow)->portRect);
				SetPort(svPort);
				break;
			default:
				GetItem(hMenu,theItem,BMPName);
				if (ReadBMP(BMPName)) {
					GetPort(&svPort);
					SetPort((WindowPtr)gBkgndWindow);
					DoInvalRect(&((WindowPtr)gBkgndWindow)->portRect);
					SetPort(svPort);
				}
				break;
			}
			break;

		case mWinFile:
			switch (theItem) {
			case iNew:
				doCatSearch();
				break;

			case iLogout:
		logout:
				gDone = true;
				DoMSAlert(kCaution, kExitMsg);
//				Terminate();	// when the OK button is pressed
				break;
			}
			break;

		case mOptions:
			CheckItem(hMenu,theItem,gOptions[theItem] = !gOptions[theItem]);
			break;

		case mWindow:
			switch (theItem) {
			case iCascade:
				DoMSCommand(MSChild,vCascade);
				break;
			case iTile:
				DoMSCommand(MSChild,vTile);
				break;
			case iArrange:
				SizeMSWindow(MSChild,true);	// ???
				break;

			default:
				MSChild = gChild[theItem];
				MSChild->icon->restore = MSChild;
				DoubleClickIcon(MSChild,MSChild->icon);
				break;
			}
			break;

		case mControl:
			switch (theItem) {
			case iRestore:
				DoMSCommand(MSChild,vRestore);
				break;
			case iMove:
				DoMSCommand(MSChild,vMove);
				break;
			case iWinSize:
				break;
			case iMinimize:
				DoMSCommand(MSChild,vMinimize);
				break;
			case iMaximize:
				DoMSCommand(MSChild,(MSChild->maximized) ? vRestore : vMaximize);
				break;
			case iWinClose:
				HideMSWindow((WindowPtr)(MSChild->window));
			// 	SelectWindow(gPMWindow or gGameWindow);
				break;
			case iSwitchTo:
				break;
			}
			break;

		case mHelp:
			switch (theItem) {
			case iIndex:
				DoGetHelp(kHelpPM);			/* bring up PM Help text */
	showhelp:	ShowWindow((WindowPtr)gHelpWindow);
				SelectWindow((WindowPtr)gHelpWindow);
				break;
			case iUsingHelp:
				DoGetHelp(kHelpHelp);		/* bring up Help Help text */
				goto showhelp;
			case iAboutHelp:
				doDialog(rAbout);			/* bring up About Box */
				break;
			default:
				DoMSAlert(kInfo, kHelpMsg);	/* just show an error */
				break;
			}
			break;

		case mMineHelp:
			switch (theItem) {
			case iHowToPlay:		
				DoGetHelp(kHelpWhats);		/* bring up Help text */
				goto showhelp;
			case iGameCommands:
				DoGetHelp(kHelpMine);
				goto showhelp;
			case iGameHelp:
				DoGetHelp(kHelpHelp);
				goto showhelp;
			case iAboutMines:				/* bring up About Box */
				doDialog(rAboutMines);
				break;
			}
			break;

		case mMines:
			switch (theItem) {
			case iBeginner:
			case iIntermediate:
			case iExpert:
				CheckItem(hMenu, gGameType + iBeginner, false);
				gGameType = theItem - iBeginner;
				CheckItem(hMenu, theItem, true);
				NewGame(true);
				break;
			case iNew:
				NewGame(false);
				break;
			case iCustom:
				doDialog(rCustom);
				break;
			case iMarks:
				CheckItem(hMenu, iMarks, gMarks = !gMarks);
				break;
			case iTimes:
				doDialog(rBestTimes);
				break;
			}
			break;

		case mHelpFile:
			switch (theItem) {
			case iHelpOpen:
				DoMSAlert(kError,kBadPath);
				break;
			case iHelpPrint:
				DoMSAlert(kError, kNoQueue);
				break;
			case iHelpSetup:
				DoMSAlert(kInfo, kHelpMsg);
				break;
			case iHelpExit:
				HideMSWindow((WindowPtr)MSChild->window);
				break;
			}
			break;

		case mHelpEdit:
			switch (theItem) {
			case iHelpCopy:
				DoMSAlert(kError,kLostPath);
				break;
			case iHelpAnnotate:
				DoMSAlert(kError,kUAEError);
				break;
			}
			break;

		case mHelpBookmark:
			switch (theItem) {
			case iHelpDefine:
				DoMSAlert(kError,kBadDir);
				break;
			}
			break;

		case mHelpHelp:
			switch (theItem) {
			case iHelpHow:
				DoGetHelp(kHelpHelp);
				DoInvalRect(&((WindowPtr)gHelpWindow)->portRect);	// my menu
				goto showhelp;
			case iHelpOnTop:
				break;
			case iHelpAbout:
				DoMSAlert(kInfo, kHelpMsg);
				break;
			}
			break;
	}

	HiliteMenu(0);						/* Unhighlight menu title */
										/* (highlighted by MenuSelect) */
}

void
SaveBits(WindowPtr window)
{
	CGrafPtr		currentPort;
	GDHandle		currentDevice;
	PixMapHandle	pixMap;			/* PixMap of the GWorld */
	
	/******************************************************************************/
	/* Store the current port and device before switching to the offscreen world. */
	/******************************************************************************/

	GetGWorld( &currentPort, &currentDevice );
	
	/****************************************************************************/
	/* Switch to the offscreen GWorld then lock the offscreen buffer in memory. */
	/****************************************************************************/

	SetGWorld( MSWindow->GWorld, nil );
	pixMap = MSWindow->GWorld->portPixMap;	//	GetGWorldPixMap(MSWindow->GWorld);
	LockPixels( pixMap );
	
	RGBForeColor(&gBlack);
	RGBBackColor(&gWhite);
	ClipRect(&window->portRect);
	CopyBits(&window->portBits, (BitMap *) *pixMap, 
			&window->portRect, &window->portRect, srcCopy, nil);

	/********************************************************************/
	/* After drawing the image, unlock the offscreen buffer in memory	*/
	/*	and set the port and device back to the window's.        		*/
	/********************************************************************/

	UnlockPixels( pixMap );
	SetGWorld( currentPort, currentDevice );
}

void
SetCorner(RGBColor *magicColor)
{
	GrafPtr	svPort;

	GetPort(&svPort);
	SetPort((WindowPtr)gBkgndWindow);
	SetCPixel(0,0,magicColor);
	SetPort(svPort);
}

void
DrawMineWindow(WindowPtr window)
{
	CGrafPtr	currentPort;
	GDHandle	currentDevice;
	PixMapHandle	pixMap;			/* PixMap of the GWorld */
	
	/******************************************************************************/
	/* Store the current port and device before switching to the offscreen world. */
	/******************************************************************************/
	
	GetGWorld( &currentPort, &currentDevice );
	pixMap = MSWindow->GWorld->portPixMap;	//	GetGWorldPixMap(MSWindow->GWorld);
	
	/****************************************************************************/
	/* Switch to the offscreen GWorld then lock the offscreen buffer in memory. */
	/****************************************************************************/

	SetGWorld( MSWindow->GWorld, nil );
	LockPixels( pixMap );
	
	DrawMSWindow(window);
	DrawGame( (BitMap *)*pixMap );
	
	/********************************************************************/
	/* After drawing the image, unlock the offscreen buffer in memory	*/
	/*	and set the port and device back to the window's.        		*/
	/********************************************************************/

	SetGWorld( currentPort, currentDevice );

	RGBForeColor(&gBlack);
	RGBBackColor(&gWhite);
	ClipRect(&window->portRect);
	CopyBits ((BitMap *) *pixMap, &window->portBits, 
			&window->portRect, &window->portRect, srcCopy, nil);
	UnlockPixels( pixMap );
}

void PositionWindow(WindowPtr window)	
{
	WindowPtr	saved,front;
	Rect		r;
	Point		pt;
	
	GetPort(&saved);
	front = FrontWindow();
	SetPort(front);
	r = front->portRect;
	LocalToGlobal(&TopLeft(r));
	LocalToGlobal(&BotRight(r));
	SetPort(saved);
	
	pt = CenterWithin(&window->portRect, &r);
	MoveWindow(window, pt.h, pt.v, false);
}

// within is in global coordinates
// returns global coordinate of r's topleft point
Point CenterWithin( Rect *r, Rect *within )
{
	Point	pt;
	
	pt.h = within->left + ((within->right - within->left) - (r->right - r->left)) / 2;
	pt.v = within->top + ((within->bottom - within->top) - (r->bottom - r->top)) / 3;
	
	return(pt);
}
