
#include "Types.r"
#include "SysTypes.r"

#include "Resource.h"
#include "Help.h"

resource 'vers' (1, "Windows") {
	0x03, 0x00, release, 0x1,
	verUs,
	"3.1",
	"3.1 by Bob Spence"
};

resource 'vers' (2, "Windows") {
	0x03, 0x00, release, 0x1,
	verUs,
	"3.1",
	"  for the Macintosh"
};

resource 'BNDL' (128) {
	'MsWn',
	0,
	{
		'FREF', { 0, 128 },
		'ICN#', { 0, 12888 }
	}
};

resource 'FREF' (128) {
	'APPL',
	0,
	""
};

data 'MsWn' (0, "Owner resource") {
	"3.1 by Bob Spence"
};


resource 'MENU' (mApple, "Apple", preload) {
	mApple, textMenuProc,
	AllItems & ~MenuItem2,	/* Disable dashed line, enable About and DAs */
	enabled, apple,
	{
		"About Windows",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mFile, "File", preload) {
	mFile, textMenuProc,
	AllItems & ~(MenuItem2 + MenuItem4 + MenuItem6),	/* everything */
	enabled, "File",
	{
		"Save Background as Pict",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"SoundBlaster",
			noicon, nokey, check, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Quit",
			noicon, "Q", nomark, plain;
	}
};

resource 'MENU' (mEdit, "Edit", preload) {
	mEdit, textMenuProc,
	NoItems,		/* disable everything, program does the enabling */
	enabled, "Edit",
	 {
		"Undo",
			noicon, "Z", nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Cut",
			noicon, "X", nomark, plain;
		"Copy",
			noicon, "C", nomark, plain;
		"Paste",
			noicon, "V", nomark, plain;
		"Clear",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mBMP, "Background", preload) {
	mBMP, textMenuProc,
	AllItems & ~MenuItem2,				/* enable everything */
	enabled, "Background",
	 {
		"Double",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (mWinFile, "File", preload) {
	mWinFile, MSMenuProc,
	NoItems + MenuItem1 + MenuItem10,	/* just logout */
	enabled, "File",
	{
		"&New Group",
			noicon, nokey, nomark, plain;
		"&Open%Enter",
			noicon, nokey, nomark, plain;
		"&Move%F7",
			noicon, nokey, nomark, plain;
		"&Copy%F8",
			noicon, nokey, nomark, plain;
		"&Delete%Del",
			noicon, nokey, nomark, plain;
		"&PropertiesAlt+Enter",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"&Run",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"&Logoff%Alt+F4",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (mOptions, "Options", preload) {
	mOptions, MSMenuProc,
	AllItems,	/* Disabled separators */
	enabled, "Options",
	{
		"&Auto Arrange",
			noicon, nokey, check, plain;
		"&Minimize on Use",
			noicon, nokey, nomark, plain;
		"&Save Settings on Exit",
			noicon, nokey, check, plain;
	}
};

resource 'MENU' (mWindow, "Window", preload) {
	mWindow, MSMenuProc,
	AllItems & ~MenuItem4,	/* and Disabled separators */
	enabled, "Window",
	{
		"&Cascade%Shift+F5",
			noicon, nokey, nomark, plain;
		"&Tile%Shift+F4",
			noicon, nokey, nomark, plain;
		"&Arrange Icons",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (mHelp, "Win Help", preload) {
	mHelp, MSMenuProc,
	AllItems & ~MenuItem7,	/* and Disabled separators */
	enabled, "Help",
	{
		"&Index",
			noicon, nokey, nomark, plain;
		"&Keyboard",
			noicon, nokey, nomark, plain;
		"&Commands",
			noicon, nokey, nomark, plain;
		"&Procedures",
			noicon, nokey, nomark, plain;
		"&Glossary",
			noicon, nokey, nomark, plain;
		"&Using Help",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"&About Program Manager",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (mMines, "Game", preload) {
	mMines, MSMenuProc,
	AllItems & ~(MenuItem2 + MenuItem7 + MenuItem9),	/* and Disabled separators */
	enabled, "Game",
	{
		"&New Game%F2",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"&Beginner",
			noicon, nokey, nomark, plain;
		"&Intermediate",
			noicon, nokey, check, plain;
		"&Expert",
			noicon, nokey, nomark, plain;
		"&Custom",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"&Marks [?]",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Best &Times",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (mMineHelp, "Mine Help", preload) {
	mMineHelp, MSMenuProc,
	AllItems & ~MenuItem4,	/* Disabled separators */
	enabled, "Help",
	{
		"&How to Play",
			noicon, nokey, nomark, plain;
		"&Commands",
			noicon, nokey, nomark, plain;
		"&Using Help",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"&About Minesweeper",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (mControl, "Control", preload) {
	mControl, MSMenuProc,
	AllItems & ~(MenuItem2 + MenuItem3 + MenuItem6 + MenuItem8 + MenuItem9),	/* Disabled separators */
	enabled, "Control",
	{
		"&Restore",
			noicon, nokey, nomark, plain;
		"&Move",
			noicon, nokey, nomark, plain;
		"&Size",
			noicon, nokey, nomark, plain;
		"Mi&nimize",
			noicon, nokey, nomark, plain;
		"Ma&ximize",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"&Close%Alt+F4",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"S&witch To%Ctrl+Esc",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (mHelpFile, "Help File", preload) {
	mHelpFile, MSMenuProc,
	AllItems & ~(MenuItem2 + MenuItem5),	/* Disabled separators */
	enabled, "File",
	{
		"&Open",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"&Print Topic",
			noicon, nokey, nomark, plain;
		"P&rint Setup",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"E&xit",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (mHelpEdit, "Help Edit", preload) {
	mHelpEdit, MSMenuProc,
	AllItems & ~(MenuItem1 + MenuItem2),	/* Disabled separators */
	enabled, "Edit",
	{
		"&Copy",
			noicon, nokey, nomark, plain;
		"&Annotate",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (mHelpBookmark, "Help Bookmark", preload) {
	mHelpBookmark, MSMenuProc,
	AllItems,			/* Disabled separators */
	enabled, "Bookmark",
	{
		"&Define",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (mHelpHelp, "Help Help", preload) {
	mHelpHelp, MSMenuProc,
	AllItems & ~MenuItem3,	/* Disabled separators */
	enabled, "Help",
	{
		"&How to Use Help",
			noicon, nokey, nomark, plain;
		"Always on &Top",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"&About Help",
			noicon, nokey, nomark, plain;
	}
};


resource 'WIND' (rWindow, "Windows") {
	{50, 80, 50, 80},
	plainDBox, invisible, noGoAway, 0x0, "Windows"
};


resource 'CNTL' (rVScroll, preload, purgeable) {
	{-1, 400, 236, 416},
	0, visible, 0, 0, scrollBarProc, 0, ""
};



/* this ALRT and DITL are used as an error screen */

resource 'ALRT' (rUserAlert, "User Alert", purgeable) {
	{40, 20, 120, 260},
	rUserAlert,
	{ /* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};


resource 'DITL' (rUserAlert, "User Alert", purgeable) {
	{ /* array DITLarray: 3 elements */
		/* [1] */
		{50, 150, 70, 230},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{10, 60, 40, 230},
		StaticText {
			disabled,
			"Microsoft Windows -\nError occurred!"
		},
		/* [3] */
		{8, 8, 40, 40},
		Icon {
			disabled,
			2
		}
	}
};

/* this ALRT and DITL is used to report most errors */

#define kDialogWidth		261				/* Width of Error Alert */
#define kTextLines			 2				/* Number of text lines in Error Alert */

resource 'ALRT' (rErrorAlert, "Error Alert", purgeable) {
		{30, 30, 30+kDialogHeight, 30+kDialogWidth},
	rErrorAlert,
	{	/* array: 4 elements */
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};

resource 'DITL' (rErrorAlert, "Error Alert", purgeable) {
	{
		{kButtonTop, kQuitButtonLeft, kButtonBottom, kQuitButtonRight},
		Button {enabled,"Quit"},
		{kAlertIconTop, kAlertIconLeft, kAlertIconBottom, kAlertIconRight},
		Icon {disabled,0},
		{kMsgTextTop, kAlertTextLeft, kMsgTextBottom, kAlertTextRight},
		StaticText {disabled,
			"^0"
		}
	}
};

resource 'STR#' (rStrMisc,"Misc Messages") {
	{
	"Select a Directory to Group."
	""
	}
};

resource 'STR#' (rErrorAlert,"Error Messages") {
	{
	"Unsupported machine"
	"No Memory",
	"Not enough color turned on",
	"Initialize Error",
	"Unknown Error",
	""
	}
};

resource 'DLOG' (rCustom, "Custom") {
	{100, 100, 213, 305},
	dBoxProc, invisible, noGoAway, 0x0, rCustom, "Custom"
};

resource 'DITL' (rCustom, "Custom") {
	{
		{ 83, 135, 103, 195 },
		button { enabled, "OK" },
		{0, 0, 0, 0},	/* OK button's default roundrect userItem  */
		UserItem {disabled},
		{ 53, 135, 73, 195 },
		button { enabled, "Cancel" },
		{ 30, 75, 46, 105 },
		editText { enabled, "16" },
		{ 55, 75, 71, 105 },
		editText { enabled, "16" },
		{ 80, 75, 96, 105 },
		editText { enabled, "40" },
		{ 5, 10, 20, 130 },
		staticText { disabled, "Custom Field" },
		{ 30, 15, 46, 70 },
		staticText { disabled, "Height:" },
		{ 55, 20, 71, 70 },
		staticText { disabled, "Width:" },
		{ 80, 20, 96, 70 },
		staticText { disabled, "Mines:" },
	}
};


resource 'DLOG' (rBestTimes, "Best Times") {
	{100, 100, 236, 450},
	dBoxProc, invisible, noGoAway, 0x0, rBestTimes, "Best Times"
};

resource 'DITL' (rBestTimes, "Best Times") {
	 {
		{ 106, 230, 126, 300 },
		button { enabled, "OK" },
		{0, 0, 0, 0},	/* OK button's default roundrect userItem  */
		UserItem {disabled},
		{ 106, 50, 126, 160 },
		button { enabled, "Reset Scores" },
		{ 30, 110, 45, 137 },
		staticText { enabled, "999" },
		{ 55, 110, 71, 137 },
		staticText { enabled, "999" },
		{ 80, 110, 96, 137 },
		staticText { enabled, "999" },
		{ 30, 220, 45, 340 },
		staticText { enabled, "Anonymous" },
		{ 55, 220, 71, 340 },
		staticText { enabled, "Anonymous" },
		{ 80, 220, 96, 340 },
		staticText { enabled, "Anonymous" },
		{ 5, 90, 21, 300 },
		staticText { disabled, "Fastest Mine Sweepers" },
		{ 30, 10, 46, 105 },	/* 40 */
		staticText { disabled, "Beginner:" },
		{ 55, 10, 71, 105 },
		staticText { disabled, "Intermediate:" },
		{ 80, 10, 96, 105 },	/* 55 */
		staticText { disabled, "Expert:" },
		{ 30, 140, 45, 210 },
		staticText { enabled, "seconds" },
		{ 55, 140, 71, 210 },
		staticText { enabled, "seconds" },
		{ 80, 140, 96, 210 },
		staticText { enabled, "seconds" },
	}
};

resource 'DLOG' (rPlayer, "Player") {
	{100, 100, 213, 305},
	dBoxProc, invisible, noGoAway, 0x0, rPlayer, "Player"
};

resource 'DITL' (rPlayer, "Player") {
	{
		{ 83, 135, 103, 195 },
		button { enabled, "OK" },
		{0, 0, 0, 0},	/* OK button's default roundrect userItem  */
		UserItem {disabled},
		{ 353, 135, 373, 195 },
		button { enabled, "Cancel" },
		{ 55, 40, 70, 160 },
		editText { enabled, "Anonymous" },
		{ 5, 20, 21, 200 },
		staticText { disabled, "New High Score" },
		{ 30, 20, 46, 200 },
		staticText { disabled, "Enter your name:" },
	}
};

/* -------------------------- Used for Setdirectory -------------------------- */

resource 'DLOG' (rGetDirectory, "Get Directory", purgeable) {
	{0, 0, 217, 348},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	rGetDirectory,
	""
};

resource 'DITL' (rGetDirectory, "Get Directory", purgeable) {
	{	/* array DITLarray: 13 elements */
/* [1] */	{142, 256, 160, 336},	Button		{enabled,"Open"},
/* [2] */	{1152, 59, 1232, 77},	Button		{enabled,"Hidden"},
/* [3] */	{193, 256, 211, 336},	Button		{enabled,"Cancel"},
/* [4] */	{43, 232, 63, 347},		UserItem	{disabled},
/* [5] */	{72, 256, 90, 336},		Button		{enabled,"Eject"},
/* [6] */	{97, 256, 115, 336},	Button		{enabled,"Drive"},
/* [7] */	{43, 12, 189, 230},		UserItem	{enabled},
/* [8] */	{43, 229, 189, 246},	UserItem	{enabled},
/* [9] */	{128, 252, 129, 340},	UserItem	{disabled},
/* [10] */	{1044, 20, 1145, 116},	StaticText	{disabled,""},
/* [11] */	{167, 256, 185, 336},	Button		{enabled,"Directory"},
/* [12] */	{0, 30, 18, 215},		Button		{enabled,"Select Current Directory:"},
/* [13] */	{200, 20, 216, 246},	StaticText	{disabled,""}
	}
};

/* here is the quintessential MultiFinder friendliness device, the SIZE resource */

resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,				/* we can background; we don't currently, but our sleep value */
								/* guarantees we don't hog the Mac while we are in the background */
	multiFinderAware,			/* this says we do our own activate/deactivate; don't fake us out */
	backgroundAndForeground,	/* this is definitely not a background-only application! */
	getFrontClicks,				/* change this is if you want "do first click" behavior like the Finder */
	ignoreChildDiedEvents,		/* essentially, I'm not a debugger (sub-launching) */
	is32BitCompatible,			/* this app should not be run in 32-bit address space */
	isHighLevelEventAware,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	kPrefSize * 1024,
	kMinSize * 1024	
};
