/* The following constants are used to identify menus and their items. The menu IDs
   have an "m" prefix and the item numbers within each menu have an "i" prefix. */

#define	MSMenuProc		128		/* Windows MDEF */

#define	mApple			1000	/* Apple menu */
#define	iAbout			1

#define	mFile			1001	/* File menu */
#define iSavePict		1
#define iSound			3
#define iQuit			5

#define	mEdit			1002	/* Edit menu */
#define	iUndo			1
#define	iCut			3
#define	iCopy			4
#define	iPaste			5
#define	iClear			6

#define	mBMP			1003	/* BMP menu */
#define	iDouble			1

#define	mControl		2000
#define iRestore		1
#define iMove			2
#define iWinSize		3
#define iMinimize		4
#define iMaximize		5
#define iWinClose		7
#define iSwitchTo		8

#define	mWinFile		2001	/* Window's File menu */
#define iWinNew			1
#define iWinOpen		2
#define iWinMove		3
#define iWinCopy		4
#define iWinDelete		5
#define iProperties		6
#define iRun			8
#define iLogout			10

#define	mOptions		2002	/* Options menu */
#define iAutoArrange	1
#define iMinimizeOnUse	2
#define iSaveOnExit		3

#define	mWindow			2003	/* Window menu */
#define iCascade		1
#define iTile			2
#define iArrange		3
#define iMain			5
#define iMaxChild		(32 - iMain)

#define	mHelp			2004	/* Help menu */
#define iIndex			1
#define iKeyboard		2
#define iCommands		3
#define iProcedures		4
#define iGlossary		5
#define iUsingHelp		6
#define iAboutHelp		8

#define mMines			2005	/* Minesweeper menu */
#define iNew			1		/* New game. */
#define iBeginner		3		/* Game size. */
#define iIntermediate	4
#define iExpert			5
#define iCustom			6
#define iMarks			8		/* Allow question marks */
#define iTimes			10		/* Show best times */

#define mMineHelp		2006
#define iHowToPlay		1
#define iGameCommands	2
#define iGameHelp		3
#define iAboutMines		5

#define	mHelpFile		2010	/* Help File menu */
#define iHelpOpen		1
#define iHelpPrint		3
#define iHelpSetup		4
#define iHelpExit		6

#define	mHelpEdit		2011	/* Help File menu */
#define iHelpCopy		1
#define iHelpAnnotate	2

#define	mHelpBookmark	2012	/* Help File menu */
#define iHelpDefine		1

#define	mHelpHelp		2013	/* Help File menu */
#define iHelpHow		1
#define iHelpOnTop		2
#define iHelpAbout		4

#define	mAppleInx		0		/* Apple menu index */
#define	mFileInx		1		/* File menu index */
#define	mEditInx		2		/* Edit menu index */
#define	mBMPInx			3		/* BMP menu index */
#define	mControlInx		4		/* Control popup index */
#define kMenuCount		5

#define iOK				1		/* OK button */
#define iOKring			2		/* OK button 'default' ring */
#define iCancel			3		/* Cancel button */

#define rWindow			1000	/* Resource ID for main window */
#define rAboutMines		1000	/* Resource ID for About Mines box dialog. */
#define	rUserAlert		1001	/* Resource ID for error user alert */
#define rCustom 		1002	/* Resource ID for custom bounds dialog. */
#define iRows 			 	4
#define iCols 				5
#define iMines 				6
#define rBestTimes 		1003	/* Resource ID for best times dialog. */
#define iReset			 	3
#define iTime 			 	4
#define iPlayer 			7
#define rAbout 			1004	/* Resource ID for About Windows box dialog. */
#define rRegister 		1005	/* Resource ID for Registration box dialog. */
#define rPlayer 		1006	/* Resource ID for winning player dialog. */
#define iName 				4

// Misc Strings
#define rStrMisc		1008
#define iSFGetFolderMsg		1

// System errors
#define	rErrorAlert		1009	/* Resource ID for error user alert */
#define kUnsupportedMachine	1	/* Unsupported machine */
#define kNoMem				2	/* Not enough memory */
#define kNoColor			3	/* If no color QD, we must leave. */
#define kInitErr			4	/* Initialization error */

#define rGetDirectory	1030	/* Resource ID for sf get directory dialog. */

#define iHowToPlay		1
#define iGameCommands	2
#define iGameHelp		3

#define kHelpIcon		244

//	Help Text
#define kHelpMine		200		// Minesweeper Help
#define kHelpWhats		201		// What is Minesweeper?
#define kHelpMineMax	206		// Last Minesweeper Help
#define kHelpHelp		300		// How to Use Help
#define kHelpHelpMax	318		// Last How to Use Help
#define kHelpPM			400		// How to Use PM
#define kHelpPMMax		409		// Last How to Use PM

//	Sounds
#define kBaseSnd		10000
#define	sClick1				0
#define	sClick2				1
#define sFlag				2
#define sLose1a				3
#define sLose1b				4
#define sLose2a				5
#define sLose2b				6
#define sReset1				7
#define sReset2				8
#define sWin				9
#define sDone			   10
#define kSndCount		   11

//	PM Windows and Icons
#define	kMain					300
#define	kControlPanel			301
#define	kFileManager			302
#define	kDosPrompt				303
#define	kClipboard				304
#define	kPrintManager			305
#define	kTerminal				306

#define	kAccessories			310
#define	kNotepad				311
#define	kCalendar				312
#define	kPaintbrush				313
#define	kCalculator				314
#define	kCardfile				315
#define	kClock					316

#define	kGames					320
#define kMinesweeper			321
#define kSolitare				322
#define kReversi				323

#define kInfo				0
#define	kCaution			1
#define	kError				2
#define	kYesNo				3
#define kGameAction			4
#define kWindowAction		5
#define kLaunch				6
#define kLaunchDoc			7

#define kMaxOkBox			3

//	Windows Errors
#define	rTitleStr			128
#define	rTextStr			129
#define	kNoErr				0
#define	kBadPath			1
#define	kBadDir				2
#define	kLostPath			3
#define	kAppClockErr		4
#define	kUAEError			5
#define	kAssocError			6
#define	kNoMemError			7
#define	kNot3Error			8
#define	kNoComm				9
#define	kDrWatson			10
#define	kChangedMsg			11
#define	kNoQueue			12
#define	kHelpMsg			13
#define	kExitMsg			14
#define	kNeedSys7Msg		15
#define	kTooManyChildren	16

//	The Minesweeper Game score
#define	rScoreType			'Scor'
#define	rScore				1000


/*	1.01 - kTopLeft - This is for positioning the Disk Initialization dialogs. */

#define kDITop					0x0050
#define kDILeft					0x0070

/*	1.01 - kMinHeap - This is the minimum result from the following
	equation:
		
		ORD(GetApplLimit) - ORD(ApplicZone)
		
	for the application to run. It will insure that enough memory will
	be around for reasonable-sized scraps, FKEYs, etc. to exist with the
	application, and still give the application some 'breathing room'.
	To derive this number, we ran under a MultiFinder partition that was
	our requested minimum size, as given in the 'SIZE' resource. */
	 
#define kMinHeap				21 * 1024
	
/*	1.01 - kMinSpace - This is the minimum result from PurgeSpace, when called
	at initialization time, for the application to run. This number acts
	as a double-check to insure that there really is enough memory for the
	application to run, including what has been taken up already by
	pre-loaded resources, the scrap, code, and other sundry memory blocks. */
	 
#define kMinSpace				400 * 1024

#define kMinSize	1024			/* application's minimum size (in K) */
#define kPrefSize	1224			/* application's preferred size (in K) */

/* kSysEnvironsVersion is passed to SysEnvirons to tell it which version of the
   SysEnvRec we understand. */

#define	kSysEnvironsVersion		1

/* kOSEvent is the event number of the suspend/resume and mouse-moved events sent
   by MultiFinder. Once we determine that an event is an osEvent, we look at the
   high byte of the message sent to determine which kind it is. To differentiate
   suspend and resume events we check the resumeMask bit. */

#define	kOSEvent				app4Evt	/* event used by MultiFinder */
#define	kSuspendResumeMessage	1		/* high byte of suspend/resume event message */
#define	kResumeMask				1		/* bit of message field for resume vs. suspend */
#define	kMouseMovedMessage		0xFA	/* high byte of mouse-moved event message */
#define	kNoEvents				0		/* no events mask */

/* kExtremeNeg and kExtremePos are used to set up wide open rectangles and regions. */

#define kExtremeNeg				-32768
#define kExtremePos				32767 - 1 /* required to address an old region bug */

/* these #defines are used to set enable/disable flags of a menu */

#define AllItems	0b1111111111111111111111111111111	/* 31 flags */
#define NoItems		0b0000000000000000000000000000000
#define MenuItem1	0b0000000000000000000000000000001
#define MenuItem2	0b0000000000000000000000000000010
#define MenuItem3	0b0000000000000000000000000000100
#define MenuItem4	0b0000000000000000000000000001000
#define MenuItem5	0b0000000000000000000000000010000
#define MenuItem6	0b0000000000000000000000000100000
#define MenuItem7	0b0000000000000000000000001000000
#define MenuItem8	0b0000000000000000000000010000000
#define MenuItem9	0b0000000000000000000000100000000
#define MenuItem10	0b0000000000000000000001000000000
#define MenuItem11	0b0000000000000000000010000000000
#define MenuItem12	0b0000000000000000000100000000000

/*
**	Dialog layout constants
*/

#define kIconSize			32				/* Standard icon size */

#define kSpaceStd			13				/* White space between most elements */
#define kSpaceIcon			23				/* White space to left & right of icon */
#define kInsetStd		(kSpaceStd-3)		/* Standard white space inset */
#define kInsetIcon		(kSpaceIcon-3)		/* White space inset of icon */

#define kLineHeight			16				/* height of a single line of Chicago-12 */
#define kButtonHeight		20				/* standard button height */
#define kCancelLen			41				/* width of 'Cancel' in Chicago-12 */
#define kContinueLen		62				/* width of 'Connect' in Chicago-12 */
#define kCancelWidth	(kCancelLen+18)		/* Cancel button width */
#define kButtonWidth	kCancelWidth		/* standard button width */
#define kContinueWidth	(kContinueLen+18)	/* 'Continue' button width */
#define kEditBoxHeight	0	/** (kButtonHeight - kLineHeight)	/* extra text edit box height */


/*
**	Generic Dialog Box definitions
*/

#define kButtonTop			(kDialogItemsBottom + kSpaceStd)
#define kButtonBottom		(kButtonTop + kButtonHeight)

#define kOkButtonRight		(kDialogWidth - kInsetStd)
#define kOkButtonLeft		(kOkButtonRight - kButtonWidth)
#define k2ButtonRight		(kOkButtonLeft - kSpaceStd)
#define k2ButtonLeft		(k2ButtonRight - kButtonWidth)
#define k3ButtonRight		(k2ButtonLeft - kSpaceStd)
#define k3ButtonLeft		(k3ButtonRight - kButtonWidth)

#define kDialogHeight		(kButtonBottom + kInsetStd)
#define kMsgHeight			(kDialogItemsBottom + kInsetStd)

/*
**	Alert Box definition
*/

#define kAlertIconLeft		kInsetIcon
#define kAlertIconRight		(kAlertIconLeft+kIconSize)
#define kAlertIconTop		kInsetStd
#define kAlertIconBottom	(kAlertIconTop+kIconSize)

#define kAlertTextLeft		(kAlertIconRight + kSpaceIcon - 1)
#define kAlertTextRight		(kDialogWidth - kInsetStd)

#define kQuitButtonRight (kDialogWidth - kInsetStd)
#define kQuitButtonLeft	(kQuitButtonRight - kContinueWidth)


/*
**	Message Box definition
*/

#define kMsgTextLeft		(2*kInsetStd)
#define kMsgTextRight		(kDialogWidth - kMsgTextLeft)
#define kMsgTextTop			kInsetStd
#define kMsgTextBottom		(kMsgTextTop + (kTextLines * kLineHeight))

#define kMsgOkRight			(kDialogWidth - kInsetStd)
#define kMsgOkLeft			(kMsgOkRight - kButtonWidth)
#define kMsgCancelRight		(kMsgOkLeft - kSpaceStd)
#define kMsgCancelLeft		(kMsgCancelRight - kButtonWidth)

#define kDialogItemsBottom	kMsgTextBottom
