#include <Finder.h>
#include <Processes.h>
#include <AppleEvents.h>
#include <Aliases.h>
#include <Memory.h>
#include <GestaltEqu.h>
#include <StandardFile.h>
#include <SysEqu.h>
#include <Errors.h>
#include "MSWindows.h"
#include "Icons.h"
#include "SignatureToApp.h"

char *pStrcat(char *s,char *t);
char *pStrcpy(char *s,char *t);
char *PathNameFromDirID(long DirID,short vRefNum,char *s);
char *PathNameFromWD(short vRefNum,char *s);
Boolean doGetDirectory(long *dirID, short *vRefNum, StringPtr name);

OSErr GetTargetAddress(Str255 prompt,Str255 appStr,PortInfoRec *myPortInfo,
						AEAddressDesc *targetAddress,TargetID *toTargetID);
OSErr SendODOC(AEAddressDesc *targetAddress,AliasHandle targetFile);


extern MSWindowPtr	gPMWindow;
extern MSChildPtr	gPMChild;
extern ChildParams	gPMChildParams;

SFReply			reply;			/* used in all SF samples */
SFTypeList		typeList;		/* typelist for all SF samples */
OSErr			err;			/* used in all OS calls */
Point			gLocation = {0x40,0x40};

Handle			hBuffer, hMatches;

#define firstTime		-1		/* the first time our hook is called, it is passed a -1 */
#define kOptBufferSize	0x4000

#define fHasCustomIcon	0x400

/* for SetDirectory sample */
long			MyCurDir;
Boolean			CurDirValid;


PicHandle IconToPict7(short iconID)
{
	GrafPtr		thePort;
	PicHandle	thePict = nil;
	Rect		rect;

	SetRect(&rect, 0, 0, kIconSize, kIconSize);
	GetPort(&thePort);
	thePict = OpenPicture(&rect);
	if (thePict != nil) {
		PlotIconID(&rect,0,0,iconID);
		ClosePicture();
	}
	return(thePict);
}

PicHandle IconToPict6(Handle icon)
{
	GrafPtr		orgPort;
	GrafPort	tempPort;
	BitMap		aBitMap;
	PicHandle	thePict;
	Rect		rect;
	
	SetRect(&rect, 0, 0, kIconSize, kIconSize);
	GetPort(&orgPort);
	OpenPort(&tempPort);
	ClipRect(&rect);
	HLock(icon);
	aBitMap.baseAddr = *icon;
	aBitMap.rowBytes = 4;
	aBitMap.bounds = rect;
	thePict = OpenPicture(&rect);
	if (thePict != nil) {
		CopyBits(&aBitMap,&tempPort.portBits, &aBitMap.bounds, &rect, srcCopy, nil);
		ClosePicture();
	}
	HUnlock(icon);
	ClosePort(&tempPort);
	SetPort(orgPort);
	return(thePict);
}

Boolean SupportsFileLaunch(void)
{
	long	attrib;
	Boolean	result = false;

	if ((Gestalt(gestaltOSAttr,&attrib) == noErr) &&
		(attrib && (1 << gestaltLaunchFullFileSpec)))
		result = true;
	return(result);
}

void doLaunchApp(FSSpec *launchApp)
{
	LaunchParamBlockRec	myPB;
	
	myPB.launchBlockID = extendedBlock;
	myPB.launchEPBLength = extendedBlockLen;
	myPB.launchFileFlags = 0;
	myPB.launchControlFlags = launchContinue + launchNoFileFlags;
	myPB.launchAppSpec = launchApp;
	myPB.launchAppParameters = nil;
	
	LaunchApplication(&myPB);
}

/* based on LaunchWithDoc, by C.K. Haun --- Apple DTS */
/* file spec for the app (launchApp) and the file (fileToLaunch) */
void doLaunchFile(FSSpecs *launch)
{
    LaunchParamBlockRec launchThis;
	ProcessSerialNumber myPSN, targetPSN;
	OSErr			myErr;
    AEDesc			myAddress;
	AEAddressDesc	targetAddress;
    AEDesc			launchDesc;
    AEDesc			docDesc;
    AEDescList		theList;
    AliasHandle		aliasTarget;
    AppleEvent		theEvent;
	Boolean			launched;
	LaunchFlags		launchControlFlags;

	launchControlFlags = launchContinue + launchNoFileFlags;// + launchDontSwitch;
if (false) {	// it didn't work in time for the BMUG TV-ROM
	/* look for a running process */
	SignatureToApp(	
			launch->fInfo.fdCreator,// Signature of app
			&targetPSN,				// Returns PSN of app (ignored if NULL)
			&launch->app,			// Returns location of app (ignored if NULL)
			&launched,				// Set to TRUE if I had to launch (ignored if NULL)
			Sig2App_FindProcess,	// Mode -- find proc/find app/launch app
			launchControlFlags);	// Launch control flags; see Process Mgr

	if (!((targetPSN.highLongOfPSN == 0) &&
		(targetPSN.lowLongOfPSN == kNoProcess))) {
		
		myErr = AECreateDesc(
			typeProcessSerialNumber,	/* Standard PSN descriptor type. */
			(Ptr)&targetPSN,			/* "No ePPC" process serial #.	 */
			sizeof(targetPSN),			/* Size of data (2 longs).		 */
			&targetAddress				/* Wherefore art thou desc.		 */
		);
		if (err == noErr) {
			myErr = NewAlias(nil,&launch->file,&aliasTarget);
			if (err == noErr) {
				err = SendODOC(&targetAddress,aliasTarget);
			}
		}
		err = AEDisposeDesc(&targetAddress);
		DisposHandle((Handle)aliasTarget);
	}
}
	if (launch->app.parID == nil) {
		SignatureToApp(	
				launch->fInfo.fdCreator,// Signature of app
				&targetPSN,				// Returns PSN of app (ignored if NULL)
				&launch->app,			// Returns location of app (ignored if NULL)
				&launched,				// Set to TRUE if I had to launch (ignored if NULL)
				Sig2App_FindApplication,// Mode -- find proc/find app/launch app
				launchControlFlags);	// Launch control flags; see Process Mgr
	}

    launchThis.launchAppSpec = &launch->app;
    
	/* Preset our address descriptor to our PSN */
	GetCurrentProcess(&myPSN);

	/* create the address desc for the event */
    myErr = AECreateDesc(typeProcessSerialNumber, (Ptr)&myPSN, sizeof(ProcessSerialNumber), &myAddress);

    /* create an appleevent to open the file */
    AECreateAppleEvent(kCoreEventClass, kAEOpenDocuments, &myAddress, kAutoGenerateReturnID, kAnyTransactionID, &theEvent);

    /* create a list for the alaises  */
    AECreateList(nil, 0, false, &theList);

    /* create an alias out of the file spec */
    NewAlias(nil, &launch->file, &aliasTarget);

    /* now create an alias descriptor */
    HLock((Handle)aliasTarget);
    AECreateDesc(typeAlias, (Ptr)*aliasTarget, GetHandleSize((Handle)aliasTarget), &docDesc);
    HUnlock((Handle)aliasTarget);

    /* put it in the list */
    AEPutDesc(&theList, 0, &docDesc);
    AEPutParamDesc(&theEvent, keyDirectObject, &theList);

    /*  If you just want to send an 'odoc' to an application that is */
    /* already running, you can stop here and do an AESend on theEvent */
    /* coerce the event from being an event into being appParms */
    AECoerceDesc(&theEvent, typeAppParameters, &launchDesc);
    HLock((Handle)theEvent.dataHandle);

    /* and stuff it in the parameter block */
    launchThis.launchAppParameters = (AppParametersPtr)*(launchDesc.dataHandle);

    /* launch the thing */
    launchThis.launchBlockID = extendedBlock;
    launchThis.launchEPBLength = extendedBlockLen;
    launchThis.launchFileFlags = nil;
    launchThis.launchControlFlags = launchControlFlags;
    LaunchApplication(&launchThis);

	/* cleanup */
return;	// ???
	err = AEDisposeDesc(&theEvent);
	err = AEDisposeDesc(&myAddress);
	DisposHandle((Handle)aliasTarget);
	err = AEDisposeDesc(&theList);
	err = AEDisposeDesc(&docDesc);
	err = AEDisposeDesc(&launchDesc);
}

Boolean SupportsCatSearch(short vRefNum)
{
	long	attrib;
	Boolean	result = false;
	HIOParam	myHPB;
	GetVolParmsInfoBuffer infoBuffer;

	if ((Gestalt(gestaltFSAttr,&attrib) == noErr) &&
		(attrib && (1 << gestaltFullExtFSDispatching))) {
		myHPB.ioNamePtr = nil;
		myHPB.ioVRefNum = vRefNum;
		myHPB.ioBuffer = (Ptr)&infoBuffer;
		myHPB.ioReqCount = sizeof(infoBuffer);
		if ((PBHGetVolParms((HParmBlkPtr)&myHPB, false) == noErr) &&
			(infoBuffer.vMAttrib & (1 << bHasCatSearch)))
			result = true;
	}
	return(result);
}

PicHandle getIconPict(FSSpecs *pRefCons, short myFile)
{
	FSSpec		*pResFile;
	short		iconResID, inx, resFile;
	Handle		tHandle;
	Boolean		launched;
	Boolean		closeit;
	LaunchFlags	launchControlFlags;
	Handle		hIcon = 0;
	PicHandle	hPict = 0;
	ResType		resType;
	Str63		resName;

	pResFile = &pRefCons->file;
	if (pRefCons->fInfo.fdType != 'APPL') {

		launchControlFlags = launchContinue + launchNoFileFlags;
		SignatureToApp(	
				pRefCons->fInfo.fdCreator,// Signature of app
				nil,					// Returns PSN of app (ignored if NULL)
				&pRefCons->app,			// Returns location of app (ignored if NULL)
				&launched,				// Set to TRUE if I had to launch (ignored if NULL)
				Sig2App_FindApplication,// Mode -- find proc/find app/launch app
				launchControlFlags);	// Launch control flags; see Process Mgr

		tHandle = *(Handle *)TopMapHndl;
	
		SetResLoad(false);
		resFile = FSpOpenResFile(pResFile,0);
		SetResLoad(true);
		closeit = (tHandle != *(Handle *)TopMapHndl);
	
		if ((resFile != -1) && (resFile != myFile)) {
			iconResID = kCustomIconResource;
			hIcon = Get1Resource('ICN#', iconResID);
			if (hIcon) {
				GetResInfo(hIcon, &iconResID, &resType, resName);
				hPict = IconToPict7(iconResID);
			}
		}
		if (closeit)
			CloseResFile(resFile);
		else
			UseResFile(myFile);	// it was open, make mine current
		if (hPict)
			return(hPict);		// found one, so done

		pResFile = &pRefCons->app;
	}
	
/* Check the current value of TopMapHndl, open the resource file, and */
/* check it again. If it changed, then note that we should close this */
/* file later when we are done with it. */
	tHandle = *(Handle *)TopMapHndl;

	SetResLoad(false);
	resFile = FSpOpenResFile(pResFile,0);
	SetResLoad(true);
	closeit = (tHandle != *(Handle *)TopMapHndl);

	if ((resFile != -1) && (resFile != myFile)) {

		inx = 1;
		iconResID = 128;	// set a default #
		/* search for the FREF for my file type */
		while (hIcon = Get1IndResource('FREF',inx++)) {
			if (**(long**)hIcon == pRefCons->fInfo.fdType) {
				GetResInfo(hIcon, &iconResID, &resType, resName);
				break;
			}
		}
		hIcon = Get1Resource('ICN#', iconResID);

		if ((hIcon == nil) &&
			(pRefCons->fInfo.fdType == 'APPL')) {
			if (iconResID != 128)
				hIcon = Get1Resource('ICN#', 128); // try in the normal location
			if (hIcon == nil)
				hIcon = Get1IndResource('ICN#', 1);	// try anywhere
			if (hIcon == nil)
				hIcon = Get1IndResource('cicn', 1);	// just find something
			if (hIcon == nil)
				hIcon = GetResource('ICN#', 12999);	// find my default one
		}
		if (hIcon) {
			GetResInfo(hIcon, &iconResID, &resType, resName);
			hPict = IconToPict7(iconResID);
		}
	}
	if (closeit)
		CloseResFile(resFile);
	else
		UseResFile(myFile);	// it was open, make mine current
	return (hPict);
}

void doCatSearch(void)
{
	short		i;
	OSErr		myErr;
	short		myVRefNum;			// volume to search
	long		myDirID;			// ignored directory ID for HGetVol
	CSParam		myPB;				// for PBCatSearch
	FSSpec		*pMatch;			// a result file spec
	FSSpecs		*pRefCons;			// refcons to launch
	Handle		hRefCons;
	short		myFile;
	short		iconCnt;
	HFileInfo	mySpec1;
	HFileInfo	mySpec2;
	HFileInfo	fInfo;
	Ptr			p1, p2;
	PicHandle	hPict, hPict2;
	MSChildPtr	MSChild = nil;
	Str63		dirName;

	if (hBuffer == nil) {
		hBuffer = NewHandleClear(kOptBufferSize);
		MoveHHi(hBuffer);  HLock(hBuffer);
		hMatches = NewHandleClear(kMaxChildIcons * sizeof(FSSpec));
		MoveHHi(hMatches);  HLock(hMatches);  
	}
	
	myErr = HGetVol(nil, &myVRefNum, &myDirID);		// search the default volume

	if (doGetDirectory(&myDirID, &myVRefNum, &dirName)) {
		if (!SupportsCatSearch(myVRefNum)) {
			DoMSAlert(kInfo, kNeedSys7Msg);
			return;
		}
	} else
		return;

	myPB.ioCompletion = nil;
	myPB.ioNamePtr = nil;
	myPB.ioVRefNum = myVRefNum;
	myPB.ioReqMatchCount = kMaxChildIcons;
	myPB.ioSearchBits = fsSBFlAttrib + fsSBFlParID;
	if (false)	// to check for 'APPL' only
		myPB.ioSearchBits += fsSBFlFndrInfo;
	myPB.ioSearchInfo1 = (CInfoPBPtr)&mySpec1;
	myPB.ioSearchInfo2 = (CInfoPBPtr)&mySpec2;
	myPB.ioSearchTime = 0;
	myPB.ioCatPosition.initialize = 0;
	myPB.ioOptBuffer = *hBuffer;
	myPB.ioOptBufSize = kOptBufferSize;
	
	p1 = (Ptr)&mySpec1; p2 = (Ptr)&mySpec2;
	for (i = 0; i < sizeof(HFileInfo); i++) {
		*p1++ = 0x00; *p2++ = 0x00;
	}
	mySpec1.ioNamePtr = nil;
	mySpec1.ioFlAttrib = 0x00;
	mySpec1.ioFlFndrInfo.fdType = 'APPL';
	mySpec1.ioFlParID = myDirID;			/* match this directory */

	mySpec2.ioNamePtr = nil;
	mySpec2.ioFlAttrib = 0x10;				/* search for files, only */
	mySpec2.ioFlFndrInfo.fdType = -1;		/* the type of the file mask */
	mySpec2.ioFlParID = myDirID;

	iconCnt = kMaxChildIcons;
	myFile = CurResFile();
	do {
		// save each set of FSSpecs we find to use later for launching
		pMatch = (FSSpec*)*hMatches;
		hRefCons = NewHandleClear(kMaxChildIcons * sizeof(FSSpecs));
		MoveHHi(hRefCons);  HLock(hRefCons);  pRefCons = (FSSpecs*)*hRefCons;
		myPB.ioMatchPtr = (FSSpecArrayPtr)pMatch;
		
		myErr = PBCatSearchSync(&myPB);
		if ((myErr == noErr) || (myErr == eofErr)) {
			for (i = 0; i < myPB.ioActMatchCount; i++) {
				fInfo.ioCompletion = nil;
				fInfo.ioNamePtr = pMatch->name;
				fInfo.ioVRefNum = pMatch->vRefNum;
				fInfo.ioDirID = pMatch->parID;
				fInfo.ioFDirIndex = 0;
				PBGetCatInfo((CInfoPBPtr)&fInfo,false);
				pRefCons->fInfo = fInfo.ioFlFndrInfo;

				if (!(pRefCons->fInfo.fdFlags & fInvisible)) {
					pRefCons->file = *pMatch;
					hPict = getIconPict(pRefCons, myFile);
					if (hPict) {
						iconCnt++;
						if (kMaxChildIcons <= iconCnt) {
							if (MSChild) {
								SizeMSWindow(MSChild,true);
								BringChildFront((WindowPtr)gPMWindow,MSChild,
											MSChild->origin,false);
							}
							hPict2 = (PicHandle)GetResource('PICT', kMain);
							DetachResource((Handle)hPict2);
							AddPict(gPMChildParams.iconID, (Handle)hPict2, dirName);
							MSChild = AddPMChild(gPMChild, dirName);
							iconCnt = 0;
						}
						AddPict(gPMChildParams.iconID, (Handle)hPict, pMatch->name);
						AddPMIcon(gPMChild, MSChild, 
							(pRefCons->fInfo.fdType == 'APPL') ? kLaunch : kLaunchDoc,
							(long)pRefCons );
						pRefCons++;
					}
				}
				pMatch++;
			}
		}
	} while (myErr != eofErr);
	if (MSChild) {
		SizeMSWindow(MSChild,true);
		BringChildFront((WindowPtr)gPMWindow,MSChild,MSChild->origin,false);
	}
}

/** pStrcat / pStrCpy *********************************************************/
/*
/*	A couple of utility routines. C is thoughtless enough to not really 
/*	support P-strings. In order to perform string copies and concatenations,
/*	I have to use these routines.
/*
/******************************************************************************/

char *pStrcat(s,t)
	unsigned char *s, *t;
{
	unsigned char *s2;
	short tLen;

	s2 = s + *s;
	*s += (tLen = *t);
	for (++tLen; --tLen; s2[tLen] = t[tLen]);
	return (s);
}

char *pStrcpy(s,t)
	unsigned char *s, *t;
{
	short	tLen;

	for (tLen = *t + 1; tLen--; s[tLen] = t[tLen]);
	return (s);
}


/** PathNameFromDirID *********************************************************/
/*
/*	Given a DirID and real vRefnum, this routine will create and return the
/*	full pathname that corresponds to it. It does this by calling PBGetCatInfo
/*	for the given directory, and finding out its name and the DirID of its
/*	parent. It the performs the same operation on the parent, sticking ITS
/*	name onto the beginning of the first directory. This whole process is
/*	carried out until we have processed the root directory (identified with
/*	a DirID of 2.
/*
/******************************************************************************/

char *PathNameFromDirID(DirID, vRefNum, s)
	long	DirID;
	short	vRefNum;
	char	*s;
{
	CInfoPBRec	block;
	Str255		directoryName;

	*s = 0;
	block.dirInfo.ioNamePtr = &directoryName;
	block.dirInfo.ioDrParID = DirID;

//	do {
		block.dirInfo.ioVRefNum = vRefNum;
		block.dirInfo.ioFDirIndex = -1;
		block.dirInfo.ioDrDirID = block.dirInfo.ioDrParID;

		err = PBGetCatInfo(&block,false);

		/* **don't** Append a Macintosh style colon (':') */
		pStrcat(&directoryName,"\p");	// was "\p:"
		pStrcat(&directoryName,s);
		pStrcpy(s,&directoryName);
//	} while (block.dirInfo.ioDrDirID != 2);

	return(s);
}


/** PathNameFromWD ************************************************************/
/*
/*	Given an HFS working directory, this routine returns the full pathname
/*	that corresponds to it. It does this by calling PBGetWDInfo to get the
/*	VRefNum and DirID of the real directory. It then calls PathNameFromDirID,
/*	and returns its result.
/*
/******************************************************************************/

char *PathNameFromWD(vRefNum,s)
	long	vRefNum;
	char	*s;
{

	WDPBRec	myBlock;

	myBlock.ioNamePtr = nil;
	myBlock.ioVRefNum = vRefNum;
	myBlock.ioWDIndex = 0;
	myBlock.ioWDProcID = 0;

	/* Change the Working Directory number in vRefnum into a real vRefnum */
	/* and DirID. The real vRefnum is returned in ioVRefnum, and the real */
	/* DirID is returned in ioWDDirID. */

	PBGetWDInfo(&myBlock,false);

	return(PathNameFromDirID(myBlock.ioWDDirID,myBlock.ioWDVRefNum,s));
};


/** doGetDirectory ************************************************************/
/*
/*	Shows how to modify SFGetFile to allow you to select a directory. This
/*	mimics the "GetFileName -d" function of MPW. As a matter of fact, the
/*	DLOG and DITL used in this sample are taken directly out of MPW.
/*
/*	There are 2 major additions in the dialog used in this sample:
/*		- a Simple button that lets one select the directory that is
/*			currently highlighted in the list of directories,
/*		- a Simple button at the top of the dialog that lets the user select
/*			the directory that we are currently *IN*.
/*
/*	No new techniques are really used in this sample. Hits on the two simple
/*	buttons are handled by a dlgHook called MyGetDirHook. Depending on
/*	which button is hit, we set the global variable MyCurDir to either
/*	reply.fType (for the currently highlighted directory) or CurDirStore^ (for
/*	the directory that we are currently in). We then simulate a hit on the
/*	Cancel button so that Standard File will return to our application.
/*
/*	However, when we get back to our application, there is no way for it to
/*	determine if we simulated a click on the Cancel Button, or if the user
/*	actually clicked on it; reply.good will be FALSE in either case. So we also
/*	set the value of global variable CurDirValid to TRUE if we only simulated
/*	a click on Cancel.
/*
/*	We also use the "Item== -1" feature to set up a prompt string and init-
/*	alize the value of CurDirValid to FALSE.
/*
/******************************************************************************/
pascal short MyGetDirHook(item, dPtr)
	short		item;
	DialogPtr	dPtr;
{
/* Equates for the items that I've added */
#define getDirButton 11
#define getDirNowButton 12
#define getDirMessage 13

	Str255	messageTitle;
	short	kind;
	Handle	h;
	Rect	r;

	switch (item) {
		case firstTime:

			/* Read in the prompt string from the resource fork, and initialize */
			/* CurDirValid to FALSE. */

			GetIndString(&messageTitle,rStrMisc,iSFGetFolderMsg);
			GetDItem(dPtr,getDirMessage,&kind,&h,&r);
			SetIText(h,&messageTitle);
			CurDirValid = false;
			break;
		case getDirButton:
			if (reply.fType != 0) {
				MyCurDir = reply.fType;
				CurDirValid = true;
				return(getCancel);
			};
			break;
		case getDirNowButton:
			MyCurDir = *(long *)CurDirStore;
			CurDirValid = true;
			return(getCancel);
	};
	return(item);	/* By default, return the item passed to us. */
};


pascal Boolean FoldersOnly(p)
	ParmBlkPtr p;
{
	/* Normally, folders are ALWAYS shown, and aren't even passed to		*/
	/* this file filter for judgement. Under such circumstances, it is		*/
	/* only necessary to blindly return TRUE (allow no files whatsoever).	*/
	/* However, Standard File is not documented in such a manner, and		*/
	/* this feature may not be TRUE in the future. Therefore, we DO check	*/
	/* to see if the entry passed to us describes a file or a directory.	*/

	if ((p->fileParam.ioFlAttrib & 0x10) != 0)
		return(false);
	return(true);
};

Boolean doGetDirectory(long *dirID, short *vRefNum, StringPtr name)
{
	SFPGetFile(gLocation,	/* location */
		"\pSpace for Rent",	/* vestigial string */
		FoldersOnly,		/* fileFilter */
		-1,					/* numtypes; -1 means all */
		&typeList,			/* array to types to show */
		MyGetDirHook,		/* dlgHook */
		&reply,				/* record for returned values */
		rGetDirectory,
		nil);

	if (CurDirValid) {
		*vRefNum = -*(short *)SFSaveDisk;
		*dirID = MyCurDir;
		PathNameFromDirID(*dirID, *vRefNum, name);
		return(true);
	} else
		return(false);
};
