/*	open document snippet
	Steven Falkenburg 10/2/91
	
	This sample sends an 'odoc' event to a specified running application
	
	11/16/92 fixed bug in blockmoving target ID name (was moving too much data)
*/

#include <PPCToolBox.h>
#include <AppleEvents.h>
#include <Aliases.h>

OSErr GetTargetAddress(Str255 prompt,Str255 appStr,PortInfoRec *myPortInfo,
						AEAddressDesc *targetAddress,TargetID *toTargetID);
OSErr SendODOC(AEAddressDesc *targetAddress,AliasHandle targetFile);

PortInfoRec portInfo;
AEAddressDesc targetAddress;
TargetID targetID;
OSErr err;
	
	
OSErr GetTargetAddress(Str255 prompt,Str255 appStr,PortInfoRec *myPortInfo,
						AEAddressDesc *targetAddress,TargetID *toTargetID)
{
	OSErr err;
	
	err = PPCBrowser(prompt,appStr,false,&toTargetID->location,myPortInfo,nil,"\p");
	if (err==noErr) {
		toTargetID->name = myPortInfo->name;
		err = AECreateDesc(typeTargetID,(Ptr)toTargetID,sizeof(TargetID),targetAddress);
	}
	
	return err;
}


OSErr SendODOC(AEAddressDesc *targetAddress,AliasHandle targetFile)
{
	OSErr		err;
	AppleEvent	theAE;
	AppleEvent	reply;
	AEDescList	descList;
	
	reply.dataHandle = nil;
	
	err = AECreateAppleEvent(kCoreEventClass,kAEOpenDocuments,targetAddress,
				kAutoGenerateReturnID,kAnyTransactionID,&theAE);
	if (err!=noErr)
		return err;
	
	err = AECreateList(nil,0,false,&descList);
	if (err!=noErr)
		return err;
	
	HLock((Handle)targetFile);
	err = AEPutPtr(&descList,0,typeAlias,(Ptr)*targetFile,sizeof(AliasHandle)+(**targetFile).aliasSize);
	HUnlock((Handle)targetFile);
	if (err!=noErr)
		return err;
	
	err = AEPutParamDesc(&theAE,keyDirectObject,&descList);
	if (err!=noErr)
		return err;
	
	err = AESend(&theAE,&reply,kAENoReply,kAENormalPriority,kAEDefaultTimeout,nil,nil);

	AEDisposeDesc(&descList);
	AEDisposeDesc(&theAE);
	if (reply.dataHandle)
		AEDisposeDesc(&reply);

	return err;
}

