/* START OF FILE: Physical_File_Mapping.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Physical_File_Mapping.c - Routines to support Poor Man's Video Phone
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Physical_File_Mapping.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Physical_File_Mapping

#define _H_Physical_File_Mapping
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */



	typedef struct {
		CARDINAL_32	extent_Byte_Location;
		CARDINAL_32	extent_Byte_Range;
	} Extent_Record, *Extent_Ptr, **Extent_Hdl;
	
	typedef struct {
		Safe_Boolean		initialized;
		INTEGER_16		driver_Reference;
		CARDINAL_32	physical_File_Size;
		CARDINAL_32	logical_File_Size;
		CARDINAL_32	start_Block_Byte;
		CARDINAL_32	drive_Number;
		CARDINAL_32	volume_Allocation_Block_Size;
		CARDINAL_32	volume_Allocation_Block_Offset;
		CARDINAL_32	file_Allocation_Clump_Size;
		CARDINAL_32	file_B_Tree_Clump_Block_Ptr;
		VCB				*volume_Control_Block_Ptr;
		Safe_Boolean		every_Extent_Mapped_Already;
		CARDINAL_32	total_Extents_Mapped;
		CARDINAL_32	extent_Byte_Location_1;
		CARDINAL_32	extent_Byte_Range_1;
		CARDINAL_32	extent_Byte_Location_2;
		CARDINAL_32	extent_Byte_Range_2;
		Extent_Hdl			all_Extents_Mapped_Hdl;
		Memory_Allocation	all_Extents_Mapped_Memory_Initialized;
	} Map_Info_Rec, *Map_Info_Ptr;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Physical_File_Mapping(void);

extern Safe_Boolean Destroy_Physical_File_Mapping(void);

extern Safe_Boolean Clear_File_Map_Information_Block(Map_Info_Ptr file_Map);

extern Safe_Boolean Start_Mapping_File_Location(INTEGER_16 file_Reference, Map_Info_Ptr file_Map);

extern Safe_Boolean Map_Entire_File_Location(INTEGER_16 file_Reference
													, Map_Info_Ptr file_Map
													, Safe_Boolean	store_Data_In_System_Heap);

extern Safe_Boolean Calculate_Drive_Offset(Map_Info_Ptr file_Map
									, CARDINAL_32 data_Start_Offset
									, CARDINAL_32 *actual_Drive_Offset);

extern Safe_Boolean Destroy_File_Map_Information_Block(Map_Info_Ptr file_Map);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Physical_File_Mapping.h */