/* START OF FILE: Automatic_Dialogs.h */


/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-12, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-12, Tabs = 6]
 ** =======================================================================
 ** Skeleton v1.0, Skeleton is an application program that does nothing.
 ** Written by Jim Wolff, and Jim Merkle
 ** Automatic_Dialogs.h - Header file for Automatic_Dialogs.c
 ** current version (C) Copyright 1993 James Merkle
 ** =======================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 ** SEE NS_Shell_Main.c for revision history and version number.
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */


/*=**************************************************************************=*/
#ifndef _H_Automatic_Dialogs

#define _H_Automatic_Dialogs
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */


#include "Shell_Globals.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */

/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

typedef enum {
	character_Field,
	string_Field,
	boolean_Field,
	byte_Field,
	integer_Field,
	longint_Field,
	real_Field
} Field_Kind;

typedef struct {
	INTEGER_16		item_Hit;
	Boolean			dialog_Done;
	DialogPtr			dialog_Window;
	
	/* your stuff follows here in the physical record (in memory) */
	
} Item_Variables_Header, *Item_Variables_Header_Ptr, *Item_Variables_Ptr;

typedef struct {
	Boolean	enabled;
	void		 (*action_Function)(...);
} Button_Item, *Button_Item_Ptr;

typedef struct {
	Boolean	checked;
	Boolean	enabled;
	void		 (*action_Function)(...);
} Boolean_Item, *Boolean_Item_Ptr;

typedef struct {
	INTEGER_32	value;
	Boolean		enabled;
	void			 (*action_Function)(...);
} Control_Item, *Control_Item_Ptr;

typedef struct {
	Str255			edit_String;
	INTEGER_16	edit_String_Edit_Length;
	Field_Kind	edit_Field_Type;
	Boolean		enabled;
} Edit_Text_Item, *Edit_Text_Item_Ptr;

typedef struct {
	INTEGER_16	icn_ID;
	INTEGER_32	icon_Data[32];
	INTEGER_32	icon_Mask_Data[32];
	Rect			icon_Rect;
	Boolean		selected;
	Boolean		enabled;
	void			 (*action_Function)(...);
} Icon_Item, *Icon_Item_Ptr;

typedef struct {
	INTEGER_16	popup_Menu_ID;
	MenuHandle	popup_Menu;
	INTEGER_16	popup_Selected_Item;
	Str255			popup_Selected_String;
	Boolean		enabled;
	void			 (*action_Function)(...);
} Popup_Menu_Item, *Popup_Menu_Item_Ptr;

typedef struct {
	INTEGER_8	*original_String_List;
	INTEGER_8	*storage_String_List;
	Boolean		changed;
	INTEGER_16	list_Selected;
	Boolean		enabled;
	void			 (*action_Function)(...);
} List_Item, *List_Item_Ptr;

typedef struct {
/* ===
	void		 (*setup_Function)(...);
=== */
	pascal void (*setup_Function)(WindowPtr
						, INTEGER_16);

	void		 (*update_Function)(...);
	void		 (*action_Function)(...);
} User_Item, *User_Item_Ptr;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Automatic_Dialogs(void);

extern void Setup_Outline(void);

extern pascal void Update_Outline(WindowPtr dialog_Window
						, INTEGER_16 item_Number);
						
extern void Select_Icon(Icon_Item_Ptr icon_Item
					, Boolean select_Flag);
					
extern Boolean Perform_Dialog(INTEGER_16 dialog_Script_ID
							, Item_Variables_Ptr dialog_Item_Variables);

extern pascal void Setup_Outline_New(WindowPtr dialog_Window
						, INTEGER_16 outline_Item_Number);

extern void Old_Setup_Outline(void);


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */

extern INTEGER_16	current_Outline_Item_Number;

/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/


/* END OF FILE: Automatic_Dialogs.h */