/* START OF FILE: Cursor_Utilities.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** =======================================================================
 ** NS_Shell, The Shell From Hell
 ** Written by Jim Wolff, and Jim Merkle
 ** Cursor_Utilities.h - Header file for cursor handling routines.
 ** current version (C) Copyright 1992 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 ** SEE NS_Shell_Main.c for revision history and version number.
 **
 ** ===============
 ** OTHER INFORMATION
 ** ===============
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Cursor_Utilities

#define _H_Cursor_Utilities
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include "Shell_Globals.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */

#define STANDARD_ACUR_ID					256
#define USE_VBL									TRUE
#define DO_NOT_USE_VBL						FALSE
#define ANIMATE_CURSOR_VBL_USE_FLAG	USE_VBL

/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Boolean Initialize_Cursor_Utilities(void);
extern void Change_Cursor(INTEGER_16 cursor_ID);
extern void Arrow_Cursor(void);
extern Boolean Cursor_Being_Animated(void);
extern void Animate_Cursor_Tickle(void);
extern Safe_Boolean Animate_Cursor(INTEGER_16 acur_Resource_ID, Boolean use_VBL);
extern Safe_Boolean Stop_Animating_Cursor(void);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */

extern INTEGER_16	last_Cursor_ID;

/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/


/* END OF FILE: Cursor_Utilities.h */
