/* START OF FILE: Error_Utilities.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** =======================================================================
 ** NS_Shell, The Shell From Hell
 ** Written by Jim Wolff, and Jim Merkle
 ** Error_Utilities.h - Header file for error handling routines.
 ** current version (C) Copyright 1993 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 ** SEE NS_Shell_Main.c for revision history and version number.
 **
 ** ===============
 ** OTHER INFORMATION
 ** ===============
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Error_Utilities

#define _H_Error_Utilities
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include "Shell_Globals.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */

#define ERROR_STRING_LIST_ID						1000
#define ERROR_DESCRIPTION_STRING_INDEX		5
#define ERROR_NOTE_STRING_INDEX					6
#define NULL_STRING									7
#define READ_CAPACITY_FAILED						8
#define MINIMUM_MEMORY_NOT_MET				9
#define READ_MULTIPLE_BLOCKS_FAILED			10
#define WRITE_MULTIPLE_BLOCKS_FAILED			11
#define NEW_POINTER_FAILED							12
#define EJECT_FAILED									13
#define RESOURCE_INCORRECT_STRING_INDEX		14
#define REPLACE_PROGRAM_STRING_INDEX			15


/*  */
/* NS_COMMON_ERR_STRS (STR#) is a temporary solution to */
/* Mac OS error STR until StringMagic works */
/*  */
#define NS_COMMON_ERR_STRS						1003

#define	NS_COMMON_ERR_dskFulErr				-34
#define	NS_COMMON_ERR_INDEX_dskFulErr		2
	
#define	NS_COMMON_ERR_extFSErr				-58
#define	NS_COMMON_ERR_INDEX_extFSErr		3
	
#define	NS_COMMON_ERR_fLckdErr				-45
#define	NS_COMMON_ERR_INDEX_fLckdErr		4
	
#define	NS_COMMON_ERR_fnOpnErr				-38
#define	NS_COMMON_ERR_INDEX_fnOpnErr		5
	
#define	NS_COMMON_ERR_ioErr					-36
#define	NS_COMMON_ERR_INDEX_ioErr			6
		
#define	NS_COMMON_ERR_wPrErr					-44
#define	NS_COMMON_ERR_INDEX_wPrErr			7
	
#define	NS_COMMON_ERR_wrPermErr				-61
#define	NS_COMMON_ERR_INDEX_wrPermErr		8




/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern void Setup_Error_Handling(void);

extern void Set_Error_Messages(INTEGER_16 descrption_Index
							, INTEGER_16 note_Index);

extern void Display_Error_Message(CARDINAL_8 *unit_Name
								, CARDINAL_8 *code_Name);

extern void Display_Serious_Error_Message(CARDINAL_8 *unit_Name
										, CARDINAL_8 *code_Name
										, CARDINAL_8 *description_String
										, CARDINAL_8 *note_String);


extern void Display_Low_Memory_Error_Message(CARDINAL_8 *unit_Name
										, CARDINAL_8 *code_Name
										, CARDINAL_32 memory_Needed);

extern Boolean Validate_Ordinal_String_And_Copy(Str255	input_String, CARDINAL_32 maximum, CARDINAL_32 *current_Value);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */

/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/


/* END OF FILE: Error_Utilities.h */
