/* START OF FILE: File_Utilities.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** =======================================================================
 ** NS_Shell, The Shell From Hell
 ** Written by Jim Wolff, and Jim Merkle
 ** File_Utilities.h - Header for Volume_Utilities.c
 ** current version (C) Copyright 1992 James Merkle
 ** =======================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 ** SEE NS_Shell_Main.c for revision history and version number.
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#define _H_File_Utilities
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */

/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

	typedef struct {
		CARDINAL_32	directory_ID;
		INTEGER_16		volume_Reference;
		INTEGER_16		application_Resource_Reference;
		INTEGER_16		application_Directory_Reference;
		
		INTEGER_16		system_Resource_Reference;
		INTEGER_16		system_Volume_Reference;
	} Application_Start_Location_Rec, *Application_Start_Location_Ptr;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_File_Utilities(void);


extern Safe_Boolean Get_Grand_Parents_Directory_Name(FSSpec *near_Neighbor_File
												, Str255	*directory_Name);
												
extern Safe_Boolean Get_Parents_Directory_Name(FSSpec *near_Neighbor_File
												, Str255	*directory_Name);

extern Safe_Boolean Create_Pathname_For_Directory(INTEGER_32 directory_ID
										, INTEGER_16 volume_Reference
										, CARDINAL_32 depth_Limit
										, CARDINAL_8 *full_Path_Name);

extern Safe_Boolean Create_File_Spec_From_Open_Reference(INTEGER_16 file_Reference, FSSpec *file_Info);

extern Safe_Boolean Get_New_File_Specification_Arbitrarily( CARDINAL_32 expected_File_Minimum_Size
															, Str63				desired_Best_Name
															, CARDINAL_32 *maximum_Possible_File_Size
															, FSSpec *direct_Disk_Recording_File_Ptr);
															
extern Safe_Boolean Create_First_Non_Conflicting_File(FSSpec *arbitrary_File_Ptr);

extern Safe_Boolean Create_File_Spec_From_Open_Reference(INTEGER_16 file_Reference, FSSpec *file_Info);

extern Safe_Boolean Determine_Application_Location(Application_Start_Location_Ptr	application_Start_Location);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */

/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/* END OF FILE: File_Utilities.h */