/* START OF FILE: Interface_Utilities.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** =======================================================================
 ** NS_Shell, The Shell From Hell
 ** Written by Jim Wolff, Jim Merkle
 ** Interface_Utilities.h - Header for Interface_Utilities.c
 ** current version (C) Copyright 1992 James Merkle
 ** =======================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 ** SEE NS_Shell_Main.c for revision history and version number.
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#ifndef _H_Interface_Utilities

#define _H_Interface_Utilities
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include "Shell_Globals.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */

#define PATTERN_LENGTH		8

/*=--------------------------------------------------------------------------=*/
/* useful macro to get topleft, bottomright point of a Rect */
/*=--------------------------------------------------------------------------=*/
#define TOP_LEFT(r)				(((Point *) &(r))[0])
#define BOTTOM_RIGHT(r)		(((Point *) &(r))[1])

/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern void Center_Rect_On_Screen(Rect *rect_To_Center);
					
extern void Get_Rect_Of_Main_Device(Rect *main_Rect);

 extern INTEGER_32 Get_Bit_Depth_Of_Intersected_Devices_NEW(Rect *global_Rect);

 extern Safe_Boolean	Rect_Intersects_Rect(Rect *outer_Rect, Rect *inner_Rect);

extern Safe_Boolean	Rect_Is_In_Rect(Rect *outer_Rect, Rect *inner_Rect);

extern void Set_View_Port(GrafPtr desired_Port);
													
extern void Set_View_Device(GDHandle desired_Device);

extern INTEGER_32 Get_Index_For_Color(RGBColor	*desired_Color);

extern Safe_Boolean	Rect_Is_Same_Rect(Rect *first_Rect, Rect *second_Rect);

extern void Set_Valid_Rect_Area(Rect *rectangle_To_Remove_From_Update_Rgn);

extern void Set_Invalid_Rect_Area(Rect *rectangle_To_Add_To_Update_Rgn);

extern Safe_Boolean Initialize_Interface_Utilities(void);

extern Safe_Boolean Destroy_Interface_Utilities(void);

extern Safe_Boolean Get_Clip_Region_From_Pool(RgnHandle*clip_Region, CARDINAL_16 *pool_Index);

extern Safe_Boolean Return_Clip_Region_To_Pool(CARDINAL_16 pool_Index);


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */

/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/


/* END OF FILE: Interface_Utilities.h */