/* START OF FILE: OS_Utilities.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** =======================================================================
 ** Written by Jim Wolff, and Jim Merkle
 ** OS_Utilities.c - Miscellaneous utilities related to operating system functions
 ** current version (C) Copyright 1992 James Merkle
 ** =======================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 ** SEE OS_Utilities.c for revision history and version number.
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#ifndef _H_OS_Utilities

#define _H_OS_Utilities
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include "Shell_Globals.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */

#define GESTALT_TEMP_MEM_SUPPORT_BIT		0x00000010
#define GESTALT_TEMP_MEM_REAL_BIT				0x00000020
#define GESTALT_TEMP_MEM_TRACKED_BIT		0x00000040

/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

	/*  */
	/* This structure is to aid us in slamming data into GDEF code. */
	/* All my Gestalt functions start this way. */
	/* It is OK to modify because data is modified not code. */
	/*  */
	typedef struct {
		CARDINAL_16	branch;				/* bra.s continue */
		INTEGER_16		volume_Reference_Num;			
		INTEGER_32		directory_ID;		
		Str63				file_Name;		
	} *modify_GDEF_Code_Ptr;


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern INTEGER_16 Number_Of_Toolbox_Traps(void);
extern INTEGER_16 Get_Trap_Type(INTEGER_16 trap_Number);
extern Boolean Trap_Available(INTEGER_16 trap_Number);
extern Boolean Gestalt_Available(void);

extern Safe_Boolean	Check_Keyboard_For_Key(CARDINAL_16	keyboard_Scan_Code);

extern void Delay_For_One_Tick_Yielding_To_System(void);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */

/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/


/* END OF FILE: OS_Utilities.h */