/* START OF FILE: Shell_Dialogs.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** =======================================================================
 ** NS_Shell, The Shell From Hell
 ** Written by Jim Wolff, and Jim Merkle
 ** Shell_Dialogs.h - Header for Shell_Dialogs.c
 ** current version (C) Copyright 1992 James Merkle
 ** =======================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 ** SEE NS_Shell_Main.c for revision history and version number.
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#ifndef _H_Shell_Dialogs

#define _H_Shell_Dialogs
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include "Shell_Globals.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */

#define NO_CHOICE		0

/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Boolean Initialize_Shell_Dialogs(void);

extern Boolean Perform_Boolean_Dialog(Str255 message);

extern Boolean Perform_Yes_No_Dialog(Str255 message);

extern Boolean Perform_Yes_No_Cancel_Dialog(Str255 message
												, Boolean *yes_Or_No);

extern Boolean Get_Long_Dialog(Str255 message
								, INTEGER_32 *longint_Value
								, INTEGER_32 lower_Limit
								, INTEGER_32 upper_Limit);

extern void Perform_OK_Dialog(Str255 message);

extern void Perform_Bad_Numeric_Input_Error_Dialog(Str255 bad_Number_String);

extern void Dispose_Message(void);
extern void Display_Message_Dialog(Str255 message
									, INTEGER_32 left_Global
									, INTEGER_32 top_Global
									, Boolean zoom_Flag);
extern void Display_Message(Str255 message);

extern Boolean Perform_Get_File_Dialog(INTEGER_16 number_Of_Types
										, SFTypeList *type_List
										, SFReply *sf_Reply);

																																										
extern void Get_Last_Volume_Reference_And_Directory_ID(INTEGER_16 *volume_Reference
															, INTEGER_32 *director_ID);
															
extern Boolean Perform_Put_File_Dialog(Str255 prompt_String
										, Str255 original_Name
										, SFReply *sf_Reply);
										
extern void Display_Message_Low(Str255 message);


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */

extern Safe_Boolean message_Dialog_Active;
extern DialogPtr	message_Dialog;

/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/


/* END OF FILE: Shell_Dialogs.h */