/* START OF FILE: Volume_Utilities.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** =======================================================================
 ** NS_Shell, The Shell From Hell
 ** Written by Jim Wolff, and Jim Merkle
 ** Volume_Utilities.h - Header for Volume_Utilities.c
 ** current version (C) Copyright 1993 James Merkle
 ** =======================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 ** See Volume_Utilities.c for revision history and version number.
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#ifndef _H_Volume_Utilities

#define _H_Volume_Utilities
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include "Shell_Globals.h"
#include "Memory_Utilities.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */

/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

typedef struct {
	INTEGER_16	volume_Reference;
	INTEGER_16	driver_Reference;
	INTEGER_16	drive_Number;
	INTEGER_16	scsi_ID;
	Str255			volume_Name;
} Volume_Info;


typedef struct {
	INTEGER_16	volume_Reference;
	INTEGER_16	working_Directory_Reference;
	INTEGER_32	directory_ID;
	Str255			volume_Name;
	Str255			directory_Name;
} Hierarchial_Location;


typedef struct {
	Safe_Boolean				record_Fully_Valid;
	CARDINAL_32			volume_Mounting_Information_Size;
	Handle					volume_Mounting_Information;
	Memory_Allocation		volume_Mounting_Information_Memory_Initialized;
} Volume_Remounting_Rec;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern INTEGER_16 Get_Drive_Number(INTEGER_16 volume_Reference);
extern INTEGER_32 Get_Total_Volumes(void);

extern Safe_Boolean Flush_All_Volumes(void);

extern Safe_Boolean Find_Volume_With_Most_Writable_Free_Space(INTEGER_16 *volume_Reference_Number);

extern Safe_Boolean Determine_If_File_Creation_Possible(INTEGER_16 volume_Reference_Number);

/* ===

extern INTEGER_32 Get_Total_Volumes_For_Device(INTEGER_16 device_ID);

extern Boolean Get_Volume_Information_For_Device(INTEGER_16 device_ID
													, INTEGER_16 volume_Index_For_Device
													, Volume_Info *volume_Information);

extern Boolean Mount_Volume_For_Device(INTEGER_16 device_ID
										, INTEGER_16 volume_Index);

extern Boolean Unmount_Volume_For_Device(INTEGER_16 device_ID
											, INTEGER_16 volume_Index);

extern Boolean Unmount_All_Volumes_For_Device(INTEGER_16 device_ID);

=== */

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */

/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/


/* END OF FILE: Volume_Utilities.h */