/* START OF FILE: Window_Utilities.h */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** =======================================================================
 ** NS_Shell, The Shell From Hell
 ** Written by Jim Wolff, and Jim Merkle
 ** Window_Utilities.h - Header file for Window_Utilities.c
 ** current version (C) Copyright 1992 James Merkle
 ** =======================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 ** SEE NS_Shell_Main.c for revision history and version number.
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include "Shell_Globals.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */

/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Window_Utilities(void);

extern Safe_Boolean Remove_Non_TCL_Window_From_NS_Shell(WindowPeek shell_Window_To_Insert);

extern Safe_Boolean Fetch_NS_Window_Index_Using_WindowPeek(WindowPeek shell_Window_To_Locate
							, CARDINAL_32 *window_Index
							, Handle *window_Update_Info_Handle);


extern Safe_Boolean Insert_Non_TCL_Window_Into_NS_Shell(WindowPeek shell_Window_To_Insert
																, void	 (*update_Routine)(...)
																, void	 (*user_Shutdown)(...)
																, void	 (*window_Event_Processor)(...)
																, Safe_Boolean updates_Desired
																, Safe_Boolean shutdown_Desired
																, Safe_Boolean window_Events_Desired
																, Safe_Boolean also_TCL_Window_Compliant
																, Handle window_Globals
																, CARDINAL_16 *window_NS_Shell_ID);
																							
extern void Update_Single_Non_TCL_Shell_Window(EventRecord	*event_Ptr);
extern void Update_Single_Shell_Window(EventRecord	*event_Ptr);
extern void Update_Shell_Windows(void);
extern void Clobber_Entire_Main_Screen(void);

extern void Center_Window_In_Rect_Adjusted_For_Title_Bars(WindowPtr window_To_Center
									, Rect rect_To_Center_Within
									, INTEGER_16 title_Bar_Pixel_Adjustment);

extern void Center_Window_In_Rect(WindowPtr window_To_Center
									, Rect rect_To_Center_Within);

extern void Center_Window(WindowPtr window_To_Center);
extern void Center_Window_Unadjusted_For_Title_Bars(WindowPtr window_To_Center);
extern void Center_Window_Upper_One_Third(WindowPtr window_To_Center);
extern void Center_Window_Low_As_Possible(WindowPtr window_To_Center);
extern void Center_Window_High_As_Possible(WindowPtr window_To_Center, CARDINAL_16 title_Bar_Size);

extern void Center_Window_High_As_Possible_Offscreen(WindowPtr window_To_Center
															, Rect global_Rect_Location
															, CARDINAL_16 title_Bar_Size);


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */

extern Safe_Boolean		enable_Update_Shell_Windows;

/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/* END OF FILE: Window_Utilities.h */