/* START OF FILE: Copy_Compacted_Picture.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Copy_Compacted_Picture.h - Header for Copy_Compacted_Picture.c
 ** (C) Copyright 1993 by James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Copy_Compacted_Picture.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Copy_Compacted_Picture

#define _H_Copy_Compacted_Picture
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */
	
/*  */
/* NOTICE: THIS SHOULD BE "1" FOR 040 FOR SPEED SPEED SPEED */
/*  */
#define k_ASSUME_68040_ALWAYS		1


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

/*  */
/* This is for accessing the data stored in the header of a */
/* compressed pict lacking background. */
/* Each is usually in a handle but when taken off a disk structure */
/* directly they are stored as offsets in the header of a large piece of */
/* conglomerated data */
/*  */
typedef struct {
	CARDINAL_32	row_Raw_Data_Offset;
	CARDINAL_32	skip_List_Data_Offset;
	CARDINAL_32	skip_List_Master_List_Offset;
	CARDINAL_32	scan_Line_Bounds_Offset;
} Packed_Pict_Header_Record, *Packed_Pict_Ptr;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */


extern void Copy_Bits_From_Compressed_Pict_With_Region_NEW(CARDINAL_32	*row_Raw_Data_Ptr
															, CARDINAL_32	*skip_List_Data_Ptr
															, CARDINAL_32	*skip_List_Master_List_Ptr
															, CARDINAL_32	*destination_Word_Ptr
															, CARDINAL_32 destination_Rowbyte_Offset);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Copy_Compacted_Picture.h */
