/* START OF FILE: Direct_Background_Removal.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Direct_Background_Removal.h - Header for Direct_Background_Removal.c
 ** (C) Copyright 1993 by James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Direct_Background_Removal.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Direct_Background_Removal

#define _H_Direct_Background_Removal
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
/* ===
#include "Dialog_Of_Background_Removal.h"
=== */
#include "Indexed_Background_Removal.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define	k_IGNORE_EXAMPLES		1

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


typedef struct {

	Boolean				allow_Horizontal_Drift_Tracking;
	Boolean				allow_Vertical_Drift_Tracking;
	INTEGER_32			bright_Enough_To_Trust_For_Brighten;
	INTEGER_32			allow_Color_Trapping_Dark_Background_Cuttoff;
	INTEGER_32			maximum_Trap_Dark_Background;
	INTEGER_32			minimum_Trap_Dark_Background;
	INTEGER_32			black_Channel_Gun_Limit;
	INTEGER_32			minimum_Intensity_To_Consider_Leniance;
	INTEGER_32			insignificant_Deviance;
	
	INTEGER_32			maximum_5_Bit_Red_Channel_Deviance;
	INTEGER_32			maximum_5_Bit_Blue_Channel_Deviance;
	INTEGER_32			maximum_5_Bit_Green_Channel_Deviance;
	INTEGER_32			maximum_5_Bit_Total_Channel_Deviance;
	
	INTEGER_32			maximum_5_Bit_Red_Channel_Lenient_Deviance;
	INTEGER_32			maximum_5_Bit_Blue_Channel_Lenient_Deviance;
	INTEGER_32			maximum_5_Bit_Green_Channel_Lenient_Deviance;
	INTEGER_32			maximum_5_Bit_Total_Channel_Lenient_Deviance;
	
	INTEGER_32			maximum_5_Bit_Red_Drift_Deviance;
	INTEGER_32			maximum_5_Bit_Blue_Drift_Deviance;
	INTEGER_32			maximum_5_Bit_Green_Drift_Deviance;
	INTEGER_32			maximum_5_Bit_Total_Drift_Deviance;
	
	INTEGER_32			maximum_Brightness_Deviance_5;
	INTEGER_32			maximum_Darkness_Deviance_5;
	
	INTEGER_32			maximum_5_Bit_Red_Channel_Absolute_High_Limit;
	INTEGER_32			maximum_5_Bit_Blue_Channel_Absolute_High_Limit;
	INTEGER_32			maximum_5_Bit_Green_Channel_Absolute_High_Limit;
	INTEGER_32			maximum_5_Bit_Total_Channel_Absolute_High_Limit;
	
	INTEGER_32			maximum_5_Bit_Red_Channel_Absolute_Low_Limit;
	INTEGER_32			maximum_5_Bit_Blue_Channel_Absolute_Low_Limit;
	INTEGER_32			maximum_5_Bit_Green_Channel_Absolute_Low_Limit;
	INTEGER_32			maximum_5_Bit_Total_Channel_Absolute_Low_Limit;
	
	
	INTEGER_32			maximum_8_Bit_Red_Channel_Deviance;
	INTEGER_32			maximum_8_Bit_Blue_Channel_Deviance;
	INTEGER_32			maximum_8_Bit_Green_Channel_Deviance;
	INTEGER_32			maximum_8_Bit_Total_Channel_Deviance;
	
	INTEGER_32			maximum_8_Bit_Red_Channel_Lenient_Deviance;
	INTEGER_32			maximum_8_Bit_Blue_Channel_Lenient_Deviance;
	INTEGER_32			maximum_8_Bit_Green_Channel_Lenient_Deviance;
	INTEGER_32			maximum_8_Bit_Total_Channel_Lenient_Deviance;
	
	INTEGER_32			maximum_8_Bit_Red_Drift_Deviance;
	INTEGER_32			maximum_8_Bit_Blue_Drift_Deviance;
	INTEGER_32			maximum_8_Bit_Green_Drift_Deviance;
	INTEGER_32			maximum_8_Bit_Total_Drift_Deviance;
	
	INTEGER_32			maximum_Brightness_Deviance_8;
	INTEGER_32			maximum_Darkness_Deviance_8;
	
	INTEGER_32			maximum_8_Bit_Red_Channel_Absolute_High_Limit;
	INTEGER_32			maximum_8_Bit_Blue_Channel_Absolute_High_Limit;
	INTEGER_32			maximum_8_Bit_Green_Channel_Absolute_High_Limit;
	INTEGER_32			maximum_8_Bit_Total_Channel_Absolute_High_Limit;
	
	INTEGER_32			maximum_8_Bit_Red_Channel_Absolute_Low_Limit;
	INTEGER_32			maximum_8_Bit_Blue_Channel_Absolute_Low_Limit;
	INTEGER_32			maximum_8_Bit_Green_Channel_Absolute_Low_Limit;
	INTEGER_32			maximum_8_Bit_Total_Channel_Absolute_Low_Limit;

#if (k_IGNORE_EXAMPLES == 0)
	Boolean				result_Check_Box;
	
	INTEGER_16			result_Radio_String_Choice;
	Str255					result_Radio_String_Choice_Text;
	
	INTEGER_16			result_Radio_Value_Choice;
	CARDINAL_32		result_Radio_Value_Choice_Value;
#endif /* #if (k_IGNORE_EXAMPLES == 0) */

}Background_Options, *Background_Options_Ptr;


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */



/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

extern Safe_Boolean	Create_Region_For_Direct_Port_Image(GrafPtr offscreen_Source_Port
															, Rect *source_Rect
															, Safe_Boolean		 			create_Color_Style_Port
															, GrafPort 							*offscreen_Graph_Port
															, Off_Screen_Ptr 					modern_Offscreen_Graph_Port);

extern void Copy_Direct_Non_Masked_Bits(GrafPtr offscreen_Graph_Ptr
				, Safe_Boolean		use_Fancy_Bit_Map
				, GrafPtr				simple_Bit_Map_Ptr
				, CGrafPtr				fancy_Bit_Map_Ptr
				, Rect *source_Rect
				, Rect *target_Rect
				, INTEGER_32 mask_Color_Total
				, Color_Type mask_Colors[]);

extern pascal OSErr BitMapToRegionKRAP(RgnHandle region,BitMap *bMap);


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

extern Safe_Boolean				g_Background_Removal_Options_Ready;
extern Background_Options	g_Options;

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Direct_Background_Removal.h */
