/* START OF FILE: Fast_Bit_Copy.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Fast_Bit_Copy.h - Header for Fast_Bit_Copy.c
 ** (C) Copyright 1993 by James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Fast_Bit_Copy.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Fast_Bit_Copy

#define _H_Fast_Bit_Copy
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */
	

#define k_BACKGROUND_FREE_COMPACT_DRAWING		28
#define k_NORMAL_RAW_BITMAP_DRAWING						29
/*  */
/* "k_EVEN_ROW_DOUBLE_DRAWING" is related to  */
/* k_EVEN_ODD_ROW_COMPRESSION of spin file construction */
/*  */
#define k_EVEN_ROW_DOUBLE_DRAWING							30
#define k_ODD_ROW_SINGLE_DRAW										31



/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

typedef struct {
	PixMapHandle			destination_Pix_Map_Handle;
	CARDINAL_32			source_Base_Address;
	CARDINAL_32			source_Row_Bytes;
	CARDINAL_32			source_Extra_Offset_X;
	CARDINAL_32			source_Extra_Offset_Y;
	CARDINAL_32			preferred_Monitor_Depth;
	Rect								actual_Destination_Rect;
	INTEGER_32				current_Length;
	INTEGER_32				current_Height;
	CARDINAL_16			compression;
	CARDINAL_16			disable_Interrupts;
	
/*  */
/* These four are only valid when compression = k_BACKGROUND_FREE_COMPACT_DRAWING */ 
/*  */
	CARDINAL_32			*row_Raw_Data_Ptr;
	CARDINAL_32			*skip_List_Data_Ptr;
	CARDINAL_32			*skip_List_Master_List_Ptr;
	CARDINAL_32			*scan_Line_Bounds_Ptr;
	
} Fast_Copy_Bits_Rec, *Fast_Copy_Bits_Ptr;


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern void Draw_Bits_Raw_To_Monitor(CARDINAL_32	source_Base_Address
				, CARDINAL_32	source_Row_Bytes
				, CARDINAL_32	compression
				, CARDINAL_32	source_Extra_Offset_X
				, CARDINAL_32	source_Extra_Offset_Y
				, PixMapHandle	destination_Pix_Map_Handle
				, Rect				*initial_Destination_Rect
				, Rect				*monitor_Max_Bounding_Rect
				, CARDINAL_32	preferred_Monitor_Depth);

extern Safe_Boolean Build_Draw_Bits_Raw_Parameters(CARDINAL_32	source_Base_Address
				, CARDINAL_32	source_Row_Bytes
				, CARDINAL_32	compression
				, CARDINAL_32	source_Extra_Offset_X
				, CARDINAL_32	source_Extra_Offset_Y
				, PixMapHandle	destination_Pix_Map_Handle
				, Rect				*initial_Destination_Rect
				, Rect				*monitor_Max_Bounding_Rect
				, CARDINAL_32	preferred_Monitor_Depth
				, Fast_Copy_Bits_Ptr	copy_Options);

extern void Copy_Bits_Very_Quickly(Ptr source_Byte_Ptr
					, Ptr destination_Byte_Ptr
					, INTEGER_32 source_Row_Bytes
					, INTEGER_32	dest_Row_Bytes
					, INTEGER_16 width
					, INTEGER_16 height
					, INTEGER_16 depth);
                   
extern void Copy_Bits_Double_Even_Rows(Ptr source_Byte_Ptr
							, Ptr destination_Byte_Ptr
							, INTEGER_32 source_Row_Bytes
							, INTEGER_32 dest_Row_Bytes
							, INTEGER_16 width
							, INTEGER_16 height
							, INTEGER_16 depth);

extern void Draw_Bits_Raw_To_Monitor_Using_Params(Fast_Copy_Bits_Ptr copy_Options);

extern void Copy_Bits_Very_Quickly_Experimental(Ptr source_Byte_Ptr
							, Ptr destination_Byte_Ptr
							, INTEGER_32 source_Row_Bytes
							, INTEGER_32 dest_Row_Bytes
							, INTEGER_16 width
							, INTEGER_16 height
							, INTEGER_16 depth);
							

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Fast_Bit_Copy.h */
