/* START OF FILE: Fast_Image_Compaction.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Fast_Image_Compaction.h - Header for Fast_Image_Compaction.c
 ** (C) Copyright 1993 by James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Fast_Image_Compaction.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Fast_Image_Compaction

#define _H_Fast_Image_Compaction
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */
	


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

	/*  */
	/* If "rightmost_Pixel" is "0" no data is on this scanline */
	/*  */
typedef struct {
	CARDINAL_16	rightmost_Pixel;
	CARDINAL_16	leftmost_Pixel;
} Scan_Span_Rec, *Scan_Span_Ptr;

	/*  */
	/* This is useful for accessing header of a variable sized */
	/* structure. "spans" is usually much larger than "1" */
	/*  */
typedef struct {
	Rect				bounds_Rect;
	Rect				possible_Rect;
	CARDINAL_32	max_Lines;
	Scan_Span_Rec	spans[1];
} Scan_Bounds_Rec, *Scan_Bounds_Ptr, **Scan_Bounds_Hdl;


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Compact_Region_And_Bitmap(const BitMap *source_Port
													, Rect	*source_Rect
													, INTEGER_32	offset_Left
													, INTEGER_32	offset_Top
													, Safe_Boolean use_Mask_Input_Instead_Of_Bitmap
													, RgnHandle	clipping_Region
													, BitMapPtr		clipping_Bitmap
													, Handle	*row_Raw_Data_Hdl
													, Handle	*skip_List_Data_Hdl
													, Handle	*skip_List_Master_List_Hdl
													, Handle	*scan_Line_Bounds_Hdl);


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Fast_Image_Compaction.h */
