/* START OF FILE: Indexed_Background_Removal.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Indexed_Background_Removal.h - Header for Indexed_Background_Removal.c
 ** (C) Copyright 1993 by James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Indexed_Background_Removal.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Indexed_Background_Removal

#define _H_Indexed_Background_Removal
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Off_Screen_Color.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */
	
/* ===
#define k_TEST_MASK_COLOR_INDEX	(254)
=== */
#define k_PREFERRED_CHROMA_RESERVED_CHANNEL	(254)
#define k_PREFERRED_CHROMA_RESERVED_CHANNEL_REPLACEMENT	(255)


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

	typedef struct {
		Safe_Boolean					use_Raw_Index;
		CARDINAL_32				raw_Index;
		RGBColor						rgb_Color;
	} Color_Type;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean	Create_Region_For_Port_Image(GrafPtr offscreen_Source_Port
																	, Rect *source_Rect
																	, RgnHandle *mask);

extern Safe_Boolean	Create_Bit_Mask_For_Port_Image(GrafPtr offscreen_Source_Port
																	, Rect *source_Rect
																	, GrafPort *offscreen_Graph_Port
																	, Handle *image_Handle);

extern Safe_Boolean Copy_Rect_Non_Mask_Into_BW_Bit_Map(
															Rect *source_Rect
															, Safe_Boolean		use_Fancy_Bit_Map
															, GrafPtr				simple_Bit_Map_Ptr
															, CGrafPtr				fancy_Bit_Map_Ptr
															, Safe_Boolean image_Is_Indexed_Entry
															, INTEGER_32 mask_Color_Total
															, Color_Type mask_Colors[]);

extern Safe_Boolean	Determine_Masking_Colors(CARDINAL_32	*mask_Color_Total
																		, Color_Type mask_Colors[]
																		, Rect				*source_Rect
																		, Safe_Boolean	indexed_Colors_Desired);

extern Safe_Boolean Create_Simple_BW_Bit_Map(Rect *desired_Rect
																	, Handle		*image_Handle_Ptr
																	, Safe_Boolean create_Color_Style_Port
																	, GrafPort 		*offscreen_Graph_Port
																	, Off_Screen_Ptr modern_Offscreen_Graph_Port);
																	
extern Safe_Boolean Destroy_Simple_BW_Bit_Map(Safe_Boolean is_Color_Style_Port
												, Handle		*image_Handle_Ptr
												, GrafPort 		*offscreen_Graph_Port
												, Off_Screen_Ptr modern_Offscreen_Graph_Port);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

/* HACK HACK HACK */
/* ===
extern OSErr BitMapToRegionGlue(RgnHandle region,BitMap *bMap);
==== */

/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Indexed_Background_Removal.h */
