/* START OF FILE: Ring_Buffer_Cache.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Ring_Buffer_Cache.h - Header for Ring_Buffer_Cache.c
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Ring_Buffer_Cache.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Ring_Buffer_Cache

#define _H_Ring_Buffer_Cache
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Ring_Buffer_Cache_Setup.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

/*  */
/* All data storage is 32 byte aligned, upt to to round ups needed */
/* per cache entry is 63 (64) bytes */
/*  */
#define k_MEM_ALIGNMENT_ROUNDED_MAX	(32UL)
#define k_DOUBLE_ROUNDED_MAX	(k_MEM_ALIGNMENT_ROUNDED_MAX + k_MEM_ALIGNMENT_ROUNDED_MAX)

#define k_SAFETY_ALIGNMENT_CACHE_PAD_MAX		k_DOUBLE_ROUNDED_MAX

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

extern void Clear_Ring_Buffer_Entries(Ring_Buffer_Cache_Ptr cache_Master_Ptr);

extern Safe_Boolean Retrieve_Element_From_Buffer(Ring_Buffer_Cache_Ptr cache_Information_Ptr
											, CARDINAL_32 simple_Key_1
											, CARDINAL_32 simple_Key_2
											, CARDINAL_32 *storage_Location_To_Use);

extern Safe_Boolean Prepare_Location_For_Buffer_Write(Ring_Buffer_Cache_Ptr cache_Information_Ptr
											, CARDINAL_32 simple_Key_1
											, CARDINAL_32 simple_Key_2
											, CARDINAL_32 total_Size
											, CARDINAL_32 *storage_Location_To_Use);
											
/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Ring_Buffer_Cache.h */
