/* START OF FILE: Sound_Input_Device.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Sound_Input_Device.h - Header to support Poor Man's Video Phone
 ** (C) Copyright 1993 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Sound_Input_Device.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Sound_Input_Device

#define _H_Sound_Input_Device
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include <Sound.h>
#include <SoundInput.h>

#include <Sound_Record.h>

/* === 

#include "Dreaming_Audio.h"
=== */

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define	k_SWAP_BUFFERS								2

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern void	Stop_Async_If_Completion_Illegally_Skipped(SPBPtr sound_Recording_Parameters_Ptr);

extern void	Force_Asynchronous_Recording_To_Stop(SPBPtr sound_Recording_Parameters_Ptr);

extern pascal Safe_Boolean	Process_Interrupt_Capable_Tasks(SPBPtr sound_Recording_Parameters_Ptr
																						, Ptr buffer_Start 
																						, CARDINAL_32 peak_Volume
																						, CARDINAL_32 device_Buffer_Size);
																						
extern pascal void	Perform_Recording_Interrupt_Task(void);

extern pascal void	Perform_Asynch_Recording_Completion(SPBPtr sound_Recording_Parameters_Ptr);

extern pascal Boolean	Restart_Recording_Alternating_Buffer(Recording_Ptr monitor);

extern Safe_Boolean Start_Sound_Input_Monitoring(Recording_Ptr	monitor
										, Safe_Boolean *activated
										, CARDINAL_32	desired_Active_Channels
										, Safe_Boolean select_Any_Input);
																						
extern Safe_Boolean	Stop_Sound_Input_Monitoring(Recording_Ptr monitor);

extern Safe_Boolean Extract_Recent_Amplitude_From_SID(Voice_Hdl	voice, CARDINAL_32	*raw_Signal);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Sound_Input_Device.h */