/* START OF FILE: Sound_Play.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Sound_Play.h - Header file for Sound_Play.c
 ** (C) Copyright 1995 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Sound_Play.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Sound_Play

#define _H_Sound_Play
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Sound_Tap_Channel.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define k_MAX_FILES_ALLOWED_PLAYING				3

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

typedef struct {
	Safe_Boolean		structure_Initialized;
	CARDINAL_32	saved_Global_Reference;
	CARDINAL_32	starting_Tick_Time;
	volatile Safe_Boolean		playing_AIFF_Now;
	Safe_Boolean		buffered_Sound_Data_Memory_In_Use;
	Handle			buffered_Sound_Data_Handle;
	Ptr					buffered_Sound_Data_Start_Page_Ptr;
	Safe_Boolean		buffered_Sound_Data_Handle_In_Temporary;
	CARDINAL_32	playback_Buffer_Size;
	Safe_Boolean		pages_Held_And_Needs_Release;
	SndChannelPtr	active_Snd_Channel_Ptr;
	INTEGER_16 		file_Reference;
	
	volatile CARDINAL_32	callback_Count;
	volatile CARDINAL_32	callback_Debug_Info_More_Data_Ptr;
	/*  */
	/* For tapping the audio channel by inserting monitor on the */
	/* "More data". This is the channels "Get more data" and not the */
	/* higher lever "user" defined double buffer callback for more data. */
	/* Putting the tap at that stage allows audio monitoring of */
	/* speech synthesis without creating amplitute tables for */
	/* phonemes, it is highly useful for monitoring AIFF file play from disk.*/
	/*  */
	Safe_Boolean 	audio_Tap_Initialized;
	Audio_Progress_Tap_Ptr audio_Tap_Ptr;
} Async_AIFF_Rec, *Async_AIFF_Ptr;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Play_AIFF_Audio_File_Asyncronously(FSSpec *selected_File
															, Safe_Boolean install_Tap_On_Channel
															, Async_AIFF_Ptr	 *structure_Selected);

extern Safe_Boolean Destroy_Sound_Play(void);

extern void Stop_Playing_Any_AIFF_Asynchronously(Safe_Boolean stop_Oldest_Item_Found);

extern void Close_Any_Sound_Files_If_Needed(void);

extern Safe_Boolean Stop_Playing_AIFF_Asynchronously(Async_AIFF_Ptr	 playback);

extern Safe_Boolean Find_Structure_Index_For_AIFF_Pointer(Async_AIFF_Ptr file_Control_Ptr, CARDINAL_32 *playback_Index);

extern Safe_Boolean Initialize_Sound_Play(Ptr file_Completion_Notice_Callback);

extern Safe_Boolean Unpause_Halted_Channel(SndChannelPtr	active_Snd_Channel_Ptr);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

	extern volatile CARDINAL_32		g_AIFF_Structures_Opened;

	extern Async_AIFF_Rec	g_Playback[k_MAX_FILES_ALLOWED_PLAYING];


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Sound_Play.h */