/* START OF FILE: Video_Wipes.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_File_Loading.c - Video Routines to support Poor Man's Video Phone
 ** (C) Copyright 1993 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Video_Wipes.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Video_Wipes

#define _H_Video_Wipes
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */


/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define EFFECT_NOTHING				0
#define EFFECT_BOX_IN_WIPE			1
#define EFFECT_BOX_OUT_WIPE		2
#define EFFECT_CASTE_WIPE_R_L		3
#define EFFECT_CASTE_WIPE			4
#define EFFECT_CIRCLE_BULGE			5
#define EFFECT_CIRCLE_IN				6
#define EFFECT_CIRCLE_OUT			7
#define EFFECT_SERENDIPITY			8
#define EFFECT_CIRCULAR_WIPE		9
#define EFFECT_CORNER_CIRCLE		10
#define EFFECT_DIAGONAL_WIPE		11
#define EFFECT_DISSOLVE_WIPE		12
#define EFFECT_FOUR_CORNERS_CENTERED		13
#define EFFECT_FOUR_CORNER					14
#define EFFECT_FOUR_CORNER_SCROLL			15
#define EFFECT_FULL_SCROLL_L_R					16
#define EFFECT_FULL_SCROLL_U_D				17
#define EFFECT_HALVES_SCROLL					18
#define EFFECT_HILBERT_CURVE_WIPE			19
#define EFFECT_POUR_SCROLL				20
#define EFFECT_RANDOM_WIPE			21
#define EFFECT_RESCUE_RAIDERS			22
#define EFFECT_RIPPLE_WIPE				23
#define EFFECT_SCISSORS					24
#define EFFECT_SKIP_A_LINE_R_L			25
#define EFFECT_SKIP_A_LINE				26
#define EFFECT_SLIDE_WIPE				27
#define EFFECT_SPIRAL_GYRA				28
#define EFFECT_SPLIT_SCROLL_U_D		29
#define EFFECT_TWO_CORNER				30

#define k_MAXIMUM_WIPE_EFFECTS		31


#define EFFECT_NOTHING_TITLE								"\pNothing"
#define EFFECT_BOX_IN_WIPE_TITLE							"\pBox In Wipe"
#define EFFECT_BOX_OUT_WIPE_TITLE						"\pBox Out Wipe"
#define EFFECT_CASTE_WIPE_R_L_TITLE					"\pCaste Wipe R L"
#define EFFECT_CASTE_WIPE_TITLE							"\pCaste Wipe"
#define EFFECT_CIRCLE_BULGE_TITLE						"\pCircle Bulge"
#define EFFECT_CIRCLE_IN_TITLE								"\pCircle In"
#define EFFECT_CIRCLE_OUT_TITLE							"\pCircle Out"
#define EFFECT_SERENDIPITY_TITLE							"\pSerendipity"
#define EFFECT_CIRCULAR_WIPE_TITLE						"\pCircular Wipe"
#define EFFECT_CORNER_CIRCLE_TITLE					"\pCorner Circle"
#define EFFECT_DIAGONAL_WIPE_TITLE					"\pDiagonal Wipe"
#define EFFECT_DISSOLVE_WIPE_TITLE							"\pDissolve Wipe"
#define EFFECT_FOUR_CORNERS_CENTERED_TITLE		"\pFour Corners Centered"
#define EFFECT_FOUR_CORNER_TITLE							"\pFour Corner"
#define EFFECT_FOUR_CORNER_SCROLL_TITLE			"\pFour Corner Scroll"
#define EFFECT_FULL_SCROLL_L_R_TITLE						"\pFour Corner Scroll L R"
#define EFFECT_FULL_SCROLL_U_D_TITLE						"\pFour Corner Scroll U D"
#define EFFECT_HALVES_SCROLL_TITLE						"\pHalves Scroll"
#define EFFECT_HILBERT_CURVE_WIPE_TITLE				"\pHilbert Curve"
#define EFFECT_POUR_SCROLL_TITLE							"\pPour Scroll"
#define EFFECT_RANDOM_WIPE_TITLE							"\pRandom Wipe"
#define EFFECT_RESCUE_RAIDERS_TITLE						"\pRecue Raiders"
#define EFFECT_RIPPLE_WIPE_TITLE								"\pRipple Wipe"
#define EFFECT_SCISSORS_TITLE									"\pScissors"
#define EFFECT_SKIP_A_LINE_R_L_TITLE						"\pSkip A Line R L"
#define EFFECT_SKIP_A_LINE_TITLE								"\pSkip A Line"
#define EFFECT_SLIDE_WIPE_TITLE								"\pSlide Wipe"
#define EFFECT_SPIRAL_GYRA_TITLE								"\pSpiral Gyra"
#define EFFECT_SPLIT_SCROLL_U_D_TITLE					"\pSplit Scroll U D"
#define EFFECT_TWO_CORNER_TITLE							"\pTwo Corner"


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

Safe_Boolean	Initialize_Video_Wipes(void);

void Show_Wipe_Screen_Effect(INTEGER_32 effect, GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

extern CARDINAL_8 *g_Transition_Effect_Embedded_Titles[k_MAXIMUM_WIPE_EFFECTS];

/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Video_Wipes.h */