/* START OF FILE: Window_Environment.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Window_Environment.h - Header file for Window_Environment.c
 ** (C) Copyright 1995 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Window_Environment.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Window_Environment

#define _H_Window_Environment
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

/*  */
/* Beware changing Window_Limits_Rec. It is derived from a Resource */
/* template of k_WINDOW_SIZES_RESOURCE_TYPE ('Wind') */
/* and must not deviate order. */
/*  */
typedef struct {
 	INTEGER_32				display_Item_Width_Max;
 	INTEGER_32				display_Item_Height_Max;
 	INTEGER_32				display_Item_Width_Min;
 	INTEGER_32				display_Item_Height_Min;
} Specific_Item_Size_Rec;
																
 typedef struct {
 	Safe_Boolean					valid_Information;
 	INTEGER_32					main_Window_Width;
 	INTEGER_32					main_Window_Height;
 	Specific_Item_Size_Rec	specific;
 } Window_Limits_Rec, *Window_Limits_Rec_Ptr;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Window_Limits_If_Needed(Window_Limits_Rec *window_Limits);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

extern Safe_Boolean						g_Preferred_Monitor_Values_Valid;
extern CARDINAL_16					g_Preferred_Monitor_Depth;
extern CARDINAL_8						g_Preferred_Monitor_Slots;
extern Rect								g_Preferred_Monitor_Max_Rect;
extern Safe_Boolean						g_Preferred_Monitor_Max_Rect_Contains_Menubar;
extern PixMapHandle					g_Preferred_Monitor_Video_Pix_Map_Handle;
extern GDHandle							g_Preferred_Monitor_Graphics_Device;

extern Window_Limits_Rec			g_Window_Limits;

/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Window_Environment.h */