/* START OF FILE: MAD.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle and Antoine Rosset
 ** MAD.h - Header to support MOD music
 ** (C) Copyright 1995 James Merkle and Antoine Rosset
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 ** Taken from PD source of Antoine Rosset
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_MAD

#define _H_MAD
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

 #include "Shell_Globals.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/********************						***********************/
//
//	Player PRO 4.2 -- MAD Music Driver Definition
//
//	Library Version 2.5
//
//	To use with MusicLibrary 2.5 for Think C & CodeWarrior
//
//	Antoine ROSSET
//	16 Tranchees
//	1206 GENEVA
//	SWITZERLAND
//	
//	FAX:			(+41 22) 346 11 97
//	Compuserve:		100277,164
//	Internet: 		rosset@dial.eunet.ch
//
/********************						***********************/

#if defined(powerc) || defined(__powerc)
#pragma options align=mac68k
#endif

struct PatHeader {
	long	PatternSize;			// Length of pattern: standard = 64
	long	CompressionMode;		// Compression mode, none = 'NONE'
	char	PatternName[ 20];
	long	PatBytes;				// Pattern Size in Bytes
	long	unused2;
};

struct Command {
	Byte	InstrumentNo;		// Instrument no
	Byte 	AmigaPeriod;		// Note, see table
	Byte 	EffectCmd;			// Effect cmd
	Byte 	EffectArg;			// Effect arg
};

struct MusicPattern
{								// Pattern = 64 notes to play
	struct PatHeader	header;
	struct Command	Commands[];
};

struct FileInstrData {
	char 	Filename[ 32];		// Instrument's filename
	long 	insSize;			// Sample length
	Byte 	fineTune;
	Byte 	volume;			// Base volume
	long	freq;				// Base frequence, simple, double, quadruple
	Byte	amplitude;			// 8 or 16 bits
	long	loopStart;			// LoopStart
	long	loopLenght;			// LoopLength
};

struct MADSpec
{
	long	MADIdentification;		// Mad Identification: MADG in version 2.0
	char 	NameSignature[ 32];	// Music's name
	struct 	FileInstrData fid[ 64];	// 64 instruments descriptor
	Byte	PatMax;
	Byte 	numPointers;			// Patterns number
	Byte	oPointers[ 128];		// Patterns list
	Byte	Tracks;					// Tracks number
};
typedef struct MADSpec MADSpec;

#if defined(powerc) || defined(__powerc)
#pragma options align=reset
#endif

/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: MAD.h */
