/* START OF FILE: Video_Wipes.c */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_File_Loading.c - Video Routines to support Poor Man's Video Phone
 ** (C) Copyright 1993 James Merkle
 ** All rights reserved, except those wishing to "copy" moderate sections of code or files may do so, so long as
 ** such code is never used directly either in animation-related tools or multimedia tools that are  
 ** used in live performance or live broadcast or recorded mass market broadcast or film. Desktop usage not restricted.
 ** Conventional desktop game or entertainment not restricted.
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  1993.05.23		(James Merkle)
 **						Initial port, mostly 95% from Mark Pilgrim & David S. Blumenthal
 **						source put on Internet. Rewritten.
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 ** 
 ** 
 **
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Window_Environment.h"

#include "Error_Utilities.h"
#include "Interface_Utilities.h"

#include "Video_Wipes.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define k_V_BAR_GAP_FOR_BOX_IN_WIPE	(10L)
#define k_VIDEO_DELAY_FOR_BOX_IN_WIPE	3

/*  */
/* increase this for a finer grained but more timely effect */
/*  */
#define k_BOXES_FOR_BOX_OUT_WIPE			50	
#define k_VIDEO_DELAY_FOR_BOX_OUT_WIPE	2

/*  */
/* width of strip */
/*  */
#define k_GAP_CASTE_WIPE_R_L					14       
#define k_VIDEO_DELAY_FOR_CASTE_WIPE_R_L	1


#define k_GAP_CASTE_WIPE_REGULAR				10
#define k_VIDEO_DELAY_FOR_Caste_Wipe			1
   

#define k_START_GAP_CIRCLE_BULGE			1
#define k_GAP_RATIO_CIRCLE_BULGE			6
#define k_ZERO_POINT_H_CIRCLE_BULGE			15
#define k_VIDEO_DELAY_FOR_CIRCLE_BULGE 3

/*  */
/* difference between one radius and the next */
/*  */
#define k_GAP_FOR_CIRCLE_IN			4

/*  */
/* should be just over || (cx,cy) || */
/*  */
#define k_START_RADIUS_FOR_CIRCLE_IN	300		
#define k_VIDEO_DELAY_FOR_CIRCLE_IN 		2

/*  */
/* difference between one radius and the next */
/*  */
#define k_GAP_FOR_CIRCLE_OUT			4		
#define k_VIDEO_DELAY_FOR_Circle_Out 2

#define k_GAP_CIRCLE_FOR_SERENDIPITY						7
#define k_VIDEO_DELAY_FOR_Circle_Serendipity	2


#define k_BlockSize_Circular_Wipe					 17
#define k_VIDEO_DELAY_FOR_Circular_Wipe				 2

/*  */
/* difference between one radius and the next */
/*  */
#define gap_Corner_Circle			8
#define k_VIDEO_DELAY_FOR_Corner_Circle	2

#define k_VIDEO_BOX_SIZE_FOR_Diagonal_Wipe 13
#define k_VIDEO_DELAY_FOR_Diagonal_Wipe 2
   
#define k_VIDEO_DELAY_FOR_Dissolve_Using_Box 2

#define k_BlockSize_Four_Corner_Centered 10
#define k_VIDEO_DELAY_FOR_Four_Corner_Centered 6
   
#define VBarGap_Four_Corner 5

#define k_VIDEO_DELAY_FOR_Four_Corner 1

#define k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll		10
#define k_VIDEO_DELAY_FOR_Four_Corner_Scroll 4
   
#define k_VIDEO_BOX_SIZE_FOR_Full_Scroll_L_R	20
#define k_VIDEO_DELAY_FOR_Full_Scroll_L_R 3

#define k_VIDEO_BOX_SIZE_FOR_Full_Scroll_U_D	10
#define k_VIDEO_DELAY_FOR_FullScrollUD 3

#define k_VIDEO_BOX_SIZE_FOR_Halves_Scroll	10
#define k_VIDEO_DELAY_FOR_Halves_Scroll 3

#define k_RECURSION_LIMIT_FOR_HILBERT_WIPE	4

/*  */
/* ceiling(g_Window_Limits.main_Window_Height / 2^RecursionLevel) */
/* was 20 */
/*  */
#define k_V_BLOCK_SIZE_FOR_HILBERT_WIPE		24	

/*  */
/* ceiling(g_Window_Limits.main_Window_Width / 2^RecursionLevel) */
/* was 32 */
/*  */
#define hBlockSize_HilbertWipe		40

#define k_VIDEO_DELAY_FOR_HilbertWipe 1

/*  */
/* = how much up to scroll each strip */
/*  */
#define ScrollSize_Pour_Scroll	10		

/*  */
/* = width of each strip */
/*  */
#define k_VIDEO_BOX_SIZE_FOR_Pour_Scroll		5	

/*  */
/* = g_Window_Limits.main_Window_Width/k_VIDEO_BOX_SIZE_FOR_Pour_Scroll */	
/*  */
#define NumStrips_Pour_Scroll	100		
#define k_VIDEO_DELAY_FOR_Pour_Scroll 2
   
#define SUB_HOR_Random_Wipe		20
#define SUB_VER_Random_Wipe		20
#define AREA_Random_Wipe		(SUB_HOR_Random_Wipe * SUB_VER_Random_Wipe)
#define k_VIDEO_DELAY_FOR_Random_Wipe		1

#define NUMREGIONS_Rescue_Raiders		25
#define k_BlockSize_Rescue_Raiders				10
#define k_VIDEO_DELAY_FOR_Rescue_Raiders 5

#define BigRippleSize_Ripple_Wipe		52
#define gap_Ripple_Wipe					8
#define k_VIDEO_DELAY_FOR_Ripple_Wipe	1

#define k_BlockSize_Scissors 10
#define k_VIDEO_DELAY_FOR_Scissors 3

#define k_VIDEO_DELAY_FOR_Skipaline_L_R 1
#define k_VIDEO_DELAY_FOR_Skipaline 1

#define k_VIDEO_BOX_SIZE_FOR_Slide_Wipe		20
#define StripSize_Slide_Wipe						40
#define k_VIDEO_DELAY_FOR_Slide_Wipe			1

#define k_VIDEO_BOX_SIZE_FOR_Spiral_Gyra 20
#define k_VIDEO_DELAY_FOR_Spiral_Gyra 1

#define k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D		10
#define k_VIDEO_DELAY_FOR_Split_Scroll_U_D 4

#define k_BlockSize_Two_Corner 10
#define k_VIDEO_DELAY_FOR_Two_Corner 3


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

typedef INTEGER_8 Hilbert_Array[11];

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

void Dissolve_Using_Box(GrafPtr newImage, Rect *source, Rect *dest, GrafPtr final_Destination_Ptr);

void Recurse_Using_Hilbert_Effect(GrafPtr myGrafPtr, INTEGER_16 level, INTEGER_16 whichpattern, INTEGER_16 *x, INTEGER_16 *y, GrafPtr final_Destination_Ptr);

void Reset_Timer(void);

void Delay_If_Needed(CARDINAL_32 ticks_To_Wait);

void Show_Effect_Box_In_Wipe(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Box_Out_Wipe(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Caste_Wipe_R_L(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Caste_Wipe(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Circle_Bulge(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Circle_In(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Circle_Out(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Circle_Serendipity(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Circular_Wipe(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Corner_Circle(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Diagonal_Wipe(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Dissolve_Wipe(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Four_Corner_Centered(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Four_Corner(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Four_Corner_Scroll(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Full_Scroll_L_R(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Full_Scroll_U_D(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Halves_Scroll(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Hilbert_Wipe_Call(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Pour_Scroll(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Random_Wipe(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Rescue_Raiders(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Ripple_Wipe(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Scissors(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Skipaline_L_R(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Skipaline(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Slide_Wipe(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Spiral_Gyra(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Split_Scroll_U_D(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

void Show_Effect_Two_Corner(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */

CARDINAL_8 *g_Transition_Effect_Embedded_Titles[k_MAXIMUM_WIPE_EFFECTS];

/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

static CARDINAL_8	*unit_Name = "\pVideo Wipes";

static INTEGER_16			g_Direction_HilbertWipe;
static CARDINAL_32			g_Previous_Time = 0;
static Safe_Boolean			g_Video_Routines_Initialized = SAFE_FALSE;

static Hilbert_Array	g_Hilbert_Pattern[]=
{
	{
		0x02,0x69,0x00,0x01,0x42,0x00,0x42,0x01,0x00,0x69,0x02
	},
	{
		0x01,0x42,0x00,0x02,0x69,0x00,0x69,0x02,0x00,0x42,0x01
	}
};

void	(*Show_Wipe_Screen_Array[k_MAXIMUM_WIPE_EFFECTS])(GrafPtr, GrafPtr);

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/  
void Reset_Timer(void)
{
	g_Previous_Time = TickCount();
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/  
void Delay_If_Needed(CARDINAL_32 ticks_To_Wait)
{
register CARDINAL_32	next_Time_To_Wait;

#if (7 ==11 )
	next_Time_To_Wait = g_Previous_Time + ticks_To_Wait;
	while (TickCount() < next_Time_To_Wait) ; /* NULL */
#endif

}
/*=**************************************************************************=*/


/*=**************************************************************************=*/ 
Safe_Boolean	Initialize_Video_Wipes(void)
{
	Safe_Boolean		function_Result;
	INTEGER_16		index;
	
	
	for (index = 0; (index < k_MAXIMUM_WIPE_EFFECTS) ; index++) {
		Show_Wipe_Screen_Array[index] = &Show_Effect_Box_In_Wipe;
	}

	Show_Wipe_Screen_Array[EFFECT_NOTHING] = &Show_Effect_Box_In_Wipe;
	Show_Wipe_Screen_Array[EFFECT_BOX_IN_WIPE] = &Show_Effect_Box_In_Wipe;
	Show_Wipe_Screen_Array[EFFECT_BOX_OUT_WIPE] = &Show_Effect_Box_Out_Wipe;
	Show_Wipe_Screen_Array[EFFECT_CASTE_WIPE_R_L] = &Show_Effect_Caste_Wipe_R_L;
	Show_Wipe_Screen_Array[EFFECT_CASTE_WIPE] = &Show_Effect_Caste_Wipe;
	Show_Wipe_Screen_Array[EFFECT_CIRCLE_BULGE] = &Show_Effect_Circle_Bulge;
	Show_Wipe_Screen_Array[EFFECT_CIRCLE_IN] = &Show_Effect_Circle_In;
	Show_Wipe_Screen_Array[EFFECT_CIRCLE_OUT] = &Show_Effect_Circle_Out;
	Show_Wipe_Screen_Array[EFFECT_SERENDIPITY] = &Show_Effect_Circle_Serendipity;
	Show_Wipe_Screen_Array[EFFECT_CIRCULAR_WIPE] = &Show_Effect_Circular_Wipe;
	Show_Wipe_Screen_Array[EFFECT_CORNER_CIRCLE] = &Show_Effect_Corner_Circle;
	Show_Wipe_Screen_Array[EFFECT_DIAGONAL_WIPE] = &Show_Effect_Diagonal_Wipe;
	Show_Wipe_Screen_Array[EFFECT_DISSOLVE_WIPE] = &Show_Effect_Dissolve_Wipe;
	Show_Wipe_Screen_Array[EFFECT_FOUR_CORNERS_CENTERED] = &Show_Effect_Four_Corner_Centered;
	Show_Wipe_Screen_Array[EFFECT_FOUR_CORNER] = &Show_Effect_Four_Corner;
	Show_Wipe_Screen_Array[EFFECT_FOUR_CORNER_SCROLL] = &Show_Effect_Four_Corner_Scroll;
	Show_Wipe_Screen_Array[EFFECT_FULL_SCROLL_L_R] = &Show_Effect_Full_Scroll_L_R;
	Show_Wipe_Screen_Array[EFFECT_FULL_SCROLL_U_D] = &Show_Effect_Full_Scroll_U_D;
	Show_Wipe_Screen_Array[EFFECT_HALVES_SCROLL] = &Show_Effect_Halves_Scroll;
	Show_Wipe_Screen_Array[EFFECT_HILBERT_CURVE_WIPE] = &Show_Effect_Hilbert_Wipe_Call;
	Show_Wipe_Screen_Array[EFFECT_POUR_SCROLL] = &Show_Effect_Pour_Scroll;
	Show_Wipe_Screen_Array[EFFECT_RANDOM_WIPE] = &Show_Effect_Random_Wipe;
	Show_Wipe_Screen_Array[EFFECT_RESCUE_RAIDERS] = &Show_Effect_Rescue_Raiders;
	Show_Wipe_Screen_Array[EFFECT_RIPPLE_WIPE] = &Show_Effect_Ripple_Wipe;
	Show_Wipe_Screen_Array[EFFECT_SCISSORS] = &Show_Effect_Scissors;
	Show_Wipe_Screen_Array[EFFECT_SKIP_A_LINE_R_L] = &Show_Effect_Skipaline_L_R;
	Show_Wipe_Screen_Array[EFFECT_SKIP_A_LINE] = &Show_Effect_Skipaline;
	Show_Wipe_Screen_Array[EFFECT_SLIDE_WIPE] = &Show_Effect_Slide_Wipe;
	Show_Wipe_Screen_Array[EFFECT_SPIRAL_GYRA] = &Show_Effect_Spiral_Gyra;
	Show_Wipe_Screen_Array[EFFECT_SPLIT_SCROLL_U_D] = &Show_Effect_Split_Scroll_U_D;
	Show_Wipe_Screen_Array[EFFECT_TWO_CORNER] = &Show_Effect_Two_Corner;
	g_Video_Routines_Initialized = SAFE_TRUE;
	function_Result = SAFE_TRUE;
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/  
void Show_Wipe_Screen_Effect(INTEGER_32 effect, GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
{
	INTEGER_8	effect_Low_Bits;
	INTEGER_16	index;
	
	
	if (g_Video_Routines_Initialized != SAFE_TRUE) {
		if (Initialize_Video_Wipes() != SAFE_TRUE) {
			/*  */
			/* Ignore errors in this version */
			/*  */
		}
	}
	
	effect_Low_Bits = (effect & 0x00FF);
	Show_Wipe_Screen_Array[effect_Low_Bits](sourceGrafPtr, final_Destination_Ptr);
		
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/  
void Show_Effect_Box_In_Wipe(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Basically, there are four bars -- one starts at the top and moves down;
   one starts at the bottom and moves up; one starts at the left and moves
   right; one starts at the right and moves left.  There's a lot of overlap
   of bitcopying, but it's masked by the timing correction */
/*  */
{
	Rect		vsource1,vsource2, hsource1, hsource2;
	INTEGER_16			vbar,hbar;
	INTEGER_32			h_Bar_Gap_For_Box_In_Wipe;
	
	vbar=0;
	hbar=0;
	vsource1.top=vsource2.top=hsource2.left=hsource1.left=0;  /* these */
	vsource1.bottom=vsource2.bottom=g_Window_Limits.main_Window_Height;       /* never */
	hsource1.right=hsource2.right=g_Window_Limits.main_Window_Width;          /* change */
	
	h_Bar_Gap_For_Box_In_Wipe = ((k_V_BAR_GAP_FOR_BOX_IN_WIPE
							*g_Window_Limits.main_Window_Height)/g_Window_Limits.main_Window_Width);

	while (vbar<g_Window_Limits.main_Window_Width/2+ k_V_BAR_GAP_FOR_BOX_IN_WIPE)
	{
		Reset_Timer();
		vsource1.left=vbar;
		vsource1.right=vsource1.left+ k_V_BAR_GAP_FOR_BOX_IN_WIPE;
		vsource2.right=g_Window_Limits.main_Window_Width-vbar;
		vsource2.left=vsource2.right-k_V_BAR_GAP_FOR_BOX_IN_WIPE;
		hsource1.top=hbar;
		hsource1.bottom=hsource1.top+ g_Window_Limits.main_Window_Height;
		hsource2.bottom=g_Window_Limits.main_Window_Height-hbar;
		hsource2.top=hsource2.bottom-g_Window_Limits.main_Window_Height;
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&vsource1, &vsource1, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&hsource1, &hsource1, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&vsource2, &vsource2, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&hsource2, &hsource2, 0, 0L);
		vbar+=k_V_BAR_GAP_FOR_BOX_IN_WIPE;
		hbar+=g_Window_Limits.main_Window_Height;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_BOX_IN_WIPE);
	}
	
} /* void Show_Effect_Box_In_Wipe... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/  
void Show_Effect_Box_Out_Wipe(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr)
{
	Rect	current_Rect;
	INTEGER_16		cenx, ceny;
	INTEGER_16		boxnum;
	
	/* change this as appropriate for the source and destination bounds */
	cenx = g_Window_Limits.main_Window_Width / 2;
	ceny = g_Window_Limits.main_Window_Height / 2;
	
	for(boxnum = 0; boxnum <= k_BOXES_FOR_BOX_OUT_WIPE; boxnum++ )
	{
		Reset_Timer();
		
		/* this is not the most efficient method, but the overhead of the
		multiplies and the redundant copying is hidden by the timing mechanism */
		current_Rect.left = cenx - ((boxnum * cenx) / k_BOXES_FOR_BOX_OUT_WIPE);
		current_Rect.right = cenx +  ((boxnum * cenx) / k_BOXES_FOR_BOX_OUT_WIPE);
		current_Rect.top = ceny - ((boxnum * ceny) / k_BOXES_FOR_BOX_OUT_WIPE);
		current_Rect.bottom = ceny +  ((boxnum * ceny) / k_BOXES_FOR_BOX_OUT_WIPE);
		
		CopyBits(&(myGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&current_Rect, &current_Rect, 0, 0L);
		Delay_If_Needed(k_VIDEO_DELAY_FOR_BOX_OUT_WIPE);
	}
	
} /* void Show_Effect_Box_Out_Wipe ... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Caste_Wipe_R_L(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* This takes a strip (starting with the leftmost strip, moving right) and
   copies it into all the strips starting at the right and moving left until
   its in the right place. */
/*  */
{
	INTEGER_16		srcx, barpos;
	Rect	src, dest;
	Boolean	everyOther;
	
	everyOther=FALSE;
	src.top = 0;                       /* constant */
	src.bottom = g_Window_Limits.main_Window_Height;   /* constant */
	
	for(srcx = 0; srcx < g_Window_Limits.main_Window_Width; srcx += k_GAP_CASTE_WIPE_R_L)
	{
		for(barpos = 0; barpos +  k_GAP_CASTE_WIPE_R_L < g_Window_Limits.main_Window_Width; barpos += k_GAP_CASTE_WIPE_R_L);
		for(; barpos >= srcx; barpos -= k_GAP_CASTE_WIPE_R_L)
		{
			Reset_Timer();
			src.left = srcx;
			src.right = srcx +  k_GAP_CASTE_WIPE_R_L;
			dest = src;
			dest.left = barpos;
			dest.right = barpos +  k_GAP_CASTE_WIPE_R_L;
			CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
					&src, &dest, 0, 0L);
			if (everyOther)                        /* really, we need time */
				Delay_If_Needed(k_VIDEO_DELAY_FOR_CASTE_WIPE_R_L);       /* correction 0.5, but  */
			everyOther=!everyOther;                /* this will do (gag)   */
		}
	}
	
} /* void Show_Effect_Caste_Wipe_R_L */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Caste_Wipe(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* This takes a strip (starting with the topmost strip, moving down) and copies
   it into all the strips starting with the bottom and moving up until it's in
   the right place. */
/*  */
{
	INTEGER_16		srcy, barpos;
	Rect	src, dest;
	Boolean	everyOther;
	
	everyOther=FALSE;
	src.left = 0;
	src.right = g_Window_Limits.main_Window_Width;
	
	for(srcy = 0; srcy < g_Window_Limits.main_Window_Height; srcy += k_GAP_CASTE_WIPE_REGULAR)
	{
		for(barpos = 0; barpos +  k_GAP_CASTE_WIPE_REGULAR < g_Window_Limits.main_Window_Height; barpos += k_GAP_CASTE_WIPE_REGULAR);
		for(; barpos >= srcy; barpos -= k_GAP_CASTE_WIPE_REGULAR)
		{
			Reset_Timer();
			src.top = srcy;
			src.bottom = srcy +  k_GAP_CASTE_WIPE_REGULAR;
			dest = src;
			dest.top = barpos;
			dest.bottom = barpos +  k_GAP_CASTE_WIPE_REGULAR;
			CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
					&src, &dest, 0, 0L);
			if (everyOther)                      /* simulates time correction 0.5 */
				Delay_If_Needed(k_VIDEO_DELAY_FOR_Caste_Wipe);
			everyOther=!everyOther;
		}
	}
	
} /* void Show_Effect_Caste_Wipe... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Circle_Bulge(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* This copies ovals that always run from the left of the screen to the right,
   but start really squashed and get geometrically taller.  */
/*  */
{
	Rect		current_Rect;
	Rect		source;
	RgnHandle	curregion;
	Point		zeropoint;
	INTEGER_16			cy=g_Window_Limits.main_Window_Height/2;
	INTEGER_16			gap=k_START_GAP_CIRCLE_BULGE;
	
	source.top=source.left=0;
	source.right=g_Window_Limits.main_Window_Width;
	source.bottom=g_Window_Limits.main_Window_Height;

	current_Rect=source;
	current_Rect.top=cy-gap;
	current_Rect.bottom=cy+ gap;
		
	curregion=NewRgn();
	zeropoint.v=0;
	zeropoint.h=k_ZERO_POINT_H_CIRCLE_BULGE;       /* when we copy zeropoint, it's time to stop */
	do
	{
		Reset_Timer();

		SetEmptyRgn(curregion);
		OpenRgn();
		FrameOval(&current_Rect);  /* this makes the region for copying */
		CloseRgn(curregion);

		CopyBits(&(sourceGrafPtr->portBits)
					, &(final_Destination_Ptr->portBits)
					, &source
					, &source
					, 0
					, curregion);

		current_Rect.top-=gap;
		current_Rect.bottom+=gap;     /* make the oval taller */
		gap++;
		gap+=gap/k_GAP_RATIO_CIRCLE_BULGE;       /* make the oval grow faster next time */
		
		Delay_If_Needed(k_VIDEO_DELAY_FOR_CIRCLE_BULGE);
	}
	while (!(PtInRgn(zeropoint, curregion)));   /* quit when we hit zeropoint */

	CopyBits(&(sourceGrafPtr->portBits)
				, &(final_Destination_Ptr->portBits)
				, &source
				, &source
				, 0
				, 0L);          /* copy the whole screen to end it */
	
	DisposeRgn(curregion);
	
} /* void Show_Effect_Circle_Bulge... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Circle_In(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Take a really big circle, then a slightly smaller circle (-k_GAP_FOR_CIRCLE_IN), then
   take the region in between them and copy that, then decrease the outer
   circle radius by k_GAP_FOR_CIRCLE_IN.  Thus: circle in, by successive donut-like copies. */
/*  */
{
	Rect		current_Rect;
	Rect		source;
	INTEGER_16			cx, cy;
	RgnHandle	curregion,lastregion,diffregion;
	
	cx = g_Window_Limits.main_Window_Width / 2;
	cy = g_Window_Limits.main_Window_Height / 2;
	
	current_Rect.left=cx-k_START_RADIUS_FOR_CIRCLE_IN;     /* circumscribing rectangle for outer circle */
	current_Rect.right=cx+ k_START_RADIUS_FOR_CIRCLE_IN;
	current_Rect.top=cy-k_START_RADIUS_FOR_CIRCLE_IN;
	current_Rect.bottom=cy+ k_START_RADIUS_FOR_CIRCLE_IN;
	
	source.top=source.left=0;
	source.bottom=g_Window_Limits.main_Window_Height;
	source.right=g_Window_Limits.main_Window_Width;
	
	curregion=NewRgn();
	lastregion=NewRgn();
	diffregion=NewRgn();

	SetEmptyRgn(lastregion);
	OpenRgn();
		FrameOval(&current_Rect);        /* first circle */
	CloseRgn(lastregion);
	
	while (current_Rect.right-current_Rect.left>0)
	{
		Reset_Timer();
		current_Rect.left+=k_GAP_FOR_CIRCLE_IN;
		current_Rect.right-=k_GAP_FOR_CIRCLE_IN;
		current_Rect.top+=k_GAP_FOR_CIRCLE_IN;
		current_Rect.bottom-=k_GAP_FOR_CIRCLE_IN;
		SetEmptyRgn(curregion);
		OpenRgn();
			FrameOval(&current_Rect);   /* inner circle */
		CloseRgn(curregion);
		DiffRgn(lastregion,curregion,diffregion);   /* donut we need */
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&source, &source, 0, diffregion);
		CopyRgn(curregion,lastregion);    /* outer circle = inner circle */
		Delay_If_Needed(k_VIDEO_DELAY_FOR_CIRCLE_IN);
	}
	
	DisposeRgn(curregion);
	DisposeRgn(lastregion);
	DisposeRgn(diffregion);
	
} /* void Show_Effect_Circle_In... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Circle_Out(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Make a circular region and use it as the mask in CopyBits.  Lots of overlap,
   but masked by timing correction.  If you want to optimize it, look at the
   donut region code in "Circle in.c" */
/*  */
{
	Rect		current_Rect;
	INTEGER_16			cx, cy;
	RgnHandle	curregion;
	
	cx = g_Window_Limits.main_Window_Width / 2;
	cy = g_Window_Limits.main_Window_Height / 2;
	
	current_Rect.left=cx-k_GAP_FOR_CIRCLE_OUT;         /* circumscribing rectangle for circle */
	current_Rect.right=cx+ k_GAP_FOR_CIRCLE_OUT;
	current_Rect.top=cy-k_GAP_FOR_CIRCLE_OUT;
	current_Rect.bottom=cy+ k_GAP_FOR_CIRCLE_OUT;
	
	curregion=NewRgn();
	
	do
	{
		Reset_Timer();
		SetEmptyRgn(curregion);
		OpenRgn();
			FrameOval(&current_Rect);   /* the circle region */
		CloseRgn(curregion);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&current_Rect, &current_Rect, 0, curregion);
		current_Rect.left-=k_GAP_FOR_CIRCLE_OUT;        /* make the rect bigger (and thus the circle) */
		current_Rect.right+=k_GAP_FOR_CIRCLE_OUT;
		current_Rect.top-=k_GAP_FOR_CIRCLE_OUT;
		current_Rect.bottom+=k_GAP_FOR_CIRCLE_OUT;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Circle_Out);
	}
	while (current_Rect.right-current_Rect.left<=592);   /* (2 x || (cx,cy) ||) +  a little */
	
	DisposeRgn(curregion);
	
} /* void Show_Effect_Circle_Out... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Circle_Serendipity(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* I haven't the slightest idea why this works.  Hence the name.  -MP */
/*  */
{
	Rect		current_Rect;
	Rect		source;
	RgnHandle	curregion;
	Point		zeropoint;
	
	source.top=source.left=0;
	source.right=g_Window_Limits.main_Window_Width;
	source.bottom=g_Window_Limits.main_Window_Height;
	
	current_Rect=source;
	current_Rect.top-=g_Window_Limits.main_Window_Height;
	OffsetRect(&current_Rect,0,-g_Window_Limits.main_Window_Height);
		
	curregion=NewRgn();
	SetEmptyRgn(curregion);
	OpenRgn();
		FrameOval(&current_Rect);
	CloseRgn(curregion);
	zeropoint.v=g_Window_Limits.main_Window_Height;
	zeropoint.h=0;
	do
	{
		Reset_Timer();
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&source, &source, 0, curregion);
		OffsetRgn(curregion, 0, k_GAP_CIRCLE_FOR_SERENDIPITY);
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Circle_Serendipity);
	}
	while (!(PtInRgn(zeropoint, curregion)));

	CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&source, &source, 0, 0L);
	
	DisposeRgn(curregion);
	
} /* void Show_Effect_Circle_Serendipity... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Circular_Wipe(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Trace a region from the center to the topleft corner, over <k_BlockSize_Circle_Serendipity> pixels,
   and back to the center.  Fill that in and move the region parameters + k_BlockSize_Circle_Serendipity.
   Repeat for all sides. */
/*  */
{
	RgnHandle	curregion;
	Rect		source;
	INTEGER_16			cx,cy,gap,lastx,lasty;
	
	cx = g_Window_Limits.main_Window_Width / 2;
	cy = g_Window_Limits.main_Window_Height / 2;

	curregion=NewRgn();
	source.top=source.left=0;
	source.bottom=g_Window_Limits.main_Window_Height;
	source.right=g_Window_Limits.main_Window_Width;
	
	gap=k_BlockSize_Circular_Wipe;
	lastx=0;
	do                                            /* top quadrant */
	{
		Reset_Timer();
		SetEmptyRgn(curregion);
		MoveTo(cx,cy);
		OpenRgn();
			LineTo(lastx,0);
			LineTo(gap,0);
			LineTo(cx,cy);
		CloseRgn(curregion);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&source, &source, 0, curregion);
		lastx=gap;
		gap+=k_BlockSize_Circular_Wipe;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Circular_Wipe);
	}
	while (gap<g_Window_Limits.main_Window_Width+ k_BlockSize_Circular_Wipe);
	
	gap=k_BlockSize_Circular_Wipe;
	lasty=0;
	do                                            /* right quadrant */
	{
		Reset_Timer();
		SetEmptyRgn(curregion);
		MoveTo(cx,cy);
		OpenRgn();
			LineTo(g_Window_Limits.main_Window_Width,lasty);
			LineTo(g_Window_Limits.main_Window_Width,gap);
			LineTo(cx,cy);
		CloseRgn(curregion);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&source, &source, 0, curregion);
		lasty=gap;
		gap+=k_BlockSize_Circular_Wipe;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Circular_Wipe);
	}
	while (gap<g_Window_Limits.main_Window_Height+ k_BlockSize_Circular_Wipe);
	
	lastx=g_Window_Limits.main_Window_Width;
	gap=g_Window_Limits.main_Window_Width-k_BlockSize_Circular_Wipe;
	do                                            /* bottom quadrant */
	{
		Reset_Timer();
		SetEmptyRgn(curregion);
		MoveTo(cx,cy);
		OpenRgn();
			LineTo(lastx,g_Window_Limits.main_Window_Height);
			LineTo(gap,g_Window_Limits.main_Window_Height);
			LineTo(cx,cy);
		CloseRgn(curregion);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&source, &source, 0, curregion);
		lastx=gap;
		gap-=k_BlockSize_Circular_Wipe;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Circular_Wipe);
	}
	while (gap>-k_BlockSize_Circular_Wipe);
	
	lasty=g_Window_Limits.main_Window_Height;
	gap=g_Window_Limits.main_Window_Height-k_BlockSize_Circular_Wipe;
	do                                            /* left quadrant */
	{
		Reset_Timer();
		SetEmptyRgn(curregion);
		MoveTo(cx,cy);
		OpenRgn();
			LineTo(0,lasty);
			LineTo(0,gap);
			LineTo(cx,cy);
		CloseRgn(curregion);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&source, &source, 0, curregion);
		lastx=gap;
		gap-=k_BlockSize_Circular_Wipe;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Circular_Wipe);
	}
	while (gap>-k_BlockSize_Circular_Wipe);
	
	DisposeRgn(curregion);
	
} /* void Show_Effect_Circular_Wipe... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Corner_Circle(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Make progressively larger circle regions, centered at the top-left corner
   of the screen.  Quickdraw takes care of all the excess space off the screen
   that you include in the region. */
/*  */
{
	Rect		current_Rect;
	INTEGER_16			cx, cy;
	RgnHandle	curregion;
	Point		zeropoint;
	
	current_Rect.left=-gap_Corner_Circle;
	current_Rect.right=gap_Corner_Circle;
	current_Rect.top=-gap_Corner_Circle;
	current_Rect.bottom=gap_Corner_Circle;
	
	curregion=NewRgn();
	
	zeropoint.v=g_Window_Limits.main_Window_Height;
	zeropoint.h=g_Window_Limits.main_Window_Width;
	
	do
	{
		Reset_Timer();
		SetEmptyRgn(curregion);
		OpenRgn();
			FrameOval(&current_Rect);
		CloseRgn(curregion);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&current_Rect, &current_Rect, 0, curregion);
		current_Rect.left-=gap_Corner_Circle;
		current_Rect.right+=gap_Corner_Circle;
		current_Rect.top-=gap_Corner_Circle;
		current_Rect.bottom+=gap_Corner_Circle;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Corner_Circle);
	}
	while (!(PtInRgn(zeropoint,curregion)));
	
	DisposeRgn(curregion);
	
} /* void Show_Effect_Corner_Circle... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Diagonal_Wipe(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* If you make a long enough region starting at the bottomright corner and
   making a strip up and right of <k_VIDEO_BOX_SIZE_FOR_Diagonal_Wipe> width, all you have to do is move
   the region left until the entire screen is filled.  Dave thinks ideas like
   this should be taken out and shot, but it works. */
/*  */
{
	INTEGER_16			counter,maxmax;
	Rect		source;
	RgnHandle	archie;
	
	maxmax=g_Window_Limits.main_Window_Width+ k_VIDEO_BOX_SIZE_FOR_Diagonal_Wipe;
	archie=NewRgn();
	OpenRgn();
		MoveTo(g_Window_Limits.main_Window_Width+ k_VIDEO_BOX_SIZE_FOR_Diagonal_Wipe
		,g_Window_Limits.main_Window_Height+ k_VIDEO_BOX_SIZE_FOR_Diagonal_Wipe);
		
		Line(0,k_VIDEO_BOX_SIZE_FOR_Diagonal_Wipe);
		Line(-maxmax,maxmax);
		Line(-k_VIDEO_BOX_SIZE_FOR_Diagonal_Wipe,0);
		Line(maxmax,-maxmax);
	CloseRgn(archie);
	source.top=source.left=0;
	source.bottom=g_Window_Limits.main_Window_Height;
	source.right=g_Window_Limits.main_Window_Width;

	/* the only tricky part to this code is the starting param for counter */
	for (counter=2+ (g_Window_Limits.main_Window_Width+ g_Window_Limits.main_Window_Height)/k_VIDEO_BOX_SIZE_FOR_Diagonal_Wipe; counter>=0; counter--)
	{
		Reset_Timer();
		OffsetRgn(archie,0,-k_VIDEO_BOX_SIZE_FOR_Diagonal_Wipe);
		CopyBits(&(sourceGrafPtr->portBits),&(final_Destination_Ptr->portBits),&source,&source,
			0,archie);
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Diagonal_Wipe);
	}
	DisposeRgn(archie);
	
} /* void Show_Effect_Diagonal_Wipe... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Dissolve_Using_Box(GrafPtr newImage, Rect *source, Rect *dest, GrafPtr final_Destination_Ptr)
{
	INTEGER_32		offRowBytes, sizeOfOff;
	Ptr			myBits;
	Rect		bRect;
	GrafPort	myGrafPort;
	GrafPtr		myGrafPtr;
	RgnHandle	oldClipRgn;
	INTEGER_16			i, j;
	Pattern		thePattern;
	INTEGER_8		order[16];
	INTEGER_32		randtemp;
	INTEGER_8		ordertemp;
	CARDINAL_8		*code_Name;
/* END VAR */


	code_Name = "\pDissolve_Using_Box";
	/*  */
	/* the dissolve effect works by creating a random set of patterns which sum
	(OR) to a black pattern.  We make another offscreen bitmap and fill it with
	the pattern at each stage, and use it as a mask for the bitcopy.  Here, we
	create the offscreen bitmap. */
	/*  */
	
	Set_View_Port(newImage);
	bRect = *source;
	myGrafPtr = &myGrafPort;
	OpenPort(myGrafPtr);
	offRowBytes = (((source->right - source->left) +  15) >> 4) << 1;
	sizeOfOff = (INTEGER_32)(source->bottom - source->top) * offRowBytes;
	OffsetRect(&bRect, -bRect.left, -bRect.top);
	myBits = NewPtr(sizeOfOff);
	if(myBits == 0L) {
		goto Error_Handler_No_Memory;
	}
		
	myGrafPort.portBits.baseAddr = myBits;
	myGrafPort.portBits.rowBytes = offRowBytes;
	myGrafPort.portBits.bounds = bRect;
	myGrafPort.portRect = bRect;
	oldClipRgn = myGrafPort.clipRgn;
	myGrafPort.clipRgn = final_Destination_Ptr->visRgn;
	
	for(i = 0; i < 16; i++ )
		order[i] = i;
	
	/* this randomly shuffles the order in which the pattern bits will appear */
	for(i = 15; i >= 0; i--) {
		randtemp = (((INTEGER_32)Random() +  32767) * (i +  1)) / 65535;
		ordertemp = order[randtemp];
		order[randtemp] = order[i];
		order[i] = ordertemp;
	}
	
	for(i = 0; i < 16; i++ )
	{
		Reset_Timer();
		Set_View_Port(myGrafPtr);
		
		for(j = 0; j < 8; j++ ) thePattern.pat[j] = 0;
		thePattern.pat[order[i] >> 2] = 1 << (order[i] & 0x03);
		thePattern.pat[order[i] >> 2] |= 16 << (order[i] & 0x03);
		thePattern.pat[(order[i] >> 2) +  4] = 1 << (order[i] & 0x03);
		thePattern.pat[(order[i] >> 2) +  4] |= 16 << (order[i] & 0x03);
		
		FillRect(&bRect, (ConstPatternParam)&thePattern);
		
		Set_View_Port(final_Destination_Ptr);
		
		CopyMask(&(newImage->portBits), &(myGrafPtr->portBits),
				&(final_Destination_Ptr->portBits), source, &bRect, dest);
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Dissolve_Using_Box);
	}
	
goto Normal_Function_Exit;

Error_Handler_No_Memory:
		Display_Serious_Error_Message(unit_Name, code_Name, "\pNot enough memory", "\pNot critical");
	
Normal_Function_Exit:
	
	myGrafPort.clipRgn = oldClipRgn;
	ClosePort(myGrafPtr);
	if (myBits != nil) {
		DisposPtr(myBits);
	}
		
} /* void Dissolve_Using_Box... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Dissolve_Wipe(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* the actual dissolve wipe splits the screen into 9 blocks, and dissolves
the source onto the destination by blocks in random order.  That way, each
dissolve is faster, and the whole effect is more interesting. */
/*  */
{
	INTEGER_8	order[9];
	INTEGER_8	ordertemp;
	INTEGER_16		i;
	INTEGER_32	randtemp;
	Rect	source, dest;
	
	for(i = 0; i < 9; i++ )
		order[i] = i;
	
	for(i = 8; i >= 0; i--) {
		randtemp = (((INTEGER_32)Random() +  32767) * (i +  1)) / 65535;
		ordertemp = order[randtemp];
		order[randtemp] = order[i];
		order[i] = ordertemp;
	}
	
	for(i = 0; i < 9; i++ ) {
		source.top = (order[i] / 3) * (g_Window_Limits.main_Window_Height / 3);
		source.left = (order[i] % 3) * (g_Window_Limits.main_Window_Width / 3);
		source.bottom = (((order[i] / 3) +  1) * g_Window_Limits.main_Window_Height) / 3;
		source.right = (((order[i] % 3) +  1) * g_Window_Limits.main_Window_Width) / 3;
		
		Dissolve_Using_Box(myGrafPtr, &source, &source, final_Destination_Ptr);
	}
	
} /* void Show_Effect_Dissolve_Wipe... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Four_Corner_Centered(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Really, this only uses one region and one CopyBits per round.  Regions don't
   have to be continuous.  On each axis, on each side of the center of the screen,
   there are two parts of the region which move towards different corners. */
/*  */
{
	RgnHandle	curregion;
	Rect		source;
	INTEGER_16			cx,cy,lastx,lasty,VBlockSize;
	
	cx = g_Window_Limits.main_Window_Width / 2;
	cy = g_Window_Limits.main_Window_Height / 2;
	VBlockSize=k_BlockSize_Four_Corner_Centered*g_Window_Limits.main_Window_Height/g_Window_Limits.main_Window_Width;

	curregion=NewRgn();
	source.top=source.left=0;
	source.bottom=g_Window_Limits.main_Window_Height;
	source.right=g_Window_Limits.main_Window_Width;
	
	lasty=lastx=0;
	do
	{
		Reset_Timer();
		SetEmptyRgn(curregion);
		MoveTo(cx,cy);
		OpenRgn();              /* much much faster than 8 regions/CopyBits */
			LineTo(cx-lastx,0);
			Line(-k_BlockSize_Four_Corner_Centered,0);
			LineTo(cx+ lastx+ k_BlockSize_Four_Corner_Centered,g_Window_Limits.main_Window_Height);
			Line(-k_BlockSize_Four_Corner_Centered,0);
			LineTo(cx,cy);
			
			LineTo(cx+ lastx,0);
			Line(k_BlockSize_Four_Corner_Centered,0);
			LineTo(cx-lastx-k_BlockSize_Four_Corner_Centered,g_Window_Limits.main_Window_Height);
			Line(k_BlockSize_Four_Corner_Centered,0);
			LineTo(cx,cy);
			
			LineTo(g_Window_Limits.main_Window_Width,cy-lasty);
			Line(0,-VBlockSize);
			LineTo(0,cy+ lasty+ VBlockSize);
			Line(0,-VBlockSize);
			LineTo(cx,cy);
			
			LineTo(g_Window_Limits.main_Window_Width,cy+ lasty);
			Line(0,VBlockSize);
			LineTo(0,cy-lasty-VBlockSize);
			Line(0,VBlockSize);
			LineTo(cx,cy);
		CloseRgn(curregion);

		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&source, &source, 0, curregion);
		lastx+=k_BlockSize_Four_Corner_Centered;
		lasty+=VBlockSize;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Four_Corner_Centered);
	}
	while (lastx<cx);

	CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
		&source, &source, 0, 0L);    /* in case we miss a few pixels */
	
	DisposeRgn(curregion);
	
} /* void Show_Effect_Four_Corner_Centered... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Four_Corner(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Take 4 bars, two on each axis, and move them towards different corners.
   This means lots of overlap copying, but the timing masks it and Quickdraw
   may even take care of some of it. (?) */
/*  */
{
	Rect		vsource1,hsource1,vsource2,hsource2;
	INTEGER_16			vbar,hbar,cx,cy;
	INTEGER_32			HBarGap_Four_Corner;
	
	HBarGap_Four_Corner = ((VBarGap_Four_Corner*g_Window_Limits.main_Window_Height)/g_Window_Limits.main_Window_Width);

	vbar=VBarGap_Four_Corner;
	hbar=HBarGap_Four_Corner;
	cx = g_Window_Limits.main_Window_Width/2;
	cy = g_Window_Limits.main_Window_Height/2;
	vsource1.top=vsource2.top=hsource2.left=hsource1.left=0;    /* these */
	vsource1.bottom=vsource2.bottom=g_Window_Limits.main_Window_Height;         /* never */
	hsource1.right=hsource2.right=g_Window_Limits.main_Window_Width;            /* change */
	while (vbar<cx+ VBarGap_Four_Corner)
	{
		Reset_Timer();
		vsource1.left=cx-vbar;
		vsource1.right=vsource1.left+ VBarGap_Four_Corner;
		vsource2.right=cx+ vbar;
		vsource2.left=vsource2.right-VBarGap_Four_Corner;
		hsource1.top=cy-hbar;
		hsource1.bottom=hsource1.top+ HBarGap_Four_Corner;
		hsource2.bottom=cy+ hbar;
		hsource2.top=hsource2.bottom-HBarGap_Four_Corner;
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&vsource1, &vsource1, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&hsource1, &hsource1, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&vsource2, &vsource2, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&hsource2, &hsource2, 0, 0L);
		vbar+=VBarGap_Four_Corner;
		hbar+=HBarGap_Four_Corner;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Four_Corner);
	}
	
} /* void Show_Effect_Four_Corner(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Four_Corner_Scroll(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Four scrolls in one, each confined to a section of the screen which includes
   the center and one side, and all four scrolls moving towards the center.
   Kinda slow on my Mac IIci in 8-bit; fine in 4-bit or fewer. */
/*  */
{
	INTEGER_16			x;
	Rect		theTopRect, topdest, theBottomRect, bottomdest;
	Rect		theLeftRect, leftdest, theRightRect, rightdest;
	Rect		topscrollsource, topscrolldest, bottomscrollsource, bottomscrolldest;
	Rect		leftscrollsource, leftscrolldest, rightscrollsource, rightscrolldest;
	RgnHandle	toprgn,bottomrgn,leftrgn,rightrgn;
	INTEGER_16			cx,cy;
	INTEGER_16			H_Box_Size=k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll*g_Window_Limits.main_Window_Width/g_Window_Limits.main_Window_Height;
	
	cx = g_Window_Limits.main_Window_Width / 2;
	cy = g_Window_Limits.main_Window_Height / 2;

	toprgn=NewRgn();
	SetEmptyRgn(toprgn);
	MoveTo(0,0);
	OpenRgn();                               /* top region */
		LineTo(g_Window_Limits.main_Window_Width,0);
		LineTo(cx,cy);
		LineTo(0,0);
	CloseRgn(toprgn);
	
	bottomrgn=NewRgn();
	SetEmptyRgn(bottomrgn);
	MoveTo(0,g_Window_Limits.main_Window_Height);
	OpenRgn();                               /* bottom region */
		LineTo(g_Window_Limits.main_Window_Width,g_Window_Limits.main_Window_Height);
		LineTo(cx,cy);
		LineTo(0,g_Window_Limits.main_Window_Height);
	CloseRgn(bottomrgn);
	
	leftrgn=NewRgn();
	SetEmptyRgn(leftrgn);
	MoveTo(0,0);
	OpenRgn();                               /* left region */
		LineTo(0,g_Window_Limits.main_Window_Height);
		LineTo(cx,cy);
		LineTo(0,0);
	CloseRgn(leftrgn);
	
	rightrgn=NewRgn();
	SetEmptyRgn(rightrgn);
	MoveTo(g_Window_Limits.main_Window_Width,0);
	OpenRgn();                               /* right region */
		LineTo(g_Window_Limits.main_Window_Width,g_Window_Limits.main_Window_Height);
		LineTo(cx,cy);
		LineTo(g_Window_Limits.main_Window_Width,0);
	CloseRgn(rightrgn);
	
	topscrollsource=bottomscrollsource=leftscrollsource=rightscrollsource=
		topdest=bottomdest=leftdest=rightdest=final_Destination_Ptr->portRect;
	
	topscrollsource.bottom-=cy+ k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll;
	topscrolldest = topscrollsource;
	OffsetRect(&topscrolldest, 0, k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll);        /* dest. strip for top scroll */
	
	topdest.bottom=k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll;                        /* dest. strip for new data on top */
	
	theTopRect.top=cy-k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll;                     /* source strip for new data on top */
	theTopRect.bottom=cy;
	theTopRect.left=0;
	theTopRect.right=g_Window_Limits.main_Window_Width;
	
	bottomscrollsource.top+=cy+ k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll;
	bottomscrolldest=bottomscrollsource;
	OffsetRect(&bottomscrolldest, 0, -k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll);
	
	bottomdest.top=bottomdest.bottom-k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll;
	
	theBottomRect.top=cy;
	theBottomRect.left=0;
	theBottomRect.bottom=cy+ k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll;
	theBottomRect.right=g_Window_Limits.main_Window_Width;
	
	leftscrollsource.right-=cx+ H_Box_Size;
	leftscrolldest=leftscrollsource;
	OffsetRect(&leftscrolldest,H_Box_Size,0);
	
	leftdest.right=H_Box_Size;
	
	theLeftRect.top=0;
	theLeftRect.bottom=g_Window_Limits.main_Window_Height;
	theLeftRect.left=cx-H_Box_Size;
	theLeftRect.right=cx;
	
	rightscrollsource.left+=cx+ H_Box_Size;
	rightscrolldest=rightscrollsource;
	OffsetRect(&rightscrolldest,-H_Box_Size,0);
	
	rightdest.left=rightdest.right-H_Box_Size;
	
	theRightRect.top=0;
	theRightRect.bottom=g_Window_Limits.main_Window_Height;
	theRightRect.left=cx;
	theRightRect.right=cx+ H_Box_Size;
	
	/* for each section (top, bottom, left, right) we need to do the scroll part,
	which takes a section of the dest. window and moves it, then we need to copy
	in the new data from the source window */
	for(x = cy - k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll; x >= 0; x -= k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll)
	{
		Reset_Timer();
		CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
				&topscrollsource, &topscrolldest, 0, toprgn);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&theTopRect, &topdest, 0, toprgn);
		theTopRect.bottom-=k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll;
		theTopRect.top-=k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll;
		
		CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
				&bottomscrollsource, &bottomscrolldest, 0, bottomrgn);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&theBottomRect, &bottomdest, 0, bottomrgn);
		theBottomRect.top+=k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll;
		theBottomRect.bottom+=k_VIDEO_BOX_SIZE_FOR_Four_Corner_Scroll;
		
		CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
				&leftscrollsource, &leftscrolldest, 0, leftrgn);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&theLeftRect, &leftdest, 0, leftrgn);
		theLeftRect.left-=H_Box_Size;
		theLeftRect.right-=H_Box_Size;
		
		CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
				&rightscrollsource, &rightscrolldest, 0, rightrgn);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&theRightRect, &rightdest, 0, rightrgn);
		theRightRect.left+=H_Box_Size;
		theRightRect.right+=H_Box_Size;
		
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Four_Corner_Scroll);
	}
	
	theTopRect.top=theTopRect.left=0;
	theTopRect.bottom=g_Window_Limits.main_Window_Height;
	theTopRect.right=g_Window_Limits.main_Window_Width;
	topdest=final_Destination_Ptr->portRect;
	CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
		&theTopRect, &topdest, 0, 0L);    /* in case we missed any bits */

	DisposeRgn(toprgn);
	DisposeRgn(bottomrgn);
	DisposeRgn(leftrgn);
	DisposeRgn(rightrgn);
	
} /* void Show_Effect_Four_Corner_Scroll(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Full_Scroll_L_R(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Take the whole screen - the righthand strip; move it into the whole screen
   shifted right by k_VIDEO_BOX_SIZE_FOR_Full_Scroll_L_R; take the righthand strip of the source window and
   move it into the lefthand strip of the dest.  */
/*  */
{
	INTEGER_16			x, y;
	Rect		current_Rect, dest;
	Rect		scrollsource, scrolldest;
	
	scrollsource=final_Destination_Ptr->portRect;
	scrollsource.right-=k_VIDEO_BOX_SIZE_FOR_Full_Scroll_L_R;              /* whole screen minus righthand strip */
	scrolldest = scrollsource;
	OffsetRect(&scrolldest, k_VIDEO_BOX_SIZE_FOR_Full_Scroll_L_R, 0);      /* whole screen shifted + k_VIDEO_BOX_SIZE_FOR_Full_Scroll_L_R */
	
	dest = final_Destination_Ptr->portRect;
	dest.right=k_VIDEO_BOX_SIZE_FOR_Full_Scroll_L_R;                       /* lefthand strip */
	
	current_Rect.top=0;
	current_Rect.bottom=g_Window_Limits.main_Window_Height;
	current_Rect.left=g_Window_Limits.main_Window_Width-k_VIDEO_BOX_SIZE_FOR_Full_Scroll_L_R;
	current_Rect.right=g_Window_Limits.main_Window_Width;          /* source strip */
	
	for(x = g_Window_Limits.main_Window_Width - k_VIDEO_BOX_SIZE_FOR_Full_Scroll_L_R; x >= 0; x -= k_VIDEO_BOX_SIZE_FOR_Full_Scroll_L_R)
	{
		Reset_Timer();
		CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
				&scrollsource, &scrolldest, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&current_Rect, &dest, 0, 0L);
		current_Rect.right-=k_VIDEO_BOX_SIZE_FOR_Full_Scroll_L_R;
		current_Rect.left-=k_VIDEO_BOX_SIZE_FOR_Full_Scroll_L_R;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Full_Scroll_L_R);
	}
	
} /* void Show_Effect_Full_Scroll_L_R(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Full_Scroll_U_D(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Take the full screen minus the bottom strip, move it into the whole screen
   shifted down by k_VIDEO_BOX_SIZE_FOR_Full_Scroll_U_D, then take the bottommost source strip and put it
   in the top strip of the dest. window. */
/*  */
{
	INTEGER_16			x, y;
	Rect		current_Rect, dest;
	Rect		scrollsource, scrolldest;
	
	scrollsource=final_Destination_Ptr->portRect;
	scrollsource.bottom-=k_VIDEO_BOX_SIZE_FOR_Full_Scroll_U_D;              /* whole screen minus bottom strip */
	scrolldest = scrollsource;
	OffsetRect(&scrolldest, 0, k_VIDEO_BOX_SIZE_FOR_Full_Scroll_U_D);       /* whole screen shifted down k_VIDEO_BOX_SIZE_FOR_Full_Scroll_U_D */
	
	dest = final_Destination_Ptr->portRect;
	dest.bottom=k_VIDEO_BOX_SIZE_FOR_Full_Scroll_U_D;                       /* top strip for new data */
	
	current_Rect.top=g_Window_Limits.main_Window_Height-k_VIDEO_BOX_SIZE_FOR_Full_Scroll_U_D;    /* bottom strip of source window */
	current_Rect.bottom=g_Window_Limits.main_Window_Height;
	current_Rect.left=0;
	current_Rect.right=g_Window_Limits.main_Window_Width;
	
	for(x = g_Window_Limits.main_Window_Height - k_VIDEO_BOX_SIZE_FOR_Full_Scroll_U_D; x >= 0; x -= k_VIDEO_BOX_SIZE_FOR_Full_Scroll_U_D)
	{
		Reset_Timer();
		CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
				&scrollsource, &scrolldest, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&current_Rect, &dest, 0, 0L);
		current_Rect.bottom-=k_VIDEO_BOX_SIZE_FOR_Full_Scroll_U_D;
		current_Rect.top-=k_VIDEO_BOX_SIZE_FOR_Full_Scroll_U_D;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_FullScrollUD);
	}
	
} /* void Show_Effect_Full_Scroll_U_D(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Halves_Scroll(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* 2 regions, split down the middle of the screen.  Scroll the screen up in one
   region and down in the other. */
/*  */
{
	INTEGER_16			x;
	Rect		theTopRect, topdest, theBottomRect, bottomdest;
	Rect		topscrollsource, topscrolldest, bottomscrollsource, bottomscrolldest;
	RgnHandle	toprgn,bottomrgn;
	INTEGER_16			cx;
	
	cx = g_Window_Limits.main_Window_Width / 2;

	toprgn=NewRgn();
	SetEmptyRgn(toprgn);
	MoveTo(0,0);
	OpenRgn();
		Line(cx,0);
		LineTo(cx,g_Window_Limits.main_Window_Height);
		LineTo(0,g_Window_Limits.main_Window_Height);
		LineTo(0,0);
	CloseRgn(toprgn);
	
	bottomrgn=NewRgn();
	SetEmptyRgn(bottomrgn);
	MoveTo(cx,0);
	OpenRgn();
		LineTo(cx,g_Window_Limits.main_Window_Height);
		LineTo(g_Window_Limits.main_Window_Width,g_Window_Limits.main_Window_Height);
		LineTo(g_Window_Limits.main_Window_Width,0);
		LineTo(cx,0);
	CloseRgn(bottomrgn);
	
	topscrollsource=final_Destination_Ptr->portRect;
	topscrollsource.bottom-=k_VIDEO_BOX_SIZE_FOR_Halves_Scroll;
	topscrollsource.right=cx;
	topscrolldest = topscrollsource;
	OffsetRect(&topscrolldest, 0, k_VIDEO_BOX_SIZE_FOR_Halves_Scroll);
	
	topdest = final_Destination_Ptr->portRect;
	topdest.bottom=k_VIDEO_BOX_SIZE_FOR_Halves_Scroll;
	topdest.right=cx;
	
	theTopRect.top=g_Window_Limits.main_Window_Height-k_VIDEO_BOX_SIZE_FOR_Halves_Scroll;
	theTopRect.bottom=g_Window_Limits.main_Window_Height;
	theTopRect.left=0;
	theTopRect.right=cx;
	
	bottomscrollsource=final_Destination_Ptr->portRect;
	bottomscrollsource.top+=k_VIDEO_BOX_SIZE_FOR_Halves_Scroll;
	bottomscrollsource.left=cx;
	bottomscrolldest=bottomscrollsource;
	OffsetRect(&bottomscrolldest, 0, -k_VIDEO_BOX_SIZE_FOR_Halves_Scroll);
	
	bottomdest=final_Destination_Ptr->portRect;
	bottomdest.top=bottomdest.bottom-k_VIDEO_BOX_SIZE_FOR_Halves_Scroll;
	bottomdest.left=cx;
	
	theBottomRect.top=0;
	theBottomRect.bottom=k_VIDEO_BOX_SIZE_FOR_Halves_Scroll;
	theBottomRect.left=cx;
	theBottomRect.right=g_Window_Limits.main_Window_Width;
	
	for(x = g_Window_Limits.main_Window_Height - k_VIDEO_BOX_SIZE_FOR_Halves_Scroll; x >= 0; x -= k_VIDEO_BOX_SIZE_FOR_Halves_Scroll)
	{
		Reset_Timer();
		CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
				&topscrollsource, &topscrolldest, 0, toprgn);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&theTopRect, &topdest, 0, toprgn);
		theTopRect.bottom-=k_VIDEO_BOX_SIZE_FOR_Halves_Scroll;
		theTopRect.top-=k_VIDEO_BOX_SIZE_FOR_Halves_Scroll;
		
		CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
				&bottomscrollsource, &bottomscrolldest, 0, bottomrgn);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&theBottomRect, &bottomdest, 0, bottomrgn);
		theBottomRect.top+=k_VIDEO_BOX_SIZE_FOR_Halves_Scroll;
		theBottomRect.bottom+=k_VIDEO_BOX_SIZE_FOR_Halves_Scroll;
		
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Halves_Scroll);
	}
	
} /* void Show_Effect_Halves_Scroll(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Recurse_Using_Hilbert_Effect(GrafPtr myGrafPtr, INTEGER_16 level, INTEGER_16 whichpattern, INTEGER_16* x, INTEGER_16* y, GrafPtr final_Destination_Ptr)
/*  */
/* This fills the screen by a Hilbert space-filling curve, which is defined by
   two mutually recursive drawing functions:
   
   X = left, Y, draw, right, X, draw, X, right, draw, Y, left
   Y = right, X, draw, left, Y, draw, Y, left, draw, X, right
   
   Start by drawing X at the highest recursion level from the bottomleft of the
   screen. (At recursion level 1, X and Y are null functions.)
*/
/*  */
{
	INTEGER_16		i;
	Rect	source;
	
	for (i=0; i<11; i++ )
	{
		switch (g_Hilbert_Pattern[whichpattern][i])
		{
			case 0x01:     /* turn left */
				g_Direction_HilbertWipe--;
				if (g_Direction_HilbertWipe<0) g_Direction_HilbertWipe=3;
				break;
			case 0x02:     /* turn right */
				g_Direction_HilbertWipe++;
				if (g_Direction_HilbertWipe==4) g_Direction_HilbertWipe=0;
				break;
			case 0x00:    /* draw */
				Reset_Timer();
				source.top=*y-k_V_BLOCK_SIZE_FOR_HILBERT_WIPE;
				source.bottom=*y;
				source.left=*x;
				source.right=*x+ hBlockSize_HilbertWipe;
				CopyBits(&(myGrafPtr->portBits), &(final_Destination_Ptr->portBits),
								&source, &source, 0, 0L);
				switch (g_Direction_HilbertWipe)
				{
					case 0:
						*x+=hBlockSize_HilbertWipe;
						break;
					case 1:
						*y-=k_V_BLOCK_SIZE_FOR_HILBERT_WIPE;
						break;
					case 2:
						*x-=hBlockSize_HilbertWipe;
						break;
					case 3:
						*y+=k_V_BLOCK_SIZE_FOR_HILBERT_WIPE;
						break;
				}
				Delay_If_Needed(k_VIDEO_DELAY_FOR_HilbertWipe);
				break;
			case 0x42:    /* call X */
				if (level>1) Recurse_Using_Hilbert_Effect(myGrafPtr,level-1,0,x,y, final_Destination_Ptr);
				break;
			case 0x69:    /* call Y */
				if (level>1) Recurse_Using_Hilbert_Effect(myGrafPtr,level-1,1,x,y, final_Destination_Ptr);
				break;
		}
	}
	
} /* void Recurse_Using_Hilbert_Effect(GrafPtr myGrafPtr, INTEGER_16 level, INTEGER_16 whichpattern, INTEGER_16* x, INTEGER_16* y)*/
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Hilbert_Wipe_Call(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr)
{
	INTEGER_16			curx, cury;
	Rect		source;
	
	cury=g_Window_Limits.main_Window_Height;
	curx=0;
	g_Direction_HilbertWipe = 0;
	
	Recurse_Using_Hilbert_Effect(myGrafPtr, k_RECURSION_LIMIT_FOR_HILBERT_WIPE, 0, &curx,&cury, final_Destination_Ptr);
	source.bottom=g_Window_Limits.main_Window_Height;
	source.right=g_Window_Limits.main_Window_Width;
	source.top=source.bottom-k_V_BLOCK_SIZE_FOR_HILBERT_WIPE;
	source.left=source.right-hBlockSize_HilbertWipe;
	CopyBits(&(myGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&source, &source, 0, 0L);  /* in case we missed any bits */

} /* void Show_Effect_Hilbert_Wipe_Call(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Pour_Scroll(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Scroll down in tiny strips, starting at the left and moving right.  Scroll
   strips 1-(N), then strips 1-(N+ 1), etc.  When strip 1 is done, don't do it
   anymore!  (Duh, but this was difficult to get right.)  So only scroll strips
   2-(N), and so on. */
/*  */
{
	Rect		current_Rect[NumStrips_Pour_Scroll], dest[NumStrips_Pour_Scroll];
	Rect		scrollsource, scrolldest;
	INTEGER_16			i;
	INTEGER_16			startstrip,endstrip;
	
	scrollsource=final_Destination_Ptr->portRect;
	scrollsource.bottom-=ScrollSize_Pour_Scroll;
	scrollsource.left=0;
	scrollsource.right=k_VIDEO_BOX_SIZE_FOR_Pour_Scroll;
	scrolldest = scrollsource;
	OffsetRect(&scrolldest, 0, ScrollSize_Pour_Scroll);
		
	for (i=0; i<NumStrips_Pour_Scroll; i++ )
	{
		dest[i] = final_Destination_Ptr->portRect;
		dest[i].bottom=ScrollSize_Pour_Scroll;
		dest[i].left=i*k_VIDEO_BOX_SIZE_FOR_Pour_Scroll;
		dest[i].right=dest[i].left+ k_VIDEO_BOX_SIZE_FOR_Pour_Scroll;
		
		current_Rect[i].top=g_Window_Limits.main_Window_Height-ScrollSize_Pour_Scroll;
		current_Rect[i].bottom=g_Window_Limits.main_Window_Height;
		current_Rect[i].left=i*k_VIDEO_BOX_SIZE_FOR_Pour_Scroll;
		current_Rect[i].right=current_Rect[i].left+ k_VIDEO_BOX_SIZE_FOR_Pour_Scroll;
	}
	
	startstrip=0;
	endstrip=1;
	do
	{
		Reset_Timer();
		
		CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
				&scrollsource, &scrolldest, 0, 0L);
		
		for (i=startstrip; i<endstrip; i++ )
		{
			CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
					&current_Rect[i], &dest[i], 0, 0L);
			current_Rect[i].bottom-=ScrollSize_Pour_Scroll;
			current_Rect[i].top-=ScrollSize_Pour_Scroll;
		}
		
		if (endstrip<NumStrips_Pour_Scroll)
		{
			endstrip++;
			scrollsource.right+=k_VIDEO_BOX_SIZE_FOR_Pour_Scroll;
			scrolldest.right+=k_VIDEO_BOX_SIZE_FOR_Pour_Scroll;
		}
		if (current_Rect[startstrip].bottom==0)
		{
			startstrip++;
			scrollsource.left+=k_VIDEO_BOX_SIZE_FOR_Pour_Scroll;
			scrolldest.left+=k_VIDEO_BOX_SIZE_FOR_Pour_Scroll;
		}
		
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Pour_Scroll);
	}
	while (startstrip<endstrip);

} /* void Show_Effect_Pour_Scroll(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Random_Wipe(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Basically, we divide the window into a bunch of blocks, and copy
each to the screen in random order. */
/*  */
{
	INTEGER_16		order[AREA_Random_Wipe];
	INTEGER_16		i;
	INTEGER_32	randtemp;
	INTEGER_16		ordertemp;
	Rect	subBox;
	Rect	dest;
	Boolean	everyOther;
	
	everyOther=FALSE;
	for(i = 0; i < AREA_Random_Wipe; i++ )
		order[i] = i;
	
	for(i = (AREA_Random_Wipe - 1); i >= 0; i--) {
		randtemp = ((((INTEGER_32)Random()) + 32767) * (i +  1)) / 65535;
		
		ordertemp = order[randtemp];
		order[randtemp] = order[i];
		order[i] = ordertemp;
	}
	
	for(i = 0; i < AREA_Random_Wipe; i++ ) {
		Reset_Timer();
		subBox.top = (((order[i] / SUB_VER_Random_Wipe) *
						((myGrafPtr->portRect).bottom - (myGrafPtr->portRect).top))
						/ SUB_VER_Random_Wipe) +  (myGrafPtr->portRect).top;
		subBox.left = (((order[i] % SUB_HOR_Random_Wipe) *
						((myGrafPtr->portRect).right - (myGrafPtr->portRect).left))
						/ SUB_HOR_Random_Wipe) +  (myGrafPtr->portRect).left;
		subBox.bottom = ((((order[i] / SUB_VER_Random_Wipe) +  1) *
						((myGrafPtr->portRect).bottom - (myGrafPtr->portRect).top))
						/ SUB_VER_Random_Wipe) +  (myGrafPtr->portRect).top;
		subBox.right = ((((order[i] % SUB_HOR_Random_Wipe) +  1) *
						((myGrafPtr->portRect).right - (myGrafPtr->portRect).left))
						/ SUB_HOR_Random_Wipe) +  (myGrafPtr->portRect).left;
		
		CopyBits(&(myGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&subBox, &subBox, 0, 0L);
		if (everyOther)
			Delay_If_Needed(k_VIDEO_DELAY_FOR_Random_Wipe);
		everyOther=!everyOther;
	}

} /* void Show_Effect_Random_Wipe(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Rescue_Raiders(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* One region in 8 parts.  Each part of the region either starts at a corner
   or in the middle of a side and moves progressively clockwise until the
   entire screen is filled. Named after a similar effect in the game Rescue
   Raiders on the Apple ][e (now called Armor Alley on the Mac, but it doesn't
   have this effect in it anymore). */
 /*  */
{
	RgnHandle	curregion;
	Rect		source;
	INTEGER_16			cx,cy,lastx,lasty,VBlockSize;
	
	cx = (final_Destination_Ptr->portRect.right +  final_Destination_Ptr->portRect.left) / 2;
	cy = (final_Destination_Ptr->portRect.bottom +  final_Destination_Ptr->portRect.top) / 2;
	VBlockSize=k_BlockSize_Rescue_Raiders*g_Window_Limits.main_Window_Height/g_Window_Limits.main_Window_Width;

	source.top=source.left=0;
	source.bottom=g_Window_Limits.main_Window_Height;
	source.right=g_Window_Limits.main_Window_Width;
	
	lasty=lastx=0;
	curregion=NewRgn();
	do
	{
		Reset_Timer();

		SetEmptyRgn(curregion);
		MoveTo(cx,cy);
		OpenRgn();
			LineTo(lastx,0);
			Line(k_BlockSize_Rescue_Raiders,0);
			LineTo(g_Window_Limits.main_Window_Width-lastx-k_BlockSize_Rescue_Raiders,g_Window_Limits.main_Window_Height);
			Line(k_BlockSize_Rescue_Raiders,0);
			LineTo(cx,cy);
			
			LineTo(cx+ lastx,0);
			Line(k_BlockSize_Rescue_Raiders,0);
			LineTo(cx-lastx-k_BlockSize_Rescue_Raiders,g_Window_Limits.main_Window_Height);
			Line(k_BlockSize_Rescue_Raiders,0);
			LineTo(cx,cy);
			
			LineTo(g_Window_Limits.main_Window_Width,lasty);
			Line(0,VBlockSize);
			LineTo(0,g_Window_Limits.main_Window_Height-lasty-VBlockSize);
			Line(0,VBlockSize);
			LineTo(cx,cy);
			
			LineTo(g_Window_Limits.main_Window_Width,cy+ lasty);
			Line(0,VBlockSize);
			LineTo(0,cy-lasty-VBlockSize);
			Line(0,VBlockSize);
			LineTo(cx,cy);
		CloseRgn(curregion);

		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&source, &source, 0, curregion);

		lastx+=k_BlockSize_Rescue_Raiders;
		lasty+=VBlockSize;

		Delay_If_Needed(k_VIDEO_DELAY_FOR_Rescue_Raiders);
	}
	while (lastx<cx);
	
	CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
		&source, &source, 0, 0L);   /* in case we missed any bits */
	
	DisposeRgn(curregion);

} /* void Show_Effect_Rescue_Raiders(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Ripple_Wipe(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr)
{
	INTEGER_16		bigy, littley, barpos;
	Rect	src, dest;
	
	src.left = 0;
	src.right = g_Window_Limits.main_Window_Width;
	
	for(bigy = 0; bigy < g_Window_Limits.main_Window_Height; bigy += BigRippleSize_Ripple_Wipe)
	{
		for(littley = bigy; littley < bigy +  BigRippleSize_Ripple_Wipe; littley += gap_Ripple_Wipe)
		{
			for(barpos = bigy; barpos +  gap_Ripple_Wipe < bigy +  BigRippleSize_Ripple_Wipe; barpos += gap_Ripple_Wipe);
			for(; barpos >= littley; barpos -= gap_Ripple_Wipe)
			{
				Reset_Timer();
				src.top = littley;
				src.bottom = littley +  gap_Ripple_Wipe;
				dest = src;
				dest.top = barpos;
				dest.bottom = barpos +  gap_Ripple_Wipe;
				CopyBits(&(myGrafPtr->portBits), &(final_Destination_Ptr->portBits),
						&src, &dest, 0, 0L);
				Delay_If_Needed(k_VIDEO_DELAY_FOR_Ripple_Wipe);
			}
		}
	}

} /* void Show_Effect_Ripple_Wipe(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Scissors(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* A region in two parts, starting at the top of the left and right sides and
   moving down the sides and together towards the middle of the bottom side. */
/*  */
{
	RgnHandle	curregion;
	Rect		source,dest;
	INTEGER_16			cx,gap,lastx,lasty;
	
	cx = g_Window_Limits.main_Window_Width / 2;

	curregion=NewRgn();
	source.top=source.left=0;
	source.bottom=g_Window_Limits.main_Window_Height;
	source.right=g_Window_Limits.main_Window_Width;
	
	gap=k_BlockSize_Scissors;
	lasty=0;
	do
	{
		Reset_Timer();
		SetEmptyRgn(curregion);
		MoveTo(cx,0);
		OpenRgn();
			LineTo(g_Window_Limits.main_Window_Width,lasty);   /* get the right half */
			LineTo(g_Window_Limits.main_Window_Width,gap);
			LineTo(cx,0);
			LineTo(0,lasty);                   /* get the left half */
			LineTo(0,gap);
			LineTo(cx,0);
		CloseRgn(curregion);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&source, &source, 0, curregion);
		lasty=gap;
		gap+=k_BlockSize_Scissors;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Scissors);
	}
	while (gap<g_Window_Limits.main_Window_Height+ k_BlockSize_Scissors);
	
	lastx=g_Window_Limits.main_Window_Width;
	gap=g_Window_Limits.main_Window_Width-k_BlockSize_Scissors;
	do
	{
		Reset_Timer();
		SetEmptyRgn(curregion);
		MoveTo(cx,0);
		OpenRgn();
			LineTo(lastx,g_Window_Limits.main_Window_Height);    /* get the right half on bottom side */
			LineTo(gap,g_Window_Limits.main_Window_Height);
			LineTo(cx,0);
			LineTo(g_Window_Limits.main_Window_Width-lastx,g_Window_Limits.main_Window_Height); /* left 1/2 on bottom */
			LineTo(g_Window_Limits.main_Window_Width-gap,g_Window_Limits.main_Window_Height);
			LineTo(cx,0);
		CloseRgn(curregion);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&source, &source, 0, curregion);
		lastx=gap;
		gap-=k_BlockSize_Scissors;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Scissors);
	}
	while (gap>g_Window_Limits.main_Window_Width/2);
	
	CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
		&source, &source, 0, 0L);   /* if we missed any bits */
	
	DisposeRgn(curregion);

} /* void Show_Effect_Scissors(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Skipaline_L_R(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Copy even-numbered columns starting at the left and moving right, and odd-
   numbered columns starting at the right and moving left.  */
/*  */
{
	Rect		first_Rect,second_Rect;
	Boolean		everyOther=FALSE;
	
	first_Rect.left=first_Rect.top=second_Rect.top=0;
	first_Rect.bottom=second_Rect.bottom=g_Window_Limits.main_Window_Height;
	first_Rect.right=1;
	second_Rect.right=g_Window_Limits.main_Window_Width;
	second_Rect.left=g_Window_Limits.main_Window_Width-1;
		
	while (first_Rect.left<g_Window_Limits.main_Window_Width)
	{
		Reset_Timer();
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&first_Rect, &first_Rect, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&second_Rect, &second_Rect, 0, 0L);
		first_Rect.left+=2;      /* left column moves right by 2 */
		first_Rect.right+=2;
		second_Rect.left-=2;      /* right column moves left by 2 */
		second_Rect.right-=2;
		if (everyOther)
			Delay_If_Needed(k_VIDEO_DELAY_FOR_Skipaline_L_R);
		everyOther=!everyOther;
	}

} /* void Show_Effect_Skipaline_L_R(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Skipaline(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Copy even-numbered rows starting at the top and moving down, and copy odd-
   numbered rows starting at the bottom and moving up. */
/*  */
{
	Rect		first_Rect,second_Rect;
	
	first_Rect.top=first_Rect.left=second_Rect.left=0;
	first_Rect.bottom=1;
	second_Rect.bottom=g_Window_Limits.main_Window_Height;
	second_Rect.top=g_Window_Limits.main_Window_Height-1;
	first_Rect.right=second_Rect.right=g_Window_Limits.main_Window_Width;
	
	while (first_Rect.top<g_Window_Limits.main_Window_Height)
	{
		Reset_Timer();
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&first_Rect, &first_Rect, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&second_Rect, &second_Rect, 0, 0L);
		first_Rect.top+=2;             /* even row goes down by 2 */
		first_Rect.bottom+=2;
		second_Rect.top-=2;             /* odd row goes up by 2 */
		second_Rect.bottom-=2;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Skipaline);
	}

} /* void Show_Effect_Skipaline(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Slide_Wipe(GrafPtr myGrafPtr, GrafPtr final_Destination_Ptr)
{
	INTEGER_16			x, y;
	Rect		current_Rect, dest;
	Rect		scrollsource, scrolldest;
	INTEGER_16			direction;
	
	direction = 0;
	
	for(y = 0; y < g_Window_Limits.main_Window_Height; y += StripSize_Slide_Wipe)
	{
		scrollsource = final_Destination_Ptr->portRect;
		scrollsource.top = scrollsource.top +  y;
		scrollsource.bottom = scrollsource.top +  StripSize_Slide_Wipe;
		
		scrolldest = scrollsource;
		
		dest = final_Destination_Ptr->portRect;
		dest.top = dest.top +  y;
		dest.bottom = dest.top +  StripSize_Slide_Wipe;
		
		current_Rect.top = y;
		current_Rect.bottom = y +  StripSize_Slide_Wipe;
		
		if(direction == 0)
		{
			OffsetRect(&scrolldest, k_VIDEO_BOX_SIZE_FOR_Slide_Wipe, 0);
			
			dest.right = dest.left +  k_VIDEO_BOX_SIZE_FOR_Slide_Wipe;
			
			current_Rect.left = g_Window_Limits.main_Window_Width - k_VIDEO_BOX_SIZE_FOR_Slide_Wipe;
			current_Rect.right = g_Window_Limits.main_Window_Width;
			
			for(x = g_Window_Limits.main_Window_Width - k_VIDEO_BOX_SIZE_FOR_Slide_Wipe; x >= 0; x -= k_VIDEO_BOX_SIZE_FOR_Slide_Wipe)
			{
				Reset_Timer();
				current_Rect.left = x;
				CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
						&scrollsource, &scrolldest, 0, 0L);
				CopyBits(&(myGrafPtr->portBits), &(final_Destination_Ptr->portBits),
						&current_Rect, &dest, 0, 0L);
				current_Rect.right = x;
				Delay_If_Needed(k_VIDEO_DELAY_FOR_Slide_Wipe);
			}
		}
		else
		{
			OffsetRect(&scrolldest, -k_VIDEO_BOX_SIZE_FOR_Slide_Wipe, 0);
			
			dest.left = dest.right - k_VIDEO_BOX_SIZE_FOR_Slide_Wipe;
			
			current_Rect.left = 0;
			current_Rect.right = k_VIDEO_BOX_SIZE_FOR_Slide_Wipe;
			
			for(x = k_VIDEO_BOX_SIZE_FOR_Slide_Wipe; x <= g_Window_Limits.main_Window_Width; x += k_VIDEO_BOX_SIZE_FOR_Slide_Wipe)
			{
				Reset_Timer();
				current_Rect.right = x;
				CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
						&scrollsource, &scrolldest, 0, 0L);
				CopyBits(&(myGrafPtr->portBits), &(final_Destination_Ptr->portBits),
						&current_Rect, &dest, 0, 0L);
				current_Rect.left = x;
				Delay_If_Needed(k_VIDEO_DELAY_FOR_Slide_Wipe);
			}
		}
		
		direction = 1 - direction;
	}

} /* void Show_Effect_Slide_Wipe(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Spiral_Gyra(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Start in the topleft corner, facing downwards.  Copy until you hit (a) the
   edge of the screen, or (b) bits you've already copied.  Then turn counter-
   clockwise and do it again.  */
/*  */
{
	INTEGER_16		stop,sbottom,sleft,sright,iterrow,itercol,direction;
	Rect	source;
	Boolean	everyOther;
	
	everyOther=FALSE;
	stop=0;
	sbottom=g_Window_Limits.main_Window_Height/k_VIDEO_BOX_SIZE_FOR_Spiral_Gyra-(g_Window_Limits.main_Window_Height%k_VIDEO_BOX_SIZE_FOR_Spiral_Gyra ? 0 : 1);
	sleft=0;
	sright=g_Window_Limits.main_Window_Width/k_VIDEO_BOX_SIZE_FOR_Spiral_Gyra-(g_Window_Limits.main_Window_Width%k_VIDEO_BOX_SIZE_FOR_Spiral_Gyra ? 0 : 1);
	direction=3;
	iterrow=stop;
	itercol=sleft;
	while ((stop<=sbottom)&&(sleft<=sright))
	{
		Reset_Timer();
		source.top=iterrow*k_VIDEO_BOX_SIZE_FOR_Spiral_Gyra;         /* Yes, I know I should recode this */
		source.bottom=source.top+ k_VIDEO_BOX_SIZE_FOR_Spiral_Gyra;   /* to take out multiplication. */
		source.left=itercol*k_VIDEO_BOX_SIZE_FOR_Spiral_Gyra;        /* If it matter that much to you, */
		source.right=source.left+ k_VIDEO_BOX_SIZE_FOR_Spiral_Gyra;   /* you do it. */
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&source, &source, 0, 0L);
		switch (direction)
		{
			case 0:  /* facing right */
				if (itercol==sright)
				{
					sbottom--;
					direction++;
					iterrow--;
				}
				else itercol++;
				break;
			case 1:  /* facing up */
				if (iterrow==stop)   /* that reads "s top," not "stop" */
				{
					sright--;
					direction++;
					itercol--;
				}
				else iterrow--;
				break;
			case 2:  /* facing left */
				if (itercol==sleft)
				{
					stop++;
					direction++;
					iterrow++;
				}
				else itercol--;
				break;
			case 3:  /* facing down */
				if (iterrow==sbottom)
				{
					sleft++;
					direction=0;
					itercol++;
				}
				else iterrow++;
				break;
		}
		if (everyOther)
			Delay_If_Needed(k_VIDEO_DELAY_FOR_Spiral_Gyra);
		everyOther=!everyOther;
	}

} /* void Show_Effect_Spiral_Gyra(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Split_Scroll_U_D(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* Draw a line from the topleft to the bottomright of the screen and split the
   screen into two regions.  The top region scrolls down and the bottom region
   scrolls up. */
/*  */
{
	INTEGER_16			x;
	Rect		theTopRect, topdest, theBottomRect, bottomdest;
	Rect		topscrollsource, topscrolldest, bottomscrollsource, bottomscrolldest;
	RgnHandle	toprgn,bottomrgn;
	
	toprgn=NewRgn();
	SetEmptyRgn(toprgn);
	MoveTo(0,0);
	OpenRgn();
		Line(g_Window_Limits.main_Window_Width,0);
		Line(0,g_Window_Limits.main_Window_Height);
		LineTo(0,0);
	CloseRgn(toprgn);
	
	bottomrgn=NewRgn();
	SetEmptyRgn(bottomrgn);
	MoveTo(0,0);
	OpenRgn();
		Line(0,g_Window_Limits.main_Window_Height);
		Line(g_Window_Limits.main_Window_Width,0);
		LineTo(0,0);
	CloseRgn(bottomrgn);
	
	topscrollsource=final_Destination_Ptr->portRect;
	topscrollsource.bottom-=k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D;
	topscrolldest = topscrollsource;
	OffsetRect(&topscrolldest, 0, k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D);
	
	topdest = final_Destination_Ptr->portRect;
	topdest.bottom=k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D;
	
	theTopRect.top=g_Window_Limits.main_Window_Height-k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D;
	theTopRect.bottom=g_Window_Limits.main_Window_Height;
	theTopRect.left=0;
	theTopRect.right=g_Window_Limits.main_Window_Width;
	
	bottomscrollsource=final_Destination_Ptr->portRect;
	bottomscrollsource.top+=k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D;
	bottomscrolldest=bottomscrollsource;
	OffsetRect(&bottomscrolldest, 0, -k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D);
	
	bottomdest=final_Destination_Ptr->portRect;
	bottomdest.top=bottomdest.bottom-k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D;
	
	theBottomRect.top=0;
	theBottomRect.bottom=k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D;
	theBottomRect.left=0;
	theBottomRect.right=g_Window_Limits.main_Window_Width;
	
	for(x = g_Window_Limits.main_Window_Height - k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D; x >= 0; x -= k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D)
	{
		Reset_Timer();
		CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
				&topscrollsource, &topscrolldest, 0, toprgn);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&theTopRect, &topdest, 0, toprgn);
		theTopRect.bottom-=k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D;
		theTopRect.top-=k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D;
		
		CopyBits(&(final_Destination_Ptr->portBits), &(final_Destination_Ptr->portBits),
				&bottomscrollsource, &bottomscrolldest, 0, bottomrgn);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
				&theBottomRect, &bottomdest, 0, bottomrgn);
		theBottomRect.top+=k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D;
		theBottomRect.bottom+=k_VIDEO_BOX_SIZE_FOR_Split_Scroll_U_D;
		
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Split_Scroll_U_D);
	}

} /* void Show_Effect_Split_Scroll_U_D(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Effect_Two_Corner(GrafPtr sourceGrafPtr, GrafPtr final_Destination_Ptr)
/*  */
/* One region starts at the top of the screen and moves down the right side
   (making triangles with the topleft of the screen).  The other region starts
   at the bottom of the screen and moves up the left side (making triangles with
   the bottomright of the screen). */
/*  */
{
	RgnHandle	curregion;
	Rect		source;
	INTEGER_16			gap;
	
	curregion=NewRgn();
	source.top=source.left=0;
	source.bottom=g_Window_Limits.main_Window_Height;
	source.right=g_Window_Limits.main_Window_Width;
	
	gap=0;
	do
	{
		Reset_Timer();
		SetEmptyRgn(curregion);
		MoveTo(0,0);
		OpenRgn();
			Line(g_Window_Limits.main_Window_Width,gap);
			Line(0,k_BlockSize_Two_Corner);
			LineTo(0,0);
			MoveTo(g_Window_Limits.main_Window_Width,g_Window_Limits.main_Window_Height);   /* region is discontinuous */
			Line(-g_Window_Limits.main_Window_Width,-gap);                  /* but this is much faster */
			Line(0,-k_BlockSize_Two_Corner);                             /* than two regions & two  */
			LineTo(g_Window_Limits.main_Window_Width,g_Window_Limits.main_Window_Height);   /* CopyBits */
		CloseRgn(curregion);
		CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
			&source, &source, 0, curregion);
		gap+=k_BlockSize_Two_Corner;
		Delay_If_Needed(k_VIDEO_DELAY_FOR_Two_Corner);
	}
	while (gap<g_Window_Limits.main_Window_Height+ k_BlockSize_Two_Corner);
	
	CopyBits(&(sourceGrafPtr->portBits), &(final_Destination_Ptr->portBits),
		&source, &source, 0, 0L);   /* in case we missed any bits */
	
	DisposeRgn(curregion);

} /* void Show_Effect_Two_Corner(... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: Video_Wipes.c */






