/* START OF FILE: Window_Environment.c */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Window_Environment.c - Routines to manages primary window size and position
 ** (C) Copyright 1995 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  1995.06.04		(James Merkle)
 **						Initial coding started from scratch
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 ** 
 ** 
 **
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Memory_Utilities.h"

#include "Window_Environment.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define k_WINDOW_SIZES_RESOURCE_TYPE		'Wind'
#define k_WINDOW_SIZES_RESOURCE_ID			128

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */

	Safe_Boolean							g_Preferred_Monitor_Values_Valid;
	CARDINAL_16						g_Preferred_Monitor_Depth;
	CARDINAL_8							g_Preferred_Monitor_Slots;
	Rect									g_Preferred_Monitor_Max_Rect;
	Safe_Boolean							g_Preferred_Monitor_Max_Rect_Contains_Menubar;
	PixMapHandle						g_Preferred_Monitor_Video_Pix_Map_Handle;
	GDHandle								g_Preferred_Monitor_Graphics_Device;

	Window_Limits_Rec				g_Window_Limits;

/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

static CARDINAL_8	*unit_Name = "\pWindow_Environment";


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Initialize_Window_Limits_If_Needed(Window_Limits_Rec *window_Limits)
{
Handle	window_Sizes_Hdl;
/* END VAR */


	if (window_Limits->valid_Information != SAFE_TRUE) {

		/*  */
		/* Load resource. */
		/*  */
		window_Sizes_Hdl = Get1Resource(k_WINDOW_SIZES_RESOURCE_TYPE
																, k_WINDOW_SIZES_RESOURCE_ID);

		if ((ResError() == noErr) && (window_Sizes_Hdl != nil)) {
			Move_Memory(*window_Sizes_Hdl, (Ptr)window_Limits, sizeof(Window_Limits_Rec));
	
			ReleaseResource((Handle)window_Sizes_Hdl);
			if (ResError() != noErr) {
				/*  */
				/* Ignore error, we are exiting anyway  */
				/*  */
			}
		}

		/*  */
		/* If resource no good, then fill in defaults. */
		/*  */
		if (window_Limits->valid_Information != SAFE_TRUE) {

			window_Limits->valid_Information = SAFE_TRUE;
			window_Limits->specific.display_Item_Width_Max = 640;
			window_Limits->specific.display_Item_Width_Min = 64;
		
			window_Limits->specific.display_Item_Height_Max = 480;
			window_Limits->specific.display_Item_Height_Min = 64;
			
			window_Limits->main_Window_Width = 640;
			window_Limits->main_Window_Height = 480;
		}
	}

} /* Safe_Boolean Initialize_Window_Limits_If_Needed... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: Window_Environment.c */






