/* _______________________________________________________________________
	skanky asynchronous list manger package for James Merkle

	started: 03/24/94
	last modified: 08/01/94 

	font: Geneva	
	size: 9		
	tabs: 4
	
	Copyright  1994 by Craig A. Marciniak - all rights reserved. 
 _______________________________________________________________________*/
 
 #include	"AsyncListManagerLib.h"

 SkankyEventRec				gAsyncListManagerEvent;
 
 
 PicHandle					gScrollArtwork[kNumberofScrollPics];

/*______________________________________________________________________*/

pascal OSErr InitializeAsyncListManager(long	skankyListFlags)
{
	short				index;
	OSErr			errorResult;
	
	errorResult = FALSE;
	
	gAsyncListManagerEvent.lastKnownControl = 0;
	gAsyncListManagerEvent.wasMouseDown = 0;
	gAsyncListManagerEvent.lastMousePosition.v = 0;
	gAsyncListManagerEvent.lastMousePosition.h = 0;
	gAsyncListManagerEvent.skankyFlags = skankyListFlags;
	
	for(index = 0; index < kNumberofScrollPics; index++)
	{
		gScrollArtwork[index] = (PicHandle)GetResource(kScrollArtResource, kScrollArtBaseID + index);
	
		if(gScrollArtwork[index] == NIL)
		{
			errorResult = TRUE;
			break;
		}
		else
		{
			DetachResource((Handle)gScrollArtwork[index] );
		}
	}
	
	return (errorResult);
}

/*______________________________________________________________________*/

pascal  OSErr NewAsyncList(WindowPtr  window, Rect *listRectangle, short listFont, short listFontSize, SkankyListHandle *newSkankyList)
{
	GrafPtr 				savePort;
	SkankyListPtr			listPointer;
	FontInfo				skankyFontInfo;
	short					normalizeScroll;
	OSErr				errorResult;
	
	GetPort(&savePort);	
	SetPort(window);
	
	*newSkankyList = (SkankyListHandle)NewHandleClear(sizeof(SkankyListRec));
	if(*newSkankyList != NIL)
	{
		HLock((Handle)*newSkankyList);
		errorResult = MemError();
		if(errorResult == noErr)
		{
			SetDefaultText(listFont,normal,listFontSize);
			GetFontInfo( &skankyFontInfo );
			
			listPointer = **newSkankyList;
			listPointer->window = window;
			listPointer->listRectangle = *listRectangle;
			listPointer->listFont = listFont;
			listPointer->listFontSize = listFontSize;
			listPointer->numberOfItems = 0L;
			listPointer->scrollOffset = 0L;
			listPointer->selectedItem = 1L;
			listPointer->chunkCount = 0;
			listPointer->activateFlag = 0;
			listPointer->lineHeight = skankyFontInfo.ascent + skankyFontInfo.descent + skankyFontInfo.leading;	
			listPointer->descent = skankyFontInfo.descent;
			
			listPointer->viewBounds = *listRectangle;
			listPointer->viewBounds.right -= kScrollBarWidth;
			
			listPointer->upScroll = *listRectangle;
			listPointer->upScroll.left = listPointer->viewBounds.right;
			listPointer->upScroll.bottom = listPointer->upScroll.top + kScrollBarWidth;			
			
			listPointer->downScroll = *listRectangle;
			listPointer->downScroll.left = listPointer->viewBounds.right;
			listPointer->downScroll.top = listPointer->downScroll.bottom - kScrollBarWidth;
			
			listPointer->pageUpScroll = *listRectangle;
			listPointer->pageUpScroll.left = listPointer->viewBounds.right + 1;
			listPointer->pageUpScroll.right--;
			listPointer->pageUpScroll.top = 0;
			listPointer->pageUpScroll.bottom  = 0;			
			
			listPointer->thumbScroll = *listRectangle;
			listPointer->thumbScroll.left = listPointer->viewBounds.right + 1;
			listPointer->thumbScroll.right--;
			listPointer->thumbScroll.top += kScrollBarWidth;
			listPointer->thumbScroll.bottom = listPointer->thumbScroll.top + 16;

			listPointer->pageDownScroll = *listRectangle;
			listPointer->pageDownScroll.left = listPointer->viewBounds.right + 1;
			listPointer->pageDownScroll.right--;
			listPointer->pageDownScroll.top = listPointer->thumbScroll.bottom + 1;
			listPointer->pageDownScroll.bottom = listPointer->downScroll.top - 1;
			
			listPointer->scrollBarRect.left = listPointer->listRectangle.right - 15;
			listPointer->scrollBarRect.right = listPointer->listRectangle.right - 1;
			listPointer->scrollBarRect.top = listPointer->upScroll.bottom;
			listPointer->scrollBarRect.bottom = listPointer->downScroll.top;
			
			listPointer->scrollBarPixRange = listPointer->downScroll.top -  listPointer->upScroll.bottom - 15;
			
			InsetRect(&listPointer->viewBounds, 2, 2);
			normalizeScroll = ((listPointer->viewBounds.bottom - listPointer->viewBounds.top) /  listPointer->lineHeight) *  listPointer->lineHeight;
			listPointer->viewBounds.bottom = listPointer->viewBounds.top + normalizeScroll;
			listPointer->numberOfItemsInView = ((listPointer->viewBounds.bottom - listPointer->viewBounds.top) /  listPointer->lineHeight) ;
			
			listPointer->listData  = NewHandle(sizeof(Ptr) * kListChunkSize);
			
			errorResult = MemError();
			if(errorResult == noErr)
			{
				HLockHi(listPointer->listData);
				errorResult = MemError();
				if(errorResult == noErr)
				{
					UpdateAsyncList(*newSkankyList , TRUE);
					gAsyncListManagerEvent.lastSkankyList = NIL;
				}
			}	
		}
	}
	else
	{
		errorResult = cNoMemErr; 
	}
	
	SetPort(savePort);
	
	return (errorResult);
}

/*______________________________________________________________________*/

pascal OSErr AddItemToAsyncList(SkankyListHandle skankHandle, short insertion, StringPtr newString)
{
	Size				listDataSize;
	unsigned long		calculateLocation;
	OSErr			errorResult;
	
	if((**skankHandle).chunkCount > kListChunkSize - 1)
	{
		HUnlock((**skankHandle).listData);
		errorResult = MemError();
		if(errorResult == noErr)
		{
			listDataSize = GetHandleSize((**skankHandle).listData);
			errorResult = MemError();
			if(errorResult == noErr)
			{
				SetHandleSize((**skankHandle).listData, listDataSize + (kListChunkSize * sizeof(Ptr)));
				errorResult = MemError();
				if(errorResult == noErr)
				{
					HLockHi((**skankHandle).listData);
					errorResult = MemError();
					if(errorResult != noErr)
					{
						return (errorResult);
					}
				}	
			}
		}
	}

	calculateLocation = (**skankHandle).numberOfItems * sizeof(Ptr);
	calculateLocation += ((unsigned long)*(**skankHandle).listData);
	*(Ptr *)calculateLocation = NewPtr((long)newString[0]);
	
	errorResult = MemError();
	if(errorResult == noErr)
	{
		BlockMove(newString, *(Ptr *)calculateLocation, (long)newString[0] + 1);
		(**skankHandle).numberOfItems++;	
		(**skankHandle).chunkCount++;
	}

	return (errorResult);
}

/*______________________________________________________________________*/

pascal OSErr GetListItemData(SkankyListHandle skankHandle, long itemIndex, StringPtr itemData)
{
	unsigned long 				calculateLocation;
	Ptr						tempPtr;	
	OSErr					errorResult;
	
	errorResult = TRUE;
	
	if(itemIndex < (**skankHandle).numberOfItems && itemIndex > 0)
	{
		calculateLocation = (itemIndex - 1) * sizeof(Ptr);
		calculateLocation += ((unsigned long)*(**skankHandle).listData);
		tempPtr = *(Ptr *)calculateLocation;
		BlockMove(tempPtr, itemData, tempPtr[0] + 1);
		errorResult = MemError();
	}
	
	return (errorResult);
}

/*______________________________________________________________________*/

pascal OSErr SetListItemData(SkankyListHandle skankHandle, long itemIndex, StringPtr newData)
{
	unsigned long 				calculateLocation;
	OSErr					errorResult;
	
	errorResult = TRUE;
	
	if((itemIndex < (**skankHandle).numberOfItems) && (newData != NIL) && itemIndex > 0)
	{
		calculateLocation = (itemIndex - 1) * sizeof(Ptr);
		calculateLocation += ((unsigned long)*(**skankHandle).listData);
		
		DisposePtr(*(Ptr *)calculateLocation);
		errorResult = MemError();
		if(errorResult == noErr)
		{
			*(Ptr *)calculateLocation = NewPtr((Size)newData[0] +1);
			errorResult = MemError();
			if(errorResult == noErr)
			{
				BlockMove(newData, *(Ptr *)calculateLocation, (Size)newData[0] +1);
			}
		}
	}
	
	return (errorResult);
}

/*______________________________________________________________________*/

pascal OSErr DeleteAllListItems(SkankyListHandle skankHandle)
{
	unsigned long 				calculateLocation;
	long						loop;
	OSErr					errorResult;
	
	errorResult = TRUE;
	calculateLocation = 0L;
	
	for(loop = 0; loop < (**skankHandle).numberOfItems; loop++)
	{
		calculateLocation = loop * sizeof(Ptr) ;
		calculateLocation += ((unsigned long)*(**skankHandle).listData);
		
		if(*(Ptr *)calculateLocation != NIL)
		{
			DisposPtr(*(Ptr *)calculateLocation);
			
			errorResult = MemError();
			if(errorResult != noErr)
			{
				break;
			}
		}
	}
	
	HUnlock((**skankHandle).listData);
	errorResult = MemError();
	if(errorResult == noErr)
	{
		SetHandleSize((**skankHandle).listData, sizeof(Ptr));
		errorResult = MemError();
		if(errorResult == noErr)
		{
			HLockHi((**skankHandle).listData);
			errorResult = MemError();
		}
		
		(**skankHandle).numberOfItems = 0L;
		(**skankHandle).chunkCount  = 0;
	}
	
	return (errorResult);
}

/*______________________________________________________________________*/

pascal OSErr DisposeAsyncList(SkankyListHandle killSkankyListHandle)
{
	OSErr				errorResult;
	
	errorResult = DeleteAllListItems(killSkankyListHandle);
	
	DisposeHandle((Handle)(**killSkankyListHandle).listData);
	DisposeHandle((Handle)killSkankyListHandle);
	
	return (errorResult);
}

/*______________________________________________________________________*/

pascal OSErr GetSelectedItemFromList(SkankyListHandle skankHandle, long *theItem)
{
	OSErr				errorResult;
	
	if(skankHandle == NIL)
	{
		errorResult = TRUE;
	}
	else
	{
		*theItem = (**skankHandle).selectedItem;
		errorResult = noErr;
	}

	return (errorResult);
}

/*______________________________________________________________________*/

pascal OSErr SetSelectedItemInList(SkankyListHandle skankHandle, long  theItem)
{
	OSErr				errorResult;
	
	errorResult = TRUE;
	
	if(theItem < (**skankHandle).numberOfItems)
	{
		(**skankHandle).selectedItem = theItem;
		DrawListElementsToScreen(skankHandle, TRUE);
		errorResult = noErr;
	}
	
	return(errorResult);
}

/*______________________________________________________________________*/

pascal void ProcessAsyncListTask(SkankyListHandle checkSkankyListHandle)
{
	GrafPtr 				savePort;

	if((gAsyncListManagerEvent.lastSkankyList == NIL) 
		|| (gAsyncListManagerEvent.lastSkankyList == checkSkankyListHandle))
	{
		GetPort(&savePort);	
		
		SetPort((**checkSkankyListHandle).window);
		GetMouse(&gAsyncListManagerEvent.lastMousePosition);
		
		if((gAsyncListManagerEvent.wasMouseDown == 0) && (Button() == TRUE))
		{
			
			if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).viewBounds)) 
			{
				TrackListSelection(checkSkankyListHandle);
				gAsyncListManagerEvent.lastSkankyList = checkSkankyListHandle;
			}
			else if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).upScroll))
			{
				ScrollOneLine(checkSkankyListHandle, kUpDirection, TRUE);
				gAsyncListManagerEvent.lastSkankyList = checkSkankyListHandle;
			}
			else if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).downScroll))
			{
				ScrollOneLine(checkSkankyListHandle, kDownDirection, TRUE);
				gAsyncListManagerEvent.lastSkankyList = checkSkankyListHandle;
			}
			else if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).pageUpScroll))
			{
				ScrollPage(checkSkankyListHandle, kUpDirection);
				gAsyncListManagerEvent.lastSkankyList = checkSkankyListHandle;
			}
			else if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).pageDownScroll))
			{
				ScrollPage(checkSkankyListHandle, kDownDirection);
				gAsyncListManagerEvent.lastSkankyList = checkSkankyListHandle;
			}
			else if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).thumbScroll))
			{
				TrackScrollThumb(checkSkankyListHandle);
				gAsyncListManagerEvent.lastSkankyList = checkSkankyListHandle;
			}
		}
		else if((gAsyncListManagerEvent.wasMouseDown > 0) && (Button() == TRUE))
		{
			if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).viewBounds)  && (gAsyncListManagerEvent.wasMouseDown == kSelectionMode))
			{
				TrackListSelection(checkSkankyListHandle);
			}
			else if(gAsyncListManagerEvent.wasMouseDown == kSelectionMode)
			{
				if(gAsyncListManagerEvent.lastMousePosition.v > (**checkSkankyListHandle).viewBounds.bottom)
				{
					if((**checkSkankyListHandle).selectedItem < (**checkSkankyListHandle).numberOfItems)
					{
						(**checkSkankyListHandle).selectedItem++;
						ScrollOneLine(checkSkankyListHandle, kDownDirection, FALSE);
						gAsyncListManagerEvent.wasMouseDown = kSelectionMode;
					}
				}
				else if(gAsyncListManagerEvent.lastMousePosition.v < (**checkSkankyListHandle).viewBounds.top)
				{
					if((**checkSkankyListHandle).selectedItem > 1)
					{
						(**checkSkankyListHandle).selectedItem--;
						ScrollOneLine(checkSkankyListHandle, kUpDirection, FALSE);
						gAsyncListManagerEvent.wasMouseDown = kSelectionMode;
					}
				}
			}
			else if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).upScroll) && (gAsyncListManagerEvent.wasMouseDown == kScrollUpMode))
			{
				ScrollOneLine(checkSkankyListHandle, kUpDirection, FALSE);
			}
			else if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).downScroll) && (gAsyncListManagerEvent.wasMouseDown == kScrollDownMode))
			{
				ScrollOneLine(checkSkankyListHandle, kDownDirection, FALSE);
			}
			else if(gAsyncListManagerEvent.wasMouseDown == kScrollPageUp)
			{
				if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).pageUpScroll) || PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).thumbScroll))
				{
					ScrollPage(checkSkankyListHandle, kUpDirection);
				}
			}
			else if(gAsyncListManagerEvent.wasMouseDown == kScrollPageDown)
			{
				if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).pageDownScroll) || PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).thumbScroll))
				{
					ScrollPage(checkSkankyListHandle, kDownDirection);
				}
			}
			else if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &(**checkSkankyListHandle).thumbScroll) && (gAsyncListManagerEvent.wasMouseDown == kTrackThumb))
			{
				TrackScrollThumb(checkSkankyListHandle);
			}
		}
		else
		{
			switch(gAsyncListManagerEvent.wasMouseDown)
			{
				case 1:
					InvalRect(&(**checkSkankyListHandle).upScroll);
					break;
				case 2:
					InvalRect(&(**checkSkankyListHandle).downScroll);
					break;
				case 3:
					break;
				default:
					break;
			}
			
			gAsyncListManagerEvent.wasMouseDown = 0;
			gAsyncListManagerEvent.lastSkankyList = NIL;
		}
		
		SetPort(savePort);
	}
}

/*______________________________________________________________________*/

pascal void ActivateAsyncList(SkankyListHandle dirtySkankyListHandle)
{
	GrafPtr 				savePort;
	Rect					scrollBarRect;
	
	GetPort(&savePort);
	SetPort((**dirtySkankyListHandle).window);
	scrollBarRect = (**dirtySkankyListHandle).listRectangle;
	scrollBarRect.left = scrollBarRect.right - 15;
	scrollBarRect.right--;
	InvalRect(&scrollBarRect);
	(**dirtySkankyListHandle).activateFlag  =  kHighLightScroll;
	SetPort(savePort);
}

/*______________________________________________________________________*/

pascal void DeActivateAsyncList(SkankyListHandle dirtySkankyListHandle)
{
	GrafPtr 				savePort;
	Rect					scrollBarRect;
	
	GetPort(&savePort);	
	SetPort((**dirtySkankyListHandle).window);

	if((**dirtySkankyListHandle).activateFlag == kHighLightScroll)
	{
		scrollBarRect = (**dirtySkankyListHandle).listRectangle;
		scrollBarRect.left = scrollBarRect.right - 15;
		scrollBarRect.right--;
		EraseRect(&scrollBarRect);
	}
	
	if(gAsyncListManagerEvent.skankyFlags & kUseBandWScrolls)
	{
		DrawPicture(gScrollArtwork[7], &(**dirtySkankyListHandle).upScroll);
		DrawPicture(gScrollArtwork[8], &(**dirtySkankyListHandle).downScroll);
	}
	else
	{
		DrawPicture(gScrollArtwork[0], &(**dirtySkankyListHandle).upScroll);
		DrawPicture(gScrollArtwork[1], &(**dirtySkankyListHandle).downScroll);
	}
	
	(**dirtySkankyListHandle).activateFlag  =  kDeactivatedScroll;
	
	SetPort(savePort);
}

/*______________________________________________________________________*/

pascal void UpdateAsyncList(SkankyListHandle dirtySkankyListHandle, Boolean completeUpdate)
{
	GrafPtr 				savePort;

	GetPort(&savePort);	
	SetPort((**dirtySkankyListHandle).window);

	FrameRect(&(**dirtySkankyListHandle).listRectangle);
	MoveTo((**dirtySkankyListHandle).listRectangle.right - kScrollBarWidth, (**dirtySkankyListHandle).listRectangle.top );
	LineTo((**dirtySkankyListHandle).listRectangle.right - kScrollBarWidth, (**dirtySkankyListHandle).listRectangle.bottom - 1);
	
	DrawListElementsToScreen(dirtySkankyListHandle, FALSE);
	
	if((**dirtySkankyListHandle).activateFlag == kHighLightScroll)
	{
		FillRect(&(**dirtySkankyListHandle).scrollBarRect, &qd.ltGray);
		if(gAsyncListManagerEvent.skankyFlags & kUseBandWScrolls)
		{
			EraseRect(&(**dirtySkankyListHandle).thumbScroll);
			FrameRect(&(**dirtySkankyListHandle).thumbScroll);
			DrawPicture(gScrollArtwork[7], &(**dirtySkankyListHandle).upScroll);
			DrawPicture(gScrollArtwork[8], &(**dirtySkankyListHandle).downScroll);
		}
		else
		{
			DrawPicture(gScrollArtwork[6], &(**dirtySkankyListHandle).thumbScroll);
			DrawPicture(gScrollArtwork[2], &(**dirtySkankyListHandle).upScroll);
			DrawPicture(gScrollArtwork[3], &(**dirtySkankyListHandle).downScroll);
		}

	}
	else
	{
		if(gAsyncListManagerEvent.skankyFlags & kUseBandWScrolls)
		{
			DrawPicture(gScrollArtwork[7], &(**dirtySkankyListHandle).upScroll);
			DrawPicture(gScrollArtwork[8], &(**dirtySkankyListHandle).downScroll);
		}
		else
		{
			DrawPicture(gScrollArtwork[0], &(**dirtySkankyListHandle).upScroll);
			DrawPicture(gScrollArtwork[1], &(**dirtySkankyListHandle).downScroll);
		}
	}
	
	SetPort(savePort);
}

/*______________________________________________________________________*/

pascal void DrawListElementsToScreen(SkankyListHandle skankHandle, Boolean eraseRect)
{
	GrafPtr 				savePort;
	unsigned long 			stringLocation;
	Rect					calculateSelectionRect;
	long					loopCount;
	long					selectOffset;
	long					offset;

	GetPort(&savePort);
	SetPort((**skankHandle).window);
	ClipRect(&(**skankHandle).viewBounds);
	
	if(eraseRect)
	{
		EraseRect(&(**skankHandle).viewBounds);
	}

	offset = 0L;
	selectOffset = 0L;
	
	for(loopCount = (**skankHandle).scrollOffset; loopCount < (**skankHandle).numberOfItems; loopCount++)
	{
		offset += (**skankHandle).lineHeight;
		selectOffset++;
		
		if(offset > (long)(**skankHandle).viewBounds.bottom)
		{
			if((**skankHandle).activateFlag != kDeactivatedScroll)
			{
				(**skankHandle).activateFlag = kHighLightScroll;
			}
			
			break;
		}

		stringLocation = loopCount * sizeof(Ptr) ;
		stringLocation += ((unsigned long)*(**skankHandle).listData);		
		MoveTo((**skankHandle).viewBounds.left + 2, (**skankHandle).viewBounds.top + offset - (**skankHandle).descent);
			
		if((**skankHandle).scrollOffset + selectOffset == (**skankHandle).selectedItem )
		{
			calculateSelectionRect = (**skankHandle).viewBounds;
			calculateSelectionRect.bottom = (**skankHandle).viewBounds.top + offset;
			calculateSelectionRect.top  =  calculateSelectionRect.bottom  - (**skankHandle).lineHeight;
			BackColor(blackColor);
			EraseRect(&calculateSelectionRect);
			BackColor(whiteColor);
			ForeColor(whiteColor);

		}
		
		DrawString((StringPtr)*(Ptr *)stringLocation);
		ForeColor(blackColor);
	}
	
	ClipRect(&(**skankHandle).window->portRect);
	SetPort(savePort);
}

/*______________________________________________________________________*/

pascal void TrackListSelection(SkankyListHandle skankHandle)
{
	Rect						calculateRect;
	long						newSelected;
	short						loop;
	
	gAsyncListManagerEvent.wasMouseDown = kSelectionMode;
	calculateRect = (**skankHandle).viewBounds;
	calculateRect.bottom = calculateRect.top + (**skankHandle).lineHeight;
	newSelected = (**skankHandle).scrollOffset + 1;

	for(loop = 0; loop < (**skankHandle).numberOfItemsInView; loop++)
	{
		if(PtInRect(gAsyncListManagerEvent.lastMousePosition, &calculateRect))
		{
			if((**skankHandle).selectedItem !=  newSelected)
			{
				(**skankHandle).selectedItem = newSelected ;
				DrawListElementsToScreen(skankHandle, TRUE);
			}
						
			break;
		}
		
		newSelected++;
		calculateRect.top += (**skankHandle).lineHeight;
		calculateRect.bottom += (**skankHandle).lineHeight;
	}
}

/*______________________________________________________________________*/

pascal void ScrollOneLine(SkankyListHandle skankHandle, short direction, short hiliteArrow)
{
	Rect						testThumb;
	double					thumbCalc;
	
	testThumb = (**skankHandle).thumbScroll;
				
	if(direction == kDownDirection)
	{
	
		if((**skankHandle).scrollOffset < (**skankHandle).numberOfItems - (**skankHandle).numberOfItemsInView)
		{
			if(hiliteArrow == TRUE)
			{
				if(gAsyncListManagerEvent.skankyFlags & kUseBandWScrolls)
				{
					DrawPicture(gScrollArtwork[10], &(**skankHandle).downScroll);
				}
				else
				{
					DrawPicture(gScrollArtwork[5], &(**skankHandle).downScroll);
				}
			}
			
			gAsyncListManagerEvent.wasMouseDown = kScrollDownMode;
			(**skankHandle).scrollOffset++;
			
			thumbCalc = (double)((**skankHandle).scrollOffset / (double)(**skankHandle).numberOfItems) ;
			thumbCalc *= (**skankHandle).scrollBarPixRange;
			
			if((**skankHandle).scrollOffset == ((**skankHandle).numberOfItems - (**skankHandle).numberOfItemsInView))
			{
				thumbCalc = (**skankHandle).scrollBarPixRange - 1;
			}
			
			(**skankHandle).thumbScroll.top = (**skankHandle).upScroll.bottom + thumbCalc;
			(**skankHandle).thumbScroll.bottom = (**skankHandle).thumbScroll.top + 16;
			
			if(gAsyncListManagerEvent.skankyFlags & kUseFasterScrolls)
			{
				/* draw offscreen and copybit here to get rid of flicker */
			}
			else
			{
				DrawListElementsToScreen(skankHandle, TRUE);
			}
			
			if((**skankHandle).thumbScroll.top != testThumb.top)
			{
				FillRect(&testThumb, &qd.ltGray);
				
				if(gAsyncListManagerEvent.skankyFlags & kUseBandWScrolls)
				{
					EraseRect(&(**skankHandle).thumbScroll);
					FrameRect(&(**skankHandle).thumbScroll);
				}
				else
				{
					DrawPicture(gScrollArtwork[6], &(**skankHandle).thumbScroll);
				}
				
				(**skankHandle).pageUpScroll.bottom = (**skankHandle).thumbScroll.top + 1;
				(**skankHandle).pageDownScroll.top = (**skankHandle).thumbScroll.bottom - 1;
			}
		}
	}
	else
	{
		if((**skankHandle).scrollOffset > 0L)
		{
			if(hiliteArrow ==TRUE)
			{
				if(gAsyncListManagerEvent.skankyFlags & kUseBandWScrolls)
				{
					DrawPicture(gScrollArtwork[9], &(**skankHandle).upScroll);
				}
				else
				{
					DrawPicture(gScrollArtwork[4], &(**skankHandle).upScroll);
				}
			}
			
			gAsyncListManagerEvent.wasMouseDown = kScrollUpMode;
			(**skankHandle).scrollOffset--;
			
			thumbCalc = (double)((**skankHandle).scrollOffset / (double)(**skankHandle).numberOfItems) ;
			thumbCalc *= (**skankHandle).scrollBarPixRange;
			
			if((**skankHandle).scrollOffset == ((**skankHandle).numberOfItems - (**skankHandle).numberOfItemsInView))
			{
				thumbCalc = (**skankHandle).scrollBarPixRange - 1;
			}
					
			(**skankHandle).thumbScroll.top = (**skankHandle).upScroll.bottom + thumbCalc;
			(**skankHandle).thumbScroll.bottom = (**skankHandle).thumbScroll.top + 16;
			
			if(gAsyncListManagerEvent.skankyFlags & kUseFasterScrolls)
			{
				/* draw offscreen and copybit  here to get rid of flicker */
			}
			else
			{
				DrawListElementsToScreen(skankHandle, TRUE);
			}
			
			if((**skankHandle).thumbScroll.top != testThumb.top)
			{
				FillRect(&testThumb, &qd.ltGray);
				
				if(gAsyncListManagerEvent.skankyFlags & kUseBandWScrolls)
				{
					EraseRect(&(**skankHandle).thumbScroll);
					FrameRect(&(**skankHandle).thumbScroll);
				}
				else
				{
					DrawPicture(gScrollArtwork[6], &(**skankHandle).thumbScroll);
				}
				
				(**skankHandle).pageUpScroll.bottom = (**skankHandle).thumbScroll.top + 1;
				(**skankHandle).pageDownScroll.top = (**skankHandle).thumbScroll.bottom - 1;
			}
		}
	}
}

/*______________________________________________________________________*/

pascal void ScrollPage(SkankyListHandle skankHandle, short direction)
{
	Rect						testThumb;
	double					thumbCalc;
	short						scrollMoved;
	
	testThumb = (**skankHandle).thumbScroll;
	scrollMoved = TRUE;
				
	if(direction == kDownDirection)
	{
		if((**skankHandle).scrollOffset < (**skankHandle).numberOfItems )
		{
			gAsyncListManagerEvent.wasMouseDown = kScrollPageDown;
			(**skankHandle).scrollOffset += (**skankHandle).numberOfItemsInView;
			
			if((**skankHandle).scrollOffset > (**skankHandle).numberOfItems)
			{
				(**skankHandle).scrollOffset = (**skankHandle).numberOfItems - (**skankHandle).numberOfItemsInView;
				gAsyncListManagerEvent.wasMouseDown = 0;
			}
			

			thumbCalc = (double)((**skankHandle).scrollOffset / (double)(**skankHandle).numberOfItems) ;
			thumbCalc *= (**skankHandle).scrollBarPixRange;
			
			if((**skankHandle).scrollOffset == ((**skankHandle).numberOfItems - (**skankHandle).numberOfItemsInView))
			{
				thumbCalc = (**skankHandle).scrollBarPixRange - 1;
			}
			
			(**skankHandle).thumbScroll.top = (**skankHandle).upScroll.bottom + thumbCalc;
			(**skankHandle).thumbScroll.bottom = (**skankHandle).thumbScroll.top + 16;
			
			if(gAsyncListManagerEvent.skankyFlags & kUseFasterScrolls)
			{
				/* draw offscreen and copybit  here to get rid of flicker */
			}
			else
			{
				DrawListElementsToScreen(skankHandle, TRUE);
			}
			
			if((**skankHandle).thumbScroll.top != testThumb.top)
			{
				FillRect(&testThumb, &qd.ltGray);
				
				if(gAsyncListManagerEvent.skankyFlags & kUseBandWScrolls)
				{
					EraseRect(&(**skankHandle).thumbScroll);
					FrameRect(&(**skankHandle).thumbScroll);
				}
				else
				{
					DrawPicture(gScrollArtwork[6], &(**skankHandle).thumbScroll);
				}
				
				(**skankHandle).pageUpScroll.bottom = (**skankHandle).thumbScroll.top;
				(**skankHandle).pageDownScroll.top = (**skankHandle).thumbScroll.bottom;
			}
		}
		else
		{
			scrollMoved = FALSE;
		}
	}
	else
	{
		if((**skankHandle).scrollOffset > 0L)
		{
			gAsyncListManagerEvent.wasMouseDown = kScrollPageUp;
			(**skankHandle).scrollOffset -= (**skankHandle).numberOfItemsInView;
			
			if((**skankHandle).scrollOffset < 0L)
			{
				(**skankHandle).scrollOffset = 0L;
			}
			
			thumbCalc = (double)((**skankHandle).scrollOffset / (double)(**skankHandle).numberOfItems) ;
			thumbCalc *= (**skankHandle).scrollBarPixRange;
			
			if((**skankHandle).scrollOffset == ((**skankHandle).numberOfItems - (**skankHandle).numberOfItemsInView))
			{
				thumbCalc = (**skankHandle).scrollBarPixRange - 1;
			}
				
			(**skankHandle).thumbScroll.top = (**skankHandle).upScroll.bottom + thumbCalc;
			(**skankHandle).thumbScroll.bottom = (**skankHandle).thumbScroll.top + 16;
			
			if(gAsyncListManagerEvent.skankyFlags & kUseFasterScrolls)
			{
				/* draw offscreen and copybit  here to get rid of flicker */
			}
			else
			{
				DrawListElementsToScreen(skankHandle, TRUE);
			}
			
			if((**skankHandle).thumbScroll.top != testThumb.top)
			{
				FillRect(&testThumb, &qd.ltGray);
				
				if(gAsyncListManagerEvent.skankyFlags & kUseBandWScrolls)
				{
					EraseRect(&(**skankHandle).thumbScroll);
					FrameRect(&(**skankHandle).thumbScroll);
				}
				else
				{
					DrawPicture(gScrollArtwork[6], &(**skankHandle).thumbScroll);
				}
				
				(**skankHandle).pageUpScroll.bottom = (**skankHandle).thumbScroll.top;
				(**skankHandle).pageDownScroll.top = (**skankHandle).thumbScroll.bottom;
			}
		}
		else
		{
			scrollMoved = FALSE;
		}
	}
}

/*______________________________________________________________________*/

pascal void  TrackScrollThumb(SkankyListHandle skankHandle)
{

/* need to track thumb*/

}

/*______________________________________________________________________*/

pascal OSErr KillAsyncListManager(void)
{
	short			index;
	
	for(index = 0; index < kNumberofScrollPics; index++)
	{
		DisposeHandle((Handle)gScrollArtwork[index] );
	}
}

/*______________________________________________________________________*/