/* _______________________________________________________________________
	SkankyListManager.h  - 

	started: 03/24/94
	last modified: 07/24/94 

	font: Geneva	
	size: 9		
	tabs: 4
	
	Copyright  1994 by Craig A. Marciniak - all rights reserved. 
 _______________________________________________________________________*/

#ifndef _SkankyListManager_
#define _SkankyListManager_

	#define NIL					0L
	#define SetDefaultText(fn,fc,sz) 	{ TextFont(fn); TextFace(fc); TextSize(sz); }
	#define kScrollArtResource 		'srt'
	
	enum{
		kInsertAtBottom = 0,
		kUseFasterScrolls = 0x00000001,
		kUseBandWScrolls = 0x00000010,
		kInsertAtTop = 1,
		kInsertAlphabetically = 2,
		kHighLightScroll = 2,
		kDeactivatedScroll,
		kNumberofScrollPics = 11,
		kScrollBarWidth = 16,
		kTheShiftKey = 0x38,
		kScrollArtBaseID = 1000,
		kListChunkSize = 4096
	};

	enum{
		kUpDirection = 0,
		kDownDirection
	};
		
	enum{
		kScrollUpMode = 1,
		kScrollDownMode,
		kSelectionMode,
		kScrollPageUp,
		kScrollPageDown,
		kTrackThumb
	};
	
	typedef struct{
		WindowPtr		window;
		Handle			listData;
		Rect				listRectangle;
		Rect 				viewBounds;
		Rect				scrollBarRect;
		Rect 				upScroll;
		Rect				pageUpScroll;
		Rect 				thumbScroll;
		Rect				pageDownScroll;
		Rect 				downScroll;
		long				numberOfItems;
		long				selectedItem;
		long				scrollOffset;
		short			numberOfItemsInView;
		short			activateFlag;
		short			listFont;
		short			listFontSize;
		short			lineHeight;
		short			descent;
		short			chunkCount;
		short			scrollBarPixRange;
		long				refCon;
	}SkankyListRec, *SkankyListPtr, **SkankyListHandle;
	
	typedef struct{
		long				skankyFlags;
		SkankyListHandle	lastSkankyList;
		short			wasMouseDown;
		Point				lastMousePosition;
		short			lastKnownControl;
	}SkankyEventRec, *SkankyEventPtr, **SkankyEventHandle;


extern  SkankyEventRec				gAsyncListManagerEvent;

	pascal OSErr		InitializeAsyncListManager(long skankyListFlags);
	pascal OSErr		NewAsyncList(WindowPtr window, Rect *listRectangle, short listFont, short listFontSize, SkankyListHandle *newSkankyList);
	pascal OSErr		AddItemToAsyncList(SkankyListHandle skankHandle, short insertion, StringPtr newString);
	pascal OSErr		GetListItemData(SkankyListHandle skankHandle, long itemIndex, StringPtr itemData);
	pascal OSErr		SetListItemData(SkankyListHandle skankHandle, long itemIndex, StringPtr newData);
	pascal OSErr		DeleteAllListItems(SkankyListHandle skankHandle);
	pascal OSErr		DisposeAsyncList(SkankyListHandle killSkankyListHandle);
	pascal OSErr		GetSelectedItemFromList(SkankyListHandle skankHandle, long *theItem);
	pascal OSErr		SetSelectedItemInList(SkankyListHandle skankHandle, long theItem);
	pascal void		ProcessAsyncListTask(SkankyListHandle checkSkankyListHandle);
	pascal void		ActivateAsyncList(SkankyListHandle dirtySkankyListHandle);
	pascal void		DeActivateAsyncList(SkankyListHandle dirtySkankyListHandle);
	pascal void		UpdateAsyncList(SkankyListHandle dirtySkankyListHandle, Boolean completeUpdate);
	pascal void		DrawListElementsToScreen(SkankyListHandle skankHandle, Boolean eraseRect);
	pascal void		TrackListSelection(SkankyListHandle skankHandle);
	pascal void		ScrollOneLine(SkankyListHandle skankHandle, short direction, short hiliteArrow);
	pascal void		ScrollPage(SkankyListHandle skankHandle, short direction);
	pascal void		TrackScrollThumb(SkankyListHandle skankHandle);
	pascal OSErr		KillAsyncListManager(void);

#endif
 
/*______________________________________________________________________*/

