/* START OF FILE: Dreaming_Analog_Card.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_Analog_Card.h - Header to support Poor Man's Video Phone
 ** (C) Copyright 1993 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Dreaming_Analog_Card.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Dreaming_Analog_Card

#define _H_Dreaming_Analog_Card
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include <SoundInput.h>


/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define k_POSITIVE_SIDE_SKEW		0x0000

	/*  */
	/* 12 bit to 8 bit is "3" */
	/*  */
#define k_SAMPLER_DIVISOR			3

	/*  */
	/* the first number affects the range of bytes to average, the second */
	/* one represents the skip samples based on corruption cased by the */
	/* triggering */
	/* NORMALLY JUST 100 */
	/* BUT 300 for faster smaple speeds*/
	/* 300 is ok for fast speed */
	/*  */
#define k_MAXIMUM_MINI_SAMPLES								(110L)

/*  */
/*	 at the Xth position in the block.	(skips a few samples)*/
/* actually causes corruption problem at position into block!!! */
/* based upon k_SKIP_SAMPLES in the header */
/* "4" is a good value if slope triggered */
/*  */

#define k_SKIP_SAMPLES														(0L)


#define k_DEFAULT_CARD_CHANNELS								(4L)


/* normally 4, can be helpful as high as 80 (SHOULD BE close to 8)!!! */
/* ==
#define k_SOFTWARE_EIGHTHS_AMPLIFIER_FACTOR		(88L)
=== */
#define k_SOFTWARE_EIGHTHS_AMPLIFIER_FACTOR		(4L)

/*  */
/*  */
#define k_CARD_AMPLIFICATION_RESPONSE					(1.0)

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Test_Digital_Audio_Card(void);
extern Safe_Boolean Stop_Sampling_From_Card(void);
extern Safe_Boolean Start_Sampling_From_Card(CARDINAL_32	total_Channels_Scanning);

extern Safe_Boolean Fetch_Tap_Of_Digital_Audio_Card(INTEGER_16 channel
					, CARDINAL_16 *minibuffer
					, CARDINAL_16 samples
					, Boolean			*no_New_Data_Yet);

extern Safe_Boolean Reset_Sampling_From_Audio_Card(void);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

extern Safe_Boolean					g_Digital_Audio_Card_In_Use;

/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Dreaming_Analog_Card.h */