/* START OF FILE: Dreaming_Animation.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_Animation.h - Header to support Dreaming_Animation.c
 ** (C) Copyright 1993 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Dreaming_Animation.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Dreaming_Animation

#define _H_Dreaming_Animation
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Core_Specific.h"
#include "Shell_Globals.h"
#include "Dreaming_Stuff.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define k_DRAW_MAXIMUM_SPAN_OF_ALL_FRAMES	0
#define k_DRAW_ONLY_SINGLE_FRAME							1
#define k_DRAW_BOUNDING_RECT_OF_FRAME				2
#define k_DRAW_BUFFERRED_SINGLE_FRAMES				3
#define k_DRAW_ENTIRE_MAXIMUM_CLIPPED_FRAME	4
#define k_DRAW_REDIRECTED_DISK_ART_FRAME			5
#define k_DRAW_REDIRECTED_DISK_SQUARE_FRAME	6


/*  */
/*This lets benchmark code know to ignore using CLUT match or */
/* match QD flag to be flipped false. Normally 1 except when suspicious */
/* That ports are not the way they should be and analyzing mismatch of cluts. */
/*  */
#define	k_FORCE_NO_QUICKDRAW_CLUT_MATCH		1

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean	Draw_Specific_Frame_Of_Item(Off_Screen_Ptr	modern_Destination_Bitmap
																		, const BitMap	*destination_Bitmap
																		, Safe_Boolean	avoid_Modern_Bitmap
																		, INTEGER_16 	scene_Index
																		, INTEGER_16 	index_Into_Scene
																		, Puppet_Orientation_Ptr puppet_Orientation
																		, Point		scene_Offset
																		, INTEGER_32		extra_Offset_X
																		, INTEGER_32		extra_Offset_Y);

extern Safe_Boolean	Revise_Current_Scene(CARDINAL_32	window_Index, CARDINAL_32 scene_Index);

extern Safe_Boolean Repaint_Background_Portion(Puppet_Ptr puppet
						, CARDINAL_32 current_frame_Offset
						, Off_Screen_Port_Rec *scene_Port
						, Point *position_In_Scene_Point
						, Rect *scene_Background_Rect);

extern Safe_Boolean	Benchmark_Animation_Frames(CARDINAL_32 puppet_Index
																		, CARDINAL_32 scene_Index
																		, INTEGER_16 index_Into_Scene);

extern Safe_Boolean	Redraw_Idle_Screen_Completely(Boolean actual_System_Update, Boolean show_Closed_Mouths);

extern Safe_Boolean	Get_Current_Volume_Frame(Stage_Item_Ptr	item_Ptr
												, Boolean *frame_Changed
												, INTEGER_16 old_Frame
												, INTEGER_16 *new_Frame);

extern Boolean Fetch_Keyboard_Amplitude(CARDINAL_32 *keyboard_Amplitude);

extern Safe_Boolean Fill_Selected_Port_With_All_Scene_Items(Off_Screen_Ptr	modern_Destination_Bitmap
																		, const BitMap	*destination_Bitmap
																		, Safe_Boolean	avoid_Modern_Bitmap
																		, CARDINAL_16	scene_To_Use
																		, Boolean show_Closed_Mouths
																		, INTEGER_16		audio_Index
																		, INTEGER_32		extra_Offset_X
																		, INTEGER_32		extra_Offset_Y);


extern Safe_Boolean	Erase_Old_Item_From_Mix_Buffer(Off_Screen_Port_Rec *port_Ptr
																		, Puppet_Ptr current_Puppet
																		, INTEGER_16 current_Frame
																		, Point		scene_Offset
																		, INTEGER_32		extra_Offset_X
																		, INTEGER_32		extra_Offset_Y);

extern Safe_Boolean	Erase_Spin_Item_From_Mix_Buffer( Off_Screen_Port_Rec *port_Ptr
																					, Off_Screen_Port_Rec *optional_Background_Port_Ptr
																					, CARDINAL_32	composite_Search_Key
																					, CARDINAL_32	spin_Info_Address
																					, CARDINAL_32 previous_Index
																					, INTEGER_16 file_Reference
																					, INTEGER_16 offset_X
																					, INTEGER_16 offset_Y);

extern void Reset_Graphics_Tables_For_Main_Screen_If_Needed(void);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Dreaming_Animation.h */