/* START OF FILE: Dreaming_Audio.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_Audio.h - Header to support Poor Man's Video Phone
 ** (C) Copyright 1993 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Dreaming_Audio.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Dreaming_Audio

#define _H_Dreaming_Audio
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include <SoundInput.h>

#include "Sound_Play.h"
#include "Sound_Record.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define	k_MAXIMUM_VOICE_MONITORS	17

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */



typedef struct {
volatile		Boolean					phoneBridge_ADB_Active;
volatile		Boolean					phoneBridge_Off_Hook;
volatile		Boolean					phoneBridge_Ringing;
volatile		Boolean					phoneBridge_Enabled;
		INTEGER_16			phoneBridge_Ref;
}PhoneBridge;

/*  */
/* Structure for managing dreaming voice monitoring. */
/*  */
 typedef struct {
	Safe_Boolean						initialized;
	Safe_Boolean						monitor_Microphone_For_Speech;
	Safe_Boolean						monitor_Sampler_For_Speech;
	Safe_Boolean						monitor_Keyboard_As_Speech;
	Safe_Boolean						monitor_Network_As_Speech;
	Safe_Boolean						monitor_MIDI_For_Sound;
	Safe_Boolean						Monitor_Phonebridge_For_Sound;
	CARDINAL_32					total_Voices_Active;
	CARDINAL_32					audio_Channels_Needed_On_Cards;
	CARDINAL_32					tickCount_MIO_DAQ_Last_Updated;
	PhoneBridge						phone_Rec;						
	Safe_Boolean						voice_Active[k_MAXIMUM_VOICE_MONITORS];
	Memory_Allocation			voice_Memory_Initialized[k_MAXIMUM_VOICE_MONITORS];
	Voice_Hdl							voice[k_MAXIMUM_VOICE_MONITORS];
 } Voice_Monitoring_Rec, *Voice_Monitoring_Ptr;


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean	Initialize_Audio_Monitoring_If_Needed(void);

extern Safe_Boolean Get_Sampler_Voice(Audio_Source_Type type);

extern Safe_Boolean Stop_Sound_Input_Monitoring(Recording_Ptr	monitor);

Safe_Boolean Start_Sound_Input_Monitoring(Recording_Ptr	monitor
			, Safe_Boolean *activated
			, CARDINAL_32	desired_Active_Channels
			, Safe_Boolean select_Any_Input);
			
extern Safe_Boolean Process_Sound_Updating(Voice_Hdl	voice);

extern Safe_Boolean Get_Sound_Input_Voice(Audio_Source_Type type
					, Recording_Ptr *voice_Ptr);

extern Safe_Boolean Stop_All_Sound_Monitoring_Of_Type(Audio_Source_Type type_Of_Service_To_Kill);

extern Safe_Boolean Update_Sound_Input_Monitoring(void);
extern Safe_Boolean Shutdown_Sound_Input_Monitoring(void);

extern Safe_Boolean Start_Sampler_Monitoring(Safe_Boolean *activated);

extern Safe_Boolean Attach_Default_Inputs_To_Scene_Puppets(INTEGER_32 scene_To_Use, CARDINAL_32 start_Offset_Into_Voices, Boolean reset_Voices);

extern Safe_Boolean Shutdown_Voice(CARDINAL_32		index, Audio_Source_Type type_To_Destroy);

extern Safe_Boolean Delete_A_Specific_Input_From_Any_Scene_Puppets(Voice_Hdl voice_To_Eliminate_Soon_Hdl);

extern Safe_Boolean Attach_Default_Inputs_To_All_Scene_Puppets(CARDINAL_32 start_Offset_Into_Voices);

extern void Convert_Audio_To_Non_Linear_Gain(CARDINAL_32 input, SPEED_DIGITS_REAL *effect_Ratio, CARDINAL_32 *output);

extern Safe_Boolean Reattach_Inputs_To_Scene_Puppets(CARDINAL_32 scene_To_Use, CARDINAL_32 start_Offset_Into_Voices, Boolean reset_Voices);

extern Safe_Boolean Notify_Sync_Audio_Problem_Found_If_First_Time(void);

extern Safe_Boolean Swap_Or_Delete_An_Input_From_Any_Scene_Puppets(Voice_Hdl voice_To_Eliminate_Soon_Hdl
																														, Safe_Boolean	swap_With_Another_Voice
																														, Voice_Hdl		voice_To_Swap_With_Hdl);

extern Safe_Boolean Revert_All_Voices_In_Items_To_Paused_Original_Sources(Voice_Hdl original_Voice);

extern pascal void Inform_Main_Routine_Audio_File_Is_Closing(Async_AIFF_Ptr file_Control_Ptr);

extern Safe_Boolean Create_Sound_Input_Voice(Audio_Source_Type type
					, CARDINAL_32	*position);

extern Safe_Boolean Extract_Recent_Amplitude_From_Sampler(Voice_Hdl	voice, CARDINAL_32	*raw_Signal);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

extern Voice_Monitoring_Rec		g_Voices;
extern Safe_Boolean						g_Voice_Globals_Initialized;

/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Dreaming_Audio.h */