/* START OF FILE: Dreaming_Backdrop_Files.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_Backdrop_Files.h - Header for Dreaming_Backdrop_Files.c
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Dreaming_Backdrop_Files.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Dreaming_Backdrop_Files

#define _H_Dreaming_Backdrop_Files
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Command_Dialogs.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define	k_BACKDROP_VERSION_010000		0x00010000
#define	k_BACKDROP_VERSION_010100		0x00010100

/*  */
/* First version that saved data in data fork instead of resources */
/*  */
#define	k_BACKDROP_VERSION_020000		0x00020000
#define	k_BACKDROP_VERSION_020100		0x00020100

#define	k_BACKDROP_VERSION_NOW				k_BACKDROP_VERSION_020100

/*  */
/* k_BACKDROP_BASE_VERSION_NOW must never be greater than */
/* k_BACKDROP_VERSION_NOW. */
/*  */
#define	k_BACKDROP_BASE_VERSION_NOW		k_BACKDROP_VERSION_020000

#define	k_BACKDROP_FILE_TYPE							'HFWb'

#define	k_BACKDROP_MAIN_RESOURCE_TYPE			'Bak1'

#define k_MINIMUM_BACKDROP_HEIGHT		63
#define k_MINIMUM_BACKDROP_WIDTH		63

#define	k_BASE_BACKDROP_RESOURCE_ID			128

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

 typedef struct {
	Safe_Boolean					valid;
	CARDINAL_32				version;
	CARDINAL_32				backward_Compatible_Version;
	CARDINAL_16				stored_Bit_Depth;
	Rect							backdrop_Size_Rect;
	Str63							file_Name;
	Safe_Boolean					backdrop_Special_Effect;
	CARDINAL_32				effect_Type;
 } Backdrop_File_Header_Rec, *Backdrop_File_Header_Ptr, **Backdrop_File_Header_Hdl;


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Dreaming_Backdrop_Files(void);

extern Safe_Boolean Destroy_Dreaming_Backdrop_Files(void);
								
extern Safe_Boolean	Load_Backdrop_File(Load_Backdrop_Rec	*params_For_Load_Backdrop);

extern Safe_Boolean	Specify_Backdrop_To_Load(FSSpec		*file_Specification
											, Safe_Boolean *user_Abort);

extern Safe_Boolean	Save_Backdrop_Sequence(Save_Backdrop_Rec	*params_For_Save_Backdrop);

extern Safe_Boolean	Specify_Backdrop_To_Save(FSSpec		*file_Specification
												, Str63			*assumed_File_Name
												, Safe_Boolean *user_Abort);

extern Safe_Boolean	Load_Or_Import_Backdrop_File(Load_Backdrop_Rec	*params_For_Load_Backdrop
													, Convert_Backdrop_Rec	*params_For_Convert_Backdrop
													, Boolean		importation_Desired);

extern  Safe_Boolean	Specify_Backdrop_To_Save(FSSpec		*file_Specification
															, Str63				*assumed_File_Name
															, Safe_Boolean *user_Abort);

extern Safe_Boolean Load_Some_More_Background(void);

extern Safe_Boolean	Convert_Backdrop_File_Immediate_Style(Convert_Backdrop_Rec	*params_For_Convert_Backdrop);

extern Safe_Boolean	Load_Backdrop_File_Immediate_Style(Load_Backdrop_Rec	*params_For_Load_Backdrop);

extern Safe_Boolean	Load_Convert_Backdrop_File_Immediate_Style(Load_Backdrop_Rec	*params_For_Load_Backdrop
													, Convert_Backdrop_Rec	*params_For_Convert_Backdrop
													, Boolean		importation_Desired);

extern Safe_Boolean	Specify_Pict_To_Import(FSSpec		*file_Specification
															, Safe_Boolean	*file_Is_Pict_File_Type
															, INTEGER_16		*resource_Index
															, Safe_Boolean *user_Abort
															, CARDINAL_32	*selected_Pict_Width
															, CARDINAL_32	*selected_Pict_Height);


extern Safe_Boolean	Specify_Backdrop_To_Export(FSSpec		*file_Specification
															, Str63				*assumed_File_Name
															, Safe_Boolean *user_Abort);

extern Safe_Boolean	Export_Backdrop_Sequence(Export_Backdrop_Rec	*params_For_Export_Backdrop);

extern Safe_Boolean	Destroy_A_Backdrop(CARDINAL_32 backdrop_To_Destroy);

extern Safe_Boolean Load_Raw_Pict_Fork_From_Backdrop(FSSpec *file_Info
																		, CARDINAL_16	desired_Color_Depth
																		, CTabHandle		offscreen_Color_Table_Handle
																		, CGrafPtr	offscreen_Graph_Port
																		, GDHandle	*offscreen_GDevice_Ptr
																		, Handle		*image_Handle_Ptr);


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Dreaming_Backdrop_Files.h */
