/* START OF FILE: Dreaming_Color_Stuff.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_Color_Stuff.h - Header to support Poor Man's Video Phone
 ** (C) Copyright 1993 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Dreaming_Color_Stuff.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Dreaming_Color_Stuff

#define _H_Dreaming_Color_Stuff
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include <PictUtil.h>
#include "Shell_Globals.h"
#include "Dreaming_Stuff.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

	/*  */
	/* Maximum is (256 - 2) (no B&w), minimum should be reasonable */
	/*  */
#define k_MAXIMUM_SPECIAL_COLORS				256


#define k_DREAM_STRINGS						1200
#define k_UNIQUE_COLORS_1_INDEX		1
#define k_UNIQUE_COLORS_2_INDEX		2
#define k_TOTAL_COLORS_1_INDEX		3
#define k_TOTAL_COLORS_2_INDEX		4
#define k_LOCATE_PICT_CONTAINING_A_CLUT_INDEX		5
#define k_LOAD_PICS_FILE_INDEX											6
#define k_SPECIAL_COLORS_WAS_LESS_INDEX					7
#define k_SELECTED_CLUT_NOT_SPECIAL_INDEX					8
#define k_MISSING_COLOR_INDEX											9
#define k_LOADING_AND_CONVERTING_TO_CURRENT_COLORS		10
#define k_PROCESSING_PICTURES_FOR_BACKGROUND_EDGES			11
#define k_REMAINING_FRAMES																12
#define k_SAVE_PUPPET_PROMPT														13
#define k_SAVE_PUPPET_FILE_SUFFIX													14
#define k_DONT_EDIT_RESOURCE_COMMENT										15
#define k_XXXXXX_FILE_INDEX																16
#define k_SORRY_WRONG_FILE_INDEX													17
#define k_EXPORT_PUPPET_PICS_FILE_SUFFIX										18
#define k_EXPORT_PUPPET_PICS_PROMPT											19
#define k_BAD_STRING_LENGTHS_PROMPT											20
#define k_ENTER_SCENE_NAMES_PROMPT											21
#define k_ENTER_PUPPET_NAMES_PROMPT										22
#define k_ERROR_UNTITLED_NOT_ALLOWED_PROMPT						23
#define k_SAVE_SCENE_PROMPT															24
#define k_SAVE_SCENE_FILE_SUFFIX														25
#define k_SAVE_BACKDROP_PROMPT													26
#define k_SAVE_BACKDROP_FILE_SUFFIX												27
#define k_OLD_BACKDROP_NOT_DISPOSED_YET_ERROR					28
#define k_ERROR_BACKDROP_UNSAVABLE											29
#define k_ERROR_NO_PICT_RESOURCES_IN_FILE									30
#define k_RESOURCE_IS_JUST_THUMBNAIL_COMMENT						31
#define k_EXPORT_BACKDROP_PROMPT												32
#define k_EXPORT_BACKDROP_BACKDROP_FILE_SUFFIX					33
#define k_IMPORT_PUPPET_FILE_MAX_COLORS_SUFFIX					34
#define k_IMPORT_PUPPET_NO_PICT_ANALYSIS_POSSIBLE				35
#define k_IMPORT_BACKDROP_ALLOW_NON_256_COLOR				36
#define k_CHOOSE_A_CHROMA_KEY_256_COLOR								37
#define k_COMPRESSING_AND_SAVING_FRAME									38
#define k_NUMBER_OF_FILES_SOLO_AND_NOT_PICTS						39
#define k_NUMBER_OF_FILES_DOES_NOT_MATCH_NEIGHBORS		40
#define k_SELECT_SPIN_FILE_TO_ADD_TO_DEFINITION_INDEX			41


#define k_SPIN_STRINGS																		1203
#define k_ERROR_SPIN_OBJECT_UNSAVABLE									1
#define k_SAVE_SPIN_OBJECT_PROMPT											2
#define k_SAVE_SPIN_OBJECT_FILE_SUFFIX										3
#define k_EXPORT_SPIN_OBJECT_PROMPT										4
#define k_EXPORT_SPIN_OBJECT_SPIN_OBJECT_FILE_SUFFIX		5
#define k_OLD_SPIN_OBJECT_NOT_DISPOSED_YET_ERROR			6
#define k_IMPORT_SPIN_OBJECT_ALLOW_NON_256_COLOR		7
#define k_NOTE_SPIN_OBJECT_WIDTH_WILL_CLIP							8
#define k_NOTE_SPIN_OBJECT_HEIGHT_WILL_CLIP							9
#define k_ERROR_SPIN_OBJECT_TOO_SMALL									10
#define k_ERROR_WAS_PICT_FILE_INSTEAD_OF_PICS						11
#define k_ERROR_DID_NOT_CONTAIN_MULTIPLE_PICS					12
#define k_ERROR_USER_CANCELLED_IMPORT									13
#define k_IMPORT_SPIN_OBJECT_ALLOW_HIERARCHY_PART_1	14
#define k_IMPORT_SPIN_OBJECT_ALLOW_HIERARCHY_PART_2	15
#define k_IMPORT_SPIN_OBJECT_ALLOW_HIERARCHY_PART_3	16
#define k_IMPORT_SPIN_OBJECT_ALLOW_HIERARCHY_PART_4	16
#define k_IMPORT_SPIN_OBJECT_ALLOW_HIERARCHY_PART_5	17

/*  */
/* Hopefully this is an exlicit enough request for a nearly intolerant */
/* palette selection */
/*  */
#define k_PUPPET_INTOLERENT		0x0004
#define k_PUPPET_TOLERENT			0x0200


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Tally_Colors_Not_In_Default_Clut(PaletteHandle	source_Hdl
																		, CARDINAL_32 *total_Colors
																		, Safe_Boolean	reset_Common_To_Tolerant);

extern Safe_Boolean Determine_If_Another_Clut_Wanted(CARDINAL_32 total_Colors_In_File
																, CARDINAL_32  actual_Total_Of_Special_Colors);

extern Safe_Boolean Ask_User_For_Another_Clut(CTabHandle *located_Clut);

extern Safe_Boolean Create_Palette_From_Clut(CTabHandle source_Clut, PaletteHandle	*source_Hdl);

extern Safe_Boolean Activate_Palette_And_Verify_Intolerant(WindowPtr window_Ptr
																								, PaletteHandle	palette_Hdl);

extern Safe_Boolean Setup_Pallette_Animation(CARDINAL_32	window_Index);

extern Safe_Boolean Animate_Color_Table_For_Window(CARDINAL_32	window_Index);

extern Safe_Boolean Force_Pallete_And_Clut_To_Match_Puppet(WindowPtr window_Ptr
																								, Puppet_Ptr current_Puppet);


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

extern Safe_Boolean		g_Permit_Palette_Colors;
extern Safe_Boolean		g_Force_All_To_Use_Main_Puppet_Colors;

/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Dreaming_Color_Stuff.h */