/* START OF FILE: Dreaming_PhoneBridge.c */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_PhoneBridge.h - Header to Collaboration Technologies PhoneBridge (voice 714-639-1500)
 ** Concept (C) Copyright 1994 James Merkle, portions (C) Copyright 1994 Collaboration Technologies
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  1993.06.23		(James Merkle)
 **						Initial coding started, most ported from other routines
 **						probably written by Francis Stanbach and Pete Helme
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 ** 
 ** 	RAW QUICK MAC HACK STUFF!!! ROUGH!
 **
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */


#include <GestaltEqu.h>
#include <Sound.h>
#include <DeskBus.h>
#include <LowMem.h>


/* THINK C */
#include <Asm.h>
#include <Files.h>

#include "PBDriverInterface.h"

#include "Error_Utilities.h"
#include "OS_Utilities.h"
#include "Shell_Dialogs.h"
#include "Shell_Globals.h"
#include "Memory_Utilities.h"
#include "Sound_Utilities.h"
#include "String_Utilities.h"
#include "Window_Utilities.h"

#include "Dreaming_Analog_Card.h"

#include "Core_Universal.h" /* Non_Specific_Support_Routines */
#include "Shell_Globals.h"

#include "Dreaming_Stuff.h"
#include "Dreaming_PhoneBridge.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

enum {
	kCPCDetect	 = 23,
	kMacSndToPBSpeakerPTMicEnabled = 25,
	kEarphoneToMacSoundIO,
	kPhoneLineToMacSoundIO,					// hook switch must be done in separate command
	kPhoneLineToMacSoundIOwPBSpeaker,		// hook switch must be done in separate command
	kEarphoneToPhoneLineMacToPBSpeaker,		// hook switch must be done in separate command
	kEarphoneToPhoneLineMacSndToPhoneLine,	// hook switch must be done in separate command
	kOnHookMonitoringEnableCallerID,		// use when decoding Caller ID data (w/amp boost)
	kOnHookMonitoringEnableCallerIDNoGain,	// use when decoding Caller ID data (no gain)
	kDTMFDetect	 = 33
};

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

static void __Get_A5(void);
Safe_Boolean InitializePhoneBoySettings(void);

pascal OSErr  MyPhoneBridgeCallBack(INTEGER_16 msg
																, INTEGER_16 mType
																, INTEGER_16 value
																, INTEGER_32 otherInfo
																, INTEGER_16 lineNo
																, INTEGER_32 reserved);

void ToggleCallerID(void);

Safe_Boolean RegisterCallBack(void);
void CompletionRoutine(void);

Safe_Boolean Toggle_Audio_Matrix(INTEGER_16 item);

/*=--------------------------------------------------------------------------=*/
/* Unique little THINK C constructs to save and restore A5 worlds */
/*=--------------------------------------------------------------------------=*/
#define RememberA5()	do { __Get_A5(); asm { move.l A5,(a1) } } while (0)

#define Setup_A5()			do { asm { move.l A5,-(sp) } __Get_A5(); asm { move.l (a1),A5 } } while (0)
#define Restore_A5()		do { asm { move.l (sp)+,A5 } } while (0)


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */


/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

static CARDINAL_8	*unit_Name = "\pDreaming_PhoneBridge";
	
/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
static void __Get_A5(void)
{
	asm {
		bsr.s	@1
		dc.l	0			;  store A5 here
@1		move.l	(sp)+,a1
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean	Shutdown_Phone_Bridge(void)
{
	OSErr		os_Result;
/* END VAR */


	if (g_Voice_Globals_Initialized == SAFE_TRUE) {
		
		if (g_Voices.phone_Rec.phoneBridge_Enabled == TRUE) {
			if (g_Voices.phone_Rec.phoneBridge_ADB_Active != TRUE) {
			
				Take_Phone_On_Or_Off_Hook(TRUE);
				
				os_Result = CloseDriver((g_Voices.phone_Rec.phoneBridge_Ref));
				if (os_Result != noErr) {
					Perform_OK_Dialog("\pSorry. Couldn't close driver (.PhoneBridge) from Collaboration Technologies");
				}
			}
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Toggle_Audio_Matrix(INTEGER_16 item)
{
	PhoneBridgeControlParam		pbcp;
	PhoneBridgeStatus	pbStatus;
	OSErr	err;
	Safe_Boolean		function_Result;
/* END VAR */

	function_Result = SAFE_TRUE;

	// send the command
	pbcp.line = 1;
	pbcp.u.value = item - 9;	// hack!  just happens to map 9 lower for ADB command
	
	if (Control(g_Voices.phone_Rec.phoneBridge_Ref,pbControlSetAudioMatrix,&pbcp) != noErr) {
		function_Result = SAFE_FALSE;
	}
	
	return (function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean	Initialize_PhoneBridge(void)
{
	Safe_Boolean		function_Result;
	OSErr					os_Result;
	CARDINAL_32	index;
/* END VAR */


	function_Result = SAFE_FALSE;
	
	if (g_Voice_Globals_Initialized == SAFE_TRUE) {
			
		g_Voices.phone_Rec.phoneBridge_ADB_Active = FALSE;
		g_Voices.phone_Rec.phoneBridge_Enabled = FALSE;
		g_Voices.phone_Rec.phoneBridge_Off_Hook = FALSE;
		g_Voices.phone_Rec.phoneBridge_Ringing = FALSE;
		g_Voices.phone_Rec.phoneBridge_Ref = 0;

		os_Result = OpenDriver("\p.PhoneBridge",&(g_Voices.phone_Rec.phoneBridge_Ref));
		if (os_Result != noErr) {
			Perform_OK_Dialog("\pSorry. Couldn't locate driver (.PhoneBridge) from Collaboration Technologies");
			goto Error_Handler;
		}

		if (InitializePhoneBoySettings() != SAFE_TRUE) {
			goto Error_Handler;
		}

		RememberA5();

		if (RegisterCallBack() != SAFE_TRUE) {
			goto Error_Handler;
		}
		
#if (7 == 11)
					case kMacSndToPBSpeakerPTMicEnabled:
					case kEarphoneToMacSoundIO:
					case kPhoneLineToMacSoundIO:					// hook switch must be done in separate command
					case kPhoneLineToMacSoundIOwPBSpeaker:		// hook switch must be done in separate command
					case kEarphoneToPhoneLineMacToPBSpeaker:		// hook switch must be done in separate command
					case kEarphoneToPhoneLineMacSndToPhoneLine:	// hook switch must be done in separate command
					case kOnHookMonitoringEnableCallerID:		// use when decoding Caller ID data (w/amp boost)
					case kOnHookMonitoringEnableCallerIDNoGain:	// use when decoding Caller ID data (no gain)
#endif /* 7 == 11 */

		/*  */
		/* Request audio path to tap off SID port and internal unit monitor */
		/*  */
		if (Toggle_Audio_Matrix(kPhoneLineToMacSoundIOwPBSpeaker) != SAFE_TRUE) {
		
			/*  */
			/* For forced driver close we need to set to true momentarily */
			/*  */
			g_Voices.phone_Rec.phoneBridge_ADB_Active = FALSE;
			g_Voices.phone_Rec.phoneBridge_Enabled = TRUE;
			
			if (Shutdown_Phone_Bridge() != SAFE_TRUE) {
				/*  */
				/* Ignore error, we are quitting anyway */
				/*  */
			}
		
			goto Error_Handler;
		}
		
		g_Voices.phone_Rec.phoneBridge_ADB_Active = FALSE;
		g_Voices.phone_Rec.phoneBridge_Enabled = TRUE;

		/*  */
		/* Temp hack!, ring detection not possible for some reason in my code.*/
		/* Take off hook now (phone must be already ringing) */
		/*  */
		Take_Phone_On_Or_Off_Hook(FALSE);

	}
	else {
		goto Error_Handler;
	}
	
	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
	
Error_Handler:
	function_Result = SAFE_FALSE;
			
Normal_Function_Exit:
	return(function_Result);
	
} /* Safe_Boolean	Initialize_Dreaming_Globals... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean InitializePhoneBoySettings(void)
{
	OSErr	err;
	PhoneBridgeControlParam		pbcp;
	Safe_Boolean		function_Result;
/* END VAR */


	function_Result = SAFE_FALSE;

	pbcp.line = 1;
	pbcp.u.value = 1;
	if (Control(g_Voices.phone_Rec.phoneBridge_Ref,pbControlDisableCPCDetect,&pbcp) != noErr) {
		goto Error_Handler;
	}

	pbcp.line = 1;
	pbcp.u.value = 1;
	if (Control(g_Voices.phone_Rec.phoneBridge_Ref,pbControlDisableDTMFDetect,&pbcp) != noErr) {
		goto Error_Handler;
	}

	
	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
	
Error_Handler:
	function_Result = SAFE_FALSE;
			
Normal_Function_Exit:
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean RegisterCallBack(void)
/*  */
// this is how one sets up the call back.  it's pretty straightforward. make sure and
// leave in the A5 setup code!
/*  */
{
	PhoneBridgeControlParam		pbcp;
	OSErr	err;
	Safe_Boolean		function_Result;
/* END VAR */


	pbcp.line = 1;
	pbcp.u.callback = (PhoneBridgeCallBackProc *)&MyPhoneBridgeCallBack;
	pbcp.callbackRefcon = (INTEGER_32)LMGetCurrentA5(); // *(INTEGER_32 *)CurrentA5;
	
	if (Control(g_Voices.phone_Rec.phoneBridge_Ref,pbControlRegisterCallback,&pbcp) != noErr) {
		goto Error_Handler;
	}

	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
	
Error_Handler:
	function_Result = SAFE_FALSE;
			
Normal_Function_Exit:
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
pascal OSErr  MyPhoneBridgeCallBack(INTEGER_16 msg
																, INTEGER_16 mType
																, INTEGER_16 value
																, INTEGER_32 otherInfo
																, INTEGER_16 lineNo
																, INTEGER_32 reserved)
/*  */
// this is the callback itself. it will be called by the driver for the appropriate events
/*  */
{
 	INTEGER_32	savedA5;
/* END VAR */


	savedA5 = (INTEGER_32)LMGetCurrentA5();
	LMSetCurrentA5((Ptr)reserved);

 	switch(msg) 
 	{
 		case messageRingDetected:
			g_Voices.phone_Rec.phoneBridge_Ringing = TRUE;
		
	/* ===
			if(gCallerID) {
				CallCallerID();
			}
	=== */
			
			break;
			
		case messageDTMFDetected:
			break;
			
		case messageLoopCurrentTransition:
	/* =====
			Take_Phone_On_Or_Off_Hook(FALSE);
			g_Voices.phone_Rec.phoneBridge_Ringing = FALSE;
	==== */
			break;
			
		case messageHandsetStatus:
		case messageCallProgressState:
			; /* NULL */
 	}
	
	LMSetCurrentA5((Ptr)savedA5);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Take_Phone_On_Or_Off_Hook(Boolean hookValue)
{
	INTEGER_16 commandNum = 0x68;		// Listen Reg 0
	unsigned char buffer[3];
/* END VAR */


	buffer[0] = 2;
	if (hookValue)
		buffer[1] = 0x01;
	else 
		buffer[1] = 0x02;
	buffer[2] = 0x00;
	
	g_Voices.phone_Rec.phoneBridge_ADB_Active = true;
	
#if !defined(ORIGINAL_MAC_SYSTEM)
#error "UNDEFINED PARAMETER!"
#endif
#if (ORIGINAL_MAC_SYSTEM == 0)
XXXX 	do correctly
	if (ADBOp(nil, (ProcPtr) &CompletionRoutine, (Ptr)&buffer[0], commandNum) != noErr)
		DebugStr("\p problem in ADBOp");
#else
	if (ADBOp(nil, (ADBServiceRoutineUPP) &CompletionRoutine, (Ptr)&buffer, commandNum) != noErr)
		DebugStr("\p problem in ADBOp");
#endif 

	
		
	while (g_Voices.phone_Rec.phoneBridge_ADB_Active) {
		; /* NULL */
	}	// wait for completion routine
	
	if (hookValue == TRUE) {
		g_Voices.phone_Rec.phoneBridge_Off_Hook = FALSE;
	}
	else {
		g_Voices.phone_Rec.phoneBridge_Off_Hook = TRUE;
	}
	
	// DebugStr("\p done");
}

#if (17 == 11 )

/*  */
// this is the CallerID wrapper.  the actual recognizing code is in CallerID.c.o and CallerID.a.o
// this is all the caller ID code you need below.  this is of course all temporary
// and in the future the driver will most likely handle all of it. When the ring is 
// detected, simply call the CallCallerID() function and DecodeCIDandDR() within will
// fill in the structure.
/*  */

void ToggleCallerID()
{
	Handle		theControl;
	DialogPtr	theDialog;
	INTEGER_16		theItem;
	Rect		iRect;
	INTEGER_16		iType;
	
	OSErr	err;
	PhoneBridgeControlParam		pbcp;
/* END VAR */


	switch(gCallerID)
	{
	
	case false:
		pbcp.line = 1;
		pbcp.u.value = 1;
		err = Control(g_Voices.phone_Rec.phoneBridge_Ref,pbControlEnableCallerID,&pbcp);
		gCallerID = true;
		break;
		
	case true:
		pbcp.line = 1;
		pbcp.u.value = 1;
		err = Control(g_Voices.phone_Rec.phoneBridge_Ref,pbControlEnableCallerID,&pbcp);
		gCallerID = false;
		break;
	}
}
#endif /* #if (17 == 11 ) */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void CompletionRoutine(void)
{
	Setup_A5();
	g_Voices.phone_Rec.phoneBridge_ADB_Active = false;
	Restore_A5();
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: Dreaming_PhoneBridge.c */
