/* START OF FILE: Dreaming_Popup_Dialogs.c */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_Popup_Dialogs.c - Routines to support a variety of simple popup selection dialogs.
 ** (C) Copyright 1995 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  1995.06.04		(James Merkle)
 **						Initial coding started from scratch
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 ** 
 ** 
 **
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include <GestaltEqu.h>
#include <Sound.h>
#include <SoundInput.h>

#include "Shell_Globals.h"
#include "String_Utilities.h"
#include "OS_Utilities.h"
#include "Shell_Dialogs.h"

/* ===
#include "Network_Zone_Conrol.h"
=== */
#include "Dreaming_Audio.h"
#include "Dreaming_Stuff.h"
#include "Dreaming_Color_Stuff.h"
#include "Dreaming_File_Loading.h"
#include "Command_Menu.h"
#include "Command_Executor.h"
#include "Command_Dialogs.h"
#include "Command_Redirector.h"
#include "Object_Inventory.h"

#include "Video_Wipes.h"
#include "Slide_Show_Routines.h"

#include "Core_Globals.h"
#include "Core_Specific.h"
#include "Graphics_Demos_Support.h"
#include "Graphics_Primitives.h"
#include "Dreaming_Analog_Card.h"

#include "Simple_Popup_Dialog.h"
#include "Dreaming_Popup_Dialogs.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */
																
pascal Safe_Boolean Prepare_Menu_List_For_Dreams(MenuHandle	popup_Menu
													, INTEGER_16 *preferred_Mark
													, CARDINAL_32	*total_Listed_Items
													, CARDINAL_16	type_of_List
													, CARDINAL_16 *popup_References);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */


/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Get_Dream_Popup_Menu_Choice(CARDINAL_16	type_of_List
																, CARDINAL_32	*resulting_Index
																, Safe_Boolean 	*valid_Result)
{
	Safe_Boolean								function_Result;
pascal Safe_Boolean (*preparation_Function_Ptr)(MenuHandle, INTEGER_16 *, CARDINAL_32	*, CARDINAL_16, CARDINAL_16 *);
/* END VAR */

	preparation_Function_Ptr = &Prepare_Menu_List_For_Dreams;
	
	function_Result = Get_Popup_Menu_Choice(type_of_List, resulting_Index, valid_Result, preparation_Function_Ptr);
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
pascal Safe_Boolean Prepare_Menu_List_For_Dreams(MenuHandle	popup_Menu
													, INTEGER_16 *preferred_Mark
													, CARDINAL_32	*total_Listed_Items
													, CARDINAL_16	type_of_List
													, CARDINAL_16 *popup_References)
{
	Safe_Boolean			function_Result;
	CARDINAL_32		items_Found;
	CARDINAL_32		total_Items;
	INTEGER_16			index;
	OSErr					os_Error;
	CARDINAL_8			hot_Key;
	Str255					menu_String;
/* END VAR */


	function_Result = SAFE_FALSE;
	*preferred_Mark = 1;
	*total_Listed_Items = 0;
	
	/*  */
	/* For quick example, to add FONTs one would do the following: */
	/*  */
/* ===
	AddResMenu(popup_Menu,'FONT');
=== */

	popup_References[*total_Listed_Items] = 0;
	
	switch(type_of_List) {
	
		case k_SCENE_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Dreaming_Module_Globals_Initialized == SAFE_TRUE) {
				for (index = 0; ((index < k_MAX_ACTIVE_SCENES) && (*total_Listed_Items < dream.play.total_Scenes)); index++) {
					if (dream.play.scene_Memory_In_Use[index] == MEMORY_INITIALIZED) {
					
						/*  */
						/* Craig Marciniak indicated an important filter technique */
						/* to eliminate macros from menu names. It involves copying strings into markers. */
						/*  */
					
						menu_String[0] = 1;
						menu_String[1] = 'X';
						AppendMenu(popup_Menu, menu_String);
						popup_References[*total_Listed_Items] = index;
						
						Copy_Pascal_String((**(dream.play.scene[index])).file_Name, menu_String);
						
						if (index <= 8) {
							Concat_String(menu_String, "\p   ");
							Concat_Long_To_String(menu_String, (index + 1), NO_PAD);
						}
						else {
							if (index == 9) {
								Concat_String(menu_String, "\p   ");
								menu_String[0] += 1;
								menu_String[menu_String[0]] = '0';
							}
							else {
								if ((index > 9) && ((index <= 37))) {
									Concat_String(menu_String, "\p   ");
																		
									switch (index + 1) {
										case 11:
											hot_Key = 'p';
										break;
										
										case 12:
											hot_Key = 'o';
										break;
										
										case 13:
											hot_Key = 'i';
										break;
										
										case 14:
											hot_Key = 'u';
										break;
										
										case 15:
											hot_Key = 'y';
										break;
										
										case 16:
											hot_Key = 't';
										break;
										
										case 17:
											hot_Key = 'r';
										break;
										
										case 18:
											hot_Key = 'e';
										break;
										
										case 19:
											hot_Key = 'w';
										break;
										
										case 20:
											hot_Key = 'q';
										break;
										
										case 21:
											hot_Key = 'a';
										break;
										
										case 22:
											hot_Key = 's';
										break;
										
										case 23:
											hot_Key = 'd';
										break;
										
										case 24:
											hot_Key = 'f';
										break;
										
										case 25:
											hot_Key = 'g';
										break;
										
										case 26:
											hot_Key = 'h';
										break;
										
										case 27:
											hot_Key = 'j';
										break;
										
										case 28:
											hot_Key = 'k';
										break;
										
										case 29:
											hot_Key = 'l';
										break;
										
										case 30:
											hot_Key = '.';
										break;
										
										case 31:
											hot_Key = ',';
										break;
										
										case 32:
											hot_Key = 'm';
										break;
										
										case 33:
											hot_Key = 'n';
										break;
										
										case 34:
											hot_Key = 'b';
										break;
										
										case 35:
											hot_Key = 'v';
										break;
										
										case 36:
											hot_Key = 'c';
										break;
										
										case 37:
											hot_Key = 'x';
										break;
										
										case 38:
											hot_Key = 'z';
										break;
										
										default:
											hot_Key = ' ';
									}
									menu_String[0] += 1;
									menu_String[menu_String[0]] = hot_Key;
								}
							}
						}
						
						*total_Listed_Items += 1;
						SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);
					}
				}
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;
		
		case k_PUPPET_SELECTION:
		case k_PROP_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Dreaming_Module_Globals_Initialized == SAFE_TRUE) {			
			
				for (index = 0; ((index < k_MAXIMUM_PUPPETS) && (*total_Listed_Items < dream.active_Puppets_Total)); index++) {
					if (dream.puppet_Memory_Initialized[index] == MEMORY_INITIALIZED) {
										
						menu_String[0] = 1;
						menu_String[1] = 'X';
						AppendMenu(popup_Menu, menu_String);
						popup_References[*total_Listed_Items] = index;
						
						Copy_Pascal_String( (**(dream.puppet[index])).file_Name, menu_String);
						*total_Listed_Items += 1;
						SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);

					}
				}
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;	
		
		
		case k_ANIMATED_PUPPET_IN_SCENE_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Dreaming_Module_Globals_Initialized == SAFE_TRUE) {			
						
				if (dream.play.scene_Memory_In_Use[dream.current_Scene] == MEMORY_INITIALIZED) {
					if ((**(dream.play.scene[dream.current_Scene])).initialized == SAFE_TRUE) {
	
						total_Items = (**(dream.play.scene[dream.current_Scene])).total_Items_In_Scene;
						items_Found = 0;
						
						for (index = 0; ((index < k_MAX_STAGE_ITEMS) && (items_Found < total_Items)); index++) {
						
							if (((**(dream.play.scene[dream.current_Scene])).item[index].valid_Pointer == SAFE_TRUE)
								&& ((**(dream.play.scene[dream.current_Scene])).item[index].puppet != nil)) {
								
								items_Found += 1;
								
								/*  */
								/* Only add animated talking items into list */
								/* or any of the new style puppets. */
								/*  */
								if (((*((**(dream.play.scene[dream.current_Scene])).item[index].puppet)).direct_Art.talk_Total_Frames > 1) 
								 || ((*((**(dream.play.scene[dream.current_Scene])).item[index].puppet)).puppet_File_Is_Old_Self_Contained_Type != SAFE_TRUE)){
												
									menu_String[0] = 1;
									menu_String[1] = 'X';
									AppendMenu(popup_Menu, menu_String);
									popup_References[*total_Listed_Items] = index;

									Copy_Pascal_String( (*((**(dream.play.scene[dream.current_Scene])).item[index].puppet)).file_Name, menu_String);
									*total_Listed_Items += 1;
									SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);

								}
							}
						}
					}
				}
				
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;	
		

		case k_ITEM_IN_SCENE_SELECTION:
			/*  */
			/* Not implemented yet */
			/*  */
			goto Error_Handler;
		break;	


		case k_BACKDROP_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Dreaming_Module_Globals_Initialized == SAFE_TRUE) {
				for (index = 0; ((index < k_MAX_ACTIVE_BACKDROPS) && (*total_Listed_Items < dream.backdrops.total_Backdrops)); index++) {
					if (dream.backdrops.backdrop_Memory_In_Use[index] == MEMORY_INITIALIZED) {
					
						menu_String[0] = 1;
						menu_String[1] = 'X';
						AppendMenu(popup_Menu, menu_String);
						popup_References[*total_Listed_Items] = index;
						
						Copy_Pascal_String((**(dream.backdrops.backdrop[index])).backdrop_Name, menu_String);
						*total_Listed_Items += 1;
						SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);

					}
				}
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;	

		case k_SPIN_OBJECT_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Dreaming_Module_Globals_Initialized == SAFE_TRUE) {
				for (index = 0; ((index < k_MAX_ACTIVE_SPIN_OBJECTS) && (*total_Listed_Items < dream.spin_Objects.total_Spin_Objects)); index++) {
					if (dream.spin_Objects.spin_Object_Memory_In_Use[index] == MEMORY_INITIALIZED) {
					
						menu_String[0] = 1;
						menu_String[1] = 'X';
						AppendMenu(popup_Menu, menu_String);
						popup_References[*total_Listed_Items] = index;
						
						Copy_Pascal_String((**(dream.spin_Objects.spin_Object[index])).spin_Object_Name, menu_String);
						*total_Listed_Items += 1;
						SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);

					}
				}
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;	
		
		case k_SLIDE_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Total_Picts_Available > 0) {
				for (index = 0; ((index < k_MAXIMUM_SLIDES) && (*total_Listed_Items < g_Total_Picts_Available)); index++) {
								
					if ((**g_Slides_Hdl).slides[index].active == SAFE_TRUE) {
						menu_String[0] = 1;
						menu_String[1] = 'X';
						AppendMenu(popup_Menu, menu_String);
						popup_References[*total_Listed_Items] = index;
						
						Copy_Pascal_String((**g_Slides_Hdl).slides[index].slide_Name, menu_String);
						*total_Listed_Items += 1;
						SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);
					}
					
				}
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;


		case k_SCENE_FILE_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Remote_Scenes.total_Available > 0) {
				for (index = 0; ((index < k_MAXIMUM_DATABASE_SCENES) && (*total_Listed_Items < g_Remote_Scenes.total_Available)); index++) {
								
					if ((**g_Remote_Scenes.info.scenes.handle).scenes[index].active == SAFE_TRUE) {
						menu_String[0] = 1;
						menu_String[1] = 'X';
						AppendMenu(popup_Menu, menu_String);
						popup_References[*total_Listed_Items] = index;
						
						Copy_Pascal_String((**g_Remote_Scenes.info.scenes.handle).scenes[index].scene_Name, menu_String);
						*total_Listed_Items += 1;
						SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);
					}
					
				}
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;

		case k_PUPPET_FILE_SELECTION:
		case k_PROP_FILE_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Puppets.total_Available > 0) {
				for (index = 0; ((index < k_MAXIMUM_DATABASE_PUPPETS) && (*total_Listed_Items < g_Puppets.total_Available)); index++) {
								
					if ((**g_Puppets.info.puppets.handle).puppets[index].active == SAFE_TRUE) {
						menu_String[0] = 1;
						menu_String[1] = 'X';
						AppendMenu(popup_Menu, menu_String);
						popup_References[*total_Listed_Items] = index;
						
						Copy_Pascal_String((**g_Puppets.info.puppets.handle).puppets[index].puppet_Name, menu_String);
						*total_Listed_Items += 1;
						SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);
					}
					
				}
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;


		case k_BACKDROP_FILE_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Backdrops.total_Available > 0) {
				for (index = 0; ((index < k_MAXIMUM_DATABASE_BACKDROPS) && (*total_Listed_Items < g_Backdrops.total_Available)); index++) {
								
					if ((**g_Backdrops.info.backdrops.handle).backdrops[index].active == SAFE_TRUE) {
						menu_String[0] = 1;
						menu_String[1] = 'X';
						AppendMenu(popup_Menu, menu_String);
						popup_References[*total_Listed_Items] = index;
						
						Copy_Pascal_String((**g_Backdrops.info.backdrops.handle).backdrops[index].backdrop_Name, menu_String);
						*total_Listed_Items += 1;
						SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);
					}
					
				}
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;


		case k_SPIN_OBJECT_FILE_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Spin_Objects.total_Available > 0) {
				for (index = 0; ((index < k_MAXIMUM_DATABASE_SPIN_OBJECTS) && (*total_Listed_Items < g_Spin_Objects.total_Available)); index++) {
								
					if ((**g_Spin_Objects.info.spin_Objects.handle).spin_Objects[index].active == SAFE_TRUE) {
						menu_String[0] = 1;
						menu_String[1] = 'X';
						AppendMenu(popup_Menu, menu_String);
						popup_References[*total_Listed_Items] = index;
						
						Copy_Pascal_String((**g_Spin_Objects.info.spin_Objects.handle).spin_Objects[index].spin_Object_Name, menu_String);
						*total_Listed_Items += 1;
						SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);
					}
					
				}
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;


		case k_AUDIO_OBJECT_FILE_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Audio_Files.total_Available > 0) {
				for (index = 0; ((index < k_MAXIMUM_DATABASE_SOUND_OBJECTS) && (*total_Listed_Items < g_Audio_Files.total_Available)); index++) {
								
					if ((**g_Audio_Files.info.sounds.handle).sound_Objects[index].active == SAFE_TRUE) {
						if ((**g_Audio_Files.info.sounds.handle).sound_Objects[index].type_Of_Source = k_FROM_FILE) {
						
							/*  */
							/* Craig Marciniak indicated an important filter technique */
							/* to eliminate macros from menu names. It involves copying strings into markers. */
							/*  */
							menu_String[0] = 1;
							menu_String[1] = 'X';
							AppendMenu(popup_Menu, menu_String);
							popup_References[*total_Listed_Items] = index;
							
							Copy_Pascal_String((**g_Audio_Files.info.sounds.handle).sound_Objects[index].sound_Object_Name, menu_String);
							*total_Listed_Items += 1;
							SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);
						}
					}
					
				}
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;

		
		case k_TRANSITION_SELECTION:
		case k_FIRST_TRANSITION_SELECTION:

				*total_Listed_Items = 0;
				
				/*  */
				/* Hardcoded deliberately so that no resource hits or preloading */
				/* Or storage of large string holders, or unpacking of small string holders */
				/*  */
				g_Transition_Effect_Embedded_Titles[0] = &EFFECT_NOTHING_TITLE[0];
				g_Transition_Effect_Embedded_Titles[1] = &EFFECT_BOX_IN_WIPE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[2] = &EFFECT_BOX_OUT_WIPE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[3] = &EFFECT_CASTE_WIPE_R_L_TITLE[0];
				g_Transition_Effect_Embedded_Titles[4] = &EFFECT_CASTE_WIPE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[5] = &EFFECT_CIRCLE_BULGE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[6] = &EFFECT_CIRCLE_IN_TITLE[0];
				g_Transition_Effect_Embedded_Titles[7] = &EFFECT_CIRCLE_OUT_TITLE[0];
				g_Transition_Effect_Embedded_Titles[8] = &EFFECT_SERENDIPITY_TITLE[0];
				g_Transition_Effect_Embedded_Titles[9] = &EFFECT_CIRCULAR_WIPE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[10] = &EFFECT_CORNER_CIRCLE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[11] = &EFFECT_DIAGONAL_WIPE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[12] = &EFFECT_DISSOLVE_WIPE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[13] = &EFFECT_FOUR_CORNERS_CENTERED_TITLE[0];
				g_Transition_Effect_Embedded_Titles[14] = &EFFECT_FOUR_CORNER_TITLE[0];
				g_Transition_Effect_Embedded_Titles[15] = &EFFECT_FOUR_CORNER_SCROLL_TITLE[0];
				g_Transition_Effect_Embedded_Titles[16] = &EFFECT_FULL_SCROLL_L_R_TITLE[0];
				g_Transition_Effect_Embedded_Titles[17] = &EFFECT_FULL_SCROLL_U_D_TITLE[0];
				g_Transition_Effect_Embedded_Titles[18] = &EFFECT_HALVES_SCROLL_TITLE[0];
				g_Transition_Effect_Embedded_Titles[19] = &EFFECT_HILBERT_CURVE_WIPE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[20] = &EFFECT_POUR_SCROLL_TITLE[0];
				g_Transition_Effect_Embedded_Titles[21] = &EFFECT_RANDOM_WIPE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[22] = &EFFECT_RESCUE_RAIDERS_TITLE[0];
				g_Transition_Effect_Embedded_Titles[23] = &EFFECT_RIPPLE_WIPE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[24] = &EFFECT_SCISSORS_TITLE[0];
				g_Transition_Effect_Embedded_Titles[25] = &EFFECT_SKIP_A_LINE_R_L_TITLE[0];
				g_Transition_Effect_Embedded_Titles[26] = &EFFECT_SKIP_A_LINE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[27] = &EFFECT_SLIDE_WIPE_TITLE[0];
				g_Transition_Effect_Embedded_Titles[28] = &EFFECT_SPIRAL_GYRA_TITLE[0];
				g_Transition_Effect_Embedded_Titles[29] = &EFFECT_SPLIT_SCROLL_U_D_TITLE[0];
				g_Transition_Effect_Embedded_Titles[30] = &EFFECT_TWO_CORNER_TITLE[0];
				

				for(index = 0; (index < k_MAXIMUM_WIPE_EFFECTS); index++) {
					menu_String[0] = 1;
					menu_String[1] = 'X';
					AppendMenu(popup_Menu, menu_String);
					popup_References[*total_Listed_Items] = *total_Listed_Items + 1;
					Copy_Pascal_String(&(g_Transition_Effect_Embedded_Titles[index][0]), menu_String);
					*total_Listed_Items += 1;
					SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);
				}
				
			break;
	

		case k_WINDOW_SIZE_SELECTION:

				*total_Listed_Items = 0;
					
				/*  */
				/* System default */
				/*  */
				menu_String[0] = 1;
				menu_String[1] = 'X';
				AppendMenu(popup_Menu, menu_String);
				popup_References[*total_Listed_Items] = *total_Listed_Items + 1;
				Copy_Pascal_String(&k_WINDOW_SIZE_DEFAULT_STRING[0], menu_String);
				*total_Listed_Items += 1;
				SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);

				/*  */
				/* Window size 640 * 390 */
				/*  */
				menu_String[0] = 1;
				menu_String[1] = 'X';
				AppendMenu(popup_Menu, menu_String);
				popup_References[*total_Listed_Items] = *total_Listed_Items + 1;
				Copy_Pascal_String(&k_WINDOW_SIZE_640_390_STRING[0], menu_String);
				*total_Listed_Items += 1;
				SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);

				/*  */
				/* Window size 638 * 455 */
				/*  */
				menu_String[0] = 1;
				menu_String[1] = 'X';
				AppendMenu(popup_Menu, menu_String);
				popup_References[*total_Listed_Items] = *total_Listed_Items + 1;
				Copy_Pascal_String(&k_WINDOW_SIZE_638_455_STRING[0], menu_String);
				*total_Listed_Items += 1;
				SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);

				/*  */
				/* Window size 640 * 480 */
				/*  */
				menu_String[0] = 1;
				menu_String[1] = 'X';
				AppendMenu(popup_Menu, menu_String);
				popup_References[*total_Listed_Items] = *total_Listed_Items + 1;
				Copy_Pascal_String(&k_WINDOW_SIZE_640_480_STRING[0], menu_String);
				*total_Listed_Items += 1;
				SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);

				/*  */
				/* Window size 960 * 720 */
				/*  */
				menu_String[0] = 1;
				menu_String[1] = 'X';
				AppendMenu(popup_Menu, menu_String);
				popup_References[*total_Listed_Items] = *total_Listed_Items + 1;
				Copy_Pascal_String(&k_WINDOW_SIZE_960_720_STRING[0], menu_String);
				*total_Listed_Items += 1;
				SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);
				
				/*  */
				/* Window size fullscreen */
				/*  */
				menu_String[0] = 1;
				menu_String[1] = 'X';
				AppendMenu(popup_Menu, menu_String);
				popup_References[*total_Listed_Items] = *total_Listed_Items + 1;
				Copy_Pascal_String(&k_WINDOW_SIZE_FILLSCREEN_STRING[0], menu_String);
				*total_Listed_Items += 1;
				SetItem(popup_Menu, *total_Listed_Items, &menu_String[0]);
		break;
			
			
			
		case k_REMOTE_SLIDE_SELECTION:
			*total_Listed_Items = 0;
					
			if (g_Recent_Remote_Slides_Valid == SAFE_TRUE) {
			
				if (Convert_Text_List_Of_Slides_To_Menu(g_Recent_Remote_Slides_Hdl
											, g_Recent_Remote_Slides_Length
											, popup_Menu
											, total_Listed_Items
											, popup_References) != SAFE_TRUE) {
					goto Error_Handler;
				}
						
			}
			else {
				/*  */
				/* No Harm, no choices available */
				/*  */
			}
		break;
			

	
		default:
			goto Error_Handler;
	}		
			
	/*  */
	/* Locate new position of original selection */
	/*  */
	
	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
	
Error_Handler:
	function_Result = SAFE_FALSE;

Normal_Function_Exit:
	return(function_Result);

} /* Safe_Boolean Prepare_Menu_List_For_Dreams(MenuHandle	popup_Menu) */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: Dreaming_Popup_Dialogs.c */






