/* START OF FILE: Dreaming_Scene_Files.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Dreaming_Scene_Files.h - Header for Dreaming_Scene_Files.c
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Dreaming_Scene_Files.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Dreaming_Scene_Files

#define _H_Dreaming_Scene_Files
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Dreaming_Stuff.h"
#include "Command_Dialogs.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define	k_SCENE_VERSION_010000		0x00010000
#define	k_SCENE_VERSION_010100		0x00010100

#define	k_SCENE_VERSION_NOW					k_SCENE_VERSION_010100

/*  */
/* k_SCENE_BASE_VERSION_NOW must never be greater than */
/* k_SCENE_VERSION_NOW. */
/*  */
#define	k_SCENE_BASE_VERSION_NOW		k_SCENE_VERSION_010000

#define	k_SCENE_FILE_TYPE										'HFWs'

#define	k_SCENE_MAIN_RESOURCE_TYPE					'Scn1'

#define k_MINIMUM_SCENE_HEIGHT		63
#define k_MINIMUM_SCENE_WIDTH		63

#define	k_BASE_SCENE_RESOURCE_ID			128

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

 typedef struct {
	Safe_Boolean					valid;
	CARDINAL_32				version;
	CARDINAL_32				backward_Compatible_Version;
	CARDINAL_32				total_Colors_Used_In_Pallette;
	CARDINAL_32				total_Special_Colors_To_Honor;
	CARDINAL_16				stored_Bit_Depth;
	INTEGER_16					special_Pallette_ID;
	INTEGER_16					current_Clut_ID;
	Rect							scene_Size_Rect;
	Str255							screen_Name;
	Str63							screen_Short_Name;
	Str63							file_Name;
	CARDINAL_32				file_Item_Total;
	
	
	Safe_Boolean					backdrop_Selected;
	Str63							backdrop_Name;
 } Scene_File_Header_Rec, *Scene_File_Header_Ptr, **Scene_File_Header_Hdl;


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Dreaming_Scene_Files(void);

extern Safe_Boolean Destroy_Dreaming_Scene_Files(void);

extern Safe_Boolean	Create_New_Scene(Create_Scene_Rec	*params_For_Create_Scene);
								
extern Safe_Boolean	Load_Scene_File(Open_Scene_Rec	*params_For_Open_Scene);

extern Safe_Boolean Reset_Menu_Control_Selectability(void);

extern Safe_Boolean	Specify_Scene_To_Load(FSSpec		*file_Specification
											, Safe_Boolean *user_Abort);

extern Safe_Boolean	Save_Scene_Sequence(Save_Scene_Rec	*params_For_Save_Scene);

extern Safe_Boolean	Specify_Scene_To_Save(FSSpec		*file_Specification
												, Str63			*assumed_File_Name
												, Safe_Boolean *user_Abort);

extern  Safe_Boolean Load_Scene_File_Immediate_Style(Open_Scene_Rec	*params_For_Open_Scene);

extern  Safe_Boolean Determine_If_Scene_Loadable(Scene_Ptr current_Scene, Str255 *missing_Item);

extern  Safe_Boolean Advance_Scene(CARDINAL_32	direction);

extern  Safe_Boolean	Add_Background_Immediately_To_Scene(CARDINAL_32 current_Scene_Index, Str255 name_String);

extern  Safe_Boolean	Add_Item_Immediately_To_Scene(CARDINAL_32 scene_To_Use, Str255 name_String);

extern Safe_Boolean	Remove_Item_Immediately_From_Scene(CARDINAL_32 scene_To_Use, CARDINAL_32 item_To_Remove);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Dreaming_Scene_Files.h */
