/* [Graphics_Demos_Support.c] START OF FILE */
/* [---BEGIN---] FILE HEADER COMMENTS */

/**
 ** SCREEN VIEW = Adobe Syntax Black-10, Tabs=6 chars
 ** PRINTER VIEW = Adobe Syntax Black -10, Tabs=0.30 inch
 ** ========================================================================
 ** Written by Jim Merkle
 ** [Graphics_Demos_Support.c] - supporting routines
 ** (C) Copyright 1990 by Jim Merkle.
 ** ========================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 **  91.02.03			(James Merkle)
 **						Initial coding started 
 **
 **  91.02.22			(James Merkle)
 **						direct video access added 
 **
 **  91.09.26			(James Merkle)
 **						wrote Milli timers , main monitor detector, rectangle flasher, interrupt controller 
 **
 **  94.04.09			(James Merkle)
 **						Fixed problem where "Reposition_Along_Byte_Coordinates" was not handling
 **						windows on negative locations on screens negative to main system screen.
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **	Original purpose : Routines to support a series of computer graphics exercises.
 **
 **/

/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/

/* [---BEGIN---] FILE INCLUDE AREA */

#include "Core_Universal.h" /* Non_Specific_Support_Routines */
#include "Core_Specific.h" /*System_Dependent_Hooks.h */
#include "SysHooks.h" /*System_Dependent_Hooks.h */

#include "Graphics_Primitives.h"
#include "Interface_Utilities.h"

#include "Dreaming_Animation.h"
#include "Number_Utilities.h"

#include "Shell_Globals.h"
#include "Core_Globals.h"
#include "Three_D_Utilities.h"
#include "Vertical_Blanking_Interrupt.h"
#include "Off_Screen_Color.h"
#include "Graphics_Primitives_Support.h"

#include "Graphics_Demos_Support.h"



/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */

#define	MAX_TICKS_UNTIL_TIMEOUT	300
#define	MAX_LOOP	50

/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPES-------------------------- */

/*------------ LOCAL PROTOTYPES -------------------*/
/* extern void Support_Update_By_Getting_Pict(PicHandle	*current_PICT, WindowPtr *theWindow); */
/* extern void Support_Update_By_Putting_Pict(PicHandle	*current_PICT, WindowPtr *theWindow); */

/* extern Boolean Generate_Primary_Display(void); */
/* extern Boolean Generate_Test_Rect_Display(void); */
/* extern Boolean Generate_Test_Arc_Display(void); */
/* extern Boolean Generate_Test_Line_Display(void)*/
/* extern Boolean Generate_Demo_Clipped_Outline_Display(void); */

/* [----END----] PROTOTYPES-------------------------- */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */


/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* variables used in  Graphics_Demos_Support.c  */
static CARDINAL_8		*unit_Name = "\pGraphics_Demos_Support";
static INTEGER_16			os_Error;

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Generate_Primary_Display(void)
{
	INTEGER_32		Index;
	OSErr	err;
	Boolean			function_Result;
	INTEGER_16		current_Font,current_Font_Size;
	CARDINAL_16	current_Y_Pixel_Offset;
	GrafPtr				saved_Port;
/* END VAR */


	GetPort(&saved_Port);
	current_Font = DEFAULT_TEXT_FONT;
	TextFont(current_Font);
	current_Font_Size = DEFAULT_TEXT_SIZE;
	TextSize(current_Font_Size);
	
	current_Y_Pixel_Offset = 12;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	
	TextFace(bold);
	DrawString ((StringPtr)"\pPoor Man's Video Phone");
	TextFace(0);

	current_Y_Pixel_Offset = current_Y_Pixel_Offset + TEXT_LINE_SPACING;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	DrawString ((StringPtr)"\pThis is the self-contained prototype the Poor Man's Video Phone project.");
	
	current_Y_Pixel_Offset = current_Y_Pixel_Offset + TEXT_LINE_SPACING;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	DrawString ((StringPtr)"\pIts main purpose is to provide an environment for testing Poor Man's Video Phone.");

	function_Result = TRUE;

END_OF_FUNCTION:
	Set_View_Port(saved_Port);
	Reset_Graphics_Tables_For_Main_Screen_If_Needed();
	return(function_Result);
	
} /* Generate_Primary_Display */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
static Boolean Create_Random_Graphics_Test(CARDINAL_16	graphics_To_Show)
{
	CARDINAL_8		*code_Name;

	INTEGER_32		Index;
	OSErr	err;
	Boolean			function_Result;
	Rect				element_Rect, window_Rect;
	RGBColor			element_Color;
	Handle			temp_Handle;
	INTEGER_32		loop;
	CARDINAL_16	element_Width, element_Height;
	CARDINAL_16	adjusted_Window_Right,adjusted_Window_Bottom;
	PixPatHandle		current_Color_Pattern;
	Pattern			current_Pattern;
	INTEGER_16		start_Angle , arc_Angle;
	INTEGER_32		newLeft, newTop;
	INTEGER_16		window_Bottom, window_Right;
	INTEGER_32		random_Grab_One, random_Grab_Two;
	INTEGER_32		total_Units_Displayed;
	INTEGER_32		timeout_Limit;
	CARDINAL_32	random_31_Bits;
	Rect				temp_Rect;
	GrafPtr			previous_Port;
	GDHandle			saved_Device;
/* END VAR */


	code_Name = "\pCreate_Random_Graphics_Test";
	function_Result = TRUE;


	GetPort(&previous_Port);
	saved_Device = GetGDevice();
	SetPort(primitives_Current_Port);
	Set_View_Device(g_Primitives_Current_Device);

	window_Rect = primitives_Current_Port->portRect;
	window_Bottom = window_Rect.bottom;
	window_Right = window_Rect.right;

	SetRect(&temp_Rect, 150, 100, 400, 350); /* !!! debugging stuff only */

	SetRect(&element_Rect, 0, 0, 1, 1); /* Simple Initialize */
		
	timeout_Limit = TickCount() + MAX_TICKS_UNTIL_TIMEOUT;

	PenMode(patCopy);
	PenPat(&(qd.black));
	Move_Memory_Hook((char *)&(qd.black), (char *)&current_Pattern, sizeof((qd.black)));
	
	PenSize(1, 1);

/*=----------------------------------------------------------------------------- Removed bad technique
	temp_Handle = GetResource('ppat',130);
	
	HLock(temp_Handle);
	if (ResError() != noErr) {
		C_Display_Error_Message(unit_Name, code_Name, "\pProgram unable to load resource (ppat).  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}
	
	current_Color_Pattern = (PixPatHandle)temp_Handle;
	os_Error = HandToHand(&current_Color_Pattern);
	if ((os_Error != noErr) || (MemError() != noErr)) {
		C_Display_Error_Message(unit_Name, code_Name, "\pProgram unable to load resource (ppat).  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}
		
	HUnlock(temp_Handle);
	
	ReleaseResource(temp_Handle);
	if (ResError() != noErr) {
		C_Display_Error_Message(unit_Name, code_Name, "\pProgram unable to unload resource (ppat).  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}
	--------------------------------------------------------------------------- */	
	
	current_Color_Pattern = GetPixPat(130);	
	MoveHHi((Handle)current_Color_Pattern);
	HLock((Handle)current_Color_Pattern);	
		
	total_Units_Displayed = 0;	
	
/*=**************************************************************************=*/

	Auto_Initialize_Seeds();
	
	do { /*  while (((Button) || (timeout_Limit <= TickCount() )) == FALSE) */
	
		for ( loop = 0; loop <= MAX_LOOP ; loop++ ) {
	
			random_31_Bits = Fetch_Random_Number_RAW();
			random_Grab_One = (random_31_Bits & 0x0000FFFF);
			random_Grab_Two = (((CARDINAL_32)random_31_Bits & 0x7FFF8000) >> 15);
			
			/* avoid zero size elements */
			element_Width = (random_31_Bits & 0x007F) + 1; 
			element_Height = (random_Grab_Two & 0x007F) + 1;
			
			adjusted_Window_Right = (window_Right - element_Width);
			adjusted_Window_Bottom = (window_Bottom - element_Height);
			
			newTop = (random_Grab_One * adjusted_Window_Bottom) / 0x00010000;
			newLeft = (random_Grab_Two * adjusted_Window_Right) / 0x00010000;

			element_Rect.left = newLeft;
			element_Rect.right = newLeft + element_Width;
			element_Rect.top = newTop;
			element_Rect.bottom = newTop + element_Height;
				
			/* avoid white objects in demo for B&W sreens */
			if ( primitives_Current_Screen_Depth > 1) {
				/*  */
				/* This second call is wasteful, but needed for randomness */
				/*  */
				random_31_Bits = Fetch_Random_Number_RAW();
			
				element_Color.blue = (random_31_Bits & 0x0000FFFF);
				element_Color.red = (((CARDINAL_32)random_31_Bits & 0x7FFF8000) >> 15);
				element_Color.green = ((random_31_Bits & 0x00FFFF00) >> 8);
				Set_Current_Color_Primitive(&element_Color);
			}
	
			switch (graphics_To_Show) {
				case TEST_RECT_WINDOW_INDEX:
						Draw_Filled_Rectangle(&element_Rect,current_Color_Pattern); 
					break;
					
				case TEST_CIRCLE_INDEX:
						Draw_Circle(&element_Rect);
					break;
					
				case TEST_FILLED_CIRCLE_INDEX:
						/*  */
						/* this ensures that Apples routine does not draw ovals instead of */
						/* rectangles */
						/*  */
						if (element_Width > element_Height) {
							element_Rect.right = element_Rect.left + element_Height;
						}
						else if (element_Height > element_Width) {
							element_Rect.bottom = element_Rect.top + element_Width;
						}
						Draw_Filled_Circle(&element_Rect, current_Color_Pattern);
					break;
					
				case TEST_ELIPSE_WINDOW_INDEX:	
						Draw_Ellipse(&element_Rect);
					break;
					
				case TEST_FILLED_ELIPSE_WINDOW_INDEX:	
						Draw_Filled_Ellipse(&element_Rect, current_Color_Pattern);
					break;
					
/* ==============
								
				case TEST_ARC_INDEX:	
						start_Angle = random_Grab_One % 360;
						arc_Angle = random_Grab_Two % 360;
						Draw_Filled_Arc(&element_Rect,start_Angle,arc_Angle,current_Color_Pattern);
					break;
					
=============== */	

				case TEST_LINE_WINDOW_INDEX:
						Draw_Line_To(newLeft,newTop);
				
						/* Draw_Clipped_Line_To(newLeft,newTop, &temp_Rect ); */
					break;
					
				default:
					break;
			} /* switch (theMenu) */
	
			total_Units_Displayed += 1;
			
			
		} /* for ( loop = 0; loop <= MAX_LOOP ; loop++ )  */
	} while (((Button() ) || (timeout_Limit <= TickCount() )) == FALSE);

	function_Result = TRUE;

END_OF_FUNCTION:
	Set_View_Device(saved_Device);
	Set_View_Port(previous_Port);
	Reset_Graphics_Tables_For_Main_Screen_If_Needed();
	return(function_Result);
	
} /* Create_Random_Graphics_Test */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Generate_Test_Rect_Display(void)
{
	CARDINAL_8		*code_Name;
	Boolean			function_Result;
	INTEGER_16		current_Font,current_Font_Size;
	CARDINAL_16	current_Y_Pixel_Offset;
	GrafPtr				saved_Port;
/* END VAR */


	GetPort(&saved_Port);
	function_Result = TRUE;
	code_Name = "\pGenerate_Test_Rect_Display";

	if (Initialize_Graphics_Primitives(TRUE, FALSE) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pInitialize_Graphics_Primitives failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	HideCursor();

	current_Font = DEFAULT_TEXT_FONT;
	TextFont(current_Font);
	current_Font_Size = 24;
	TextFace(0);
	TextSize(current_Font_Size);
	current_Y_Pixel_Offset = 36;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	DrawString ((StringPtr)"\pRectangle Primitive Test");

	if (Create_Random_Graphics_Test(TEST_RECT_WINDOW_INDEX) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pCreate_Random_Graphics_Test failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}


	ShowCursor();

END_OF_FUNCTION:
	Set_View_Port(saved_Port);
	Reset_Graphics_Tables_For_Main_Screen_If_Needed();
	return(function_Result);
	
} /* Generate_Test_Rect_Display */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Generate_Test_Three_D_Display(void)
{
	CARDINAL_8		*code_Name;
	Boolean			function_Result;
	INTEGER_16		current_Font,current_Font_Size;
	CARDINAL_16	current_Y_Pixel_Offset;
	GrafPtr			previous_Port;
	GDHandle			saved_Device;
	GrafPtr			saved_Port;
/* END VAR */


	GetPort(&saved_Port);
	saved_Device = GetGDevice();
	function_Result = TRUE;
	code_Name = "\pGenerate_Test_Three_D_Display";

	if (Initialize_Graphics_Primitives(TRUE, FALSE) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pInitialize_Graphics_Primitives failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	SetPort(primitives_Current_Port);
	Set_View_Device(g_Primitives_Current_Device);

	HideCursor();

	current_Font = DEFAULT_TEXT_FONT;
	TextFont(current_Font);
	current_Font_Size = 24;
	TextFace(0);
	TextSize(current_Font_Size);
	current_Y_Pixel_Offset = 36;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	DrawString ((StringPtr)"\pThree-D Test");


	Demonstrate_Three_D();


	ShowCursor();

END_OF_FUNCTION:

	Set_View_Device(saved_Device);
	Set_View_Port(saved_Port);
	Reset_Graphics_Tables_For_Main_Screen_If_Needed();
	return(function_Result);
	
} /* Generate_Test_Three_D_Display */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Generate_Test_Circle_Display(void)
{
	CARDINAL_8		*code_Name;
	Boolean			function_Result;
	INTEGER_16		current_Font,current_Font_Size;
	CARDINAL_16	current_Y_Pixel_Offset;
	GrafPtr			saved_Port;
/* END VAR */


	GetPort(&saved_Port);
	function_Result = TRUE;
	code_Name = "\pGenerate_Test_Circle_Display";

	if (Initialize_Graphics_Primitives(TRUE, FALSE) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pInitialize_Graphics_Primitives failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	HideCursor();

	current_Font = DEFAULT_TEXT_FONT;
	TextFont(current_Font);
	current_Font_Size = 24;
	TextFace(0);
	TextSize(current_Font_Size);
	current_Y_Pixel_Offset = 36;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	DrawString ((StringPtr)"\pCircle Primitive Test");

	if (Create_Random_Graphics_Test(TEST_CIRCLE_INDEX) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pCreate_Random_Graphics_Test failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	
	ShowCursor();

END_OF_FUNCTION:
	Set_View_Port(saved_Port);
	Reset_Graphics_Tables_For_Main_Screen_If_Needed();
	return(function_Result);
	
} /* Generate_Test_Circle_Display */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Generate_Test_Filled_Circle_Display(void)
{
	CARDINAL_8		*code_Name;
	Boolean			function_Result;
	INTEGER_16		current_Font,current_Font_Size;
	CARDINAL_16	current_Y_Pixel_Offset;
	GrafPtr				saved_Port;
/* END VAR */


	GetPort(&saved_Port);
	function_Result = TRUE;
	code_Name = "\pGenerate_Test_Filled_Circle_Display";

	if (Initialize_Graphics_Primitives(TRUE, FALSE) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pInitialize_Graphics_Primitives failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	HideCursor();

	current_Font = DEFAULT_TEXT_FONT;
	TextFont(current_Font);
	current_Font_Size = 24;
	TextFace(0);
	TextSize(current_Font_Size);
	current_Y_Pixel_Offset = 36;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	DrawString ((StringPtr)"\pFilled Circle Primitive Test");

	if (Create_Random_Graphics_Test(TEST_FILLED_CIRCLE_INDEX) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pCreate_Random_Graphics_Test failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	
	ShowCursor();

END_OF_FUNCTION:
	Set_View_Port(saved_Port);
	Reset_Graphics_Tables_For_Main_Screen_If_Needed();
	return(function_Result);
	
} /* Generate_Test_Filled_Circle_Display */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Generate_Test_Elipses_Display(void)
{
	CARDINAL_8		*code_Name;
	Boolean			function_Result;
	INTEGER_16		current_Font,current_Font_Size;
	CARDINAL_16	current_Y_Pixel_Offset;
	GrafPtr				saved_Port;
/* END VAR */


	GetPort(&saved_Port);
	function_Result = TRUE;
	code_Name = "\pGenerate_Test_Elipses_Display";

	if (Initialize_Graphics_Primitives(TRUE, FALSE) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pInitialize_Graphics_Primitives failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	HideCursor();

	current_Font = DEFAULT_TEXT_FONT;
	TextFont(current_Font);
	current_Font_Size = 24;
	TextFace(0);
	TextSize(current_Font_Size);
	current_Y_Pixel_Offset = 36;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	DrawString ((StringPtr)"\pOval Primitive Test");

	if (Create_Random_Graphics_Test(TEST_ELIPSE_WINDOW_INDEX) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pCreate_Random_Graphics_Test failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	
	ShowCursor();

END_OF_FUNCTION:
	Set_View_Port(saved_Port);
	Reset_Graphics_Tables_For_Main_Screen_If_Needed();
	return(function_Result);
	
} /* Generate_Test_Elipses_Display */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Generate_Test_Filled_Elipses_Display(void)
{
	CARDINAL_8		*code_Name;
	Boolean			function_Result;
	INTEGER_16		current_Font,current_Font_Size;
	CARDINAL_16	current_Y_Pixel_Offset;
	GrafPtr				saved_Port;
/* END VAR */


	GetPort(&saved_Port);
	function_Result = TRUE;
	code_Name = "\pGenerate_Test_Filled_Elipses_Display";

	if (Initialize_Graphics_Primitives(TRUE, FALSE) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pInitialize_Graphics_Primitives failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	HideCursor();

	current_Font = DEFAULT_TEXT_FONT;
	TextFont(current_Font);
	current_Font_Size = 24;
	TextFace(0);
	TextSize(current_Font_Size);
	current_Y_Pixel_Offset = 36;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	DrawString ((StringPtr)"\pFilled Oval Test");

	if (Create_Random_Graphics_Test(TEST_FILLED_ELIPSE_WINDOW_INDEX) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pCreate_Random_Graphics_Test failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	
	ShowCursor();

END_OF_FUNCTION:
	Set_View_Port(saved_Port);
	Reset_Graphics_Tables_For_Main_Screen_If_Needed();
	return(function_Result);
	
} /* Generate_Test_Filled_Elipses_Display */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Generate_Test_Line_Display(void)
{
	CARDINAL_8		*code_Name;
	Boolean			function_Result;
	INTEGER_16		current_Font,current_Font_Size;
	CARDINAL_16	current_Y_Pixel_Offset;
	RGBColor			active_Color;
	INTEGER_32		degrees;
	GrafPtr				saved_Port;
/* END VAR */


	GetPort(&saved_Port);
	function_Result = TRUE;
	code_Name = "\pGenerate_Test_Line_Display";

	if (Initialize_Graphics_Primitives(TRUE, FALSE) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pInitialize_Graphics_Primitives failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}
	
	
	HideCursor();
/* ===
	ShieldCursor();
=== */
	
	current_Font = DEFAULT_TEXT_FONT;
	TextFont(current_Font);
	current_Font_Size = 24;
	TextFace(0);
	TextSize(current_Font_Size);
	current_Y_Pixel_Offset = 36;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	DrawString ((StringPtr)"\pLine Primitive Test");

	if (Create_Random_Graphics_Test(TEST_LINE_WINDOW_INDEX) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pCreate_Random_Graphics_Test failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}
	
	ShowCursor();


END_OF_FUNCTION:
	Set_View_Port(saved_Port);
	Reset_Graphics_Tables_For_Main_Screen_If_Needed();
	return(function_Result);
	
} /* Generate_Test_Line_Display */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Generate_Test_Line_Pattern_Speed_Display(void)
{
	CARDINAL_8		*code_Name;
	Boolean			function_Result;
	INTEGER_16		current_Font,current_Font_Size;
	CARDINAL_16	current_Y_Pixel_Offset;
	RGBColor			active_Color;
	INTEGER_32		degrees;
	CARDINAL_32	start_Time, end_Time;
	Str255				temp_String_1,temp_String_2;
	CARDINAL_16	loop;
	GrafPtr			previous_Port;
	GDHandle			saved_Device;
	GrafPtr			saved_Port;
/* END VAR */


	function_Result = TRUE;
	GetPort(&saved_Port);
	saved_Device = GetGDevice();
	code_Name = "\pGenerate_Test_Line_Pattern_Speed_Display";

	if (Initialize_Graphics_Primitives(TRUE, FALSE) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pInitialize_Graphics_Primitives failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	HideCursor();
	
	GetPort(&previous_Port);
	SetPort(primitives_Current_Port);
	Set_View_Device(g_Primitives_Current_Device);

	current_Font = DEFAULT_TEXT_FONT;
	TextFont(current_Font);
	current_Font_Size = 24;
	TextFace(0);
	TextSize(current_Font_Size);
	current_Y_Pixel_Offset = 36;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	DrawString ((StringPtr)"\pLine Speed Pattern Test");


	Set_Current_Color_Primitive(&g_Shell.library.color_Black);
/* =======
	for (loop = 0; (loop < 32) ; loop++) {
	
		Set_Current_Color_Primitive(&g_Shell.library.color_Black);

		MoveTo(62 + loop,62);
		Draw_Line_To(82 + loop,58);
		
		MoveTo(62 + loop,62);
		Draw_Line_To(82 + loop,66);
		
		MoveTo(62 + loop,62);
		Draw_Line_To(82 + loop,82);
		
		MoveTo(62 + loop,62);
		Draw_Line_To(66 + loop,42);
		
		MoveTo(62 + loop,62);
		Draw_Line_To(66 + loop,82);
				
		Set_Current_Color_Primitive(&g_Shell.library.color_White);

		MoveTo(62 + loop,62);
		Draw_Line_To(82 + loop,58);
		
		MoveTo(62 + loop,62);
		Draw_Line_To(82 + loop,66);
		
		MoveTo(62 + loop,62);
		Draw_Line_To(82 + loop,82);
		
		MoveTo(62 + loop,62);
		Draw_Line_To(66 + loop,42);
		
		MoveTo(62 + loop,62);
		Draw_Line_To(66 + loop,82);
				
	} 
========= */
	/* for (loop = 0; (loop < 32) ; loop++) */
	
		Set_Current_Color_Primitive(&g_Shell.library.color_Black);
		
		
		
/*===	
	MoveTo(180,80);
	Draw_Line_To(220,120);
=== */

	

	start_Time = (CARDINAL_32)TickCount();
	while ( start_Time == TickCount()) {
		; /* NULL */
	}
	
	start_Time += (CARDINAL_32)1;

	for (loop = 0; (loop < 13) ; loop++) {

		for ( degrees = 100; degrees <= 200; degrees += 1 ) {
			MoveTo(degrees,degrees);
			Draw_Line_To(100,200);
		}
		
		for ( degrees = 200; degrees <= 300; degrees += 1 ) {
			MoveTo(400 - degrees , degrees);
			Draw_Line_To(100,200);
		}
		
		for ( degrees = 300; degrees >= 200; degrees -= 1 ) {
			MoveTo(degrees - 200 , degrees);
			Draw_Line_To(100,200);
		}
		
		for ( degrees = 200; degrees >= 100; degrees -= 1 ) {
			MoveTo(200 - degrees  , degrees);
			Draw_Line_To(100,200);
		}
		
		if ((loop & 0x0001) == 1) {
			Set_Current_Color_Primitive(&g_Shell.library.color_Black);
		}
		else {
			Set_Current_Color_Primitive(&g_Shell.library.color_White);
		}

	}

/* for (loop = 0; (loop < 4) ; loop++) */
	
	

	end_Time = (TickCount() - start_Time);

	Set_View_Device(saved_Device);
	Set_View_Port(primitives_Current_Port);

	ShowCursor();
	Convert_Long_To_String_Hook(end_Time,(CARDINAL_8  *)temp_String_1 , NO_LIMITS);
	Copy_Pascal_String_Hook("\pThe total Time for test was ",temp_String_2);
	Concat_After_Pascal_String_Hook(temp_String_2, temp_String_1 );
	Concat_After_Pascal_String_Hook(temp_String_2, "\p ticks" );
	Perform_OK_Dialog_Hook(temp_String_2);

	
	ShowCursor();


END_OF_FUNCTION:
	Set_View_Device(saved_Device);
	Set_View_Port(saved_Port);
	Reset_Graphics_Tables_For_Main_Screen_If_Needed();
	return(function_Result);
	
} /* Generate_Test_Line_Pattern_Speed_Display */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Generate_Demo_Clipped_Outline_Display(void)
{
	CARDINAL_8		*code_Name;
	Boolean			function_Result;
	INTEGER_16		current_Font,current_Font_Size;
	INTEGER_16		top_Border, side_Border;
	INTEGER_16		current_X,current_Y; /* for simple animation */
	INTEGER_16		previous_X, previous_Y;
	INTEGER_32		current_Offset;
	CARDINAL_16	current_Y_Pixel_Offset;
	Rect				temp_Rect;
	PixPatHandle		current_Color_Pattern;
	Pattern			current_Pattern;
	Polygon_List		current_Polygon;
	Boolean			image_Exits_From_Previous_Loop;
	Rect				active_Port_Sample_Global_Rect;
	CARDINAL_8	 	video_Device_Slot_To_Synchronize_With;
	GrafPtr			previous_Port;
	GDHandle			saved_Device;
	Str255				temp_String_1,temp_String_2;
	INTEGER_32		start_Time, end_Time;
	INTEGER_32		loop;
	INTEGER_32		temp_Integer_32;
	GrafPtr				saved_Port;
/* END VAR */


	function_Result = TRUE;
	GetPort(&saved_Port);
	saved_Device = GetGDevice();
	code_Name = "\pGenerate_Demo_Clipped_Outline_Display";

	if (Initialize_Graphics_Primitives(TRUE, FALSE) != TRUE) {
		C_Display_Error_Message(unit_Name, code_Name, "\pInitialize_Graphics_Primitives failed.  Program will abort.", "\p");
		g_Shell.interface.abort_Program = TRUE;
		function_Result = FALSE;
		goto END_OF_FUNCTION;
	}

	HideCursor();

	GetPort(&previous_Port);
	SetPort(primitives_Current_Port);
	Set_View_Device(g_Primitives_Current_Device);

	current_Font = DEFAULT_TEXT_FONT;
	TextFont(current_Font);
	current_Font_Size = 24;
	TextFace(0);
	TextSize(current_Font_Size);
	current_Y_Pixel_Offset = 26;
	MoveTo(HORIZONTAL_OFFSET, current_Y_Pixel_Offset);
	DrawString ((StringPtr)"\pDemo of clipped Polygon outlines (10x)");

	PenMode(patCopy);
	PenPat(&(qd.black));
	Move_Memory_Hook((char *)&(qd.black), (char *)&current_Pattern, sizeof((qd.black)));
	Set_Current_Color_Primitive(&g_Shell.library.color_Black);
	PenSize(1, 1);

	current_Color_Pattern = GetPixPat(130);	
	MoveHHi((Handle)current_Color_Pattern);
	HLock((Handle)current_Color_Pattern);	


	side_Border = 40;
	top_Border = 34;
	

	SetRect(&temp_Rect, (primitives_Current_Port->portRect.left + side_Border)
	 		, (primitives_Current_Port->portRect.top + top_Border)
	 		, (primitives_Current_Port->portRect.right - side_Border)
			, (primitives_Current_Port->portRect.bottom - top_Border ) ); /* inset rect */


	MoveTo( temp_Rect.left -1 , temp_Rect.top -1);
	Draw_Line_To(temp_Rect.right + 1 , temp_Rect.top -1);
	Draw_Line_To(temp_Rect.right + 1 , temp_Rect.bottom +1);
	Draw_Line_To(temp_Rect.left -1 , temp_Rect.bottom +1);
	Draw_Line_To(temp_Rect.left -1 , temp_Rect.top -1);

	MoveTo( temp_Rect.left -4 , temp_Rect.top -4);
	Draw_Line_To(temp_Rect.right + 4 , temp_Rect.top -4);
	Draw_Line_To(temp_Rect.right + 4 , temp_Rect.bottom +4);
	Draw_Line_To(temp_Rect.left -4 , temp_Rect.bottom +4);
	Draw_Line_To(temp_Rect.left -4 , temp_Rect.top -4);


/* ======================================================================= */
/* 	start_Time = TickCount();  */

/* ====

	for ( loop = 0; loop < 20;  loop++ ) {	
		for ( current_X = 0; current_X < 310;  current_X = current_X + 1 ) {	
			SetRect(&temp_Rect, 3  + current_X
			 		, 35 + current_X
			 		, 128  +  current_X 
			 		, 55 + current_X );
			Draw_Filled_Rectangle(&temp_Rect, current_Color_Pattern);
		}
	}
======= */

/* ====

	for ( loop = 0; loop < 60;  loop++ ) {	
		for ( current_X = 0; current_X < 320;  current_X = current_X + 32 ) {	
			SetRect(&temp_Rect, 3  + current_X
			 		, 35 + current_X
			 		, 128  +  current_X 
			 		, 66 + current_X );
			Draw_Filled_Rectangle(&temp_Rect, current_Color_Pattern);
		}
	}
======================== */

/*========= tall skinny bars ============= */

/*===========
	for ( loop = 0; loop < 10;  loop++ ) {	
		for ( current_X = 0; current_X < 38;  current_X = current_X + 1 ) {	
			SetRect(&temp_Rect, 3  + (16 * current_X), 32 , 17  + (16 * current_X) , 350 );
			Draw_Filled_Rectangle(&temp_Rect, current_Color_Pattern);
		}
	}
=============*/

/* ====
	for ( loop = 0; loop < 1;  loop++ ) {	
		for ( current_X = 0; current_X < 5;  current_X = current_X + 1 ) {	
			SetRect(&temp_Rect, 3  + (120 * current_X), 32 , 36  + (120 * current_X) , 200 + (current_X *30) ); 
			Draw_Filled_Rectangle(&temp_Rect, current_Color_Pattern);
		}
	}
=============*/


/*============
		for ( current_X = 0; current_X < 17;  current_X = current_X + 1 ) {	
			SetRect(&temp_Rect, 0  + (32 * current_X), 260 , 1  + (32 * current_X)  , 350 );
			Draw_Filled_Rectangle(&temp_Rect, current_Color_Pattern);
		}
=============*/

/*====================

	for ( loop = 0; loop < 10;  loop++ ) {	
		for ( current_X = 0; current_X < 10;  current_X = current_X + 1 ) {	
			SetRect(&temp_Rect, 5 + current_X, 40  + (30 * current_X), 600 + current_X , 68 +(30 * current_X) );
			Draw_Filled_Rectangle(&temp_Rect, current_Color_Pattern);
		}
	}

======================= */


/* ======================================================================= */



	/*  */
	/*      construct a simple automobile shaped polygon for testing */
	/*  */
	
	current_Polygon.total_Polygons =1;
	current_Offset = 0;
	
	current_Polygon.polygon_Data[current_Offset++] = 16; /* number of vertices */
	current_Polygon.polygon_Data[current_Offset++] = 0; /* x offset from self */
	current_Polygon.polygon_Data[current_Offset++] = 0; /* y offset from self */
	
	current_Polygon.polygon_Data[current_Offset++] = 30; /* x offset vertex 1 from vertex 0*/
	current_Polygon.polygon_Data[current_Offset++] = 0; /* x offset vertex 1 from vertex 0*/

	current_Polygon.polygon_Data[current_Offset++] = 40; /* x offset vertex 2 from vertex 0*/
	current_Polygon.polygon_Data[current_Offset++] = 10; /* x offset vertex 2 from vertex 0*/

	current_Polygon.polygon_Data[current_Offset++] = 50; /* x offset vertex 3 from vertex 0*/
	current_Polygon.polygon_Data[current_Offset++] = 10; /* x offset vertex 3 from vertex 0*/

	current_Polygon.polygon_Data[current_Offset++] = 60;
	current_Polygon.polygon_Data[current_Offset++] = 20;

	current_Polygon.polygon_Data[current_Offset++] = 60;
	current_Polygon.polygon_Data[current_Offset++] = 30;

	current_Polygon.polygon_Data[current_Offset++] = 50;
	current_Polygon.polygon_Data[current_Offset++] = 30;

	current_Polygon.polygon_Data[current_Offset++] = 46;
	current_Polygon.polygon_Data[current_Offset++] = 40;

	current_Polygon.polygon_Data[current_Offset++] = 34;
	current_Polygon.polygon_Data[current_Offset++] = 40;

	current_Polygon.polygon_Data[current_Offset++] = 30;
	current_Polygon.polygon_Data[current_Offset++] = 30;

	current_Polygon.polygon_Data[current_Offset++] = 10;
	current_Polygon.polygon_Data[current_Offset++] = 30;

	current_Polygon.polygon_Data[current_Offset++] = 6;
	current_Polygon.polygon_Data[current_Offset++] = 40;

	current_Polygon.polygon_Data[current_Offset++] = -6;
	current_Polygon.polygon_Data[current_Offset++] = 40;

	current_Polygon.polygon_Data[current_Offset++] = -10;
	current_Polygon.polygon_Data[current_Offset++] = 30;

	current_Polygon.polygon_Data[current_Offset++] = -20;
	current_Polygon.polygon_Data[current_Offset++] = 30;

	current_Polygon.polygon_Data[current_Offset++] = -20;
	current_Polygon.polygon_Data[current_Offset++] = 10;

	current_Polygon.polygon_Data[current_Offset++] = 0;
	current_Polygon.polygon_Data[current_Offset++] = 10;

	current_Polygon.total_Offset_Size =current_Offset;

	current_X = temp_Rect.left - 20;  /* start pen point outside clipping rect */
	current_Y = temp_Rect.top + 20;
		
		
	/*  */
	/* Setup VBL Slot monitor for this port, actual rect unimportant in this case */
	/*  */
	active_Port_Sample_Global_Rect.top = 0;
	active_Port_Sample_Global_Rect.left = 0;
	active_Port_Sample_Global_Rect.right = 1;
	active_Port_Sample_Global_Rect.bottom = 1;
	if (Install_VBL_Synchronizer_For_Slot_If_Needed(active_Port_Sample_Global_Rect, &video_Device_Slot_To_Synchronize_With) != SAFE_TRUE) {
		goto END_OF_FUNCTION;
	}
		
	/*  */
	/*      move polygons and clip, simple animation          */
	/*  */
	
	start_Time = TickCount();


/*=======
		MoveTo( 220, 70);
		Draw_Clipped_Line_To(20,70,&temp_Rect);
=========== */

	image_Exits_From_Previous_Loop = FALSE;

	for ( ; current_X < temp_Rect.right + 6  ;  ) {
	
		if ( image_Exits_From_Previous_Loop == TRUE) {
			Set_Current_Color_Primitive(&g_Shell.library.color_White);
			MoveTo( previous_X, previous_Y);
			
			Wait_For_Next_Video_Monitor_VBL(video_Device_Slot_To_Synchronize_With);
			
			Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );
			MoveTo( previous_X + 130, previous_Y- 40);
			Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );
			MoveTo( previous_X + 160, previous_Y +20);
			Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );
			MoveTo( previous_X + 60, previous_Y+ 40);
			Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );
			
			MoveTo( previous_X -50, previous_Y - 40);
			Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );
			MoveTo( previous_X -130, previous_Y - 70);
			Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );

		
		}
		else {
			image_Exits_From_Previous_Loop = TRUE;
		}
		
		Set_Current_Color_Primitive(&g_Shell.library.color_Black);
		MoveTo( current_X, current_Y);
		
		Set_Current_Color_Primitive(&g_Shell.library.color_Black);
		Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );
		MoveTo( current_X + 130, current_Y- 40);
		Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );
		MoveTo( current_X + 160, current_Y +20);
		Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );
		MoveTo( current_X + 60, current_Y+ 40);
		Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );
		
		MoveTo( current_X -50, current_Y - 40);
		Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );
		MoveTo( current_X -130, current_Y - 70);
		Draw_Framed_Polygon(&current_Polygon, BOUNDED,  &temp_Rect );

		/*  */
		/*      This delay is discretionary, but is included for its beneficial effect */
		/*  */
		Wait_For_Next_Video_Monitor_VBL(video_Device_Slot_To_Synchronize_With);
		
		previous_X = current_X;
		previous_Y = current_Y;
		
		current_X = current_X + 2;
		current_Y = current_Y +1;
		
	} /* for ( ; current_X < temp_Rect.right + 6  ;  ) */
	
		

	end_Time = (TickCount() - start_Time);
	
	/*  */
	/* Remove VBL Slot monitor for this port, actual rect unimportant in this case */
	/*  */
	if (Remove_VBL_Synchronizer_For_Slot_If_Needed(active_Port_Sample_Global_Rect) != SAFE_TRUE) {
		goto END_OF_FUNCTION;
	}
	
	ShowCursor();
	Convert_Long_To_String_Hook(end_Time,(CARDINAL_8  *)temp_String_1 , NO_LIMITS);
	Copy_Pascal_String_Hook("\pThe total Time for test was ",temp_String_2);
	Concat_After_Pascal_String_Hook(temp_String_2, temp_String_1 );
	Concat_After_Pascal_String_Hook(temp_String_2, "\p ticks" );
	Perform_OK_Dialog_Hook(temp_String_2);



END_OF_FUNCTION:
	Set_View_Device(saved_Device);
	Set_View_Port(saved_Port);
	Reset_Graphics_Tables_For_Main_Screen_If_Needed();
	return(function_Result);
	
} /* Generate_Demo_Clipped_Outline_Display */
/*=**************************************************************************=*/

	
/*=**************************************************************************=*/
/* END OF FILE: Graphics_Demos_Support.c */
