/* START OF FILE: Network_Communication.c */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Network_Communication.c - Upkeep for lists of Scenes, Puppets, and Props. Both loaded or on Disk
 ** (C) Copyright 1994 James Merkle
 ** All rights reserved, except those wishing to "copy" moderate sections of code or files may do so, so long as
 ** such code is never used directly either in animation-related tools or multimedia tools that are  
 ** used in live performance or live broadcast or recorded mass market broadcast or film. Desktop usage not restricted.
 ** Conventional desktop game or entertainment not restricted.
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  1994.02.01		(James Merkle)
 **						Initial coding started
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **  
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include <AppleTalk.h>

#include "Error_Utilities.h"
#include "String_Utilities.h"

#include "Network_Communication.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

Safe_Boolean	Initialize_Network_Communication(void);
Safe_Boolean	Destroy_Network_Communication(void);
															
/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */


/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

static CARDINAL_8	*unit_Name;

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Initialize_Network_Communication(void)
{
	CARDINAL_8			*static_Unit_Name = "\pNetwork_Communication";
/* END VAR */

/*  */
/* Global persistant structures are created here */
/*  */

	unit_Name = static_Unit_Name;
	return(SAFE_TRUE);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Destroy_Network_Communication(void)
{
	Safe_Boolean		function_Result;
/* END VAR */

/*  */
/* Global persistant structures are deleted here */
/*  */

	function_Result = SAFE_TRUE;
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#if (7 == 11)

void SetUpSocketListener(void);
void SetUpSocketListener(void)
{
OSErr		os_Error;
INTEGER_16	loop;

	g_Socket_Listener_Ready = SAFE_FALSE;
	
	g_Free_Frame_Queue.QHead = nil;   /* initialize to nil to indicate empty queue */
	g_Free_Frame_Queue.QTail = nil;   /* initialize to nil to indicate end of queue */
	g_Busy_Frame_Queue.QHead = nil;   /* initialize to nil to indicate empty queue */
	g_Busy_Frame_Queue.QTail = nil;   /* initialize to nil to indicate end of queue */
	
	/* First, specifiy all buffers to be moved into "free" queue */
			 
	 for(loop = 0; (loop < k_MAXIMUM_PACKETS); loop++) {
	 	Enqueue(&(Buffers[loop]), &g_Free_Frame_Queue);
	 }

	os_Error = SL_InitSktListener(@g_Free_Frame_Queue, @g_Busy_Frame_Queue); 
				/* initialize the socket listener code */
				
	if (os_Error == noErr) {
		g_Socket_Listener_Ready = SAFE_TRUE;
	}
	else {
	
	}
}
#endif
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: Network_Communication.c */
