/* START OF FILE: Network_Zone_Conrol.c */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Network_Zone_Conrol.c - Faster version of very limited copy bits for source mode, same rect, no region, etc.
 ** (C) Copyright 1993 by James Merkle
 ** All rights reserved, except those wishing to "copy" moderate sections of code or files may do so, so long as
 ** such code is never used directly either in animation-related tools or multimedia tools that are  
 ** used in live performance or live broadcast or recorded mass market broadcast or film. Desktop usage not restricted.
 ** Conventional desktop game or entertainment not restricted.
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  1993.03.16		(James Merkle)
 **						Initial coding started
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Memory_Utilities.h"
#include "Core_Specific.h"
#include "Network_Zone_Control.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

															
/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */

Safe_Boolean Zone_Window_Active;
Safe_Boolean Zone_Scanning_Active;

/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

RGBColor g_Hilight_RGB_Color: 0xDA0;

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Initialize_Network_Zone_Management(void)
{
	Safe_Boolean		function_Result;
/* END VAR */


	function_Result = SAFE_TRUE;
	Zone_Window_Active = SAFE_FALSE;
	Zone_Scanning_Active = SAFE_FALSE;
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Start_Network_Zone_Management(WindowPtr current_Graphics_Window_Ptr)
{
	Safe_Boolean		function_Result;
/* END VAR */


	function_Result = SAFE_TRUE;
	Zone_Window_Active = SAFE_FALSE;
	Zone_Scanning_Active = SAFE_FALSE;
	
/* ====
	if (doInitializing(current_Graphics_Window_Ptr) != SAFE_TRUE) {
		function_Result = SAFE_FALSE;
	}
	else {
		Zone_Window_Active = SAFE_TRUE;
		Zone_Scanning_Active = SAFE_TRUE;
	}
	
	DoZoomWindow(g_Zone_Window_Ptr, inZoomOut);
	
=== */


	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Revise_Network_Zone_Management(void)
{

	if (Zone_Scanning_Active == SAFE_TRUE) {
	/* ===
		doIdle();
	==== */
	}

}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Shutdown_Network_Zone_Management(void)
{

	if ((Zone_Scanning_Active == SAFE_TRUE) || (Zone_Window_Active == SAFE_TRUE)){
/* ===	
		doCleanUpAndTerminate();
==== */		
	}
	
	Zone_Window_Active = SAFE_FALSE;
	Zone_Scanning_Active = SAFE_FALSE;

}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Update_Network_Zone_Window(void)
{
	Safe_Boolean	function_Result;
/* END VAR */


	function_Result = SAFE_TRUE;
		
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Test_Newtork_Code(void)
{
	RGBColor		saved_Color;
	RGBColor		hilight_Color;
	WindowPtr	current_Graphics_Window_Ptr;
	SignedByte	status_Globals_State;
/* END VAR */
	
	
	if (Initialize_Network_Zone_Management() == SAFE_TRUE) {
	
		Select_Graphics_Window(SHOW_NETWORK_ZONES_WINDOW_INDEX);
		/*  */
		/* Lock down for no real reason except paranoia? */
		/*  */
		if (Begin_Use_Of_Handle((Handle) active_Window_List[SHOW_NETWORK_ZONES_WINDOW_INDEX], MOVE_HIGH_REQUIRED, &status_Globals_State) != SAFE_TRUE) {
			goto Error_Handler;
		}
	
		current_Graphics_Window_Ptr	= (**active_Window_List[SHOW_NETWORK_ZONES_WINDOW_INDEX]).status_Window;
		
		if (Start_Network_Zone_Management(current_Graphics_Window_Ptr) == SAFE_TRUE) {

			Shutdown_Network_Zone_Management();
		}
		
		if (End_Use_Of_Handle((Handle) active_Window_List[SHOW_NETWORK_ZONES_WINDOW_INDEX], status_Globals_State) != SAFE_TRUE) {
			goto Error_Handler;
		}
	}
	
Error_Handler:

	; /* NULL */
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: Network_Zone_Conrol.c */
