/* START OF FILE: AVL_Tree_Manager.h */

/* [---BEGIN---] FILE HEADER COMMENTS */

/**
 ** SCREEN VIEW = Adobe Syntax Black-10, Tabs=6 chars
 ** PRINTER VIEW = Adobe Syntax Black -10, Tabs=0.30 inch
 ** ========================================================================
 ** [AVL_Tree_Manager.h] - support routines for the creating Syntax table for RapidoGraph
 ** ========================================================================
 ** 1990 by Jim Merkle.
 **
 **/

/* [----END----] FILE HEADER COMMENTS */


/*============================================================================= */
/*============================================================================= */
#ifndef _H_AVL_Tree_Manager

#define _H_AVL_Tree_Manager
/*============================================================================= */
/*============================================================================= */

#define	ALREADY_PRESENT	4




typedef struct node
	{
	char					*item_Key;
	struct node		*left_Node_Ptr;
	struct node		*right_Node_Ptr;
	int					balance;
	char					*item_Data;
	} AVL_node;

/*============================================================================= */
/* [---BEGIN---] FILE INCLUDE AREA */

#include "main.h"

/* [----END----] FILE INCLUDE AREA */
/*============================================================================= */


/*============================================================================= */
/* [---BEGIN---] PROTOTYPES-------------------------- */
															
/* Caution : str55 is used as first parameter, but second parameter is like variable_String_65537 */															
extern	CARDINAL_16 Insert_AVL_Node(AVL_node *parent, char *thekey, char *thedata);

/* Caution : str55 is used as first parameter, but second parameter is like variable_String_65537 */															
extern AVL_node *Create_AVL_Node(char *thekey, char *thedata);

extern	AVL_node *Find_Tree_Node(AVL_node *AVL_Tree, char *thekey);

extern	void Dispose_Of_The_Tree_Recursive(AVL_node *AVL_Tree);
										
											
/* [----END----] PROTOTYPES-------------------------- */
/*============================================================================= */


/*============================================================================= */
/*============================================================================= */
#endif
/*============================================================================= */
/*============================================================================= */


/* END OF FILE: AVL_Tree_Manager.h */
