/* [Vertical_Blanking_Interrupt.h] START OF FILE */

/* [---BEGIN---] FILE HEADER COMMENTS */

/**
 ** SCREEN VIEW = Adobe Syntax Black-10, Tabs=6
 ** PRINTER VIEW = Adobe Syntax Black -10, Tabs=0.30 inch
 ** ========================================================================
 ** Vertical_Blanking_Interrupt
 ** Written by Jim Merkle
 ** [Vertical_Blanking_Interrupt.h] - supporting routines animating (during VBL: copy bitmaps or 
 ** 			swap pages or erase previous sprite)
 ** (C) Copyright 1992 by Jim Merkle
 ** ========================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 **
 ** See Vertical_Blanking_Interrupt.c for revision history and version number.
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **
 **
 **
 **/

/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#ifndef _H_Vertical_Blanking_Interrupt

#define _H_Vertical_Blanking_Interrupt
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include <Retrace.h>
#include "Shell_Globals.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */
#pragma mark DEFINE_AREA


#define MAXIMUM_DEVICE_SLOTS	16

/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */
	
		/*=--------------------------------------------------------------------------=*/
		/* This structure is to aid us in slamming data into GDEF code. */
		/* The NS-Shell Gestalt function starts this way. */
		/*=--------------------------------------------------------------------------=*/
	typedef struct {
		CARDINAL_16	branch_To_GDEF_Routine;
		CARDINAL_16	branch_To_Install_Synchronizing;
		CARDINAL_32	start_VBL_Tasks_Address;		
		CARDINAL_32	remove_VBL_Tasks_Address;
		
		CARDINAL_32	current_VBL_Slot_Count;		
		CARDINAL_16	current_VBL_Slot_Number;		
		CARDINAL_16	current_VBL_Slot_Slot_Participants;		
		Safe_Boolean		current_VBL_Slot_Task_Initialized;
		VBLTask			current_VBL_Slot_VBL_Task;
	} *modify_GDEF_VBL_Synchronizing_Code_Ptr;


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */
#pragma mark PROTOTYPE_AREA

extern Safe_Boolean	Initialize_Structures_Allowing_VBL_Slot_Monitoring(void);

extern Safe_Boolean	Destroy_Structures_Allowing_VBL_Slot_Monitoring(void);

extern Safe_Boolean	Post_Gestalt_VBL_Slot_Synch_If_Needed( OSType Application_ID
									, CARDINAL_16	desired_VBL_Slot_Number	
									, Safe_Boolean 	*already_Present );

extern Safe_Boolean	Install_VBL_Synchronizer_For_Slot( CARDINAL_8	video_Device_Slot_To_Install_Synchronizer_On);

extern Safe_Boolean	Install_VBL_Synchronizer_For_Slot_If_Needed( Rect	active_Port_Sample_Global_Rect, CARDINAL_8	 *video_Device_Slot_To_Synchronize_With);

extern Safe_Boolean	Remove_VBL_Synchronizer_For_Slot_If_Needed( Rect	active_Port_Sample_Local_Rect);

extern void Wait_For_Next_Video_Monitor_VBL( CARDINAL_8	video_Device_Slot_To_Synchronizer_With );

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */

extern	Safe_Boolean										routine_Monitoring_VBL_Currently_Installed[MAXIMUM_DEVICE_SLOTS];
extern	modify_GDEF_VBL_Synchronizing_Code_Ptr	routine_Monitoring_VBL_Data_Address[MAXIMUM_DEVICE_SLOTS];
extern	CARDINAL_32									*routine_Monitoring_VBL_Current_Count[MAXIMUM_DEVICE_SLOTS];
extern	CARDINAL_32									routine_Monitoring_VBL_Total_Of_Dependant_Ports[MAXIMUM_DEVICE_SLOTS];

/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Vertical_Blanking_Interrupt.h */
