/* START OF FILE: Slide_Show_Routines.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Slide_Show_Routines.h - Header for Slide_Show_Routines.c
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Slide_Show_Routines.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Slide_Show_Routines

#define _H_Slide_Show_Routines
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Command_Executor.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define k_MAXIMUM_SLIDES			120
	
/* type_Of_Source */
#define k_FROM_ALGORITHM	0
#define k_FROM_RESOURCE	1
#define k_FROM_FILE			2


#define k_NO_WINDOW						0
#define k_NO_WINDOW_NAME			"\pNo Slide (Hidden)"

#define k_BLUESCREEN_WINDOW				1
#define k_BLUESCREEN_WINDOW_NAME		"\pBluescreen (for Chromakey)"

#define k_GREENSCREEN_WINDOW				2
#define k_GREENSCREEN_WINDOW_NAME		"\pGreenscreen (for Chromakey)"

#define k_BLACK_WINDOW					3
#define k_BLACK_WINDOW_NAME		"\pBlack Slide (Visible)"

	/*  */		
	/* k_MAXIMUM_CACHED_REMOTE_LIST_SIZE is used for sizing */
	/* g_Recent_Remote_Slides_Hdl. It holds list of available remote items */
	/*  */		
#define k_MAXIMUM_CACHED_REMOTE_LIST_SIZE		(32700L)
#define k_MAXIMUM_CACHED_DORAMNT_LIST_SIZE	(10240L)

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


typedef struct {
	Safe_Boolean		active;
	CARDINAL_16	type_Of_Source;
	
	CARDINAL_32	algorithm_Id;
	INTEGER_16		resource_Id;
	FSSpec			file_Info;
	Str31				slide_Name;
} Slide_Rec, *Slide_Ptr;

	
typedef struct {
	Slide_Rec		slides[k_MAXIMUM_SLIDES];
}Slides_Array, *Slides_Ptr, **Slides_Hdl;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Slide_Show_Routines(void);

extern Safe_Boolean Destroy_Slide_Show_Routines(void);

extern Safe_Boolean Command_Executor(void);

extern Safe_Boolean Redraw_General_Screen_Completely(Boolean from_Official_Update);

extern Safe_Boolean Select_Slide(CARDINAL_32	slide);

extern Safe_Boolean Advance_Slide(CARDINAL_32	direction);

extern Safe_Boolean Create_Text_List_Of_Slides(CARDINAL_8 *list_Data
											, CARDINAL_32 available_Bytes
											, CARDINAL_32 *utilized_Bytes);

extern Safe_Boolean Convert_Text_List_Of_Slides_To_Menu(Handle list_Data_Hdl
											, CARDINAL_32 utilized_Bytes
											, MenuHandle	popup_Menu
											, CARDINAL_32	*total_Listed_Items
											, CARDINAL_16 *popup_References);

extern Safe_Boolean Change_Window_Size_BASE(Change_Window_Size_Rec	*params_For_Change_Window_Size);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */



extern	Safe_Boolean			g_Recent_Remote_Slides_Valid;
extern	Handle				g_Recent_Remote_Slides_Hdl;
extern	Memory_Allocation	g_Recent_Remote_Slides_Memory_In_Use;
extern	CARDINAL_32		g_Recent_Remote_Slides_Length;
extern CARDINAL_32	g_Active_Pict_Index;
extern CARDINAL_32	g_Total_Picts_Available;

extern Slides_Ptr			g_Slides_Ptr;
extern	Slides_Hdl			g_Slides_Hdl;

extern	CARDINAL_32	g_Clear_Screen_Index;


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Slide_Show_Routines.h */
