/* START OF FILE: Spin_O_Rama.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Spin_O_Rama.h - Header for Spin_O_Rama.c
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Spin_O_Rama.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Spin_O_Rama

#define _H_Spin_O_Rama
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Command_Executor.h"
#include "Fast_Bit_Copy.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define k_FORCE_VBL_METERING			0

/*  */
/* Extra pixels used for window height alignment */
/* Normally 5 */
/*  */
#define k_SPIN_HEIGHT_READJUST	(5)

/*  */
/* Supposed to be same as a bset #5 (6th bit) */
/*  */
#define k_FORCE_NO_CACHE_BIT		0x20

#define k_TICK_DELAY_BETWEEN_SPIN_SOUND_CHECKS	1

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

	typedef struct {
		CARDINAL_32			last_Spinfile_Index;
		CARDINAL_32			avoidance_Image_Index;
		Safe_Boolean				valid_Information;
		CARDINAL_8				intensity;
		CARDINAL_8				horizontal_Angle;
		CARDINAL_8				vertical_Angle;
		CARDINAL_8				roll_Angle;
		Safe_Boolean				use_Fast_Copy;
		Fast_Copy_Bits_Rec		copy_Options_Rec;
	} Last_Image_Rec;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Spin_O_Rama(void);

extern Safe_Boolean Destroy_Spin_O_Rama(void);

extern Safe_Boolean	Redraw_Spinning_Window_Completely(Boolean actual_System_Update, Boolean partial_Update_Allowed);

extern Safe_Boolean	Select_Spin_Window_Display_First_Time(void);

extern Safe_Boolean Process_Periodic_Async_Spin_Tasks(void);

extern void Clear_Cached_Spin_Window_Placement_Structures(void);

extern Safe_Boolean	Recompress_Spin_Object_BASE(Recompress_Spin_Object_Rec	*params_For_Recompress_Spin_Object);

extern Safe_Boolean	Get_Current_Volume_For_Spinfile(CARDINAL_32	*the_256_Percentage);

extern Safe_Boolean Reset_Mouse_Settings_For_Spin_Window(void);

extern Safe_Boolean	Redraw_Spinning_Window_Title_Bar_If_Possible(Safe_Boolean restore_Titlebar);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

extern Point				g_Last_Spinning_Point_Position;
extern CARDINAL_32	g_Last_Spinning_Sound_Level;
extern CARDINAL_32	g_Time_Since_Last_Sound_Change;
extern CARDINAL_32	g_Time_Since_Last_Sound_Check;
extern Safe_Boolean		g_Interactive_Motion_Disabled;
extern Safe_Boolean		g_Spin_File_Importation_Active;
extern Safe_Boolean		g_Cursor_Probably_Still_Hidden;

extern Last_Image_Rec	g_Last_Image;
extern CARDINAL_32	g_Last_Movie_Frame_Paused;
extern Safe_Boolean		g_Loop_Movie_Forever;


/*  */
/* These are all related and are used for hiding menubar */
/*  */
extern Safe_Boolean 	g_Set_Spin_Window_Max_Monitor_Size;
extern Safe_Boolean 	g_Menu_Bar_Obscured;
extern INTEGER_16 		g_Menu_Bar_Previous_Height;
extern	RgnHandle		g_Menu_Bar_Previous_Region;		 	
extern RgnHandle		g_Corner_Regions;


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Spin_O_Rama.h */
