/* START OF FILE: Spin_O_Rama_Files.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Spin_O_Rama_Files.h - Header for Spin_O_Rama_Files.c
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Spin_O_Rama_Files.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Spin_O_Rama_Files

#define _H_Spin_O_Rama_Files
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Command_Dialogs.h"
#include "Dreaming_Stuff.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define	k_SPIN_OBJECT_VERSION_010000		0x00010000
#define	k_SPIN_OBJECT_VERSION_010100		0x00010100

/*  */
/* First version that saved data in data fork instead of resources */
/*  */
#define	k_SPIN_OBJECT_VERSION_020000		0x00020000
#define	k_SPIN_OBJECT_VERSION_020100		0x00020100

#define	k_SPIN_OBJECT_VERSION_NOW				k_SPIN_OBJECT_VERSION_020100

/*  */
/* k_SPIN_OBJECT_BASE_VERSION_NOW must never be greater than */
/* k_SPIN_OBJECT_VERSION_NOW. */
/*  */
#define	k_SPIN_OBJECT_BASE_VERSION_NOW		k_SPIN_OBJECT_VERSION_020000

#define	k_SPIN_OBJECT_FILE_TYPE							'HFWr'

#define	k_SPIN_OBJECT_MAIN_RESOURCE_TYPE			'Spin'

#define k_MINIMUM_SPIN_OBJECT_HEIGHT		63
#define k_MINIMUM_SPIN_OBJECT_WIDTH		63

#define	k_BASE_SPIN_OBJECT_RESOURCE_ID			128


#define k_NO_COMPRESSION						0
#define k_MERKLE_TIME_COMPRESSION			1

/*  */
/* "k_EVEN_ODD_ROW_COMPRESSION" is related to  */
/* k_EVEN_ROW_DOUBLE_DRAWING and */
/* k_ODD_ROW_SINGLE_DRAW */
/*  */
#define k_EVEN_ODD_ROW_COMPRESSION		2

#define k_BOGUS_INDEX_FRAME	(2999999UL)

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


 typedef struct {
	Safe_Boolean					valid;
	CARDINAL_32				version;
	CARDINAL_32				backward_Compatible_Version;
	CARDINAL_16				stored_Bit_Depth;
	Rect									spin_Object_Size_Rect;
	Str63								file_Name;
	
	Safe_Boolean					spin_Object_Special_Effect;
	CARDINAL_32				effect_Type;
 } Spin_Object_File_Header_Rec, *Spin_Object_File_Header_Ptr, **Spin_Object_File_Header_Hdl;

typedef struct {
	Safe_Boolean			sentinel_1;
	Safe_Boolean			sentinel_2;
	CARDINAL_32		row_Raw_Data_Size;
	CARDINAL_32		row_Raw_Data_Start_Offset;
	CARDINAL_32		skip_List_Data_Size;
	CARDINAL_32		skip_List_Data_Start_Offset;
	CARDINAL_32		skip_List_Master_List_Size;
	CARDINAL_32		skip_List_Master_List_Start_Offset;
	CARDINAL_32		scan_Line_Bounds_Size;
	CARDINAL_32		scan_Line_Bounds_Offset;
	CARDINAL_32		pad_Bytes_For_48_Part_1;
	CARDINAL_32		pad_Bytes_For_48_Part_2;
	CARDINAL_32		pad_Bytes_For_48_Part_3;
} compression_Data_Header_Rec, *compression_Data_Header_Ptr;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */
								
extern Safe_Boolean	Load_Spin_Object_File(Load_Spin_Object_Rec	*params_For_Load_Spin_Object);

extern Safe_Boolean	Specify_Spin_Object_To_Load(FSSpec		*file_Specification
											, Safe_Boolean *user_Abort);

extern Safe_Boolean	Save_Spin_Object_Sequence(Save_Spin_Object_Rec	*params_For_Save_Spin_Object);

extern Safe_Boolean	Specify_Spin_Object_To_Save(FSSpec		*file_Specification
												, Str63			*assumed_File_Name
												, Safe_Boolean *user_Abort);

extern Safe_Boolean	Load_Or_Import_Spin_Object_File(Load_Spin_Object_Rec	*params_For_Load_Spin_Object
													, Convert_Spin_Object_Rec	*params_For_Convert_Spin_Object
													, Boolean		importation_Desired);

extern  Safe_Boolean	Specify_Spin_Object_To_Save(FSSpec		*file_Specification
															, Str63				*assumed_File_Name
															, Safe_Boolean *user_Abort);

extern Safe_Boolean Load_Some_More_Spin_Object(void);

extern Safe_Boolean	Convert_Spin_Object_File_Immediate_Style(Convert_Spin_Object_Rec	*params_For_Convert_Spin_Object);

extern Safe_Boolean	Load_Spin_Object_File_Immediate_Style(Load_Spin_Object_Rec	*params_For_Load_Spin_Object);

extern Safe_Boolean	Load_Convert_Spin_Object_File_Immediate_Style(Load_Spin_Object_Rec	*params_For_Load_Spin_Object
													, Convert_Spin_Object_Rec	*params_For_Convert_Spin_Object
													, Boolean		importation_Desired);

extern Safe_Boolean	Specify_Spin_Object_Pict_To_Import(FSSpec		*file_Specification
															, Safe_Boolean	*file_Is_Pict_File_Type
															, INTEGER_16		*resource_Index
															, Safe_Boolean *user_Abort
															, CARDINAL_32	*selected_Pict_Width
															, CARDINAL_32	*selected_Pict_Height);

extern Safe_Boolean	Specify_Spin_Object_To_Export(FSSpec		*file_Specification
															, Str63				*assumed_File_Name
															, Safe_Boolean *user_Abort);

extern Safe_Boolean	Export_Spin_Object_Sequence(Export_Spin_Object_Rec	*params_For_Export_Spin_Object);

extern Safe_Boolean	Destroy_A_Spin_Object(CARDINAL_32 spin_Object_To_Destroy);

extern Safe_Boolean Destroy_Spin_Object_Files(void);

extern Safe_Boolean Initialize_Spin_Object_Files(void);

extern Safe_Boolean	Append_Spin_Object_To_File(FSSpec *desired_File
								, Off_Screen_Port_Rec *port_Ptr
								, Spin_Pict_Info_Handle	spin_Info
								, CARDINAL_8 intensity
								, CARDINAL_8 horizontal_Angle
								, CARDINAL_8 vertical_Angle
								, CARDINAL_8 roll_Angle
								, CARDINAL_16	compression_Type
								, Handle row_Raw_Data_Hdl
								, Handle skip_List_Data_Hdl
								, Handle skip_List_Master_List_Hdl
								, Handle scan_Line_Bounds_Hdl);

extern Safe_Boolean	Draw_Spin_Object_From_Closed_File(FSSpec *desired_File
								, Off_Screen_Port_Rec *port_Ptr
								, Off_Screen_Port_Rec *optional_Background_Port_Ptr
								, Spin_Pict_Info_Handle	spin_Info
								, Previously_Drawn_Frame_Ptr	frame_To_Erase_First
								, CARDINAL_8 intensity
								, CARDINAL_8 horizontal_Angle
								, CARDINAL_8 vertical_Angle
								, CARDINAL_8 roll_Angle
								, INTEGER_32		offset_Offscreen_Pixel_X
								, INTEGER_32		offset_Offscreen_Pixel_Y);

extern Safe_Boolean	Draw_Spin_Object_From_File(INTEGER_16		file_Reference
								, Off_Screen_Port_Rec *port_Ptr
								, Off_Screen_Port_Rec *optional_Background_Port_Ptr
								, Spin_Pict_Info_Handle	spin_Info
								, Previously_Drawn_Frame_Ptr	frame_To_Erase_First
								, CARDINAL_8 intensity
								, CARDINAL_8 horizontal_Angle
								, CARDINAL_8 vertical_Angle
								, CARDINAL_8 roll_Angle
								, Boolean	check_Validity
								, CARDINAL_32 *avoidance_Image_Index
								, INTEGER_32		offset_Offscreen_Pixel_X
								, INTEGER_32		offset_Offscreen_Pixel_Y);

extern void Get_Max_Ranges(Spin_Pict_Info_Handle	spin_Info
								, CARDINAL_32 *intensity
								, CARDINAL_32 *horizontal_Angle
								, CARDINAL_32 *vertical_Angle
								, CARDINAL_32 *roll_Angle);

extern Safe_Boolean	Reset_Any_Window_Size_If_Needed(CARDINAL_16 window_Index
													, Rect *source_Bit_Rect
													, Safe_Boolean *resize_Occured
													, Boolean from_Official_Update);

extern void Get_Periodicity_Ranges(Spin_Pict_Info_Handle	spin_Info
											, CARDINAL_16		highest_Horizontal
											, CARDINAL_16		highest_Vertical
											, CARDINAL_16		highest_Roll
											, CARDINAL_32 *horizontal_Angle_Periodicity
											, CARDINAL_32 *vertical_Angle_Periodicity
											, CARDINAL_32 *roll_Angle_Periodicity);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Spin_O_Rama_Files.h */
