/* [SysHooks.c] START OF FILE */

/* [---BEGIN---] FILE HEADER COMMENTS */

/**
 ** SCREEN VIEW = Adobe Syntax Black-10, Tabs=6
 ** PRINTER VIEW = Adobe Syntax Black -10, Tabs=0.30 inch
 ** ========================================================================
 ** SysHooks
 ** Written by Jim Merkle
 ** [SysHooks.c] - supporting routines for poratble code that avoids Mac toolbox and NS-Shell
 ** (C) Copyright 1991 by Jim Merkle
 ** All rights reserved, except those wishing to "copy" moderate sections of code or files may do so, so long as
 ** such code is never used directly either in animation-related tools or multimedia tools that are  
 ** used in live performance or live broadcast or recorded mass market broadcast or film. Desktop usage not restricted.
 ** Conventional desktop game or entertainment not restricted.
 ** ========================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 **
 **  1991.11.25		(James Merkle)
 **						Initial coding started, routines transferred from 'Non_Specific_Support_Routines.h' and modified
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **
 **
 **
 **/

/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/

/* [---BEGIN---] FILE INCLUDE AREA */

/*#include "Automatic_Dialogs.h" */
#include "Error_Utilities.h"
#include "Interface_Utilities.h"
#include "Memory_Utilities.h"
#include "OS_Utilities.h"

/* #include "Program_Globals.h" */

#include "Off_Screen_Color.h"

#include "Shell_Assembly.h"
#include "Shell_Dialogs.h"
#include "Shell_Globals.h"
#include "String_Utilities.h"

/* #include "Core_Specific.h" */ /* Specific_Support_Routines */

/* #include "GutsUniv.h"  */ /* Non_Specific_Support_Routines */

#include "SysHooks.h" /* Non_Specific_Support_Routines */


/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */


/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */



/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPES-------------------------- */
#pragma mark PROTOTYPE_AREA

/*------------ LOCAL PROTOTYPES -------------------*/


/* [----END----] PROTOTYPES-------------------------- */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */


/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

static CARDINAL_8				*unit_Name = "\pSysHooks";

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
CARDINAL_8 *Convert_Long_To_String_Hook(INTEGER_32 long_Value
								, ASCII_Character *long_String
								, CARDINAL_8 field_Size)
{

 	Convert_Long_To_String( long_Value,  long_String,  field_Size);

} /* void Concat_Long_To_String_Hook(Str255 pascal_String ...  */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Concat_After_Pascal_String_Hook(Str255 pascal_String
									, Str255 pascal_String_To_Concat)
{

	Concat_After_Pascal_String( pascal_String,  pascal_String_To_Concat);
	
} /* void Concat_After_Pascal_String_Hook(Str255 pascal_String... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Copy_Pascal_String_Hook(Str255 source_String
									, Str255 destination_String) 
{
	Copy_Pascal_String(source_String,  destination_String);
	
} /* void Copy_Like_Pascal_String(ASCII_Character *source_String... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Concat_Long_To_String_Hook(Str255 pascal_String
								, INTEGER_32 long_Value
								, INTEGER_16 field_Size)
{

 Concat_Long_To_String( pascal_String,  long_Value,  field_Size);

} /* void Concat_Long_To_String_Hook(Str255 pascal_String ...  */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Determine_Absolute_Free_Memory_Hook(INTEGER_32 	*total_Bytes_Contiguous_Now
													,INTEGER_32	*total_Bytes_Now
													,INTEGER_32 	*total_Bytes_Contiguous_Later
													,INTEGER_32	*total_Bytes_Later)
{

	return(Determine_Absolute_Free_Memory(total_Bytes_Contiguous_Now
				,total_Bytes_Now
				,total_Bytes_Contiguous_Later
				,total_Bytes_Later));


} /* Determine_Absolute_Free_Memory_Hook */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Determine_Bit_Depth_Of_Device_Containing_Rect_Hook_NEW(Rect *global_Rect
													, CARDINAL_16  *total_Intersected_Screens
													, INTEGER_32	 *bits_Per_Pixel
													, Safe_Boolean	*rect_Is_Within_A_Screen)
{

/* =====
WAS ....  void Determine_Bit_Depth_Of_Device_Containing_Rect_Hook(Rect *local_Rect
													, INTEGER_32	 *bits_Per_Pixel
													, CARDINAL_16  *total_Intersected_Screens
													, Safe_Boolean	*rect_Is_Within_A_Screen);

==== */

	Determine_Bit_Depth_Of_Device_Containing_Rect(global_Rect
																	, total_Intersected_Screens
																	, bits_Per_Pixel
																	, rect_Is_Within_A_Screen);

}													
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Move_Memory_Hook(Ptr data_Source, Ptr data_Destination, INTEGER_32 bytes_To_Copy)
{
	INTEGER_16	function_Result;
	
/* END VAR */
	if ( Move_Memory( data_Source,  data_Destination,  bytes_To_Copy) != TRUE) {
		function_Result = FALSE;
	}
	else {
		function_Result = TRUE;
	}
	
	return(function_Result);

} /* Move_Memory */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Setup_Error_Handling_Hook(void)
{
	Setup_Error_Handling();
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Display_Error_Message_Hook(CARDINAL_8 *unit_Name
								, CARDINAL_8 *code_Name)
{
	Display_Error_Message(unit_Name, code_Name);
	
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Assign_String_Hook(Str255 string_To_Assign
					, ASCII_Character *pascal_String)
{
	Assign_String(string_To_Assign, pascal_String);
	
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Create_System_Handle_Hook(CARDINAL_32 *memory_Requested
								, CARDINAL_32 memory_To_Preserve
								, Safe_Boolean purge_Allowed
								, Safe_Boolean partial_Allowed
								, Handle *data_Handle
								, Memory_Allocation *allocated)
{

	return(Create_System_Handle(memory_Requested
								,  memory_To_Preserve
								,  purge_Allowed
								,  partial_Allowed
								, data_Handle
								, allocated));
								
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Create_Handle_Hook(CARDINAL_32 *memory_Requested
								, CARDINAL_32 memory_To_Preserve
								, Safe_Boolean purge_Allowed
								, Safe_Boolean partial_Allowed
								, Handle *data_Handle
								, Memory_Allocation *allocated)
{

	return(Create_Handle(memory_Requested
								,  memory_To_Preserve
								,  purge_Allowed
								,  partial_Allowed
								, data_Handle
								, allocated));
								
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Destroy_Handle_Hook(Handle *data_Handle
									, Memory_Allocation *allocated)
{

	return( Destroy_Handle(data_Handle, allocated));	

}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Begin_Use_Of_Handle_Hook(Handle handle_To_Prepare
									, Safe_Boolean move_High_Vital
									, SignedByte *original_State)
{

	return(  Begin_Use_Of_Handle( handle_To_Prepare
									,  move_High_Vital
									, original_State));	
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean End_Use_Of_Handle_Hook(Handle handle_To_Prepare
									, SignedByte original_State)
{

	return(  End_Use_Of_Handle( handle_To_Prepare,  original_State));	
	
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/

/* WAS ====
void Determine_Information_Of_Device_Containing_Rect_Hook(Rect *local_Rect
													, INTEGER_32	 *bits_Per_Pixel
													, CARDINAL_16  *total_Intersected_Screens
													, Safe_Boolean	*rect_Is_Within_A_Screen
													, Safe_Boolean	*slot_Information_Valid													
													, INTEGER_16		*video_Monitor_Driver_Ref
													, INTEGER_8		*video_Monitor_Slot
													, INTEGER_8		*video_Monitor_ID
													, CARDINAL_32	*video_Optional_Base_Address)
=== */
void Determine_Information_Of_Device_Containing_Rect_Hook_NEW(Rect *global_Rect_Passed
													, INTEGER_16		*video_Monitor_Driver_Ref
													, INTEGER_8		*video_Monitor_Slot
													, INTEGER_8		*video_Monitor_ID
													, CARDINAL_32	*video_Optional_Base_Address
													, INTEGER_32		 *bits_Per_Pixel
													, INTEGER_32		 *bits_Per_Pixel_Greatest
													, CARDINAL_16  *total_Intersected_Screens
													, Safe_Boolean	*rect_Is_Within_A_Screen
													, PixMapHandle	*video_Pix_Map_Handle
													, GDHandle		*graphics_Device
													, Safe_Boolean	*slot_Information_Valid)

{
/* END VAR */


	Determine_Information_Of_Device_Containing_Rect(global_Rect_Passed
													, video_Monitor_Driver_Ref
													, video_Monitor_Slot
													, video_Monitor_ID
													, video_Optional_Base_Address
													, bits_Per_Pixel
													, bits_Per_Pixel_Greatest
													, total_Intersected_Screens
													, rect_Is_Within_A_Screen
													, video_Pix_Map_Handle
													, graphics_Device
													, slot_Information_Valid);
													
													
} /* void Determine_Information_Of_Device_Containing_Rect_Hook(Rect *local_Rect ... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Gestalt_Available_Hook(void)
{
	return(Gestalt_Available());
	
} /* Boolean Gestalt_Available_Hook() */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
pascal OSErr Perform_Gestalt_Hook(OSType selector
						, INTEGER_32 *response)
{
	return(Gestalt( selector, response));
	
} /* Boolean Gestalt_Available_Hook() */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: SysHooks.c */
