/* [SysHooks.h] START OF FILE */

/* [---BEGIN---] FILE HEADER COMMENTS */

/**
 ** SCREEN VIEW = Adobe Syntax Black-10, Tabs=6
 ** PRINTER VIEW = Adobe Syntax Black -10, Tabs=0.30 inch
 ** ========================================================================
 ** SysHooks (Non_Specific_Support_Routines)
 ** Written by Jim Merkle
 ** [SysHooks.c] - supporting routines for poratble code that avoids Mac toolbox and NS-Shell
 ** (C) Copyright 1991 by Jim Merkle
 ** ========================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 **
 ** See SysHooks.c for revision history and version number.
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **
 **
 **
 **/

/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#ifndef _H_SysHooks

#define _H_SysHooks
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include "Shell_Globals.h"

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */
#pragma mark DEFINE_AREA

/* NO_LIMIT is defined in actual file String_Utilities as '0' */
#define NO_LIMITS	0


/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */
	


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */
#pragma mark PROTOTYPE_AREA


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */


extern void Copy_Pascal_String_Hook(Str255 source_String
									, Str255 destination_String);
									
extern void Concat_After_Pascal_String_Hook(Str255 pascal_String
									, Str255 pascal_String_To_Concat);
									
extern Boolean Move_Memory_Hook(Ptr data_Source, Ptr data_Destination, INTEGER_32 bytes_To_Copy);

extern void Concat_Long_To_String_Hook(Str255 pascal_String
								, INTEGER_32 long_Value
								, INTEGER_16 field_Size);
								
								
extern CARDINAL_8 *Convert_Long_To_String_Hook(INTEGER_32 long_Value
								, CARDINAL_8 *long_String
								, CARDINAL_8 field_Size);

extern Boolean Determine_Absolute_Free_Memory_Hook(INTEGER_32 	*total_Bytes_Contiguous_Now
													,INTEGER_32	*total_Bytes_Now
													,INTEGER_32 	*total_Bytes_Contiguous_Later
													,INTEGER_32	*total_Bytes_Later);
													
													
extern void Determine_Bit_Depth_Of_Device_Containing_Rect_Hook_NEW(Rect *global_Rect
													, CARDINAL_16  *total_Intersected_Screens
													, INTEGER_32	 *bits_Per_Pixel
													, Safe_Boolean	*rect_Is_Within_A_Screen);

extern void Setup_Error_Handling_Hook(void);

extern void Display_Error_Message_Hook(CARDINAL_8 *unit_Name
								, CARDINAL_8 *code_Name);

extern void Assign_String_Hook(Str255 string_To_Assign
					, CARDINAL_8 *pascal_String);

extern Safe_Boolean Create_System_Handle_Hook(CARDINAL_32 *memory_Requested
								, CARDINAL_32 memory_To_Preserve
								, Safe_Boolean purge_Allowed
								, Safe_Boolean partial_Allowed
								, Handle *data_Handle
								, Memory_Allocation *allocated);

extern Safe_Boolean Create_Handle_Hook(CARDINAL_32 *memory_Requested
								, CARDINAL_32 memory_To_Preserve
								, Safe_Boolean purge_Allowed
								, Safe_Boolean partial_Allowed
								, Handle *data_Handle
								, Memory_Allocation *allocated);

extern Safe_Boolean Destroy_Handle_Hook(Handle *data_Handle
									, Memory_Allocation *allocated);

extern Safe_Boolean Begin_Use_Of_Handle_Hook(Handle handle_To_Prepare
									, Safe_Boolean move_High_Vital
									, SignedByte *original_State);

extern Safe_Boolean End_Use_Of_Handle_Hook(Handle handle_To_Prepare
									, SignedByte original_State);

void Determine_Information_Of_Device_Containing_Rect_Hook_NEW(Rect *global_Rect_Passed
													, INTEGER_16		*video_Monitor_Driver_Ref
													, INTEGER_8		*video_Monitor_Slot
													, INTEGER_8		*video_Monitor_ID
													, CARDINAL_32	*video_Optional_Base_Address
													, INTEGER_32		 *bits_Per_Pixel
													, INTEGER_32		 *bits_Per_Pixel_Greatest
													, CARDINAL_16  *total_Intersected_Screens
													, Safe_Boolean	*rect_Is_Within_A_Screen
													, PixMapHandle	*video_Pix_Map_Handle
													, GDHandle		*graphics_Device
													, Safe_Boolean	*slot_Information_Valid);

extern Boolean Gestalt_Available_Hook(void);

extern pascal OSErr Perform_Gestalt_Hook(OSType selector
						, INTEGER_32 *response);

/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: SysHooks.h */
