/* START OF FILE: Video_Backdrop_Background.c */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 6]
 ** =======================================================================
 ** Written by James Merkle
 ** Video_Backdrop_Background.c - 
 ** (C) Copyright 1993 by James Merkle
 ** All rights reserved, except those wishing to "copy" moderate sections of code or files may do so, so long as
 ** such code is never used directly either in animation-related tools or multimedia tools that are  
 ** used in live performance or live broadcast or recorded mass market broadcast or film. Desktop usage not restricted.
 ** Conventional desktop game or entertainment not restricted.
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  1995.02.12		(James Merkle)
 **						Initial coding started
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include <QDOffscreen.h>

#include <QuickTimeComponents.h>

#include "OS_Utilities.H"
#include "Shell_Dialogs.H"
#include "Dreaming_Stuff.H"
#include "String_Utilities.H"
#include "Window_Environment.h"

/* ====
#include <Movies.h>
#include <ImageCompression.h>


#include "Core_Universal.h"
#include "Core_Specific.h"
#include "SysHooks.h"
#include "Shell_Globals.h"
#include "Interface_Utilities.h"
#include "Cursor_Utilities.h"
#include "Interface_Utilities.h"
#include "Error_Utilities.h"

==== */

#include "Core_Globals.h"
#include "Memory_Utilities.h"
#include "Spin_O_Rama.h"

#include "Off_Screen_Color.h"
#include "Graphics_Primitives.h"

#include "Video_Backdrop_Background.h"


/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

/*  */
/* We only use the first digitizer anyways */
/*  */
#define k_MAX_DIGITIZERS_TO_EXAMINE	8

/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */



typedef struct {
	
	Boolean					video_In_Signal_Lock;
	
	Boolean					video_Out_Does_1_Bits;
	Boolean					video_Out_Does_2_Bits;
	Boolean					video_Out_Does_4_Bits;
	Boolean					video_Out_Does_8_Bits;
	Boolean					video_Out_Does_16_Bits;
	Boolean					video_Out_Does_32_Bits;
	Boolean					video_Out_Does_Dither;
	Boolean					video_Out_Does_Stretch;
	Boolean					video_Out_Does_Shrink;
	Boolean					video_Out_Does_Mask;
	Boolean					video_Out_Does_Double;
	Boolean					video_Out_Does_Quad;
	Boolean					video_Out_Does_Quarter;
	Boolean					video_Out_Does_Sixteenth;
	Boolean					video_Out_Does_Rotate;
	Boolean					video_Out_Does_HorizFlip;
	Boolean					video_Out_Does_VertFlip;
	Boolean					video_Out_Does_Skew;
	Boolean					video_Out_Does_Blend;
	Boolean					video_Out_Does_Warp;
	Boolean					video_Out_Does_DMA;
	Boolean					video_Out_Does_HW_Play_Through;
	Boolean					video_Out_Does_Inverse_Color_Tables;
	Boolean					video_Out_Does_KeyColor;
	Boolean					video_Out_Does_Async_Grabs;
	Boolean					video_Out_Does_Unreadable_Screen_Bits;
	Boolean					video_Out_Does_Compress;
	Boolean					video_Out_Does_Compress_Only;
	Boolean					video_Out_Does_Playthrough_During_Compress;
	
	Boolean					video_Out_1_Bits_Active;
	Boolean					video_Out_2_Bits_Active;
	Boolean					video_Out_4_Bits_Active;
	Boolean					video_Out_8_Bits_Active;
	Boolean					video_Out_16_Bits_Active;
	Boolean					video_Out_32_Bits_Active;
	Boolean					video_Out_Dither_Active;
	Boolean					video_Out_Stretch_Active;
	Boolean					video_Out_Shrink_Active;
	Boolean					video_Out_Mask_Active;
	Boolean					video_Out_Double_Active;
	Boolean					video_Out_Quad_Active;
	Boolean					video_Out_Quarter_Active;
	Boolean					video_Out_Sixteenth_Active;
	Boolean					video_Out_Rotate_Active;
	Boolean					video_Out_HorizFlip_Active;
	Boolean					video_Out_VertFlip_Active;
	Boolean					video_Out_Skew_Active;
	Boolean					video_Out_Blend_Active;
	Boolean					video_Out_Warp_Active;
	Boolean					video_Out_DMA_Active;
	Boolean					video_Out_HW_Play_Through_Active;
	Boolean					video_Out_Inverse_Color_Tables_Active;
	Boolean					video_Out_KeyColor_Active;
	Boolean					video_Out_Async_Grabs_Active;
	Boolean					video_Out_Unreadable_Screen_Bits_Active;
	Boolean					video_Out_Compress_Active;
	Boolean					video_Out_Compress_Only_Active;
	Boolean					video_Out_Playthrough_During_Compress_Active;

	Boolean					video_In_Does_NTSC;
	Boolean					video_In_Does_PAL;
	Boolean					video_In_Does_SECAM;
	Boolean					video_In_Does_GenLock;
	Boolean					video_In_Does_Composite;
	Boolean					video_In_Does_SVideo;
	Boolean					video_In_Does_Component;
	Boolean					video_In_Does_VTR_Broadcast_Deviance;
	Boolean					video_In_Does_Color;
	Boolean					video_In_Does_BW;
	
	Boolean					video_In_NTSC_Active;
	Boolean					video_In_PAL_Active;
	Boolean					video_In_SECAM_Active;
	Boolean					video_In_GenLock_Active;
	Boolean					video_In_Composite_Active;
	Boolean					video_In_SVideo_Active;
	Boolean					video_In_Component_Active;
	Boolean					video_In_VTR_Broadcast_Deviance_Active;
	Boolean					video_In_Color_Active;
	Boolean					video_In_BW_Active;
	
}Mega_Video_Options_Rec, *Mega_Video_Options_Ptr;


typedef struct {
	Safe_Boolean						component_Is_Ready_For_Openning;
	Safe_Boolean						component_Initialized_And_Active;
	Component						specific_Component;
	ComponentDescription			specific_Component_Description;
	ComponentInstance				component_Instance;
	Handle							component_Name_Handle;
	CARDINAL_32					component_Type;
	CARDINAL_32					component_Sub_Type;
} Component_Stored_List;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

Boolean Extract_All_Video_Options(Mega_Video_Options_Ptr options, DigitizerInfo *digitizer_Info);

Boolean Clear_Video_Options(Mega_Video_Options_Ptr options);

Safe_Boolean Build_List_Of_Suitable_Components(void);

Safe_Boolean	Close_Open_Components(void);

Safe_Boolean	Open_Digitizer_In_Components(INTEGER_16 component_Index_To_Use
													, INTEGER_16 desired_Input_Port_Type
													, INTEGER_16 desired_Input_Port_Offset
													, Rect			*digitizing_Rect
													, ComponentInstance	*instance_Copy);

Safe_Boolean Reset_Video_Using_New_Rect_Position(ComponentInstance video_Component_Instance
															, WindowPtr	current_Graphics_Window_Ptr
															, CARDINAL_32 			color_Table_Index
															, PixMapHandle			destination_Bitmap_Handle);

Safe_Boolean Clip_Reset_Digitizing_Rect(ComponentInstance video_Component_Instance
												, Rect	*digitizing_Rect);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */

CARDINAL_32	g_Chroma_Index_Optimized_Long;
Safe_Boolean		g_Forced_Digitizer_Window_Update_Required;

/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

static CARDINAL_8	*unit_Name = "\pVideo_Backdrop_Background";

Component_Stored_List		g_Component_List[k_MAX_DIGITIZERS_TO_EXAMINE];
CARDINAL_32				g_Component_Total;
CARDINAL_32				g_Component_Index_To_Use;
Safe_Boolean					g_Digitizer_In_Use;

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Initialize_Video_Backdrop_Background(void)
{
	CARDINAL_8			*static_Unit_Name = "\pVideo_Backdrop_Background";
	Safe_Boolean			function_Result;
/* END VAR */

/*  */
/* Global persistant structures are created here */
/*  */
	g_Component_Total = 0;
	g_Digitizer_In_Use = SAFE_FALSE;
	g_Forced_Digitizer_Window_Update_Required = SAFE_FALSE;
	function_Result = SAFE_TRUE;

	unit_Name = static_Unit_Name;
	
	g_Chroma_Index_Optimized_Long = k_PREFERRED_CHROMA_RESERVED_CHANNEL;
	g_Chroma_Index_Optimized_Long = g_Chroma_Index_Optimized_Long << 8;
	g_Chroma_Index_Optimized_Long |= k_PREFERRED_CHROMA_RESERVED_CHANNEL;
	g_Chroma_Index_Optimized_Long = g_Chroma_Index_Optimized_Long << 8;
	g_Chroma_Index_Optimized_Long |= k_PREFERRED_CHROMA_RESERVED_CHANNEL;
	g_Chroma_Index_Optimized_Long = g_Chroma_Index_Optimized_Long << 8;
	g_Chroma_Index_Optimized_Long |= k_PREFERRED_CHROMA_RESERVED_CHANNEL;


	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean	Start_Video_Display_Setup(Setup_Chromakey_Video_Rec	*params_For_Setup_Chromakey_Video)
{
	Rect 						active_Source_Rect;
	INTEGER_32				window_Index;
	GrafPtr					saved_Port;
	ComponentInstance		video_Component_Instance;
	WindowPtr				current_Graphics_Window_Ptr;
	Safe_Boolean				function_Result;
	VideoDigitizerError		video_Result;
/* END VAR */

	
	function_Result = SAFE_FALSE;
	GetPort(&saved_Port);

	
	if (g_Digitizer_In_Use == SAFE_TRUE) {
		/*  */
		/* Already in use, kill it? Restart?, Nah, just skip over this section */
		/*  */
		function_Result = SAFE_TRUE;
		goto Normal_Function_Exit;
	}
	
	if (g_Preferred_Monitor_Values_Valid != SAFE_TRUE) {
		goto Error_Handler;
	}
		
	window_Index = params_For_Setup_Chromakey_Video->window_Index;
	
	if ((active_Window_List[window_Index] == nil)
		|| ((**active_Window_List[window_Index]).structure_Initialized != SAFE_TRUE)) {
		goto Error_Handler;
	}
	
	current_Graphics_Window_Ptr	= (**active_Window_List[window_Index]).status_Window;
	
	/*  */
	/* Paranoia setting momentarily during setup */
	/*  */
	SetPort((GrafPtr)current_Graphics_Window_Ptr);

	/*  */
	/* Make certain port is set up first! Set the port before calling */
	/*  */
	
	if (Build_List_Of_Suitable_Components() != SAFE_TRUE) {
		function_Result = SAFE_FALSE;
	}

	if (g_Component_Total > 0) {
		if (Open_Digitizer_In_Components(g_Component_Index_To_Use
												, k_NTSC_COMPOSITE_OR_ARBITRARY_IN_PORT
												, 0
												, &active_Source_Rect
												, &video_Component_Instance) != SAFE_TRUE) {
			goto Error_Handler;
		}
	}
	
	video_Result = VDSetPlayThruOnOff(video_Component_Instance
										, FALSE);
	if ((INTEGER_32)video_Result != 0) {
		goto Error_Handler;
	}
	
	if (g_Preferred_Monitor_Values_Valid != SAFE_TRUE) {
		goto Error_Handler;
	}
	
	if (Reset_Video_Using_New_Rect_Position(video_Component_Instance
													, current_Graphics_Window_Ptr
													, params_For_Setup_Chromakey_Video->chroma_1
													, g_Preferred_Monitor_Video_Pix_Map_Handle) != SAFE_TRUE) {
		goto Error_Handler;
	}


	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
		
Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:

	SetPort(saved_Port);
	return(function_Result);

} /* Safe_Boolean	Start_Video_Display_Setup(void)... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Reset_Video_Using_New_Rect_Position(ComponentInstance video_Component_Instance
															, WindowPtr	current_Graphics_Window_Ptr
															, CARDINAL_32 			color_Table_Index
															, PixMapHandle			destination_Bitmap_Handle)
{
	VideoDigitizerError		video_Result;
	INTEGER_32				destination_Left;
	INTEGER_32				destination_Top;
	GrafPtr					saved_Port;
	Rect						destination_Rect;
	Rect						active_Source_Rect;
	Rect						global_Rect;
	Rect						maximum_Source_Rect;
	Rect						vertical_Blank_Source_Rect;
	INTEGER_32				crop_Amount_X;
	INTEGER_32				crop_Amount_Y;
	INTEGER_32				window_Backdrop_Slide_Right;
	INTEGER_32				window_Backdrop_Slide_Left;
	INTEGER_32				window_Backdrop_Slide_Bottom;
	INTEGER_32				window_Backdrop_Slide_Top;
	Boolean					force_Normalized_Full_Screen_Feature;
	CARDINAL_32			width;
	CARDINAL_32			height;
	Rect						window_Rect;
	Safe_Boolean				function_Result;
/* END VAR */


	function_Result = SAFE_FALSE;
	GetPort(&saved_Port);


	video_Result = VDSetPlayThruOnOff(video_Component_Instance
										, FALSE);
	if ((INTEGER_32)video_Result != 0) {
		goto Error_Handler;
	}
	
	/*  */
	/* active_Source_Rect is actually not used in this routine. */
	/*  */
	if (Clip_Reset_Digitizing_Rect(video_Component_Instance
											, &active_Source_Rect) != SAFE_TRUE) {
		goto Error_Handler;
	}

	/*  */
	/* Setup chroma (It is already ASSUMED that it is available at this point */
	/*  */
	video_Result = VDGetKeyColor(video_Component_Instance, (long *)&color_Table_Index);
	
	if (video_Result == noErr) {
		if ((color_Table_Index == 0xFFFFFFFF)
			|| (color_Table_Index != k_PREFERRED_CHROMA_RESERVED_CHANNEL)) {
			
			video_Result = VDSetKeyColor(video_Component_Instance, (long)color_Table_Index);
	
			if (video_Result != noErr) {
				goto Error_Handler;
			}
		}
	}
	
	/*  */
	/* Get window offset in global coordinate for direct destination */
	/*  */
	window_Rect = ((WindowPeek)(current_Graphics_Window_Ptr))->port.portRect;
	destination_Rect = window_Rect;
	LocalToGlobal(&TOP_LEFT(destination_Rect));
	LocalToGlobal(&BOTTOM_RIGHT(destination_Rect));
	
	if (g_Set_Spin_Window_Max_Monitor_Size == SAFE_TRUE) {
		/*  */
		/* Allows menubar to come and go */
		/*  */
		destination_Rect.top = 0;
	}
		
	/*  */
	/* Remember offsets for sliding backdrop within cropped Rect view port */
	/*  */
	
	window_Backdrop_Slide_Right = 0;
	window_Backdrop_Slide_Left = 0;
	window_Backdrop_Slide_Bottom = 0;
	window_Backdrop_Slide_Top = 0;
	
	if (g_Preferred_Monitor_Values_Valid == SAFE_TRUE) {
		if (destination_Rect.right > g_Preferred_Monitor_Max_Rect.right) {
			window_Backdrop_Slide_Right = destination_Rect.right - g_Preferred_Monitor_Max_Rect.right;
			destination_Rect.right = g_Preferred_Monitor_Max_Rect.right;
		}
		if (destination_Rect.left < g_Preferred_Monitor_Max_Rect.left) {
			window_Backdrop_Slide_Left = g_Preferred_Monitor_Max_Rect.left - destination_Rect.left;
			destination_Rect.left = g_Preferred_Monitor_Max_Rect.left;
		}
		if (destination_Rect.bottom > g_Preferred_Monitor_Max_Rect.bottom) {
			window_Backdrop_Slide_Bottom = destination_Rect.bottom - g_Preferred_Monitor_Max_Rect.bottom;
			destination_Rect.bottom = g_Preferred_Monitor_Max_Rect.bottom;
		}
		if (destination_Rect.top < g_Preferred_Monitor_Max_Rect.top) {
			window_Backdrop_Slide_Top = g_Preferred_Monitor_Max_Rect.top - destination_Rect.top;
			destination_Rect.top = g_Preferred_Monitor_Max_Rect.top;
		}
	}

	
	/*  */
	/* Video scaling not permitted so realign. */
	/*  */
	active_Source_Rect = destination_Rect;
	OffsetRect(&active_Source_Rect, -(active_Source_Rect.left), -(active_Source_Rect.top));
	
	video_Result = VDGetMaxSrcRect(video_Component_Instance
										, ntscIn
										, &maximum_Source_Rect);
	if ((INTEGER_32)video_Result != 0) {
		goto Error_Handler;
	}
	
							
	/*  */
	/* Adjust VBL portion out */
	/* Assumes is in top portion and slides downward. */
	/*  */
	video_Result = VDGetVBlankRect(video_Component_Instance
										, ntscIn
										, &vertical_Blank_Source_Rect);
	if ((INTEGER_32)video_Result == 0) {
		maximum_Source_Rect.bottom = maximum_Source_Rect.bottom - (vertical_Blank_Source_Rect.bottom);
		maximum_Source_Rect.bottom = maximum_Source_Rect.bottom - 1;
	
		if (active_Source_Rect.bottom > maximum_Source_Rect.bottom) {
			active_Source_Rect.bottom = maximum_Source_Rect.bottom;
		}
	}
	
	/*  */
	/* HACK HACK HACK Had to add because of defective logic */
	/* requiring ASININE hidden state knowledge to know true limit */
	/* of horizontal quality range */
	/*  */
	if ((maximum_Source_Rect.right - maximum_Source_Rect.left) > 640) {
		maximum_Source_Rect.right = maximum_Source_Rect.left + 640;
	}


	if (active_Source_Rect.right > maximum_Source_Rect.right) {
		active_Source_Rect.right = maximum_Source_Rect.right;
	}
		
	/*  */
	/* Adjust horizontally. */
	/*  */
	if ((maximum_Source_Rect.right - maximum_Source_Rect.left)
		> (active_Source_Rect.right - active_Source_Rect.left)) {
		
		/*  */
		/* Center Video within digitizer max (simple). */
		/* (Was also subbing by one previously)
		/*  */
		OffsetRect(&active_Source_Rect
			, ((((maximum_Source_Rect.right - maximum_Source_Rect.left)
				- (active_Source_Rect.right - active_Source_Rect.left))) >> 1)
			, 0);

		/*  */
		/* Reposition Center of Video if needed. */
		/* This is where we balance the source to the center of useful region */
		/* In case window is bad alignment (off edge of destination port) */
		/*  */		
		if (window_Backdrop_Slide_Right != 0) {
			OffsetRect(&active_Source_Rect
				, - (window_Backdrop_Slide_Right >> 1)
				, 0);
		}
		
		if (window_Backdrop_Slide_Left != 0) {
			OffsetRect(&active_Source_Rect
				, (window_Backdrop_Slide_Left >> 1)
				, 0);
		}
		
		/*  */
		/* After applying both sides modifications, pin to max bounds */	
		/*  */
		if (active_Source_Rect.left < maximum_Source_Rect.left) {
			OffsetRect(&active_Source_Rect
				, (maximum_Source_Rect.left - active_Source_Rect.left)
				, 0);
		}
		
		if (active_Source_Rect.right > maximum_Source_Rect.right) {
			active_Source_Rect.right = maximum_Source_Rect.right;
		}
			
	}
	else {
		/*  */
		/* Too big of a request. Have to chop off some. */
		/* Use maximum useful space */
		/*  */
		active_Source_Rect.left = maximum_Source_Rect.left;
		active_Source_Rect.right = maximum_Source_Rect.right;
	}
	

	/*  */
	/* Adjust vertically. */
	/*  */
	if ((maximum_Source_Rect.bottom - maximum_Source_Rect.top)
		> (active_Source_Rect.bottom - active_Source_Rect.top)) {
		
		/*  */
		/* Center Video within digitizer max (simple). */
		/* (Was also subbing by one previously)
		/*  */
		OffsetRect(&active_Source_Rect
			, 0
			, ((((maximum_Source_Rect.bottom - maximum_Source_Rect.top)
				- (active_Source_Rect.bottom - active_Source_Rect.top))) >> 1));

		/*  */
		/* Reposition Center of Video if needed. */
		/* This is where we balance the source to the center of useful region */
		/* In case window is bad alignment (off edge of destination port) */
		/*  */		
		if (window_Backdrop_Slide_Bottom != 0) {
			OffsetRect(&active_Source_Rect
				, 0
				, - (window_Backdrop_Slide_Bottom >> 1));
		}
		
		if (window_Backdrop_Slide_Top != 0) {
			OffsetRect(&active_Source_Rect
				, 0
				, (window_Backdrop_Slide_Top >>1));
		}
		
		/*  */
		/* After applying both sides modifications, pin to max bounds */	
		/*  */
		if (active_Source_Rect.top < maximum_Source_Rect.top) {
			OffsetRect(&active_Source_Rect
				, 0
				, (maximum_Source_Rect.top - active_Source_Rect.top));
		}
		
		if (active_Source_Rect.bottom > maximum_Source_Rect.bottom) {
			active_Source_Rect.bottom = maximum_Source_Rect.bottom;
		}
			
	}
	else {
		/*  */
		/* Too big of a request. Have to chop off some. */
		/* Use maximum useful space */
		/*  */
		active_Source_Rect.top = maximum_Source_Rect.top;
		active_Source_Rect.bottom = maximum_Source_Rect.bottom;
	}


	/*  */
	/* This is nuts! but off course, max rect was already small */
	/* enough to provide space and guarantee that it would fit. */
	/*  */
	OffsetRect(&active_Source_Rect, 0, (vertical_Blank_Source_Rect.bottom + 1));

	/*  */
	/* Now recenter destination rect to equal best viewing region */
	/* We have a finalized size for source rect, and a preffered final size for */
	/* destination rect. */
	/* Center Destination Rect within reasonable bounds */
	/*  */
	if ((destination_Rect.right - destination_Rect.left) > (active_Source_Rect.right - active_Source_Rect.left)){
		/*  */
		/* Could recenter, might as well */
		/*  */
		OffsetRect(&destination_Rect
			, ((((destination_Rect.right - destination_Rect.left)
				- (active_Source_Rect.right - active_Source_Rect.left))) >> 1)
			, 0);
	}

	if ((destination_Rect.bottom - destination_Rect.top) > (active_Source_Rect.bottom - active_Source_Rect.top)){
		/*  */
		/* Could recenter, might as well */
		/*  */
	/* ====
		OffsetRect(&destination_Rect
			, 0
			, ((((destination_Rect.bottom - destination_Rect.top)
				- (active_Source_Rect.bottom - active_Source_Rect.top))) >> 1));
	===== */
	
		/*  */
		/* Forget recentering, just hug the bottom. */
		/*  */
		OffsetRect(&destination_Rect
			, 0
			, ((((destination_Rect.bottom - destination_Rect.top)
				- (active_Source_Rect.bottom - active_Source_Rect.top)))));
	}
	
	/*  */
	/* HACK HACK HACK HACK */
	/* If window is approximating a 640 * 480 viewscreen, then */
	/* tell the program to go ahead and do so. */
	/* THIS IS NOT Extremely desirable but there is nothing bettter. */
	/* Use deviation of 3 pixels as indicator */
	/*  */
	force_Normalized_Full_Screen_Feature = TRUE;
	width = (active_Source_Rect.right - active_Source_Rect.left);
	height = (active_Source_Rect.bottom - active_Source_Rect.top);
	if (width > 640) {
		if ((width - 640) > 3){
			force_Normalized_Full_Screen_Feature = FALSE;
		}
	}
	else {
		if ((640 - width) > 3){
			force_Normalized_Full_Screen_Feature = FALSE;
		}
	}
	
	if (height > 480) {
		if ((height - 480) > 3){
			force_Normalized_Full_Screen_Feature = FALSE;
		}
	}
	else {
		if ((480 - height) > 3){
			force_Normalized_Full_Screen_Feature = FALSE;
		}
	}
	
	/*  */
	/* Finish up */
	/*  */
	destination_Left = destination_Rect.left;
	destination_Top = destination_Rect.top;
	
	if (force_Normalized_Full_Screen_Feature == TRUE) {
		if ((destination_Left < 3) 
			&& (destination_Left >= 0) 
			&& (destination_Top < 3)
			&& (destination_Top >= 0)) {
			
			SetRect(&active_Source_Rect, 0, 0, 640, 480);
			OffsetRect(&active_Source_Rect, 2, (vertical_Blank_Source_Rect.bottom + 1));
			destination_Left = 0;
			destination_Top = 0;
		}
	}
	
	destination_Rect = active_Source_Rect;
	OffsetRect(&destination_Rect, (-destination_Rect.left), (-destination_Rect.top));
	OffsetRect(&destination_Rect, destination_Left, destination_Top);


	video_Result = VDSetDigitizerRect(video_Component_Instance
										, &active_Source_Rect);
	if ((INTEGER_32)video_Result != 0) {
		goto Error_Handler;
	}

			
	/*  */
	/* Window had better be on main screen digitization is supposed to be occuring on! */
	/*  */
	video_Result = VDPreflightDestination(video_Component_Instance
										, &active_Source_Rect
										, destination_Bitmap_Handle
										, &destination_Rect
										, nil);
	if ((INTEGER_32)video_Result != 0) {
		goto Error_Handler;
	}
	
	video_Result = VDSetPlayThruDestination(video_Component_Instance
										, destination_Bitmap_Handle
										, &destination_Rect
										, nil
										, nil);
	if ((INTEGER_32)video_Result != 0) {
		goto Error_Handler;
	}
	
	video_Result = VDSetPlayThruOnOff(video_Component_Instance
										, TRUE);
	if ((INTEGER_32)video_Result != 0) {
		goto Error_Handler;
	}
	
	g_Digitizer_In_Use = SAFE_TRUE;
	
	
	/*  */
	/* Screen needs full redraw when this happens */
	/* Chroma not honered until redrawn into port. (Apple QD only bug?) */
	/* WARNING : cannot actually call routine here for */
	/* redraw because this can be recursive if invoked within */
	/* redraw code itself (it does). So Port needs to be marked invalid */
	/* but that structure is not safe because that concept (ValidRect, InvalidRect) */
	/* is messed with. */
	/* One way to force full redraw is to set this flag. */
	/*  */
	g_Forced_Digitizer_Window_Update_Required = SAFE_TRUE;


/* =====

vdsetinputcolorspace (vdDigitizerRGB)

vd clearclipRgn
vdsetclipstate(0)

vdsetcompressionOOnOff digitizerOn

vdpreflightglobalrect
vd setplaythruglobalrect


==== maybe vdSetPlayThruPOnOff(digitiozerOn)

== infovdgetdatarate

===== */


	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
		
Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:
	SetPort(saved_Port);

	return(function_Result);

}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Destroy_Video_Backdrop_Background(void)
{
	Safe_Boolean		function_Result;
/* END VAR */

/*  */
/* Global persistant structures are deleted here */
/*  */
	function_Result = SAFE_TRUE;
	if (Close_Open_Components() != SAFE_TRUE) {
		function_Result = SAFE_FALSE;
	}

	return(function_Result);
	
} /* Safe_Boolean Destroy_Video_Backdrop_Background ... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Build_List_Of_Suitable_Components(void)
{
	SysEnvRec					system_Environment;
	ComponentDescription		arbitrary_Component;
	Component					any_Component;
	ComponentInstance			video_Component_Instance;
	VideoDigitizerComponent	video_Component;
	VideoDigitizerError			video_Result;
	ComponentResult			general_Result;
	DigitizerInfo 					digitizer_Copy_Info;
	CARDINAL_32				returned_Value;
	INTEGER_32					component_Index;
	CARDINAL_32				color_Table_Index;
	CARDINAL_8					*code_Name;
	INTEGER_16					index;
	INTEGER_16					total_Video_Inputs;
	INTEGER_16					input_Format_For_Port;
	INTEGER_16					desired_Port_Index;
	OSErr							os_Error;
	Safe_Boolean					function_Result;
	Boolean						still_Looking;
	Boolean						found_Something;
	Mega_Video_Options_Rec	options;
	Str255							message_String;
/* END VAR */


	code_Name = "\pBuild_List_Of_Suitable_Components";
	function_Result = SAFE_FALSE;
	
	os_Error = SysEnvirons(SYSTEM_0605, &system_Environment);
	if (os_Error != noErr) {
		function_Result = SAFE_FALSE;
		goto Normal_Function_Exit;
	}
	
	if (Gestalt_Available() != TRUE) {
		function_Result = SAFE_FALSE;
		goto Normal_Function_Exit;
	}
	
	/*  */
	/* Check If QuickTime SEEMS availbale (Missing PowerPlug does not */
	/* remove this selector though will crash on shitty PowerMacs */
	/*  */
	os_Error = Gestalt(gestaltQuickTime, (INTEGER_32 *)&returned_Value);
	if (os_Error != noErr ) {
		
		Get_NS_String(k_DREAM_ERROR_STRINGS
					, k_ERROR_YOU_NEED_QUICKTIME_INSTALLED
					, message_String);
					
		Perform_OK_Dialog(message_String);

		goto Error_Handler;
	}
		
	/*  */
	/* Check If QuickTime 2.0 */
	/*  */
	if (((returned_Value >> 16) & 0xffff) < 0x0200) {

		Get_NS_String(k_DREAM_ERROR_STRINGS
					, k_ERROR_YOU_NEED_QUICKTIME_2_0_INSTALLED
					, message_String);
					
		Perform_OK_Dialog(message_String);

		goto Error_Handler;
	}
	
	for ( index=0; (index < k_MAX_DIGITIZERS_TO_EXAMINE); index++ ) {
		g_Component_List[index].component_Initialized_And_Active = SAFE_FALSE;
		g_Component_List[index].component_Is_Ready_For_Openning = SAFE_FALSE;
	}
	g_Component_Total = 0;


	/*  */
	/* Try to get a video encoder (first one openable) */
	/*  */
	arbitrary_Component.componentType = sgVideoDigitizerType;
	arbitrary_Component.componentSubType = 0;
	arbitrary_Component.componentManufacturer = 0;
	arbitrary_Component.componentFlags = 0;
	arbitrary_Component.componentFlagsMask = 0;
	
	any_Component = 0;
	still_Looking = TRUE;
	
	video_Component = 0;
	for ( index=0; ((index < k_MAX_DIGITIZERS_TO_EXAMINE) && (still_Looking == TRUE)); index++ ) {
		any_Component = FindNextComponent(any_Component, &arbitrary_Component);
		if (any_Component != 0) {

			g_Component_List[index].component_Name_Handle = NewHandle(4);
			GetComponentInfo(any_Component
									, &(g_Component_List[index].specific_Component_Description)
									, g_Component_List[index].component_Name_Handle
									, nil
									, nil);

			g_Component_List[index].specific_Component = any_Component;
			g_Component_List[index].component_Type = sgVideoDigitizerType;
			g_Component_List[index].component_Sub_Type = g_Component_List[index].specific_Component_Description.componentSubType;

			g_Component_Total += 1;
		} else {
			still_Looking = FALSE;
		}
	}
	
	if (g_Component_Total <= 0) {
		goto Error_Handler;
	}
	
	
/* ====
 HACK HACK HACK 
 ==== */
	video_Component = (VideoDigitizerComponent)g_Component_List[0].specific_Component;
	
	
 	found_Something = FALSE;
 	still_Looking = TRUE;
	for ( index=0; ((index < g_Component_Total) && (still_Looking == TRUE)); index++ ) {

	/* ======
		g_Component_List[index].specific_Component_Description
		g_Component_List[index].component_Name_Handle
		g_Component_List[index].specific_Component
		g_Component_List[index].component_Type
		g_Component_List[index].component_Sub_Type
	=== */
	
		/*  */
		/* Open, close and open again. Keep if good one. */
		/*  */
		
		video_Component_Instance = OpenComponent(g_Component_List[index].specific_Component);
		
		/*  */
		/* Alternate, less acurate unused technique */
		/*  */
	/* ====
		video_Component_Instance = OpenDefaultComponent(g_Component_List[index].component_Type
																	, g_Component_List[index].component_Sub_Type);
	===== */
																	
		if (((INTEGER_32)g_Component_List[index].specific_Component != 0) && ((INTEGER_32)video_Component != -1L)) {
																	
			if (video_Component_Instance != nil) {
				os_Error = CloseComponent(video_Component_Instance);
			 	if (os_Error == noErr) {
			 	
					video_Component_Instance = OpenComponent(g_Component_List[index].specific_Component);
					
					if (video_Component_Instance != nil) {
						
						video_Result = VDGetDigitizerInfo((video_Component_Instance)
													, &digitizer_Copy_Info);
						if ((INTEGER_32)video_Result != 0) {
							os_Error = CloseComponent(video_Component_Instance);
							goto Error_Handler;
						}
						
						if (Extract_All_Video_Options(&options, &digitizer_Copy_Info) != TRUE) {
							os_Error = CloseComponent(video_Component_Instance);
							goto Error_Handler;
						}
						
						if ((options.video_Out_Does_DMA == TRUE)
							&& (options.video_Out_Does_HW_Play_Through == TRUE)
							&& (options.video_Out_Does_8_Bits == TRUE)
							&& (options.video_Out_Does_16_Bits == TRUE)
							&& (options.video_Out_Does_KeyColor == TRUE)
							&& (options.video_In_Does_Color == TRUE)
							
							/*  */
							/* One of any three normal inputs is acceptable */
							/*  */
							
							&& ((options.video_In_Does_NTSC == TRUE)
								|| (options.video_In_Does_Composite == TRUE)
								|| (options.video_In_Does_Color == TRUE))	) {
							
							/*  */
							/* Hurray! This is a good one that we want */
							/* But we close it anyway, because we just want a list of ALL useful cards */
							/*  */
							g_Component_List[index].component_Is_Ready_For_Openning = SAFE_TRUE;
							
							os_Error = CloseComponent(video_Component_Instance);
							if (os_Error != noErr) {
								/*  */
								/* Ignore closure error, it was already working. */
								/*  */
							}
							
							g_Component_Index_To_Use = index;
							
							found_Something = TRUE;
						/* ===
		 					still_Looking = FALSE;
		 				==== */
		 				
						}
						else {
							os_Error = CloseComponent(video_Component_Instance);
							if (os_Error != noErr) {
								/*  */
								/* Ignore closure error, it was already working. */
								/*  */
							}
						}
					}
				}
			}
		
		} /* if (((INTEGER_32)g_Component_List[index].specific_Component != 0) */
		
	} /* for ( index=0; ((index < g_Component_Total) && (still_Looking == TRUE)) ... */
 
 	if (found_Something != TRUE) {
 	
		Get_NS_String(k_DREAM_ERROR_STRINGS
					, k_ERROR_NO_ACCEPTABLE_DIGITAL_VIDEO_IN
					, message_String);
					
		Perform_OK_Dialog(message_String);
		
		goto Error_Handler;
 	}
 	
	/*  */
	/* "g_Component_Index_To_Use" is available for usage */
	/*  */
	
	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
		
Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:

	return(function_Result);

} /* Safe_Boolean Build_List_Of_Suitable_Components */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean	Open_Digitizer_In_Components(INTEGER_16 component_Index_To_Use
													, INTEGER_16 desired_Input_Port_Type
													, INTEGER_16 desired_Input_Port_Offset
													, Rect			*digitizing_Rect
													, ComponentInstance	*instance_Copy)
{
	ComponentInstance			video_Component_Instance;
	VideoDigitizerError			video_Result;
	CARDINAL_32				returned_Value;
	CARDINAL_32				total_Applicable_Port_Matches;
	INTEGER_32					component_Index;
	CARDINAL_32				color_Table_Index;
	CARDINAL_8					*code_Name;
	INTEGER_16					index;
	INTEGER_16					total_Video_Inputs;
	INTEGER_16					input_Format_For_Port;
	INTEGER_16					desired_Port_Index;
	INTEGER_32					digitizing_Width;
	INTEGER_32					digitizing_Height;
	Rect							active_Source_Rect;
	OSErr							os_Error;
	Safe_Boolean					function_Result;
	Boolean						still_Looking;
	Str255							message_String;
/* END VAR */


	code_Name = "\pOpen_Digitizer_In_Components";
	function_Result = SAFE_FALSE;
	*instance_Copy = nil; 

	video_Component_Instance = OpenComponent(g_Component_List[component_Index_To_Use].specific_Component);
	
	if (video_Component_Instance == nil) {
		goto Error_Handler;
	}
	
	g_Component_List[component_Index_To_Use].component_Initialized_And_Active = SAFE_TRUE;
	g_Component_List[component_Index_To_Use].component_Instance = video_Component_Instance;
	
	g_Component_Index_To_Use = component_Index_To_Use;
	
	
	video_Result = VDGetNumberOfInputs(video_Component_Instance, &total_Video_Inputs);
	if (((INTEGER_32)video_Result != 0) || (total_Video_Inputs > 3000)) {
		goto Video_Option_Error_Handler;
	}

	/*  */
	/* Accept the first input that is the desired type of input */
	/*  */
	still_Looking = TRUE;
	desired_Port_Index = 0;
	total_Applicable_Port_Matches = 0;
		
	for (index = 0; ((index < total_Video_Inputs) && (still_Looking == TRUE)); index++) {
		video_Result = VDGetInputFormat(video_Component_Instance, index, &input_Format_For_Port);
		if ((INTEGER_32)video_Result == 0) {
		
			switch (desired_Input_Port_Type) {
				case k_NTSC_COMPOSITE_OR_ARBITRARY_IN_PORT:
					if (input_Format_For_Port == compositeIn) {
						if (desired_Input_Port_Offset == total_Applicable_Port_Matches) {
							still_Looking = FALSE;
							desired_Port_Index = index;
							
							/*  */
							/* This stops using SECAM or PAL and forces NTSC if needed */
							/*  */
							video_Result = VDSetInputStandard(video_Component_Instance, ntscIn);
							if ((INTEGER_32)video_Result != 0) {
								goto Video_Option_Error_Handler;
							}
						}
						total_Applicable_Port_Matches += 1;
					}
				break;
			
				case k_S_VIDEO_IN_PORT:
					if (input_Format_For_Port == sVideoIn) {
						if (desired_Input_Port_Offset == total_Applicable_Port_Matches) {
							still_Looking = FALSE;
							desired_Port_Index = index;
						}
						total_Applicable_Port_Matches += 1;
					}
				break;
			
				case k_RGB_COMPONENT_IN_PORT:
					if (input_Format_For_Port == rgbComponentIn) {
						if (desired_Input_Port_Offset == total_Applicable_Port_Matches) {
							still_Looking = FALSE;
							desired_Port_Index = index;
						}
						total_Applicable_Port_Matches += 1;
					}
				break;
			
				case k_RGB_COMPONENT_SYNC_IN_PORT:
					if (input_Format_For_Port == rgbComponentSyncIn) {
						if (desired_Input_Port_Offset == total_Applicable_Port_Matches) {
							still_Looking = FALSE;
							desired_Port_Index = index;
						}
						total_Applicable_Port_Matches += 1;
					}
				break;
			
				case k_YUV_COMPONENT_IN_PORT:
					if (input_Format_For_Port == yuvComponentIn) {
						if (desired_Input_Port_Offset == total_Applicable_Port_Matches) {
							still_Looking = FALSE;
							desired_Port_Index = index;
						}
						total_Applicable_Port_Matches += 1;
					}
				break;
			
				case k_YUV_COMPONENT_SYNC_IN_PORT:
					if (input_Format_For_Port == yuvComponentSyncIn) {
						if (desired_Input_Port_Offset == total_Applicable_Port_Matches) {

							still_Looking = FALSE;
							desired_Port_Index = index;
						}
						total_Applicable_Port_Matches += 1;
					}
				break;
			
				default:
					; /* NULL */			
					
			} /* switch (desired_Input_Port) */
		}
	}
	
 	if (still_Looking == TRUE) {
		goto Video_Option_Error_Handler;
 	}
 	
	/*  */
	/* Setup chroma (It is already ASSUMED that it is available at this point */
	/*  */
	video_Result = VDGetKeyColor(video_Component_Instance, (long *)&color_Table_Index);
	
	if (video_Result == noErr) {
		if ((color_Table_Index == 0xFFFFFFFF)
			|| (color_Table_Index != k_PREFERRED_CHROMA_RESERVED_CHANNEL)) {
			
			video_Result = VDSetKeyColor(video_Component_Instance, (long)k_PREFERRED_CHROMA_RESERVED_CHANNEL);
	
			if (video_Result != noErr) {
				goto Video_Option_Error_Handler;
			}
		}
	}

	video_Result = VDSetCompressionOnOff(video_Component_Instance
										, FALSE);
	if ((INTEGER_32)video_Result != 0) {
		goto Video_Option_Error_Handler;
	}
	

	/*  */
	/* Select smaller digitizer on purpose */
	/*  */
	
	/*  */
	/* Select Video port. */
	/* Just takes first input source that matched */
	/*  */
	
	video_Result = VDSetInput(video_Component_Instance, desired_Port_Index);
	if ((INTEGER_32)video_Result != 0) {
		goto Video_Option_Error_Handler;
	}
	
	*instance_Copy = video_Component_Instance;
	

	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
	
Video_Option_Error_Handler:
/* ===
	Get_NS_String(k_DREAM_ERROR_STRINGS
				, k_ERROR_DIGITAL_VIDEO_SETTINGS_NOT_ACCEPTABLE
				, message_String);
				
	Perform_OK_Dialog(message_String);
==== */

	function_Result = SAFE_FALSE;
	
Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:

	return(function_Result);

} /* Safe_Boolean Open_Digitizer_In_Components... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Clip_Reset_Digitizing_Rect(ComponentInstance video_Component_Instance
											, Rect	*digitizing_Rect)
{
	VideoDigitizerError	video_Result;
	Safe_Boolean			function_Result;
	Rect					maximum_Source_Rect;
	Rect					active_Source_Rect;
	Rect					vertical_Blank_Source_Rect;
	Rect					digitizer_Source_Rect;
/* END VAR */


/*  */
/* Global persistant structures are deleted here */
/*  */
	function_Result = SAFE_FALSE;

	video_Result = VDGetMaxSrcRect(video_Component_Instance
										, ntscIn
										, &maximum_Source_Rect);
	if ((INTEGER_32)video_Result != 0) {
		goto Video_Option_Error_Handler;
	}

	video_Result = VDGetActiveSrcRect(video_Component_Instance
										, ntscIn
										, &active_Source_Rect);
	if ((INTEGER_32)video_Result != 0) {
		goto Video_Option_Error_Handler;
	}

	video_Result = VDGetVBlankRect(video_Component_Instance
										, ntscIn
										, &vertical_Blank_Source_Rect);
	if ((INTEGER_32)video_Result != 0) {
		goto Video_Option_Error_Handler;
	}
	
	video_Result = VDGetDigitizerRect(video_Component_Instance
										, &digitizer_Source_Rect);
	if ((INTEGER_32)video_Result != 0) {
		goto Video_Option_Error_Handler;
	}
	
	active_Source_Rect = digitizer_Source_Rect;
	
	
	video_Result = VDSetDigitizerRect(video_Component_Instance
										, &active_Source_Rect);
	if ((INTEGER_32)video_Result != 0) {
		goto Video_Option_Error_Handler;
	}
	
	
	/*  */
	/* Clip Digitizing Rect for Safety */
	/*  */
	if (active_Source_Rect.top < maximum_Source_Rect.top) {
		active_Source_Rect.top = maximum_Source_Rect.top;
	}
	
	if (active_Source_Rect.left < maximum_Source_Rect.left) {
		active_Source_Rect.left = maximum_Source_Rect.left;
	}
	
	if (active_Source_Rect.right > maximum_Source_Rect.right) {
		active_Source_Rect.right = maximum_Source_Rect.right;
	}
	
	if (active_Source_Rect.bottom > maximum_Source_Rect.bottom) {
		active_Source_Rect.bottom = maximum_Source_Rect.bottom;
	}
	
	video_Result = VDSetDigitizerRect(video_Component_Instance
										, &active_Source_Rect);
	if ((INTEGER_32)video_Result != 0) {
		goto Video_Option_Error_Handler;
	}

/*===
	digitizing_Width = active_Source_Rect.right - active_Source_Rect.left;
	digitizing_Height = active_Source_Rect.bottom - active_Source_Rect.top;
	SetRect(digitizing_Rect, 0, 0, digitizing_Width, digitizing_Height);
==== */
	
	*digitizing_Rect = active_Source_Rect;

	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
		
Video_Option_Error_Handler:

Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:

	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean	Close_Open_Components(void)
{
	Safe_Boolean					function_Result;
	INTEGER_16					index;
	Boolean						still_Looking;
	OSErr							os_Error;
	CARDINAL_8					*code_Name;
/* END VAR */


	code_Name = "\pClose_Open_Components";
	function_Result = SAFE_FALSE;
	
 	still_Looking = TRUE;
 	if (g_Component_Total > 0) {
	 	for ( index=0; ((index < k_MAX_DIGITIZERS_TO_EXAMINE) && (still_Looking == TRUE)); index++ ) {
	
			if (g_Component_List[index].component_Initialized_And_Active == SAFE_TRUE) {
			
				os_Error = CloseComponent(g_Component_List[index].component_Instance);
				g_Component_Total = g_Component_Total - 1;
				g_Component_List[index].component_Initialized_And_Active = SAFE_FALSE;
				if (os_Error != noErr) {
					/*  */
					/* Ignore, it is closing anyway */
					/*  */
				}
			}
	
			if (g_Component_Total <= 0) {
		 		still_Looking = FALSE;
			}
		}
	}

	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
	
Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:

	return(function_Result);

} /* Safe_Boolean Close_Open_Components ... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Clear_Video_Options(Mega_Video_Options_Ptr options)
{

	options->video_In_Signal_Lock = FALSE;
	
	options->video_Out_Does_1_Bits = FALSE;
	options->video_Out_Does_2_Bits = FALSE;
	options->video_Out_Does_4_Bits = FALSE;
	options->video_Out_Does_8_Bits = FALSE;
	options->video_Out_Does_16_Bits = FALSE;
	options->video_Out_Does_32_Bits = FALSE;
	options->video_Out_Does_Dither = FALSE;
	options->video_Out_Does_Stretch = FALSE;
	options->video_Out_Does_Shrink = FALSE;
	options->video_Out_Does_Mask = FALSE;
	options->video_Out_Does_Double = FALSE;
	options->video_Out_Does_Quad = FALSE;
	options->video_Out_Does_Quarter = FALSE;
	options->video_Out_Does_Sixteenth = FALSE;
	options->video_Out_Does_Rotate = FALSE;
	options->video_Out_Does_HorizFlip = FALSE;
	options->video_Out_Does_VertFlip = FALSE;
	options->video_Out_Does_Skew = FALSE;
	options->video_Out_Does_Blend = FALSE;
	options->video_Out_Does_Warp = FALSE;
	options->video_Out_Does_DMA = FALSE;
	options->video_Out_Does_HW_Play_Through = FALSE;
	options->video_Out_Does_Inverse_Color_Tables = FALSE;
	options->video_Out_Does_KeyColor = FALSE;
	options->video_Out_Does_Async_Grabs = FALSE;
	options->video_Out_Does_Unreadable_Screen_Bits = FALSE;
	options->video_Out_Does_Compress = FALSE;
	options->video_Out_Does_Compress_Only = FALSE;
	options->video_Out_Does_Playthrough_During_Compress = FALSE;

	options->video_Out_1_Bits_Active = FALSE;
	options->video_Out_2_Bits_Active = FALSE;
	options->video_Out_4_Bits_Active = FALSE;
	options->video_Out_8_Bits_Active = FALSE;
	options->video_Out_16_Bits_Active = FALSE;
	options->video_Out_32_Bits_Active = FALSE;
	options->video_Out_Dither_Active = FALSE;
	options->video_Out_Stretch_Active = FALSE;
	options->video_Out_Shrink_Active = FALSE;
	options->video_Out_Mask_Active = FALSE;
	options->video_Out_Double_Active = FALSE;
	options->video_Out_Quad_Active = FALSE;
	options->video_Out_Quarter_Active = FALSE;
	options->video_Out_Sixteenth_Active = FALSE;
	options->video_Out_Rotate_Active = FALSE;
	options->video_Out_HorizFlip_Active = FALSE;
	options->video_Out_VertFlip_Active = FALSE;
	options->video_Out_Skew_Active = FALSE;
	options->video_Out_Blend_Active = FALSE;
	options->video_Out_Warp_Active = FALSE;
	options->video_Out_DMA_Active = FALSE;
	options->video_Out_HW_Play_Through_Active = FALSE;
	options->video_Out_Inverse_Color_Tables_Active = FALSE;
	options->video_Out_KeyColor_Active = FALSE;
	options->video_Out_Async_Grabs_Active = FALSE;
	options->video_Out_Unreadable_Screen_Bits_Active = FALSE;
	options->video_Out_Compress_Active = FALSE;
	options->video_Out_Compress_Only_Active = FALSE;
	options->video_Out_Playthrough_During_Compress_Active = FALSE;
	
	options->video_In_Does_NTSC = FALSE;
	options->video_In_Does_PAL = FALSE;
	options->video_In_Does_SECAM = FALSE;
	options->video_In_Does_GenLock = FALSE;
	options->video_In_Does_Composite = FALSE;
	options->video_In_Does_SVideo = FALSE;
	options->video_In_Does_Component = FALSE;
	options->video_In_Does_VTR_Broadcast_Deviance = FALSE;
	options->video_In_Does_Color = FALSE;
	options->video_In_Does_BW = FALSE;
	
	options->video_In_NTSC_Active = FALSE;
	options->video_In_PAL_Active = FALSE;
	options->video_In_SECAM_Active = FALSE;
	options->video_In_GenLock_Active = FALSE;
	options->video_In_Composite_Active = FALSE;
	options->video_In_SVideo_Active = FALSE;
	options->video_In_Component_Active = FALSE;
	options->video_In_VTR_Broadcast_Deviance_Active = FALSE;
	options->video_In_Color_Active = FALSE;
	options->video_In_BW_Active = FALSE;

	return(TRUE);
	
} /* Boolean Clear_Video_Options */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Boolean Extract_All_Video_Options(Mega_Video_Options_Ptr options, DigitizerInfo *digitizer_Info)
{
CARDINAL_32 flags;

	/*  */
	/* Encapsulate into our own system */
	/*  */
	
	if (Clear_Video_Options(options) != TRUE) {
	
	}
	
	/* Now set the special input status flags */
	
	flags = digitizer_Info->inputCapabilityFlags;
	if (flags & digiInSignalLock) {
		options->video_In_Signal_Lock = TRUE;
	}
	
	/* Now set the output capability status flags */
	
	flags = digitizer_Info->outputCapabilityFlags;

	if (flags & digiOutDoes1) {
		options->video_Out_Does_1_Bits = TRUE;
	}
	if (flags & digiOutDoes2) {
		options->video_Out_Does_2_Bits = TRUE;
	}
	if (flags & digiOutDoes4) {
		options->video_Out_Does_4_Bits = TRUE;
	}
	if (flags & digiOutDoes8) {
		options->video_Out_Does_8_Bits = TRUE;
	}
	if (flags & digiOutDoes16) {
		options->video_Out_Does_16_Bits = TRUE;
	}
	if (flags & digiOutDoes32) {
		options->video_Out_Does_32_Bits = TRUE;
	}
	if (flags & digiOutDoesDither) {
		options->video_Out_Does_Dither = TRUE;
	}
	if (flags & digiOutDoesStretch) {
		options->video_Out_Does_Stretch = TRUE;
	}
	if (flags & digiOutDoesShrink) {
		options->video_Out_Does_Shrink = TRUE;
	}
	if (flags & digiOutDoesMask) {
		options->video_Out_Does_Mask = TRUE;
	}
	if (flags & digiOutDoesDouble) {
		options->video_Out_Does_Double = TRUE;
	}
	if (flags & digiOutDoesQuad) {
		options->video_Out_Does_Quad = TRUE;
	}
	if (flags & digiOutDoesQuarter) {
		options->video_Out_Does_Quarter = TRUE;
	}
	if (flags & digiOutDoesSixteenth) {
		options->video_Out_Does_Sixteenth = TRUE;
	}
	if (flags & digiOutDoesRotate) {
		options->video_Out_Does_Rotate = TRUE;
	}
	if (flags & digiOutDoesHorizFlip) {
		options->video_Out_Does_HorizFlip = TRUE;
	}
	if (flags & digiOutDoesVertFlip) {
		options->video_Out_Does_VertFlip = TRUE;
	}
	if (flags & digiOutDoesSkew) {
		options->video_Out_Does_Skew = TRUE;
	}
	if (flags & digiOutDoesBlend) {
		options->video_Out_Does_Blend = TRUE;
	}
	if (flags & digiOutDoesWarp) {
		options->video_Out_Does_Warp = TRUE;
	}
	if (flags & digiOutDoesHW_DMA) {
		options->video_Out_Does_DMA = TRUE;
	}
	if (flags & digiOutDoesHWPlayThru) {
		options->video_Out_Does_HW_Play_Through = TRUE;
	}
	if (flags & digiOutDoesILUT) {
		options->video_Out_Does_Inverse_Color_Tables = TRUE;
	}
	if (flags & digiOutDoesKeyColor) {
		options->video_Out_Does_KeyColor = TRUE;
	}
	if (flags & digiOutDoesAsyncGrabs) {
		options->video_Out_Does_Async_Grabs = TRUE;
	}
	if (flags & digiOutDoesUnreadableScreenBits) {
		options->video_Out_Does_Unreadable_Screen_Bits = TRUE;
	}
	if (flags & digiOutDoesCompress) {
		options->video_Out_Does_Compress = TRUE;
	}
	if (flags & digiOutDoesCompressOnly) {
		options->video_Out_Does_Compress_Only = TRUE;
	}
	if (flags & digiOutDoesPlayThruDuringCompress) {
		options->video_Out_Does_Playthrough_During_Compress = TRUE;
	}

	/* Now set the current output flags */
	
	flags = digitizer_Info->outputCurrentFlags;
	
	if (flags & digiOutDoes1) {
		options->video_Out_1_Bits_Active = TRUE;
	}
	if (flags & digiOutDoes2) {
		options->video_Out_2_Bits_Active = TRUE;
	}
	if (flags & digiOutDoes4) {
		options->video_Out_4_Bits_Active = TRUE;
	}
	if (flags & digiOutDoes8) {
		options->video_Out_8_Bits_Active = TRUE;
	}
	if (flags & digiOutDoes16) {
		options->video_Out_16_Bits_Active = TRUE;
	}
	if (flags & digiOutDoes32) {
		options->video_Out_32_Bits_Active = TRUE;
	}
	if (flags & digiOutDoesDither) {
		options->video_Out_Dither_Active = TRUE;
	}
	if (flags & digiOutDoesStretch) {
		options->video_Out_Stretch_Active = TRUE;
	}
	if (flags & digiOutDoesShrink) {
		options->video_Out_Shrink_Active = TRUE;
	}
	if (flags & digiOutDoesMask) {
		options->video_Out_Mask_Active = TRUE;
	}
	if (flags & digiOutDoesDouble) {
		options->video_Out_Double_Active = TRUE;
	}
	if (flags & digiOutDoesQuad) {
		options->video_Out_Quad_Active = TRUE;
	}
	if (flags & digiOutDoesQuarter) {
		options->video_Out_Quarter_Active = TRUE;
	}
	if (flags & digiOutDoesSixteenth) {
		options->video_Out_Sixteenth_Active = TRUE;
	}
	if (flags & digiOutDoesRotate) {
		options->video_Out_Rotate_Active = TRUE;
	}
	if (flags & digiOutDoesHorizFlip) {
		options->video_Out_HorizFlip_Active = TRUE;
	}
	if (flags & digiOutDoesVertFlip) {
		options->video_Out_VertFlip_Active = TRUE;
	}
	if (flags & digiOutDoesSkew) {
		options->video_Out_Skew_Active = TRUE;
	}
	if (flags & digiOutDoesBlend) {
		options->video_Out_Blend_Active = TRUE;
	}
	if (flags & digiOutDoesWarp) {
		options->video_Out_Warp_Active = TRUE;
	}
	if (flags & digiOutDoesHW_DMA) {
		options->video_Out_DMA_Active = TRUE;
	}
	if (flags & digiOutDoesHWPlayThru) {
		options->video_Out_HW_Play_Through_Active = TRUE;
	}
	if (flags & digiOutDoesILUT) {
		options->video_Out_Inverse_Color_Tables_Active = TRUE;
	}
	if (flags & digiOutDoesKeyColor) {
		options->video_Out_KeyColor_Active = TRUE;
	}
	if (flags & digiOutDoesAsyncGrabs) {
		options->video_Out_Async_Grabs_Active = TRUE;
	}
	if (flags & digiOutDoesUnreadableScreenBits) {
		options->video_Out_Unreadable_Screen_Bits_Active = TRUE;
	}
	if (flags & digiOutDoesCompress) {
		options->video_Out_Compress_Active = TRUE;
	}
	if (flags & digiOutDoesCompressOnly) {
		options->video_Out_Compress_Only_Active = TRUE;
	}
	if (flags & digiOutDoesPlayThruDuringCompress) {
		options->video_Out_Playthrough_During_Compress_Active = TRUE;
	}
	
	/* Now set the input capability flags */
	
	flags = digitizer_Info->inputCapabilityFlags;
	
	if (flags & digiInDoesNTSC) {
		options->video_In_Does_NTSC = TRUE;
	}
	if (flags & digiInDoesPAL) {
		options->video_In_Does_PAL = TRUE;
	}
	if (flags & digiInDoesSECAM) {
		options->video_In_Does_SECAM = TRUE;
	}
	if (flags & digiInDoesGenLock) {
		options->video_In_Does_GenLock = TRUE;
	}
	if (flags & digiInDoesComposite) {
		options->video_In_Does_Composite = TRUE;
	}
	if (flags & digiInDoesSVideo) {
		options->video_In_Does_SVideo = TRUE;
	}
	if (flags & digiInDoesComponent) {
		options->video_In_Does_Component = TRUE;
	}
	if (flags & digiInVTR_Broadcast) {
		options->video_In_Does_VTR_Broadcast_Deviance = TRUE;
	}
	if (flags & digiInDoesColor) {
		options->video_In_Does_Color = TRUE;
	}
	if (flags & digiInDoesBW) {
		options->video_In_Does_BW = TRUE;
	}
		
	
	flags = digitizer_Info->inputCurrentFlags;
	
	if (flags & digiInDoesNTSC) {
		options->video_In_NTSC_Active = TRUE;
	}
	if (flags & digiInDoesPAL) {
		options->video_In_PAL_Active = TRUE;
	}
	if (flags & digiInDoesSECAM) {
		options->video_In_SECAM_Active = TRUE;
	}
	if (flags & digiInDoesGenLock) {
		options->video_In_GenLock_Active = TRUE;
	}
	if (flags & digiInDoesComposite) {
		options->video_In_Composite_Active = TRUE;
	}
	if (flags & digiInDoesSVideo) {
		options->video_In_SVideo_Active = TRUE;
	}
	if (flags & digiInDoesComponent) {
		options->video_In_Component_Active = TRUE;
	}
	if (flags & digiInVTR_Broadcast) {
		options->video_In_VTR_Broadcast_Deviance_Active = TRUE;
	}
	if (flags & digiInDoesColor) {
		options->video_In_Color_Active = TRUE;
	}
	if (flags & digiInDoesBW) {
		options->video_In_BW_Active = TRUE;
	}
		

	return(TRUE);
} /* Boolean Extract_All_Video_Options */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Force_Video_Background_Full_Reupdate_If_Needed(void)
{
/*  */
/* This routine is so that buggy AV digitizer can feel chroma */
/* pixels being blasted with a legal copyBits?, and so that the */
/* routine that starts chroma (in redraw/resize code) does not */
/* recursively handle problem. Basically InvalidRect would be */
/* called, but I did not want to trust that and loose it (I do not */
/* build my world soly around valid regions). This is a one shot */
/* defeered update. Just accessing pixels probably does the trick */
/*  */
	GrafPtr					saved_Port;
/* END VAR */


	if (g_Forced_Digitizer_Window_Update_Required == SAFE_TRUE) {
		GetPort(&saved_Port);
		if (Redraw_Spinning_Window_Completely(TRUE, FALSE) != SAFE_TRUE) {
			/*  */
			/* Ignore errors */
			/*  */
		}
		SetPort(saved_Port);
	}
	
	g_Forced_Digitizer_Window_Update_Required = SAFE_FALSE;
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Stop_Any_Video_Background_Display(void)
/*  */
/* This is called whenever the window is changing */
/* momentarily and hardware scanning needs to be momentarily stopped. */
/* If this is not called a dead piece of corrupted image could result */
/* on screen in process of moving live portion around on a window. */
/*  */
{
	Safe_Boolean			function_Result;
	INTEGER_16			index;
	VideoDigitizerError	video_Result;
	Boolean				still_Looking;
/* END VAR */


	if (g_Digitizer_In_Use != SAFE_TRUE) {
		/*  */
		/* Already in use, No? just skip over this routine */
		/*  */
		function_Result = SAFE_TRUE;
		goto Normal_Function_Exit;
	}

	/*  */
	/* HACK HACK HACK */
	/* Just take first avalable digitizer that is in use. Assume */
	/* That program only uses one digitizer at a time. */
	/* THIS MUST BE ALTERRED IN FUTURE TO TRACK PROPER */
	/* COMPONENT THAT IS ACTIVE! (if any) */
	/*  */

 	still_Looking = TRUE;
 	if (g_Component_Total > 0) {
	 	for ( index=0; ((index < k_MAX_DIGITIZERS_TO_EXAMINE) && (still_Looking == TRUE)); index++ ) {
	
			if (g_Component_List[index].component_Initialized_And_Active == SAFE_TRUE) {
			
		 		still_Looking = FALSE;
								
				video_Result = VDSetPlayThruOnOff(g_Component_List[index].component_Instance
													, FALSE);
				if ((INTEGER_32)video_Result != 0) {
					/*  */
					/* Ignore, not critical */
					/*  */
				}
			}
		}
	}


	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
		
Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:

	return(function_Result);
	
} /* Safe_Boolean Stop_Any_Video_Background_Display ... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Reset_Video_Background_Rect_For_Window_Move(INTEGER_32		window_Index)
{
	Safe_Boolean		function_Result;
	INTEGER_16		index;
	Boolean			still_Looking;
	WindowPtr		current_Graphics_Window_Ptr;
/* END VAR */


	if (g_Digitizer_In_Use != SAFE_TRUE) {
		/*  */
		/* Already in use, No? just skip over this routine */
		/*  */
		function_Result = SAFE_TRUE;
		goto Normal_Function_Exit;
	}

	/*  */
	/* Only allow window digitizer resize if reasonable */
	/* Failures do nothing much different, though if fails */
	/* more than 10% in, previous digitizing is halted. */
	/*  */
	if (g_Preferred_Monitor_Values_Valid != SAFE_TRUE) {
		goto Error_Handler;
	}
	
	switch (window_Index) {
	
		case TEST_DREAMING_WINDOW_INDEX:
			function_Result = SAFE_TRUE;
			goto Normal_Function_Exit;
			break;
		
		case MAIN_SPINNING_WINDOW_INDEX:
				; /* NULL, OK to procede */
			break;
		
		default:
			function_Result = SAFE_TRUE;
			goto Normal_Function_Exit;
	}
	
	
	if ((active_Window_List[window_Index] == nil)
		|| ((**active_Window_List[window_Index]).structure_Initialized != SAFE_TRUE)) {
		goto Error_Handler;
	}
	
	current_Graphics_Window_Ptr	= (**active_Window_List[window_Index]).status_Window;

	/*  */
	/* HACK HACK HACK */
	/* Just take first avalable digitizer that is in use. Assume */
	/* That program only uses one digitizer at a time. */
	/* THIS MUST BE ALTERRED IN FUTURE TO TRACK PROPER */
	/* COMPONENT THAT IS ACTIVE! (if any) */
	/*  */

 	still_Looking = TRUE;
 	if (g_Component_Total > 0) {
	 	for ( index=0; ((index < k_MAX_DIGITIZERS_TO_EXAMINE) && (still_Looking == TRUE)); index++ ) {
	
			if (g_Component_List[index].component_Initialized_And_Active == SAFE_TRUE) {
			
		 		still_Looking = FALSE;
				
				if (Reset_Video_Using_New_Rect_Position(g_Component_List[index].component_Instance
																, current_Graphics_Window_Ptr
																, (g_Chroma_Index_Optimized_Long & 0x00FF)
																, g_Preferred_Monitor_Video_Pix_Map_Handle) != SAFE_TRUE) {
					goto Error_Handler;
				}
			}
		}
	}


	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
		
Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:

	return(function_Result);
	
} /* Safe_Boolean Reset_Video_Background_Rect_For_Window_Move ... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: Video_Backdrop_Background.c */
