/* START OF FILE: Video_Backdrop_Background.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Video_Backdrop_Background.h - Header for Video_Backdrop_Background.c
 ** (C) Copyright 1995 by James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Video_Backdrop_Background.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Video_Backdrop_Background

#define _H_Video_Backdrop_Background
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Indexed_Background_Removal.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */
	
/*  */
/* Possible ports for selective Video import */
/*  */
#define k_NTSC_COMPOSITE_OR_ARBITRARY_IN_PORT		0
#define k_S_VIDEO_IN_PORT										1
#define k_RGB_COMPONENT_IN_PORT							2
#define k_RGB_COMPONENT_SYNC_IN_PORT					3
#define k_YUV_COMPONENT_IN_PORT							4
#define k_YUV_COMPONENT_SYNC_IN_PORT					5


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Video_Backdrop_Background(void);

extern Safe_Boolean Destroy_Video_Backdrop_Background(void);

extern Safe_Boolean	Start_Video_Display_Setup(Setup_Chromakey_Video_Rec	*params_For_Setup_Chromakey_Video);

extern Safe_Boolean Reset_Video_Background_Rect_For_Window_Move(INTEGER_32 window_Index);

extern void Force_Video_Background_Full_Reupdate_If_Needed(void);

extern Safe_Boolean Stop_Any_Video_Background_Display(void);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */

extern CARDINAL_32	g_Chroma_Index_Optimized_Long;
extern Safe_Boolean		g_Forced_Digitizer_Window_Update_Required;


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Video_Backdrop_Background.h */
