///--------------------------------------------------------------------------------------
//	SpriteWorldUtils.h
//
//	Created:	Monday, January 18, 1993 at 8:57:36 PM
//	By:		Tony Myles
//
//	Copyright:  1993 Tony Myles, All rights reserved worldwide.
//
//	Description:	constants, structures, and prototypes for sprite utilities
///--------------------------------------------------------------------------------------


#ifndef __SPRITEWORLDUTILS__
#define __SPRITEWORLDUTILS__

#ifndef __QUICKDRAW__
#include <QuickDraw.h>
#endif

#ifndef __QDOFFSCREEN__
#include <QDOffscreen.h>
#endif

#ifndef __SPRITEWORLD__
#include "Sprite_World.h"
#endif

#ifndef __SPRITELAYER__
#include "Sprite_World_Sprite_Layer.h"
#endif

#ifndef __SPRITE__
#include "Sprite_World_Sprite.h"
#endif

#ifndef __FRAME__
#include "Sprite_World_Frame.h"
#endif


#ifndef SW_PASCAL
#define SW_PASCAL
#endif


///--------------------------------------------------------------------------------------
//	sprite utilities function prototypes
///--------------------------------------------------------------------------------------

#ifdef __cplusplus
extern "C" {
#endif

SW_PASCAL OSErr SWCreateBestCGrafPort(CGrafPtr *newCGrafPort, Rect *offScreenRect);
SW_PASCAL OSErr SWCreateCGrafPort(CGrafPtr *newCGrafPort, Rect *bounds, short depth, CTabHandle colors, GDHandle useGDevice);
SW_PASCAL OSErr SWCreateCGrafPortFromCIconMask(CGrafPtr *newCGrafPort, CIconHandle cIconH);
SW_PASCAL OSErr SWCreateCGrafPortFromPictResource(CGrafPtr *newCGrafPort, short pictResID);
SW_PASCAL OSErr SWCreateCGrafPortFromPict(CGrafPtr *newCGrafPort, PicHandle srcPictH);
SW_PASCAL OSErr SWSetUpPixMap(PixMapHandle aPixMap, short depth, Rect *bounds, CTabHandle colors, short bytesPerRow);
SW_PASCAL OSErr SWCreateGDevice(GDHandle *retGDevice, PixMapHandle basePixMap);
SW_PASCAL void SWDisposeCGrafPort(CGrafPtr doomedPort);

SW_PASCAL OSErr SWCreateGrafPort(GrafPtr *newPort, Rect *newPortRect);
SW_PASCAL OSErr SWCreateGrafPortFromPict(GrafPtr *offScrnPort, PicHandle srcPictH);
SW_PASCAL OSErr SWCreateGrafPortFromPictResource(GrafPtr *offScrnPort, short pictResID);
SW_PASCAL OSErr SWCreateGrafPortFromCIconMask(GrafPtr *newGrafPort, CIconHandle cIconH);
SW_PASCAL void SWDisposeGrafPort(GrafPtr doomedPort);

SW_PASCAL OSErr SWCreateRegionFromCIconMask(RgnHandle *maskRgn, CIconHandle cIconH);
SW_PASCAL OSErr SWCreateRegionFromPict(RgnHandle *pictRgnH, PicHandle srcPictH);
SW_PASCAL OSErr SWCreateRegionFromPictResource(RgnHandle *pictRgnH, short pictResID);

SW_PASCAL OSErr SWGetCIcon(CIconHandle* cIconH, short iconResID);
SW_PASCAL OSErr SWPlotCIcon(CIconHandle cIconH, Rect* iconRect);
SW_PASCAL void SWDisposeCIcon(CIconHandle cIconH);

SW_PASCAL OSErr SWCreateOptimumGWorld(GWorldPtr *optGWorld, Rect *devRect);
SW_PASCAL OSErr SWCreateGWorldFromPictResource(GWorldPtr *pictGWorldP, short pictResID);
SW_PASCAL OSErr SWCreateGWorldFromPict(GWorldPtr *pictGWorld, PicHandle srcPictH);
SW_PASCAL OSErr SWCreateGWorldFromCIconResource(GWorldPtr *iconGWorldP, short iconResID);
SW_PASCAL OSErr SWCreateGWorldFromCIcon(GWorldPtr *iconGWorldP, CIconHandle cIconH);
SW_PASCAL OSErr SWCreateGWorldFromCIconMask(GWorldPtr *maskGWorldP, CIconHandle cIconH);

SW_PASCAL Boolean SWHasColorQuickDraw(void);
SW_PASCAL Boolean SWHasGWorlds(void);

#ifdef __cplusplus
};
#endif


#endif /* __SPRITEWORLDUTILS__ */


