/* [Core_Globals.c] START OF FILE */

/* [---BEGIN---] FILE HEADER COMMENTS */

/**
 ** SCREEN VIEW = Adobe Syntax Black-10, Tabs=6
 ** PRINTER VIEW = Adobe Syntax Black -10, Tabs=0.30 inch
 ** ========================================================================
 ** Core_Globals 
 ** Written by Jim Merkle
 ** [Core_Globals.c] - Core_Globals is the global file for code related to Poor Man's Video Phone
 ** (C) Copyright 1991 by Jim Merkle
 ** All rights reserved, except those wishing to "copy" moderate sections of code or files may do so, so long as
 ** such code is never used directly either in animation-related tools or multimedia tools that are  
 ** used in live performance or live broadcast or recorded mass market broadcast or film. Desktop usage not restricted.
 ** Conventional desktop game or entertainment not restricted.
 ** ========================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 **
 **  1991.11.25		(James Merkle)
 **						Initial coding started, code transferred from 'main.h' and modified
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **
 **
 **
 **/

/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/

/* [---BEGIN---] FILE INCLUDE AREA */

#include "Memory_Utilities.h"
#include "Core_Globals.h" /* Non_Specific_Support_Routines */


/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */


/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */



/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */
#pragma mark PROTOTYPE_AREA


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */

Shell_Interactive_Globals_Rec		g_Shell;

/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

static CARDINAL_8				*unit_Name = "\pCore_Globals";

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Reset_Global_Library_Values_To_Defaults(Library_Globals_Ptr	globals)
{
	/*=--------------------------------------------------------------------=*/
	/* define black and white for copybits call */
	/*=--------------------------------------------------------------------=*/
	globals->color_Black.red = 0;
	globals->color_Black.green = 0;
	globals->color_Black.blue = 0;
	
	globals->color_White.red = 65535;
	globals->color_White.green = 65535;
	globals->color_White.blue = 65535;
	
	
	globals->application_Is_Frontmost = SAFE_TRUE;
	globals->use_Home_Made_Graphics_Primitives = TRUE;
	globals->force_Window_Alignment_To_32_Bits = TRUE;
	
	globals->initialized = SAFE_TRUE;
	
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Reset_Global_Interface_Values_To_Defaults(Interface_Globals_Ptr	globals)
{
SIMPLE_LOOP	index;
/* END VAR */


	globals->quit_Program = FALSE;
	globals->yield_Time = 1;
	globals->abort_Program = FALSE;
	globals->current_Graphics_Window = 0;
	globals->main_Menu_Bar = nil;
	globals->main_Menu_Bar_Memory_In_Use = MEMORY_NOT_INITIALIZED;

	for (index =0; (index < MENU_COUNT); index++) {
		g_Shell.interface.program_Menus[index] = nil;
	}

	globals->initialized = SAFE_TRUE;
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: Core_Globals.c */
