/* [Core_Globals.h] START OF FILE */

/* [---BEGIN---] FILE HEADER COMMENTS */

/**
 ** SCREEN VIEW = Adobe Syntax Black-10, Tabs=6
 ** PRINTER VIEW = Adobe Syntax Black -10, Tabs=0.30 inch
 ** ========================================================================
 ** Core_Globals (Core_Globals is the global file for code related to Poor Man's Video Phone)
 ** Written by Jim Merkle
 ** [Core_Globals.c] - Core_Globals is the global file for code related to Poor Man's Video Phone
 ** (C) Copyright 1991 by Jim Merkle
 ** ========================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 **
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **
 **
 **
 **/

/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#ifndef _H_Core_Globals

#define _H_Core_Globals
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include "Shell_Globals.h"
/* #include "Memory_Utilities.h" */

/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */
#pragma mark DEFINE_AREA


#define	DEFAULT_TEXT_FONT 		helvetica
#define	DEFAULT_TEXT_SIZE 		12
#define	HORIZONTAL_OFFSET 		10
#define	TEXT_LINE_SPACING			14


	/*  */
	/* All the information related to managing the menu */
	/*  */
	
#define	APPLE_MENU_ID				128
#define	FILE_MENU_ID				129
#define	EDIT_MENU_ID				130
#define	SPECIAL_MENU_ID			131
#define	ITEMS_MENU_ID				132
#define	BACKDROPS_MENU_ID		133
#define	WINDOWS_MENU_ID		134
#define	AUDIO_MENU_ID				135
#define	NETWORK_MENU_ID		136
#define	SLIDE_MENU_ID				137
#define	DEBUG_MENU_ID				138

#define	APPLE_MENU					0
#define	FILE_MENU					1
#define	EDIT_MENU					2
#define	SPECIAL_MENU				3
#define	ITEMS_MENU					4
#define	BACKDROPS_MENU			5
#define	WINDOWS_MENU			6
#define	AUDIO_MENU				7
#define	NETWORK_MENU			8
#define	SLIDE_MENU					9
#define	DEBUG_MENU				10

#define	MENU_COUNT				11


#define 	SHELL_MENU_BAR_ID		128

/*  */
/* COMMANDS FOR "APPLE_MENU" */
/*  */
#define	ABOUT_PROGRAM_ITEM			1

/*  */
/* COMMANDS FOR "FILE_MENU_ID" */
/*  */
#define	MENU_COMMAND_NEW_SCENE						1
#define	MENU_COMMAND_OPEN_SCENE 						2
#define	MENU_COMMAND_CLOSE_SCENE						3
#define	MENU_COMMAND_CLOSE_ALL_SCENE				4
#define	MENU_COMMAND_SAVE_SCENE						5
#define	MENU_COMMAND_SAVE_SCENE_AS					6

#define	MENU_COMMAND_PAGE_SETUP						8
#define	MENU_COMMAND_PAGE_PRINT						9
#define	MENU_COMMAND_PRINT_SAVED_FILES				10

#define	MENU_COMMAND_ADD_ITEM							12
#define	MENU_COMMAND_REMOVE_ITEM					13
#define	MENU_COMMAND_REPOSITION_ITEM				14
#define	MENU_COMMAND_CHANGE_BACKDROP				15

#define	MENU_COMMAND_LOAD_SELECT_SCENE			17
#define	MENU_COMMAND_SELECT_SCENE					18
#define	MENU_COMMAND_SELECT_NEXT_SCENE				19
#define	MENU_COMMAND_SELECT_PREVIOUS_SCENE		20

#define	MENU_COMMAND_RESCAN_FILES						22

#define	MENU_COMMAND_QUIT 								24

/*  */
/* COMMANDS FOR "EDIT_MENU" */
/*  */
#define	MENU_COMMAND_UNDO 								1

#define	MENU_COMMAND_CUT									3
#define	MENU_COMMAND_COPY 								4
#define	MENU_COMMAND_PASTE 								5
#define	MENU_COMMAND_CLEAR 								6

#define	MENU_COMMAND_SELECT_ALL 						8
#define	MENU_COMMAND_FIND		 						9

/*  */
/* COMMANDS FOR "SPECIAL_MENU" */
/*  */
#define	MENU_COMMAND_SET_DRAWING_PREFERENCE	1
#define	MENU_COMMAND_SET_WINDOW_ALIGNMENT		2

#define	MENU_COMMAND_GENERAL 		3

#define	MENU_COMMAND_TEST_RECT 	5
#define	WINDOW_TITLE_FOR_TEST_RECT	"\pFilled Rectangle Primitives Test"

#define	MENU_COMMAND_TEST_CIRCLE 	6
#define	WINDOW_TITLE_FOR_TEST_CIRCLE	"\pCircle Primitives Test"

#define	MENU_COMMAND_TEST_FILLED_CIRCLE 	7
#define	WINDOW_TITLE_FOR_TEST_FILLED_CIRCLE	"\pFilled Circle Primitives Test"

#define	MENU_COMMAND_TEST_ELIPSES 		8
#define	WINDOW_TITLE_FOR_TEST_ELIPSES	"\pOval Primitives Test"

#define	MENU_COMMAND_TEST_FILLED_ELIPSES 		9
#define	WINDOW_TITLE_FOR_TEST_FILLED_ELIPSES	"\pFilled Oval Primitives Test"

#define	MENU_COMMAND_TEST_LINE 		10
#define	WINDOW_TITLE_FOR_TEST_LINE	"\pLine Primitives Test"

#define	MENU_COMMAND_FRAMED_POLYGONS 	11
#define	WINDOW_TITLE_FOR_FRAMED_POLYGONS	"\pTime Framed Polygons, Line Clipped"

#define	MENU_COMMAND_TIME_LINE_SPEED 	12
#define	WINDOW_TITLE_FOR_TIME_LINE_SPEED	"\pTime Line Speed"

#define	MENU_COMMAND_TEST_THREE_D	13

#define	WINDOW_TITLE_FOR_THREE_D	"\p3-D Projection"

#define	WINDOW_TITLE_FOR_TEST_DREAMING	"\p"
#define	WINDOW_TITLE_FOR_CONTROLLER_WINDOW	"\pLocal Controls"

#define	WINDOW_TITLE_FOR_SPINNING_WINDOW	"\pPoor Man's Video Phone"


/*  */
/* COMMANDS FOR "ITEMS_MENU" */
/*  */
#define	MENU_COMMAND_LOAD_PUPPET				1
#define	MENU_COMMAND_CLOSE_PUPPET				2
#define	MENU_COMMAND_SAVE_PUPPET					3
#define	MENU_COMMAND_IMPORT_PUPPET				4
#define	MENU_COMMAND_EXPORT_PUPPET				5

#define	MENU_COMMAND_IMPORT_PROP				6
#define	MENU_COMMAND_EXPORT_PROP				7

#define	MENU_COMMAND_CREATE_PUPPET_VIA_SPINFILE			8
#define	MENU_COMMAND_ADD_ANPOTHER_SPINFILE				9

#define	MENU_COMMAND_TIME_VOICE						10

#define	MENU_COMMAND_LOAD_SPIN_OBJECT				12
#define	MENU_COMMAND_CLOSE_SPIN_OBJECT				13
#define	MENU_COMMAND_SAVE_SPIN_OBJECT				14
#define	MENU_COMMAND_IMPORT_SPIN_OBJECT			15
#define	MENU_COMMAND_EXPORT_SPIN_OBJECT			16
#define	MENU_COMMAND_RECOMPRESS_SPIN_OBJECT		17

#define	MENU_COMMAND_SET_LIFE_JIGGLE					19
#define	MENU_COMMAND_SET_SPIN_WINDOW_SIZE			20

/*  */
/* COMMANDS FOR "BACKDROPS_MENU" */
/*  */
#define	MENU_COMMAND_CLOSE_BACKDROP			1
#define	MENU_COMMAND_LOAD_BACKDROP			2
#define	MENU_COMMAND_SAVE_BACKDROP				3
#define	MENU_COMMAND_CONVERT_BACKDROP		4
#define	MENU_COMMAND_EXPORT_BACKDROP			5

/*  */
/* COMMANDS FOR "WINDOWS_MENU" */
/*  */
#define	MENU_COMMAND_SET_SCENE_AS_DEFAULT		1
#define	MENU_COMMAND_SHOW_CONTROLS			2
#define	MENU_COMMAND_SHOW_STATUS				3
#define	MENU_COMMAND_SHOW_ITEM_LIST				4
#define	MENU_COMMAND_SETUP_CHROMAKEY_LIST	5

#define	MENU_COMMAND_SELECT_TRANSITION_EFFECT	7
#define	MENU_COMMAND_FIRST_TRANSITION_EFFECT		8

#define	MENU_COMMAND_REPOSITION_BROADCAST	10
#define	MENU_COMMAND_BROADCAST_POSITIONS	11

#define	MENU_COMMAND_PLEASE_STAND_BY			13

/*  */
/* COMMANDS FOR "AUDIO_MENU" */
/*  */
#define	MENU_COMMAND_ASSOCIATE_TO_PUPPET		1

#define	MENU_COMMAND_MONITOR_REMOTE			3
#define	MENU_COMMAND_MONITOR_MICROPHONE	4
#define	MENU_COMMAND_MONITOR_PHONEBRIDGE	5

#define	MENU_COMMAND_MONITOR_SAMPLER			6
#define	MENU_COMMAND_MONITOR_MANUAL			7
#define	MENU_COMMAND_MONITOR_REAL_MIDI		8

	/* Record Item to titled AIFF */
#define	MENU_COMMAND_RECORD_TITLED_AIFF_FILE		10

	/* Record first item to titled AIFF */
#define	MENU_COMMAND_RECORD_AIFF_FILE				11

	/* Record now to untitled AIFF file */
#define	MENU_COMMAND_RECORD_UNTITLED_AIFF_FILE	12

#define	MENU_COMMAND_STOP_RECORDING_AIFF_FILE	13
#define	MENU_COMMAND_PLAY_AIFF_FILE					14

	/* Play last AIFF now (no Puppet) */
#define	MENU_COMMAND_PLAY_RECENT_AIFF_FILE			15

#define	MENU_COMMAND_STOP_PLAYING_AIFF_FILE		16

	/* Play AIFF through a Puppet */
#define	MENU_COMMAND_SWAP_VOICE_FOR_AIFF_FILE				17

	/* Play AIFF using first Puppet */
#define	MENU_COMMAND_SWAP_ASSUMED_VOICE_FOR_AIFF_FILE	18

/*  */
/* COMMANDS FOR "NETWORK_MENU" */
/*  */
#define	MENU_COMMAND_CONNECT						1
#define	MENU_COMMAND_DISCONNECT					2

#define	MENU_COMMAND_REMOTE_SELECT_SLIDE					4
#define	MENU_COMMAND_REMOTE_SELECT_NEXT_SLIDE			5
#define	MENU_COMMAND_REMOTE_SELECT_PREVIOUS_SLIDE		6
#define	MENU_COMMAND_REMOTE_HIDE_WINDOW				7

#define	MENU_COMMAND_REMOTE_RESCAN_FILES					9
#define	MENU_COMMAND_REMOTE_UPDATE_LIST					10

#define	MENU_COMMAND_REMOTE_QUIT 							12

#define	MENU_COMMAND_RESET_CONNECTION			14
#define	MENU_COMMAND_DISCONNECT_SELF			15
#define	MENU_COMMAND_SHOW_ZONES					16



/*  */
/* COMMANDS FOR "SLIDE_MENU_ID" */
/*  */
#define	MENU_COMMAND_ADD_SLIDE						1
#define	MENU_COMMAND_REMOVE_SLIDE 					2
#define	MENU_COMMAND_REMOVE_ALL_SLIDES			3

#define	MENU_COMMAND_SELECT_SLIDE						5
#define	MENU_COMMAND_SELECT_NEXT_SLIDE				6
#define	MENU_COMMAND_SELECT_PREVIOUS_SLIDE		7
#define	MENU_COMMAND_HIDE_WINDOW					8

#define	MENU_COMMAND_SET_WINDOW_SIZE				10



/*  */
/* COMMANDS FOR "DEBUG_MENU" */
/*  */
#define	MENU_COMMAND_SET_DEBUG_1					1
#define	MENU_COMMAND_SET_DEBUG_2					2
#define	MENU_COMMAND_SET_DEBUG_3					3
#define	MENU_COMMAND_SET_DEBUG_4					4


#define	DREAMING_WINDOW_ID 			129
#define	GENERAL_INFO_WINDOW_ID 		130
#define	WORKBENCH_WINDOW_ID 		131
#define	MAIN_CONTROLLER_WINDOW_ID 132
#define	NETWORK_ZONE_WINDOW_ID 	133
#define	MAIN_SPINNING_WINDOW_ID 		134


#define	k_ABOUT_COLOR_ID		(10496L)
#define	k_ABOUT_BW_ID				(10496L)

#define	k_ABOUT_STRING_LIST_ID	700


#define ALLOW_PURGING_HOOK					SAFE_TRUE
#define DISALLOW_PURGING_HOOK				SAFE_FALSE

#define ALLOW_PARTIAL_AMOUNT_HOOK		SAFE_TRUE
#define DISALLOW_PARTIAL_AMOUNT_HOOK	SAFE_FALSE

#define MOVE_HIGH_REQUIRED_HOOK			SAFE_TRUE
#define MOVE_HIGH_NOT_REQUIRED_HOOK		SAFE_FALSE



/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */
	
typedef struct{
	/*  */
	/* for when the program should go into a shutdown condition */
	/*  */
	Boolean					abort_Program;
	
	/*  */
	/* Similar to "abort_Program" and is usually set by user desiring "quit" */
	/*  */
	Boolean					quit_Program;
	
	/*  */
	/* This is used by waitnext event to control current desired yield level. */
	/*  */
	INTEGER_16				yield_Time;
	
	/*  */
	/* This is window interface index */
	/*  */
	CARDINAL_16			current_Graphics_Window;
	
	MenuHandle				program_Menus[MENU_COUNT];
	
	/*  */
	/* These control main MBAR resource */
	/* Not depeded on much yet. */
	/*  */
	Handle					main_Menu_Bar;
	Memory_Allocation		main_Menu_Bar_Memory_In_Use;
		
	Safe_Boolean				initialized;

}Interface_Globals_Rec, *Interface_Globals_Ptr;


typedef struct{

 		/*  */
		/* to determine if notification manager must be used instead of direct error messages */
		/*  */
	Safe_Boolean				application_Is_Frontmost; 

		/*  */
		/* When true, the user has allowed the windows to be aligned to 32 bit */
		/* screen locations. */
		/*  */
	Boolean					force_Window_Alignment_To_32_Bits;
	
		/*  */
		/* When the following is False, standard quickDraw routines would be called */
		/*  */
	Boolean					use_Home_Made_Graphics_Primitives;

	/*  */
	/* Having these two colors around helps speed up lots of things. */
	/*  */
	RGBColor					color_Black, color_White;


	/*  */
	/* Just a sentinel for safety. */
	/*  */
	Safe_Boolean				initialized;
	
}Library_Globals_Rec, *Library_Globals_Ptr;


typedef struct{
	Interface_Globals_Rec	interface;
	Library_Globals_Rec		library;
}Shell_Interactive_Globals_Rec;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */
#pragma mark PROTOTYPE_AREA

extern void Reset_Global_Library_Values_To_Defaults(Library_Globals_Ptr	globals);

extern void Reset_Global_Interface_Values_To_Defaults(Interface_Globals_Ptr	globals);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */

extern Shell_Interactive_Globals_Rec		g_Shell;


/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Core_Globals.h */
