/* [Application_Limits.h] START OF FILE */

/* [---BEGIN---] FILE HEADER COMMENTS */

/**
 ** SCREEN VIEW = Adobe Syntax Black-10, Tabs=6
 ** PRINTER VIEW = Adobe Syntax Black -10, Tabs=0.30 inch
 ** ========================================================================
 ** Application_Limits
 ** Written by Jim Merkle
 ** [Application_Limits.h] -  File containing arbitrary limits of application (especially RAM tradeoffs)
 ** (C) Copyright 1991 by Jim Merkle
 ** ========================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 **
 **  1994.06.03		(James Merkle)
 **						Initial definition started from scratch
 **
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **
 **
 **
 **/

/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#ifndef _H_Application_Limits

#define _H_Application_Limits
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */


/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */

/*  */
/* Changing these could affect file types for Puppets and scenes */
/*  */
#define k_MAXIMUM_PICS_FRAMES			100
#define k_MAX_STAGE_ITEMS					40

#define k_MAXIMUM_PUPPETS				50

/*  */
/* These can be changed at will */
/*  */
#define k_MAX_ACTIVE_SCENES				50
#define k_MAX_ACTIVE_BACKDROPS			50
#define k_MAX_ACTIVE_SPIN_OBJECTS		50

/*  */
/* WARNING! This number is related to "k_MAIN_CONTROLLER_TOTAL_ITEMS" */
/*  */
#define k_MAX_MAIN_CONTROLS					(74L)
#define k_SCROLLING_CONTROL_TOTAL			10

#define k_MAXIMUM_HORIZONTAL_JIGGLE_PIXELS			10
#define k_MAXIMUM_VERTICAL_JIGGLE_PIXELS				10

#define k_MAXIMUM_DATABASE_SCENES				200
#define k_MAXIMUM_DATABASE_PUPPETS				200
#define k_MAXIMUM_DATABASE_BACKDROPS			200
#define k_MAXIMUM_DATABASE_SPIN_OBJECTS		200
#define k_MAXIMUM_DATABASE_SOUND_OBJECTS		200


/*  */
/* Three large buffers are used. */
/* This allows erasure of one buffer while disk/dma related */
/* actions are occuring with the first (or if VBL waiting) */
/*  */
#define k_BACKGROUND_BUFFER	0
#define k_MIX_AREA_BUFFER_0	1
#define k_MIX_AREA_BUFFER_1	2

#define k_BUFFERS_REQUIRED			3
#define k_BASE_OFFSET_FOR_MIX		k_MIX_AREA_BUFFER_0



/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */
	

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */


/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Application_Limits.h */
