/* START OF FILE: Command_Control.c */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Command_Control.c - Command dispatcher, non menu based, window based
 ** (C) Copyright 1994 James Merkle
 ** 
 xxxx
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  1994.02.01		(James Merkle)
 **						Initial coding started
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **  bounce - hackup...
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "About.h"

#include "Error_Utilities.h"
#include "Memory_Utilities.h"
#include "Program_Globals.h"
#include "Shell_Assembly.h"
#include "String_Utilities.h"

#include "Graphics_Demos_Support.h"
#include "Graphics_Primitives.h"
#include "Interface_Utilities.h"

#include "Core_Globals.h"
#include "Core_Specific.h"
#include "Dreaming_Stuff.h"
#include "Core_Globals.h"
#include "Command_Redirector.h"

#include	"AsyncListManagerLib.h"

#include "Command_Control.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

#define k_LIST_CONTROL_0		45
#define k_LIST_CONTROL_1		47
#define k_LIST_CONTROL_2		49
#define k_LIST_CONTROL_3		51
#define k_LIST_CONTROL_4		53
#define k_LIST_CONTROL_5		55
#define k_LIST_CONTROL_6		57
#define k_LIST_CONTROL_7		59
#define k_LIST_CONTROL_8		61
#define k_LIST_CONTROL_9		63

#define k_LIST_CONTROL_0_TITLE		"\pSlates Available"
#define k_LIST_CONTROL_1_TITLE		"\pScenes Available"
#define k_LIST_CONTROL_2_TITLE		"\pScenes Loaded"
#define k_LIST_CONTROL_3_TITLE		"\pThat Scene's Items"
#define k_LIST_CONTROL_4_TITLE		"\pThat Item's Frames"
#define k_LIST_CONTROL_5_TITLE		"\pItems Available"
#define k_LIST_CONTROL_6_TITLE		"\pItems Loaded"
#define k_LIST_CONTROL_7_TITLE		"\pBackdrops Available"
#define k_LIST_CONTROL_8_TITLE		"\pBackdrops Loaded"
#define k_LIST_CONTROL_9_TITLE		"\pSound Files Available"

#define k_SLATES_AVAILABLE_LIST			0
#define k_SCENES_AVAILABLE_LIST			1
#define k_SCENES_LOADED_LIST				2
#define k_THAT_SCENES_ITEMS_LIST			3
#define k_THAT_ITEMS_FRAMES_LIST			4
#define k_ITEMS_AVAILABLE_LIST				5
#define k_ITEMS_LOADED_LIST				6
#define k_BACKDROPS_AVAILABLE_LIST		7
#define k_BACKDROPS_LOADED_LIST			8
#define k_SOUND_FILES_AVAILABLE_LIST		9


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */
															

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */


/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

static CARDINAL_8	*unit_Name;

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Initialize_Command_Control(void)
{
	CARDINAL_8			*static_Unit_Name = "\pCommand_Control";
/* END VAR */

/*  */
/* Global persistant structures are created here */
/*  */

	dream.main_Controls.initialized = SAFE_FALSE;
	dream.main_Controls.total_Controls = 0;
	dream.main_Controls.scrolling_Total = 0;
	dream.async_List_Manager_Initialized = SAFE_FALSE;

	unit_Name = static_Unit_Name;
	return(SAFE_TRUE);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Destroy_Command_Control(void)
{
	Safe_Boolean		function_Result;
/* END VAR */

/*  */
/* Global persistant structures are deleted here */
/*  */
	if (dream.main_Controls.initialized == SAFE_TRUE) {
	
	
	}
	
	if (dream.async_List_Manager_Initialized == SAFE_TRUE) {
		KillAsyncListManager();
		dream.async_List_Manager_Initialized = SAFE_FALSE;
	}
	
	dream.main_Controls.initialized = SAFE_FALSE;
	dream.main_Controls.total_Controls = 0;

	function_Result = SAFE_TRUE;
	return(function_Result);
}
/*=**************************************************************************=*/
	
	
/*=**************************************************************************=*/
Safe_Boolean	Select_Controller_And_Display_First_Time(void)
{
	Safe_Boolean		function_Result;
	SignedByte		status_Globals_State;
	WindowPtr		current_Graphics_Window_Ptr;
	CARDINAL_8		*code_Name;
	CARDINAL_32	control_Index;
	INTEGER_32		item_Number;
	INTEGER_16		item_Num;
	INTEGER_16		item_Type;
	Handle			item_Handle;
	OSErr				os_Error;
	Rect				item_Rect;
	Scrolling_List_Ptr	scroll_Ptr;
	DialogPtr			temp_Dialog;
	Str255				temp_String;
/* END VAR */


	function_Result = SAFE_FALSE;
	code_Name = "\pSelect_Controller_And_Display_First_Time";
	
	if (dream.main_Controls.initialized != SAFE_TRUE) {
	
		if (dream.async_List_Manager_Initialized != SAFE_TRUE) {
			InitializeAsyncListManager(kUseBandWScrolls);
			dream.async_List_Manager_Initialized = SAFE_TRUE;
		}

		dream.main_Controls.initialized = SAFE_FALSE;
		dream.main_Controls.total_Controls = 0;
		
		for(item_Number = 0; (item_Number < k_MAX_MAIN_CONTROLS); item_Number++) {
			SetRect(&(dream.main_Controls.control_Location[item_Number]), 0, 0, 1, 1);
			dream.main_Controls.control_Description[item_Number][0] = 0;
			dream.main_Controls.control_Value[item_Number] = 0;
			dream.main_Controls.control_Highlighted[item_Number] = FALSE;
			dream.main_Controls.control_Draw_Outline_Rect[item_Number] = TRUE;
		}


		for(item_Number = 0; (item_Number < k_SCROLLING_CONTROL_TOTAL); item_Number++) {
			dream.main_Controls.scroll[item_Number].list_Active = SAFE_FALSE;
			dream.main_Controls.scroll[item_Number].list_Handle = nil;
			dream.main_Controls.scroll[item_Number].list_Font = geneva;
			dream.main_Controls.scroll[item_Number].list_Font_Size = 9;
			dream.main_Controls.scroll[item_Number].list_Control_Reference = k_LIST_CONTROL_0;
		}

		dream.main_Controls.scroll[0].list_Control_Reference = k_LIST_CONTROL_0;
		dream.main_Controls.scroll[1].list_Control_Reference = k_LIST_CONTROL_1;
		dream.main_Controls.scroll[2].list_Control_Reference = k_LIST_CONTROL_2;
		dream.main_Controls.scroll[3].list_Control_Reference = k_LIST_CONTROL_3;
		dream.main_Controls.scroll[4].list_Control_Reference = k_LIST_CONTROL_4;
		dream.main_Controls.scroll[5].list_Control_Reference = k_LIST_CONTROL_5;
		dream.main_Controls.scroll[6].list_Control_Reference = k_LIST_CONTROL_6;
		dream.main_Controls.scroll[7].list_Control_Reference = k_LIST_CONTROL_7;
		dream.main_Controls.scroll[8].list_Control_Reference = k_LIST_CONTROL_8;
		dream.main_Controls.scroll[9].list_Control_Reference = k_LIST_CONTROL_9;

		Copy_Pascal_String(k_LIST_CONTROL_0_TITLE, &(dream.main_Controls.control_Description[k_LIST_CONTROL_0 - 1][0]));
		Copy_Pascal_String(k_LIST_CONTROL_1_TITLE, &(dream.main_Controls.control_Description[k_LIST_CONTROL_1 - 1][0]));
		Copy_Pascal_String(k_LIST_CONTROL_2_TITLE, &(dream.main_Controls.control_Description[k_LIST_CONTROL_2- 1][0]));
		Copy_Pascal_String(k_LIST_CONTROL_3_TITLE, &(dream.main_Controls.control_Description[k_LIST_CONTROL_3 - 1][0]));
		Copy_Pascal_String(k_LIST_CONTROL_4_TITLE, &(dream.main_Controls.control_Description[k_LIST_CONTROL_4 - 1][0]));
		Copy_Pascal_String(k_LIST_CONTROL_5_TITLE, &(dream.main_Controls.control_Description[k_LIST_CONTROL_5 - 1][0]));
		Copy_Pascal_String(k_LIST_CONTROL_6_TITLE, &(dream.main_Controls.control_Description[k_LIST_CONTROL_6 - 1][0]));
		Copy_Pascal_String(k_LIST_CONTROL_7_TITLE, &(dream.main_Controls.control_Description[k_LIST_CONTROL_7 - 1][0]));
		Copy_Pascal_String(k_LIST_CONTROL_8_TITLE, &(dream.main_Controls.control_Description[k_LIST_CONTROL_8 - 1][0]));
		Copy_Pascal_String(k_LIST_CONTROL_9_TITLE, &(dream.main_Controls.control_Description[k_LIST_CONTROL_9 - 1][0]));
	
		/*  */
		/* Scollbox Titles can be clicked upon to unselect selections, */
		/* but make them not look like buttons */
		/*  */
		
		dream.main_Controls.control_Draw_Outline_Rect[k_LIST_CONTROL_0 - 1] = FALSE;
		dream.main_Controls.control_Draw_Outline_Rect[k_LIST_CONTROL_1 - 1] = FALSE;
		dream.main_Controls.control_Draw_Outline_Rect[k_LIST_CONTROL_2 - 1] = FALSE;
		dream.main_Controls.control_Draw_Outline_Rect[k_LIST_CONTROL_3 - 1] = FALSE;
		dream.main_Controls.control_Draw_Outline_Rect[k_LIST_CONTROL_4 - 1] = FALSE;
		dream.main_Controls.control_Draw_Outline_Rect[k_LIST_CONTROL_5 - 1] = FALSE;
		dream.main_Controls.control_Draw_Outline_Rect[k_LIST_CONTROL_6 - 1] = FALSE;
		dream.main_Controls.control_Draw_Outline_Rect[k_LIST_CONTROL_7 - 1] = FALSE;
		dream.main_Controls.control_Draw_Outline_Rect[k_LIST_CONTROL_8 - 1] = FALSE;
		dream.main_Controls.control_Draw_Outline_Rect[k_LIST_CONTROL_9 - 1] = FALSE;

		temp_Dialog = GetNewDialog(k_MAIN_CONTROLLER_SPOOF_DITL, nil ,(WindowPtr)-1);	
			
		if (temp_Dialog != nil) {		
			for(item_Number = 0; (item_Number < k_MAIN_CONTROLLER_TOTAL_ITEMS); item_Number++) {
				item_Handle = nil;
				item_Type = 0x00FF;
				
				GetDItem(temp_Dialog, (item_Number + 1),&item_Type,&item_Handle,&item_Rect);
				/*  */
				/* Since user Items always have nil handles, two things are checked */
				/*  */
				if ((item_Handle != nil) || ((item_Type == 0) && (item_Handle == nil))){
					dream.main_Controls.control_Location[dream.main_Controls.total_Controls] = item_Rect;
					if ((item_Type & 0x007F) == statText) {
						GetIText(item_Handle, &temp_String[0]);
						if (temp_String[0] > 31) {
							temp_String[0] = 31;
						}
						Copy_Pascal_String(&temp_String[0], &(dream.main_Controls.control_Description[dream.main_Controls.total_Controls][0]));
					}
					dream.main_Controls.total_Controls += 1;
				}
			}
						
			DisposeDialog(temp_Dialog);
			
		}
		else {
			goto Error_Handler;
		}
		
	} /* if (dream.main_Controls.initialized != SAFE_TRUE) */
	
	Select_Graphics_Window(MAIN_CONTROLLER_WINDOW_INDEX);
	
	/*  */
	/* Lock down because structure content addresses are being passed */
	/*  */
	if (Begin_Use_Of_Handle((Handle) active_Window_List[MAIN_CONTROLLER_WINDOW_INDEX]
								, MOVE_HIGH_REQUIRED
								, &status_Globals_State) != SAFE_TRUE) {
								
		goto Error_Handler;
	}

	current_Graphics_Window_Ptr	= (**active_Window_List[MAIN_CONTROLLER_WINDOW_INDEX]).status_Window;

	SetWTitle(current_Graphics_Window_Ptr, (StringPtr)WINDOW_TITLE_FOR_CONTROLLER_WINDOW);
	
	if (dream.main_Controls.initialized != SAFE_TRUE) {
	
		for(item_Number = 0; (item_Number < k_SCROLLING_CONTROL_TOTAL); item_Number++) {
			scroll_Ptr = &dream.main_Controls.scroll[item_Number];
			
			control_Index = dream.main_Controls.scroll[item_Number].list_Control_Reference;
			
			dream.main_Controls.control_Draw_Outline_Rect[control_Index] = FALSE;

			scroll_Ptr->list_Rect = dream.main_Controls.control_Location[control_Index];
			
			os_Error = NewAsyncList(current_Graphics_Window_Ptr
											, &(scroll_Ptr->list_Rect)
											, scroll_Ptr->list_Font
											, scroll_Ptr->list_Font_Size
											, &(scroll_Ptr->list_Handle));
			if (os_Error == noErr) {
				scroll_Ptr->list_Active = SAFE_TRUE;
			}
		}
		
		dream.main_Controls.initialized = SAFE_TRUE;
		
	} /* if (dream.main_Controls.initialized != SAFE_TRUE) */
	
	if (Redraw_Controller_Completely(FALSE) == SAFE_TRUE) {
		/*  */
		/* Save window to a PICT for use during updates */
		/*  */
	}
										
	if (End_Use_Of_Handle((Handle) active_Window_List[MAIN_CONTROLLER_WINDOW_INDEX], status_Globals_State) != SAFE_TRUE) {
		goto Error_Handler;
	}
		
	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;

Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:
	return(function_Result);
		
} /* Safe_Boolean	Select_Controller_And_Display_First_Time... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Update_List_Information(CARDINAL_32 item_Number)
{
	Safe_Boolean		function_Result;
	Scrolling_List_Ptr	scroll_Ptr;
	CARDINAL_32	loop;
	Str255				temp_String;
	Str63				value_String;
	CARDINAL_8		*code_Name;
/* END VAR */


	function_Result = SAFE_FALSE;
	code_Name = "\pUpdate_List_Information";

	scroll_Ptr = &dream.main_Controls.scroll[item_Number];
	if (scroll_Ptr->list_Active == SAFE_TRUE) {
		
		switch(item_Number) {
		
/* =====
			case k_SLATES_AVAILABLE_LIST:
			break;
		
			case k_SCENES_AVAILABLE_LIST:
			break;
		
			case k_SCENES_LOADED_LIST:
			break;
		
			case k_THAT_SCENES_ITEMS_LIST:
			break;
		
			case k_THAT_ITEMS_FRAMES_LIST:
			break;
		
			case k_ITEMS_AVAILABLE_LIST:
			break;
		
			case k_ITEMS_LOADED_LIST:
			break;
		
			case k_BACKDROPS_AVAILABLE_LIST:
			break;
		
			case k_BACKDROPS_LOADED_LIST:
			break;
		
			case k_SOUND_FILES_AVAILABLE_LIST:
			break;
	==== */
	
			
			default:
				for(loop = 0; (loop < 30); loop++) {
				
					Copy_Pascal_String("\pTest String ", temp_String);
					NumToString((loop + 1L), value_String);
					Concat_String(temp_String, value_String);
					
					if (AddItemToAsyncList(scroll_Ptr->list_Handle, kInsertAtBottom, temp_String) != noErr) {
						SysBeep(20); 
						Assign_String(ns_Shell_Globals.error_Description_String, "\pError. AddItemToAsyncList failed");
						Assign_String(ns_Shell_Globals.error_Note_String, "\pProgrammer flaw");
						Display_Error_Message(unit_Name, code_Name);
						Setup_Error_Handling();
					}
				}
		
		} /* switch ... */
	}
	
	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;

Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:
	return(function_Result);
		
} /* Safe_Boolean Update_List_Information... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean	Redraw_Controller_Completely(Boolean actual_System_Update)
	/*  */
	/* Draws whole frame, not just deviance */
	/*  */
{
	Safe_Boolean		function_Result;
	SignedByte		status_Globals_State;
	Point				start_Point;
	Scrolling_List_Ptr	scroll_Ptr;
	INTEGER_32		control_Index;
	INTEGER_16		item_Number;
	FontInfo			font_Specs;
	WindowPtr		current_Graphics_Window_Ptr;
	Rect				temp_Rect;
	CARDINAL_8		*code_Name;
/* END VAR */


	function_Result = SAFE_FALSE;
	code_Name = "\pRedraw_Controller_Completely";

	if ((active_Window_List[MAIN_CONTROLLER_WINDOW_INDEX] == nil)
		|| ((**active_Window_List[MAIN_CONTROLLER_WINDOW_INDEX]).structure_Initialized != SAFE_TRUE)) {
		
		SysBeep(20); 
		Assign_String(ns_Shell_Globals.error_Description_String, "\pError. Improperly initialized window structure");
		Assign_String(ns_Shell_Globals.error_Note_String, "\pProgrammer flaw");
		Display_Error_Message(unit_Name, code_Name);
		Setup_Error_Handling();
		goto Error_Handler;
	}
	else {
	
		/*  */
		/* Lock down because structure content addresses are being passed */
		/*  */
		if (Begin_Use_Of_Handle((Handle) active_Window_List[MAIN_CONTROLLER_WINDOW_INDEX]
									, MOVE_HIGH_REQUIRED
									, &status_Globals_State) != SAFE_TRUE) {
									
			goto Error_Handler;
		}

		current_Graphics_Window_Ptr	= (**active_Window_List[MAIN_CONTROLLER_WINDOW_INDEX]).status_Window;
	}
	
	Set_View_Port(current_Graphics_Window_Ptr);

	ForeColor(blackColor);
	BackColor(whiteColor);
/* ===
	BackPat(&(qd.black));
=== */
	EraseRect(&(current_Graphics_Window_Ptr->portRect));
			

	TextFont(geneva);
	TextSize(9);
	GetFontInfo(&font_Specs);

	for (control_Index = 0; (control_Index < dream.main_Controls.total_Controls) ; control_Index++) {
				
		temp_Rect = dream.main_Controls.control_Location[control_Index];
		
		if (dream.main_Controls.control_Draw_Outline_Rect[control_Index] == TRUE) {
			FrameRect(&temp_Rect);
		}
		
		if (dream.main_Controls.control_Description[control_Index][0] != 0) {
			start_Point.v = temp_Rect.top + (temp_Rect.bottom - temp_Rect.top)/2
											+ (font_Specs.ascent)/2;
											
			start_Point.h = temp_Rect.left + (temp_Rect.right - temp_Rect.left)/2
											- StringWidth(dream.main_Controls.control_Description[control_Index])/2;
			
			MoveTo (start_Point.h, start_Point.v);
			DrawString (dream.main_Controls.control_Description[control_Index]);
		}
	}

	if (actual_System_Update != TRUE) {
		for (item_Number = 0; (item_Number < k_SCROLLING_CONTROL_TOTAL); item_Number++) {
			Update_List_Information(item_Number);
		}
	}

	for (item_Number = 0; (item_Number < k_SCROLLING_CONTROL_TOTAL); item_Number++) {
		scroll_Ptr = &dream.main_Controls.scroll[item_Number];
		if (scroll_Ptr->list_Active == SAFE_TRUE) {
			if (actual_System_Update == TRUE) {
				UpdateAsyncList(scroll_Ptr->list_Handle, FALSE);
			}
			else {
				UpdateAsyncList(scroll_Ptr->list_Handle, TRUE);
			}
		}
	}

	if (End_Use_Of_Handle((Handle) active_Window_List[MAIN_CONTROLLER_WINDOW_INDEX], status_Globals_State) != SAFE_TRUE) {
		goto Error_Handler;
	}

	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;

Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:
	return(function_Result);
		
} /* Safe_Boolean	Redraw_Controller_Completely ... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Process_Periodic_Async_List_Tasks(void)
{
	Safe_Boolean		function_Result;
	CARDINAL_32	item_Number;
	Scrolling_List_Ptr	scroll_Ptr;
/* END VAR */


	function_Result = SAFE_FALSE;

	if ((active_Window_List[MAIN_CONTROLLER_WINDOW_INDEX] == nil)
		|| ((**active_Window_List[MAIN_CONTROLLER_WINDOW_INDEX]).structure_Initialized != SAFE_TRUE)) {
		goto Error_Handler;
	}

	if (dream.main_Controls.initialized == SAFE_TRUE) {
		if ((Button() != 0) || (gAsyncListManagerEvent.wasMouseDown != 0)) {
			for (item_Number = 0; (item_Number < k_SCROLLING_CONTROL_TOTAL); item_Number++) {
				
				scroll_Ptr = &dream.main_Controls.scroll[item_Number];
				if (scroll_Ptr->list_Active == SAFE_TRUE) {
					ProcessAsyncListTask(scroll_Ptr->list_Handle);
				}
			}
		}
	}

	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;

Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:
	return(function_Result);
		
} /* Safe_Boolean	Process_Periodic_Async_List_Tasks ... */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: Command_Control.c */
