/* START OF FILE: Command_Dialogs.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Command_Dialogs.h - Header for Command_Dialogs.c
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Command_Dialogs.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Command_Dialogs

#define _H_Command_Dialogs
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"
#include "Command_Executor.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

	
/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


typedef struct {
	Boolean			use_Special_Colors;
	Boolean			import_Background;
	Boolean			compress_To_256_Colors;
	Boolean			ask_For_Special_CLUT;
	
	INTEGER_16		mode_Emotion_Value;
	Str255				mode_Emotion_Str255;
	
	INTEGER_16			position_Type_Vertical;
	
	CARDINAL_32		simple_Position_Vertical_Value;
	CARDINAL_32		multiple_Position_Stop_Vertical_Value;
	CARDINAL_32		multiple_Position_Start_Vertical_Value;
	CARDINAL_32		custom_Position_Vertical_Center_Value;
	CARDINAL_32		custom_Position_Vertical_1_Value;
	CARDINAL_32		custom_Position_Vertical_2_Value;
	CARDINAL_32		custom_Position_Vertical_3_Value;
	CARDINAL_32		custom_Position_Vertical_4_Value;
	CARDINAL_32		custom_Position_Vertical_5_Value;

	INTEGER_16			position_Type_Horizontal;
	
	CARDINAL_32		simple_Position_Horizontal_Value;
	CARDINAL_32		multiple_Position_Stop_Horizontal_Value;
	CARDINAL_32		multiple_Position_Start_Horizontal_Value;
	CARDINAL_32		custom_Position_Horizontal_Center_Value;
	CARDINAL_32		custom_Position_Horizontal_1_Value;
	CARDINAL_32		custom_Position_Horizontal_2_Value;
	CARDINAL_32		custom_Position_Horizontal_3_Value;
	CARDINAL_32		custom_Position_Horizontal_4_Value;
	CARDINAL_32		custom_Position_Horizontal_5_Value;

	INTEGER_16			position_Type_Roll;
	
	CARDINAL_32		simple_Position_Roll_Value;
	CARDINAL_32		multiple_Position_Stop_Roll_Value;
	CARDINAL_32		multiple_Position_Start_Roll_Value;
	CARDINAL_32		custom_Position_Roll_Center_Value;
	CARDINAL_32		custom_Position_Roll_1_Value;
	CARDINAL_32		custom_Position_Roll_2_Value;
	CARDINAL_32		custom_Position_Roll_3_Value;
	CARDINAL_32		custom_Position_Roll_4_Value;
	CARDINAL_32		custom_Position_Roll_5_Value;

}Import_Options, *Import_Options_Ptr;

/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Command_Dialogs(void);

extern Safe_Boolean Destroy_Command_Dialogs(void);

extern Boolean Get_New_Puppet_Information(CARDINAL_8 *puppet_File_Name
								, CARDINAL_8 *puppet_Short_Name
								, CARDINAL_8 *puppet_Description);

extern Boolean Edit_Fancy_Filename_Information(Str255 message
								, CARDINAL_8 *item_File_Name
								, CARDINAL_8 *item_Short_Name
								, CARDINAL_8 *item_Description);

extern Boolean Get_Import_Options(Import_Options_Ptr	options, CARDINAL_32 total_Picts);

extern Safe_Boolean Load_Puppet_Control_Preparation(Load_Puppet_Rec *params_For_Load_Puppet);

extern Safe_Boolean Load_Puppet_Menu_Preparation(Load_Puppet_Rec *params_For_Load_Puppet);

extern Safe_Boolean Close_Puppet_Control_Preparation(Close_Puppet_Rec *params_For_Close_Puppet);

extern Safe_Boolean Close_Puppet_Menu_Preparation(Close_Puppet_Rec *params_For_Close_Puppet);

extern Safe_Boolean Save_Puppet_Control_Preparation(Save_Puppet_Rec *params_For_Save_Puppet);

extern Safe_Boolean Save_Puppet_Menu_Preparation(Save_Puppet_Rec *params_For_Save_Puppet);

extern Safe_Boolean Import_Puppet_Control_Preparation(
	Import_Puppet_Rec *params_For_Import_Puppet);

extern Safe_Boolean Import_Puppet_Menu_Preparation(
	Import_Puppet_Rec *params_For_Import_Puppet);

extern Safe_Boolean Export_Puppet_Control_Preparation(
	Export_Puppet_Rec *params_For_Export_Puppet);
					
extern Safe_Boolean Create_Puppet_From_Spin_File_Control_Preparation(Import_Puppet_Rec	*params_For_Import_Puppet);

extern Safe_Boolean Create_Puppet_From_Spin_File_Menu_Preparation(Import_Puppet_Rec	*params_For_Import_Puppet);

extern Safe_Boolean Add_Another_Spin_File_To_Puppet_Control_Preparation(Add_Another_Spin_File_Rec	*params_For_Add_Another_Spin_File_To_Puppet);

extern Safe_Boolean Add_Another_Spin_File_To_Puppet_Menu_Preparation(Add_Another_Spin_File_Rec	*params_For_Add_Another_Spin_File_To_Puppet);

extern Safe_Boolean Set_Life_Jiggle_Control_Preparation(
					Set_Life_Jiggle_Rec	*params_For_Set_Life_Jiggle);
					
extern Safe_Boolean Set_Life_Jiggle_Control_Preparation(
					Set_Life_Jiggle_Rec	*Set_Life_Jiggle_Menu_Preparation);
					
extern Safe_Boolean Export_Puppet_Menu_Preparation(Export_Puppet_Rec *params_For_Export_Puppet);

extern Safe_Boolean Import_Prop_Control_Preparation(Import_Prop_Rec *params_For_Import_Prop);

extern Safe_Boolean Import_Prop_Menu_Preparation(Import_Prop_Rec *params_For_Import_Prop);

extern Safe_Boolean Export_Prop_Control_Preparation(Export_Prop_Rec *params_For_Export_Prop);

extern Safe_Boolean Export_Prop_Menu_Preparation(Export_Prop_Rec *params_For_Export_Prop);

extern Safe_Boolean Time_Animation_Control_Preparation(
	Time_Animation_Rec *params_For_Time_Animation);

extern Safe_Boolean Time_Animation_Menu_Preparation(
	Time_Animation_Rec *params_For_Time_Animation);

extern Safe_Boolean Close_Backdrop_Control_Preparation(
	Close_Backdrop_Rec *params_For_Close_Backdrop);

extern Safe_Boolean Close_Backdrop_Menu_Preparation(
	Close_Backdrop_Rec *params_For_Close_Backdrop);

extern Safe_Boolean Load_Backdrop_Control_Preparation(
	Load_Backdrop_Rec *params_For_Load_Backdrop);

extern Safe_Boolean Load_Backdrop_Menu_Preparation(
	Load_Backdrop_Rec *params_For_Load_Backdrop);

extern Safe_Boolean Save_Backdrop_Control_Preparation(
	Save_Backdrop_Rec *params_For_Save_Backdrop);

extern Safe_Boolean Save_Backdrop_Menu_Preparation(Save_Backdrop_Rec *params_For_Save_Backdrop);

extern Safe_Boolean Convert_Backdrop_Control_Preparation(
	Convert_Backdrop_Rec *params_For_Convert_Backdrop);

extern Safe_Boolean Convert_Backdrop_Menu_Preparation(
	Convert_Backdrop_Rec *params_For_Convert_Backdrop);

extern Safe_Boolean Export_Backdrop_Control_Preparation(
	Export_Backdrop_Rec *params_For_Export_Backdrop);

extern Safe_Boolean Export_Backdrop_Menu_Preparation(
	Export_Backdrop_Rec *params_For_Export_Backdrop);

extern Safe_Boolean Select_Scene_Control_Preparation(Select_Scene_Rec	*params_For_Select_Scene);

extern Safe_Boolean Select_Scene_Menu_Preparation(Select_Scene_Rec	*params_For_Select_Scene);

extern Safe_Boolean Select_Next_Scene_Control_Preparation(Select_Next_Scene_Rec	*params_For_Select_Next_Scene);

extern Safe_Boolean Select_Next_Scene_Menu_Preparation(Select_Next_Scene_Rec	*params_For_Select_Next_Scene);

extern Safe_Boolean Select_Previous_Scene_Control_Preparation(Select_Previous_Scene_Rec	*params_For_Select_Previous_Scene);

extern Safe_Boolean Select_Previous_Scene_Menu_Preparation(Select_Previous_Scene_Rec	*params_For_Select_Previous_Scene);

extern Safe_Boolean Show_Controls_Control_Preparation(
	Show_Controls_Rec *params_For_Show_Controls);

extern Safe_Boolean Show_Controls_Menu_Preparation(Show_Controls_Rec *params_For_Show_Controls);

extern Safe_Boolean Show_Status_Control_Preparation(Show_Status_Rec *params_For_Show_Status);

extern Safe_Boolean Show_Status_Menu_Preparation(Show_Status_Rec *params_For_Show_Status);

extern Safe_Boolean Show_Item_List_Control_Preparation(
	Show_Item_List_Rec *params_For_Show_Item_List);

extern Safe_Boolean Show_Item_List_Menu_Preparation(
	Show_Item_List_Rec *params_For_Show_Item_List);

extern Safe_Boolean Setup_Chromakey_Video_Control_Preparation(
	Setup_Chromakey_Video_Rec *params_For_Setup_Chromakey_Video);

extern Safe_Boolean Setup_Chromakey_Video_Menu_Preparation(
	Setup_Chromakey_Video_Rec *params_For_Setup_Chromakey_Video);

extern Safe_Boolean Repostition_For_Broadcast_Control_Preparation(
	Repostition_For_Broadcast_Rec *params_For_Repostition_For_Broadcast);

extern Safe_Boolean Repostition_For_Broadcast_Menu_Preparation(
	Repostition_For_Broadcast_Rec *params_For_Repostition_For_Broadcast);

extern Safe_Boolean Setup_Broadcast_Control_Preparation(
	Setup_Broadcast_Rec *params_For_Setup_Broadcast);

extern Safe_Boolean Setup_Broadcast_Menu_Preparation(
	Setup_Broadcast_Rec *params_For_Setup_Broadcast);

extern Safe_Boolean Associate_Voices_Control_Preparation(
	Associate_Voices_Rec *params_For_Associate_Voices);

extern Safe_Boolean Associate_Voices_Menu_Preparation(
	Associate_Voices_Rec *params_For_Associate_Voices);

extern Safe_Boolean Monitor_Remote_Control_Preparation(
	Monitor_Remote_Rec *params_For_Monitor_Remote);

extern Safe_Boolean Monitor_Remote_Menu_Preparation(
	Monitor_Remote_Rec *params_For_Monitor_Remote);

extern Safe_Boolean Monitor_Microphone_Control_Preparation(
	Monitor_Microphone_Rec *params_For_Monitor_Microphone);

extern Safe_Boolean Monitor_Microphone_Menu_Preparation(
	Monitor_Microphone_Rec *params_For_Monitor_Microphone);

extern Safe_Boolean Monitor_Using_Keyboard_Control_Preparation(
	Monitor_Using_Keyboard_Rec *params_For_Monitor_Using_Keyboard);

extern Safe_Boolean Monitor_Using_Keyboard_Menu_Preparation(
	Monitor_Using_Keyboard_Rec *params_For_Monitor_Using_Keyboard);

extern Safe_Boolean Monitor_Sampler_Control_Preparation(
	Monitor_Sampler_Rec *params_For_Monitor_Sampler);

extern Safe_Boolean Monitor_Sampler_Menu_Preparation(
	Monitor_Sampler_Rec *params_For_Monitor_Sampler);

extern Safe_Boolean Monitor_Phonebridge_Control_Preparation(Monitor_Phonebridge_Rec *params_For_Monitor_Phonebridge);

extern Safe_Boolean Monitor_Phonebridge_Menu_Preparation(Monitor_Phonebridge_Rec *params_For_Monitor_Phonebridge);

extern Safe_Boolean Reset_Connection_Control_Preparation(
	Reset_Connection_Rec *params_For_Reset_Connection);

extern Safe_Boolean Reset_Connection_Menu_Preparation(
	Reset_Connection_Rec *params_For_Reset_Connection);

extern Safe_Boolean Disconnect_Self_Control_Preparation(
	Disconnect_Self_Rec *params_For_Disconnect_Self);

extern Safe_Boolean Disconnect_Self_Menu_Preparation(
	Disconnect_Self_Rec *params_For_Disconnect_Self);

extern Safe_Boolean Set_Life_Jiggle_Menu_Preparation(Set_Life_Jiggle_Rec	*params_For_Set_Life_Jiggle);

extern Safe_Boolean Set_Life_Jiggle_Control_Preparation(Set_Life_Jiggle_Rec	*params_For_Set_Life_Jiggle);

extern Safe_Boolean Show_Zones_Control_Preparation(Show_Zones_Rec *params_For_Show_Zones);

extern Safe_Boolean Show_Zones_Menu_Preparation(Show_Zones_Rec *params_For_Show_Zones);

extern Safe_Boolean Create_Scene_Control_Preparation(Create_Scene_Rec *params_For_Create_Scene);

extern Safe_Boolean Create_Scene_Menu_Preparation(Create_Scene_Rec *params_For_Create_Scene);

extern Safe_Boolean Open_Scene_Control_Preparation(Open_Scene_Rec *params_For_Open_Scene);

extern Safe_Boolean Open_Scene_Menu_Preparation(Open_Scene_Rec *params_For_Open_Scene);

extern Safe_Boolean Close_Scenes_Control_Preparation(Close_Scenes_Rec *params_For_Close_Scenes);

extern Safe_Boolean Close_Scenes_Menu_Preparation(Close_Scenes_Rec *params_For_Close_Scenes);

extern Safe_Boolean Close_All_Scenes_Control_Preparation(
	Close_All_Scenes_Rec *params_For_Close_All_Scenes);

extern Safe_Boolean Close_All_Scenes_Menu_Preparation(
	Close_All_Scenes_Rec *params_For_Close_All_Scenes);

extern Safe_Boolean Save_Scene_Control_Preparation(Save_Scene_Rec *params_For_Save_Scene);

extern Safe_Boolean Save_Scene_Menu_Preparation(Save_Scene_Rec *params_For_Save_Scene);

extern Safe_Boolean Save_Scene_As_Control_Preparation(
	Save_Scene_As_Rec *params_For_Save_Scene_As);

extern Safe_Boolean Save_Scene_As_Menu_Preparation(Save_Scene_As_Rec *params_For_Save_Scene_As);

extern Safe_Boolean Page_Setup_Control_Preparation(Page_Setup_Rec *params_For_Page_Setup);

extern Safe_Boolean Page_Setup_Menu_Preparation(Page_Setup_Rec *params_For_Page_Setup);

extern Safe_Boolean Page_Print_Control_Preparation(Page_Print_Rec *params_For_Page_Print);

extern Safe_Boolean Page_Print_Menu_Preparation(Page_Print_Rec *params_For_Page_Print);

extern Safe_Boolean Print_Saved_Files_Control_Preparation(
	Print_Saved_Files_Rec *params_For_Print_Saved_Files);

extern Safe_Boolean Print_Saved_Files_Menu_Preparation(
	Print_Saved_Files_Rec *params_For_Print_Saved_Files);

extern Safe_Boolean Add_Item_Control_Preparation(Add_Item_Rec *params_For_Add_Item);

extern Safe_Boolean Add_Item_Menu_Preparation(Add_Item_Rec *params_For_Add_Item);

extern Safe_Boolean Remove_Item_Control_Preparation(Remove_Item_Rec *params_For_Remove_Item);

extern Safe_Boolean Remove_Item_Menu_Preparation(Remove_Item_Rec *params_For_Remove_Item);

extern Safe_Boolean Resposition_Item_Control_Preparation(
	Resposition_Item_Rec *params_For_Resposition_Item);

extern Safe_Boolean Resposition_Item_Menu_Preparation(
	Resposition_Item_Rec *params_For_Resposition_Item);

extern Safe_Boolean Change_Backdrop_Control_Preparation(
	Change_Backdrop_Rec *params_For_Change_Backdrop);

extern Safe_Boolean Change_Backdrop_Menu_Preparation(
	Change_Backdrop_Rec *params_For_Change_Backdrop);

extern Safe_Boolean Play_Audio_File_Control_Preparation(
	Play_Audio_File_Rec *params_For_Play_Audio_File);

extern Safe_Boolean Play_Audio_File_Menu_Preparation(
	Play_Audio_File_Rec *params_For_Play_Audio_File);

extern Safe_Boolean Swap_Voice_For_Audio_File_Control_Preparation(
	Swap_Voice_For_Audio_File_Rec	*params_For_Swap_Voice_For_Audio_File);

extern Safe_Boolean Swap_Voice_For_Audio_File_Menu_Preparation(
	Swap_Voice_For_Audio_File_Rec	*params_For_Swap_Voice_For_Audio_File);

extern Safe_Boolean Swap_Assumed_Voice_For_Audio_File_Control_Preparation(
	Swap_Voice_For_Audio_File_Rec	*params_For_Swap_Voice_For_Audio_File);

extern Safe_Boolean Swap_Assumed_Voice_For_Audio_File_Menu_Preparation(
	Swap_Voice_For_Audio_File_Rec	*params_For_Swap_Voice_For_Audio_File);


extern Safe_Boolean Rescan_Files_Control_Preparation(Rescan_Files_Rec *params_For_Rescan_Files);

extern Safe_Boolean Rescan_Files_Menu_Preparation(Rescan_Files_Rec *params_For_Rescan_Files);

extern Safe_Boolean Open_Slide_Control_Preparation(Open_Slide_Rec *params_For_Open_Slide);

extern Safe_Boolean Open_Slide_Menu_Preparation(Open_Slide_Rec *params_For_Open_Slide);

extern Safe_Boolean Close_Slides_Control_Preparation(Close_Slides_Rec *params_For_Close_Slides);

extern Safe_Boolean Close_Slides_Menu_Preparation(Close_Slides_Rec *params_For_Close_Slides);

extern Safe_Boolean Close_All_Slides_Control_Preparation(
	Close_All_Slides_Rec *params_For_Close_All_Slides);

extern Safe_Boolean Close_All_Slides_Menu_Preparation(
	Close_All_Slides_Rec *params_For_Close_All_Slides);

Safe_Boolean Select_Slide_Menu_Preparation(Select_Slide_Rec	*params_For_Select_Slide);

Safe_Boolean Select_Slide_Control_Preparation(Select_Slide_Rec	*params_For_Select_Slide);

Safe_Boolean Connect_Remote_Control_Preparation(Connect_Remote_Rec	*params_For_Connect_Remote);

Safe_Boolean Connect_Remote_Menu_Preparation(Connect_Remote_Rec	*params_For_Connect_Remote);

Safe_Boolean Disconnect_Remote_Control_Preparation(Disconnect_Remote_Rec	*params_For_Disconnect_Remote);

Safe_Boolean Disconnect_Remote_Menu_Preparation(Disconnect_Remote_Rec	*params_For_Disconnect_Remote);

Safe_Boolean Select_Remote_Control_Preparation(Select_Remote_Rec	*params_For_Select_Remote);

Safe_Boolean Select_Remote_Menu_Preparation(Select_Remote_Rec	*params_For_Select_Remote);

Safe_Boolean Select_Next_Remote_Control_Preparation(Select_Next_Remote_Rec	*params_For_Select_Next_Remote);

Safe_Boolean Select_Next_Remote_Menu_Preparation(Select_Next_Remote_Rec	*params_For_Select_Next_Remote);

Safe_Boolean Select_Previous_Remote_Control_Preparation(Select_Previous_Remote_Rec	*params_For_Select_Previous_Remote);

Safe_Boolean Select_Previous_Remote_Menu_Preparation(Select_Previous_Remote_Rec	*params_For_Select_Previous_Remote);

Safe_Boolean Rescan_Remote_Control_Preparation(Rescan_Remote_Rec	*params_For_Rescan_Remote);

Safe_Boolean Rescan_Remote_Menu_Preparation(Rescan_Remote_Rec	*params_For_Rescan_Remote);

Safe_Boolean Update_Remote_List_Control_Preparation(Update_Remote_List_Rec	*params_For_Update_Remote_List);

Safe_Boolean Update_Remote_List_Menu_Preparation(Update_Remote_List_Rec	*params_For_Update_Remote_List);

Safe_Boolean Play_Audio_File_Control_Preparation(Play_Audio_File_Rec	*params_For_Play_Audio_File);

Safe_Boolean Play_Audio_File_Menu_Preparation(Play_Audio_File_Rec	*params_For_Play_Audio_File);

Safe_Boolean Kill_Remote_Control_Preparation(Kill_Remote_Rec	*params_For_Kill_Remote);

Safe_Boolean Kill_Remote_Menu_Preparation(Kill_Remote_Rec	*params_For_Kill_Remote);

Safe_Boolean Change_Window_Size_Menu_Preparation(Change_Window_Size_Rec	*params_For_Change_Window_Size);

Safe_Boolean Change_Window_Size_Control_Preparation(Change_Window_Size_Rec	*params_For_Change_Window_Size);

Safe_Boolean Select_Transition_Control_Preparation(Select_Transition_Rec	*params_For_Select_Transition);

Safe_Boolean Select_Transition_Menu_Preparation(Select_Transition_Rec	*params_For_Select_Transition);

Safe_Boolean Select_First_Transition_Control_Preparation(Select_First_Transition_Rec	*params_For_Select_First_Transition);

Safe_Boolean Select_First_Transition_Menu_Preparation(Select_First_Transition_Rec	*params_For_Select_First_Transition);

Safe_Boolean Activate_Twitch_Control_Preparation(Activate_Twitch_Rec	*params_For_Activate_Twitch);

Safe_Boolean Activate_Twitch_Menu_Preparation(Activate_Twitch_Rec	*params_For_Activate_Twitch);

extern Safe_Boolean Load_Or_Select_Scene_Control_Preparation(Load_Or_Select_Scene_Rec	*params_For_Load_Or_Select_Scene);

extern Safe_Boolean Load_Or_Select_Scene_Menu_Preparation(Load_Or_Select_Scene_Rec	*params_For_Load_Or_Select_Scene);

extern Safe_Boolean Close_Spin_Object_Control_Preparation(Close_Spin_Object_Rec	*params_For_Close_Spin_Object);

extern Safe_Boolean Close_Spin_Object_Menu_Preparation(Close_Spin_Object_Rec	*params_For_Close_Spin_Object);

extern Safe_Boolean Load_Spin_Object_Control_Preparation(Load_Spin_Object_Rec	*params_For_Load_Spin_Object);

extern Safe_Boolean Load_Spin_Object_Menu_Preparation(Load_Spin_Object_Rec	*params_For_Load_Spin_Object);

extern Safe_Boolean Save_Spin_Object_Control_Preparation(Save_Spin_Object_Rec	*params_For_Save_Spin_Object);

extern Safe_Boolean Save_Spin_Object_Menu_Preparation(Save_Spin_Object_Rec	*params_For_Save_Spin_Object);

extern Safe_Boolean Convert_Spin_Object_Control_Preparation(Convert_Spin_Object_Rec	*params_For_Convert_Spin_Object);

extern Safe_Boolean Convert_Spin_Object_Menu_Preparation(Convert_Spin_Object_Rec	*params_For_Convert_Spin_Object);

extern Safe_Boolean Export_Spin_Object_Control_Preparation(Export_Spin_Object_Rec	*params_For_Export_Spin_Object);

extern Safe_Boolean Export_Spin_Object_Menu_Preparation(Export_Spin_Object_Rec	*params_For_Export_Spin_Object);

extern Safe_Boolean Recompress_Spin_Object_Menu_Preparation(Recompress_Spin_Object_Rec	*params_For_Recompress_Spin_Object);

extern Safe_Boolean Recompress_Spin_Object_Control_Preparation(Recompress_Spin_Object_Rec	*params_For_Recompress_Spin_Object);

extern Safe_Boolean Rescan_Files_Menu_Preparation(Rescan_Files_Rec	*params_For_Rescan_Files);

extern Safe_Boolean Rescan_Files_Control_Preparation(Rescan_Files_Rec	*params_For_Rescan_Files);

extern Safe_Boolean Stop_Playback_Of_All_AIFFs_Menu_Preparation(Stop_Playback_Of_All_AIFFs_Rec	*params_For_Stop_Playback_Of_All_AIFFs);

extern Safe_Boolean Stop_Playback_Of_All_AIFFs_Control_Preparation(Stop_Playback_Of_All_AIFFs_Rec	*params_For_Stop_Playback_Of_All_AIFFs);

extern Safe_Boolean Play_Last_Untitled_AIFF_Menu_Preparation(Play_Last_Untitled_AIFF_Rec	*params_For_Play_Last_Untitled_AIFF);

extern Safe_Boolean Play_Last_Untitled_AIFF_Control_Preparation(Play_Last_Untitled_AIFF_Rec	*params_For_Play_Last_Untitled_AIFF);

extern Safe_Boolean Stop_Recording_Any_Open_AIFF_Files_Menu_Preparation(Stop_Recording_Any_Open_AIFF_Files_Rec	*params_For_Stop_Recording_Any_Open_AIFF_Files);

extern Safe_Boolean Stop_Recording_Any_Open_AIFF_Files_Control_Preparation(Stop_Recording_Any_Open_AIFF_Files_Rec	*params_For_Stop_Recording_Any_Open_AIFF_Files);

extern Safe_Boolean Record_From_Any_To_Untitled_AIFF_Menu_Preparation(Record_From_Any_To_Untitled_AIFF_Rec	*params_For_Record_From_Any_To_Untitled_AIFF);

extern Safe_Boolean Record_From_Any_To_Untitled_AIFF_Control_Preparation(Record_From_Any_To_Untitled_AIFF_Rec	*params_For_Record_From_Any_To_Untitled_AIFF);

extern Safe_Boolean Record_From_Any_To_Titled_AIFF_Menu_Preparation(Record_From_Any_To_Titled_AIFF_Rec	*params_For_Record_From_Any_To_Titled_AIFF);

extern Safe_Boolean Record_From_Any_To_Titled_AIFF_Control_Preparation(Record_From_Any_To_Titled_AIFF_Rec	*params_For_Record_From_Any_To_Titled_AIFF);

extern Safe_Boolean Record_Titled_AIFF_File_Menu_Preparation(Record_Titled_AIFF_File_Rec	*params_For_Record_Titled_AIFF_File);

extern Safe_Boolean Record_Titled_AIFF_File_Control_Preparation(Record_Titled_AIFF_File_Rec	*params_For_Record_Titled_AIFF_File);

extern Safe_Boolean Monitor_Real_MIDI_Menu_Preparation(Monitor_Real_MIDI_Rec	*params_For_Monitor_Real_MIDI);

extern Safe_Boolean Monitor_Real_MIDI_Control_Preparation(Monitor_Real_MIDI_Rec	*params_For_Monitor_Real_MIDI);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Command_Dialogs.h */
