/* START OF FILE: Command_Executor.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Command_Executor.h - Header for Command_Executor.c
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Command_Executor.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Command_Executor

#define _H_Command_Executor
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

	
/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */

typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Load_Puppet_Rec;

typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Close_Puppet_Rec;

typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Save_Puppet_Rec;


typedef struct {
	Str63				puppet_File_Name;
	Str63				puppet_Short_Name;
	Str255				puppet_Description;
	Safe_Boolean		async_Task_Desired;
	
	CARDINAL_16	import_Source;

	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
}Import_Puppet_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Export_Puppet_Rec;


typedef struct {
	Str63				prop_File_Name;
	Str63				prop_Short_Name;
	Str255				prop_Description;
	Safe_Boolean		async_Task_Desired;
	
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
}Import_Prop_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Export_Prop_Rec;

typedef struct {
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Add_Another_Spin_File_Rec;


typedef struct {
	CARDINAL_32	desired_Item;
	Safe_Boolean		async_Task_Desired;
}Time_Animation_Rec;




typedef struct {
	INTEGER_16		horizontal_Jiggle_Maximum;
	INTEGER_16		vertical_Jiggle_Maximum;
	Safe_Boolean		jiggle_Enabled;
	Safe_Boolean		async_Task_Desired;
}Set_Life_Jiggle_Rec;


typedef struct {
	CARDINAL_32	desired_Backdrop;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Close_Backdrop_Rec;

typedef struct {
	CARDINAL_32	desired_Backdrop;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Load_Backdrop_Rec;


typedef struct {
	CARDINAL_32	desired_Backdrop;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Save_Backdrop_Rec;


typedef struct {
	CARDINAL_32	desired_Backdrop;
	FSSpec			desired_File;
	INTEGER_16		desired_Resource_Index;
	Safe_Boolean		file_Is_Pict_File_Type;
	Str255				desired_Name;
	CARDINAL_32	selected_Pict_Width;
	CARDINAL_32	selected_Pict_Height;
	Safe_Boolean		async_Task_Desired;
}Convert_Backdrop_Rec;


typedef struct {
	CARDINAL_32	desired_Backdrop;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Export_Backdrop_Rec;



typedef struct {
	CARDINAL_32	desired_Spin_Object;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Close_Spin_Object_Rec;

typedef struct {
	CARDINAL_32	desired_Spin_Object;
	FSSpec			desired_File;
	Safe_Boolean		load_File_With_Self_Contained_Large_Ports;
	Safe_Boolean		async_Task_Desired;
}Load_Spin_Object_Rec;

typedef struct {
	CARDINAL_32	desired_Spin_Object;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Save_Spin_Object_Rec;

typedef struct {
	CARDINAL_32	desired_Spin_Object;
	FSSpec			desired_File;
	FSSpec			output_Converted_File;
	INTEGER_16		desired_Resource_Index;
	Safe_Boolean		file_Is_Pict_File_Type;
	Str255				desired_Name;
	CARDINAL_32	selected_Pict_Width;
	CARDINAL_32	selected_Pict_Height;
	Safe_Boolean		async_Task_Desired;
}Convert_Spin_Object_Rec;

typedef struct {
	CARDINAL_32	desired_Spin_Object;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Export_Spin_Object_Rec;

typedef struct {
	CARDINAL_32	desired_Spin_Object;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Recompress_Spin_Object_Rec;

typedef struct {
	CARDINAL_32	desired_Scene;
	Safe_Boolean		async_Task_Desired;
}Select_Scene_Rec;

typedef struct {
	CARDINAL_32	desired_Scene;
	Safe_Boolean		async_Task_Desired;
}Load_Or_Select_Scene_Rec;

typedef struct {
	CARDINAL_32	desired_Direction;
	Safe_Boolean		async_Task_Desired;
}Select_Next_Scene_Rec;

typedef struct {
	CARDINAL_32	desired_Direction;
	Safe_Boolean		async_Task_Desired;
}Select_Previous_Scene_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Show_Controls_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Show_Status_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Show_Item_List_Rec;


typedef struct {
	CARDINAL_32	chroma_1;
	CARDINAL_32	chroma_2;
	CARDINAL_32	chroma_3;
	INTEGER_32		window_Index;
	Safe_Boolean		async_Task_Desired;
}Setup_Chromakey_Video_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Repostition_For_Broadcast_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Setup_Broadcast_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Associate_Voices_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Monitor_Remote_Rec;


typedef struct {
	Safe_Boolean 	select_Any_Input;
	Safe_Boolean		async_Task_Desired;
}Monitor_Microphone_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Monitor_Sampler_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Monitor_Using_Keyboard_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Monitor_Phonebridge_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Reset_Connection_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Disconnect_Self_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Show_Zones_Rec;


typedef struct {
	Str63				scene_File_Name;
	Str63				scene_Short_Name;
	Str255				scene_Description;
	Safe_Boolean		async_Task_Desired;
	Rect				desired_Scene_Size;
}Create_Scene_Rec;


typedef struct {
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
	
	CARDINAL_32	desired_Scene;
}Open_Scene_Rec;


typedef struct {
	CARDINAL_32	desired_Scene;
	Safe_Boolean		async_Task_Desired;
}Close_Scenes_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
}Close_All_Scenes_Rec;


typedef struct {
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
	
	CARDINAL_32	desired_Scene;
}Save_Scene_Rec;


typedef struct {
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
	
	CARDINAL_32	desired_Scene;
}Save_Scene_As_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Page_Setup_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Page_Print_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Print_Saved_Files_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Add_Item_Rec;


typedef struct {
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	Safe_Boolean		async_Task_Desired;
}Remove_Item_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Resposition_Item_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Backdrop;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Change_Backdrop_Rec;

typedef struct {
	CARDINAL_32	desired_Sound_Index;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Play_Audio_File_Rec;

typedef struct {
	CARDINAL_32	desired_Sound_Index;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
	Safe_Boolean		select_Arbitrary_First_Item;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
}Swap_Voice_For_Audio_File_Rec;


typedef struct {
	CARDINAL_32	value_1;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
}Rescan_Files_Rec;



typedef struct {
	Safe_Boolean		async_Task_Desired;
}Connect_Remote_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
}Disconnect_Remote_Rec;

typedef struct {
	CARDINAL_32	desired_Slide;
	Safe_Boolean		async_Task_Desired;
}Select_Remote_Rec;

typedef struct {
	CARDINAL_32	desired_Slide;
	Safe_Boolean		desired_Caller;
}Select_Caller_Scene_Rec;

typedef struct {
	CARDINAL_32	desired_Direction;
	Safe_Boolean		async_Task_Desired;
}Select_Next_Remote_Rec;

typedef struct {
	CARDINAL_32	desired_Direction;
	Safe_Boolean		async_Task_Desired;
}Select_Previous_Remote_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
	CARDINAL_32	window_Index;
	CARDINAL_32	window_Type;
	Rect				new_Rect;
}Change_Window_Size_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
	CARDINAL_32	transition_Desired;
}Select_Transition_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
	CARDINAL_32	transition_Desired;
}Select_First_Transition_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	CARDINAL_32	desired_Twitch;
}Activate_Twitch_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
}Rescan_Remote_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
}Update_Remote_List_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
}Kill_Remote_Rec;

typedef struct {
	CARDINAL_32	desired_Slide;
	Safe_Boolean		async_Task_Desired;
}Select_Slide_Rec;

typedef struct {
	CARDINAL_32	desired_Direction;
	Safe_Boolean		async_Task_Desired;
}Advance_Slide_Rec;

typedef struct {
	FSSpec			desired_File;
	Safe_Boolean		async_Task_Desired;
	
	CARDINAL_32	desired_Slide;
}Open_Slide_Rec;

typedef struct {
	CARDINAL_32	desired_Slide;
	Safe_Boolean		async_Task_Desired;
}Close_Slides_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
}Close_All_Slides_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
}Monitor_Real_MIDI_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
	CARDINAL_32	desired_Scene;
	CARDINAL_32	desired_Item;
	FSSpec			desired_File;
}Record_Titled_AIFF_File_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
	FSSpec			desired_File;
}Record_From_Any_To_Titled_AIFF_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
}Record_From_Any_To_Untitled_AIFF_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
}Stop_Recording_Any_Open_AIFF_Files_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
}Play_Last_Untitled_AIFF_Rec;

typedef struct {
	Safe_Boolean		async_Task_Desired;
}Stop_Playback_Of_All_AIFFs_Rec;


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Destroy_Command_Executor(void);

extern Safe_Boolean Initialize_Command_Executor(void);

extern Safe_Boolean Load_Puppet(Load_Puppet_Rec *params_For_Load_Puppet);

extern Safe_Boolean Close_Puppet(Close_Puppet_Rec *params_For_Close_Puppet);

extern Safe_Boolean Save_Puppet(Save_Puppet_Rec *params_For_Save_Puppet);

extern Safe_Boolean Import_Puppet(Import_Puppet_Rec *params_For_Import_Puppet);

extern Safe_Boolean Export_Puppet(Export_Puppet_Rec *params_For_Export_Puppet);

extern Safe_Boolean Import_Prop(Import_Prop_Rec *params_For_Import_Prop);

extern Safe_Boolean Export_Prop(Export_Prop_Rec *params_For_Export_Prop);

extern Safe_Boolean Time_Animation(Time_Animation_Rec *params_For_Time_Animation);

extern Safe_Boolean Close_Backdrop(Close_Backdrop_Rec *params_For_Close_Backdrop);

extern Safe_Boolean Load_Backdrop(Load_Backdrop_Rec *params_For_Load_Backdrop);

extern Safe_Boolean Save_Backdrop(Save_Backdrop_Rec *params_For_Save_Backdrop);

extern Safe_Boolean Convert_Backdrop(Convert_Backdrop_Rec *params_For_Convert_Backdrop);

extern Safe_Boolean Export_Backdrop(Export_Backdrop_Rec *params_For_Export_Backdrop);

extern Safe_Boolean Show_Controls(Show_Controls_Rec *params_For_Show_Controls);

extern Safe_Boolean Show_Status(Show_Status_Rec *params_For_Show_Status);

extern Safe_Boolean Show_Item_List(Show_Item_List_Rec *params_For_Show_Item_List);

extern Safe_Boolean Setup_Chromakey_Video(Setup_Chromakey_Video_Rec *params_For_Setup_Chromakey_Video);

extern Safe_Boolean Setup_Broadcast(Setup_Broadcast_Rec *params_For_Setup_Broadcast);

extern Safe_Boolean Associate_Voices(Associate_Voices_Rec *params_For_Associate_Voices);

extern Safe_Boolean Repostition_For_Broadcast(
	Repostition_For_Broadcast_Rec *params_For_Repostition_For_Broadcast);

extern Safe_Boolean Monitor_Remote(Monitor_Remote_Rec *params_For_Monitor_Remote);

extern Safe_Boolean Monitor_Microphone(Monitor_Microphone_Rec	*params_For_Monitor_Microphone);

extern Safe_Boolean Monitor_Sampler(Monitor_Sampler_Rec *params_For_Monitor_Sampler);

extern Safe_Boolean Monitor_Phonebridge(Monitor_Phonebridge_Rec *params_For_Monitor_Phonebridge);

extern Safe_Boolean Monitor_Using_Keyboard(
	Monitor_Using_Keyboard_Rec *params_For_Monitor_Using_Keyboard);

extern Safe_Boolean Reset_Connection(Reset_Connection_Rec *params_For_Reset_Connection);

extern Safe_Boolean Disconnect_Self(Disconnect_Self_Rec *params_For_Disconnect_Self);

extern Safe_Boolean Show_Zones(Show_Zones_Rec *params_For_Show_Zones);

extern Safe_Boolean Create_Scene(Create_Scene_Rec *params_For_Create_Scene);

extern Safe_Boolean Open_Scene(Open_Scene_Rec *params_For_Open_Scene);

extern Safe_Boolean Close_Scenes(Close_Scenes_Rec *params_For_Close_Scenes);

extern Safe_Boolean Close_All_Scenes(Close_All_Scenes_Rec *params_For_Close_All_Scenes);

extern Safe_Boolean Save_Scene(Save_Scene_Rec *params_For_Save_Scene);

extern Safe_Boolean Save_Scene_As(Save_Scene_As_Rec *params_For_Save_Scene_As);

extern Safe_Boolean Page_Setup(Page_Setup_Rec *params_For_Page_Setup);

extern Safe_Boolean Page_Print(Page_Print_Rec *params_For_Page_Print);

extern Safe_Boolean Add_Item(Add_Item_Rec *params_For_Add_Item);

extern Safe_Boolean Remove_Item(Remove_Item_Rec *params_For_Remove_Item);

extern Safe_Boolean Print_Saved_Files(Print_Saved_Files_Rec *params_For_Print_Saved_Files);

extern Safe_Boolean Resposition_Item(Resposition_Item_Rec *params_For_Resposition_Item);

extern Safe_Boolean Change_Backdrop(Change_Backdrop_Rec *params_For_Change_Backdrop);

extern Safe_Boolean Play_Audio_File(Play_Audio_File_Rec	*params_For_Play_Audio_File);

extern Safe_Boolean Swap_Voice_For_Audio_File(Swap_Voice_For_Audio_File_Rec	*params_For_Swap_Voice_For_Audio_File);

extern Safe_Boolean Select_Scene(Select_Scene_Rec *params_For_Select_Scene);

extern Safe_Boolean Select_Next_Scene(Select_Next_Scene_Rec	*params_For_Select_Next_Scene);

extern Safe_Boolean Select_Previous_Scene(Select_Previous_Scene_Rec	*params_For_Select_Previous_Scene);

extern Safe_Boolean Rescan_Files(Rescan_Files_Rec *params_For_Rescan_Files);

extern Safe_Boolean Set_Life_Jiggle(Set_Life_Jiggle_Rec	*params_For_Set_Life_Jiggle);

extern Safe_Boolean Open_Slide(Open_Slide_Rec *params_For_Open_Slide);

extern Safe_Boolean Close_Slides(Close_Slides_Rec *params_For_Close_Slides);

extern Safe_Boolean Close_All_Slides(Close_All_Slides_Rec *params_For_Close_All_Slides);

extern Safe_Boolean Select_New_Slide(Select_Slide_Rec *params_For_Select_Slide);

extern Safe_Boolean Advance_New_Slide(Advance_Slide_Rec *params_For_Advance_Slide);

extern Safe_Boolean Connect_Remote(Connect_Remote_Rec	*params_For_Connect_Remote);

extern Safe_Boolean Disconnect_Remote(Disconnect_Remote_Rec	*params_For_Disconnect_Remote);

extern Safe_Boolean Select_Remote(Select_Remote_Rec	*params_For_Select_Remote);

extern Safe_Boolean Select_Next_Remote(Select_Next_Remote_Rec	*params_For_Select_Next_Remote);

extern Safe_Boolean Select_Previous_Remote(Select_Previous_Remote_Rec	*params_For_Select_Previous_Remote);

extern Safe_Boolean Rescan_Remote(Rescan_Remote_Rec	*params_For_Rescan_Remote);

extern Safe_Boolean Update_Remote_List(Update_Remote_List_Rec	*params_For_Update_Remote_List);

extern Safe_Boolean Kill_Remote(Kill_Remote_Rec	*params_For_Kill_Remote);

extern Safe_Boolean Change_Window_Size(Change_Window_Size_Rec	*params_For_Change_Window_Size);

extern Safe_Boolean Hide_Slide_Window(void);

extern Safe_Boolean Hide_Remote_Slide_Window(void);

extern Safe_Boolean Activate_Twitch(Activate_Twitch_Rec	*params_For_Activate_Twitch);

extern Safe_Boolean Select_First_Transition(Select_First_Transition_Rec	*params_For_Select_First_Transition);

extern Safe_Boolean Select_Transition(Select_Transition_Rec	*params_For_Select_Transition);

extern Safe_Boolean Load_Or_Select_Scene(Load_Or_Select_Scene_Rec	*params_For_Load_Or_Select_Scene);

extern void Make_Scene_Default_Scene(void);

extern Safe_Boolean Close_Spin_Object(Close_Spin_Object_Rec	*params_For_Close_Spin_Object);

extern Safe_Boolean Load_Spin_Object(Load_Spin_Object_Rec	*params_For_Load_Spin_Object);

extern Safe_Boolean Save_Spin_Object(Save_Spin_Object_Rec	*params_For_Save_Spin_Object);

extern Safe_Boolean Convert_Spin_Object(Convert_Spin_Object_Rec	*params_For_Convert_Spin_Object);

extern Safe_Boolean Export_Spin_Object(Export_Spin_Object_Rec	*params_For_Export_Spin_Object);

extern Safe_Boolean Recompress_Spin_Object(Recompress_Spin_Object_Rec	*params_For_Recompress_Spin_Object);

extern Safe_Boolean Create_Puppet_From_Spin_File(Import_Puppet_Rec		*params_For_Import_Puppet);

extern Safe_Boolean Add_Another_Spin_File_To_Puppet(Add_Another_Spin_File_Rec		*params_For_Add_Another_Spin_File_To_Puppet);

extern Safe_Boolean Rescan_Files(Rescan_Files_Rec	*params_For_Rescan_Files);

extern Safe_Boolean Stop_Playback_Of_All_AIFFs(Stop_Playback_Of_All_AIFFs_Rec	*params_For_Stop_Playback_Of_All_AIFFs);

extern Safe_Boolean Play_Last_Untitled_AIFF(Play_Last_Untitled_AIFF_Rec	*params_For_Play_Last_Untitled_AIFF);

extern Safe_Boolean Stop_Recording_Any_Open_AIFF_Files(Stop_Recording_Any_Open_AIFF_Files_Rec	*params_For_Stop_Recording_Any_Open_AIFF_Files);

extern Safe_Boolean Record_From_Any_To_Untitled_AIFF(Record_From_Any_To_Untitled_AIFF_Rec	*params_For_Record_From_Any_To_Untitled_AIFF);

extern Safe_Boolean Record_From_Any_To_Titled_AIFF(Record_From_Any_To_Titled_AIFF_Rec	*params_For_Record_From_Any_To_Titled_AIFF);

extern Safe_Boolean Record_Titled_AIFF_File(Record_Titled_AIFF_File_Rec	*params_For_Record_Titled_AIFF_File);

extern Safe_Boolean Monitor_Real_MIDI(Monitor_Real_MIDI_Rec	*params_For_Monitor_Real_MIDI);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Command_Executor.h */
