/* START OF FILE: Command_Redirector.c */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Command_Redirector.c - Accepts control from menu, keyboard, remote control packets, control bar
 ** (C) Copyright 1994 James Merkle
 ** All rights reserved, except those wishing to "copy" moderate sections of code or files may do so, so long as
 ** such code is never used directly either in animation-related tools or multimedia tools that are  
 ** used in live performance or live broadcast or recorded mass market broadcast or film. Desktop usage not restricted.
 ** Conventional desktop game or entertainment not restricted.
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  1994.02.01		(James Merkle)
 **						Initial coding started
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **  
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */


#include "Command_Dialogs.h"
#include "Command_Executor.h"
#include "Spin_O_Rama_Files.h"
#include "Command_Redirector.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */


/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */
															

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] GLOBAL DEFINITION AREA */


/* [----END----] GLOBAL DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

static CARDINAL_8	*unit_Name;

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Initialize_Command_Redirector(void)
{
	CARDINAL_8			*static_Unit_Name = "\pCommand_Redirector";
/* END VAR */

/*  */
/* Global persistant structures are created here */
/*  */

	unit_Name = static_Unit_Name;
	return(SAFE_TRUE);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Destroy_Command_Redirector(void)
{
	Safe_Boolean		function_Result;
/* END VAR */

/*  */
/* Global persistant structures are deleted here */
/*  */

	function_Result = SAFE_TRUE;
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Load_Puppet_Using_Menu(void)
{
	Load_Puppet_Rec		params_For_Load_Puppet;
/* END VAR */


	if (Load_Puppet_Menu_Preparation(&params_For_Load_Puppet) == SAFE_TRUE) {
		if (Load_Puppet(&params_For_Load_Puppet) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Load_Puppet_Using_Controller(void)
{
	Load_Puppet_Rec	params_For_Load_Puppet;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Load_Puppet_Control_Preparation(&params_For_Load_Puppet) == SAFE_TRUE) {
		if (Load_Puppet(&params_For_Load_Puppet) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Close_Puppet_Using_Menu(void)
{
Close_Puppet_Rec		params_For_Close_Puppet;
/* END VAR */


	if (Close_Puppet_Menu_Preparation(&params_For_Close_Puppet) == SAFE_TRUE) {
		if (Close_Puppet(&params_For_Close_Puppet) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Close_Puppet_Using_Controller(void)
{
	Close_Puppet_Rec	params_For_Close_Puppet;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Close_Puppet_Control_Preparation(&params_For_Close_Puppet) == SAFE_TRUE) {
		if (Close_Puppet(&params_For_Close_Puppet) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Save_Puppet_Using_Menu(void)
{
Save_Puppet_Rec		params_For_Save_Puppet;
/* END VAR */


	if (Save_Puppet_Menu_Preparation(&params_For_Save_Puppet) == SAFE_TRUE) {
		if (Save_Puppet(&params_For_Save_Puppet) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Save_Puppet_Using_Controller(void)
{
	Save_Puppet_Rec	params_For_Save_Puppet;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Save_Puppet_Control_Preparation(&params_For_Save_Puppet) == SAFE_TRUE) {
		if (Save_Puppet(&params_For_Save_Puppet) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Import_Puppet_Using_Menu(void)
{
Import_Puppet_Rec		params_For_Import_Puppet;
/* END VAR */


	if (Import_Puppet_Menu_Preparation(&params_For_Import_Puppet) == SAFE_TRUE) {
		if (Import_Puppet(&params_For_Import_Puppet) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Import_Puppet_Using_Controller(void)
{
	Import_Puppet_Rec	params_For_Import_Puppet;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Import_Puppet_Control_Preparation(&params_For_Import_Puppet) == SAFE_TRUE) {
		if (Import_Puppet(&params_For_Import_Puppet) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Create_Puppet_From_Spin_File_Using_Menu(void)
{
Import_Puppet_Rec		params_For_Import_Puppet;
/* END VAR */


	if (Create_Puppet_From_Spin_File_Menu_Preparation(&params_For_Import_Puppet) == SAFE_TRUE) {
		if (Create_Puppet_From_Spin_File(&params_For_Import_Puppet) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Create_Puppet_From_Spin_File_Using_Controller(void)
{
	Import_Puppet_Rec	params_For_Import_Puppet;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Create_Puppet_From_Spin_File_Control_Preparation(&params_For_Import_Puppet) == SAFE_TRUE) {
		if (Create_Puppet_From_Spin_File(&params_For_Import_Puppet) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Add_Another_Spin_File_To_Puppet_Using_Menu(void)
{
Add_Another_Spin_File_Rec		params_For_Add_Another_Spin_File_To_Puppet;
/* END VAR */


	if (Add_Another_Spin_File_To_Puppet_Menu_Preparation(&params_For_Add_Another_Spin_File_To_Puppet) == SAFE_TRUE) {
		if (Add_Another_Spin_File_To_Puppet(&params_For_Add_Another_Spin_File_To_Puppet) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Add_Another_Spin_File_To_Puppet_Using_Controller(void)
{
	Add_Another_Spin_File_Rec	params_For_Add_Another_Spin_File_To_Puppet;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Add_Another_Spin_File_To_Puppet_Control_Preparation(&params_For_Add_Another_Spin_File_To_Puppet) == SAFE_TRUE) {
		if (Add_Another_Spin_File_To_Puppet(&params_For_Add_Another_Spin_File_To_Puppet) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Export_Puppet_Using_Menu(void)
{
Export_Puppet_Rec		params_For_Export_Puppet;
/* END VAR */


	if (Export_Puppet_Menu_Preparation(&params_For_Export_Puppet) == SAFE_TRUE) {
		if (Export_Puppet(&params_For_Export_Puppet) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Export_Puppet_Using_Controller(void)
{
	Export_Puppet_Rec	params_For_Export_Puppet;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Export_Puppet_Control_Preparation(&params_For_Export_Puppet) == SAFE_TRUE) {
		if (Export_Puppet(&params_For_Export_Puppet) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Import_Prop_Using_Menu(void)
{
Import_Prop_Rec		params_For_Import_Prop;
/* END VAR */


	if (Import_Prop_Menu_Preparation(&params_For_Import_Prop) == SAFE_TRUE) {
		if (Import_Prop(&params_For_Import_Prop) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Import_Prop_Using_Controller(void)
{
	Import_Prop_Rec		params_For_Import_Prop;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Import_Prop_Control_Preparation(&params_For_Import_Prop) == SAFE_TRUE) {
		if (Import_Prop(&params_For_Import_Prop) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Export_Prop_Using_Menu(void)
{
Export_Prop_Rec		params_For_Export_Prop;
/* END VAR */


	if (Export_Prop_Menu_Preparation(&params_For_Export_Prop) == SAFE_TRUE) {
		if (Export_Prop(&params_For_Export_Prop) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Export_Prop_Using_Controller(void)
{
	Export_Prop_Rec	params_For_Export_Prop;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Export_Prop_Control_Preparation(&params_For_Export_Prop) == SAFE_TRUE) {
		if (Export_Prop(&params_For_Export_Prop) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Time_Animation_Using_Menu(void)
{
Time_Animation_Rec		params_For_Time_Animation;
/* END VAR */


	if (Time_Animation_Menu_Preparation(&params_For_Time_Animation) == SAFE_TRUE) {
		if (Time_Animation(&params_For_Time_Animation) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Time_Animation_Using_Controller(void)
{
	Time_Animation_Rec	params_For_Time_Animation;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Time_Animation_Control_Preparation(&params_For_Time_Animation) == SAFE_TRUE) {
		if (Time_Animation(&params_For_Time_Animation) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Set_Life_Jiggle_Using_Menu(void)
{
Set_Life_Jiggle_Rec		params_For_Set_Life_Jiggle;
/* END VAR */


	if (Set_Life_Jiggle_Menu_Preparation(&params_For_Set_Life_Jiggle) == SAFE_TRUE) {
		if (Set_Life_Jiggle(&params_For_Set_Life_Jiggle) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Set_Life_Jiggle_Using_Controller(void)
{
	Set_Life_Jiggle_Rec	params_For_Set_Life_Jiggle;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Set_Life_Jiggle_Control_Preparation(&params_For_Set_Life_Jiggle) == SAFE_TRUE) {
		if (Set_Life_Jiggle(&params_For_Set_Life_Jiggle) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Close_Backdrop_Using_Menu(void)
{
Close_Backdrop_Rec		params_For_Close_Backdrop;
/* END VAR */


	if (Close_Backdrop_Menu_Preparation(&params_For_Close_Backdrop) == SAFE_TRUE) {
		if (Close_Backdrop(&params_For_Close_Backdrop) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Close_Backdrop_Using_Controller(void)
{
	Close_Backdrop_Rec	params_For_Close_Backdrop;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Close_Backdrop_Control_Preparation(&params_For_Close_Backdrop) == SAFE_TRUE) {
		if (Close_Backdrop(&params_For_Close_Backdrop) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Load_Backdrop_Using_Menu(void)
{
Load_Backdrop_Rec		params_For_Load_Backdrop;
/* END VAR */


	if (Load_Backdrop_Menu_Preparation(&params_For_Load_Backdrop) == SAFE_TRUE) {
		if (Load_Backdrop(&params_For_Load_Backdrop) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Load_Backdrop_Using_Controller(void)
{
	Load_Backdrop_Rec	params_For_Load_Backdrop;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Load_Backdrop_Control_Preparation(&params_For_Load_Backdrop) == SAFE_TRUE) {
		if (Load_Backdrop(&params_For_Load_Backdrop) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Save_Backdrop_Using_Menu(void)
{
Save_Backdrop_Rec		params_For_Save_Backdrop;
/* END VAR */


	if (Save_Backdrop_Menu_Preparation(&params_For_Save_Backdrop) == SAFE_TRUE) {
		if (Save_Backdrop(&params_For_Save_Backdrop) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Save_Backdrop_Using_Controller(void)
{
	Save_Backdrop_Rec	params_For_Save_Backdrop;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Save_Backdrop_Control_Preparation(&params_For_Save_Backdrop) == SAFE_TRUE) {
		if (Save_Backdrop(&params_For_Save_Backdrop) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Convert_Backdrop_Using_Menu(void)
{
Convert_Backdrop_Rec		params_For_Convert_Backdrop;
/* END VAR */


	if (Convert_Backdrop_Menu_Preparation(&params_For_Convert_Backdrop) == SAFE_TRUE) {
		if (Convert_Backdrop(&params_For_Convert_Backdrop) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Convert_Backdrop_Using_Controller(void)
{
	Convert_Backdrop_Rec	params_For_Convert_Backdrop;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Convert_Backdrop_Control_Preparation(&params_For_Convert_Backdrop) == SAFE_TRUE) {
		if (Convert_Backdrop(&params_For_Convert_Backdrop) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Export_Backdrop_Using_Menu(void)
{
Export_Backdrop_Rec		params_For_Export_Backdrop;
/* END VAR */


	if (Export_Backdrop_Menu_Preparation(&params_For_Export_Backdrop) == SAFE_TRUE) {
		if (Export_Backdrop(&params_For_Export_Backdrop) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Export_Backdrop_Using_Controller(void)
{
	Export_Backdrop_Rec	params_For_Export_Backdrop;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Export_Backdrop_Control_Preparation(&params_For_Export_Backdrop) == SAFE_TRUE) {
		if (Export_Backdrop(&params_For_Export_Backdrop) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Close_Spin_Object_Using_Menu(void)
{
Close_Spin_Object_Rec		params_For_Close_Spin_Object;
/* END VAR */


	if (Close_Spin_Object_Menu_Preparation(&params_For_Close_Spin_Object) == SAFE_TRUE) {
		if (Close_Spin_Object(&params_For_Close_Spin_Object) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Close_Spin_Object_Using_Controller(void)
{
	Close_Spin_Object_Rec	params_For_Close_Spin_Object;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Close_Spin_Object_Control_Preparation(&params_For_Close_Spin_Object) == SAFE_TRUE) {
		if (Close_Spin_Object(&params_For_Close_Spin_Object) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Load_Spin_Object_Using_Menu(void)
{
Load_Spin_Object_Rec		params_For_Load_Spin_Object;
/* END VAR */


	if (Load_Spin_Object_Menu_Preparation(&params_For_Load_Spin_Object) == SAFE_TRUE) {
		if (Load_Spin_Object(&params_For_Load_Spin_Object) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Load_Spin_Object_Using_Controller(void)
{
	Load_Spin_Object_Rec	params_For_Load_Spin_Object;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Load_Spin_Object_Control_Preparation(&params_For_Load_Spin_Object) == SAFE_TRUE) {
		if (Load_Spin_Object(&params_For_Load_Spin_Object) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Save_Spin_Object_Using_Menu(void)
{
Save_Spin_Object_Rec		params_For_Save_Spin_Object;
/* END VAR */


	if (Save_Spin_Object_Menu_Preparation(&params_For_Save_Spin_Object) == SAFE_TRUE) {
		if (Save_Spin_Object(&params_For_Save_Spin_Object) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Save_Spin_Object_Using_Controller(void)
{
	Save_Spin_Object_Rec	params_For_Save_Spin_Object;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Save_Spin_Object_Control_Preparation(&params_For_Save_Spin_Object) == SAFE_TRUE) {
		if (Save_Spin_Object(&params_For_Save_Spin_Object) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Convert_Spin_Object_Using_Menu(void)
{
Convert_Spin_Object_Rec		params_For_Convert_Spin_Object;
	Safe_Boolean			user_Abort;
/* END VAR */


	if (Convert_Spin_Object_Menu_Preparation(&params_For_Convert_Spin_Object) == SAFE_TRUE) {
	
		params_For_Convert_Spin_Object.output_Converted_File = params_For_Convert_Spin_Object.desired_File;
	
		if (Specify_Spin_Object_To_Save(&(params_For_Convert_Spin_Object.output_Converted_File)
												, &(params_For_Convert_Spin_Object.desired_File.name)
												, &user_Abort) != SAFE_TRUE) {
			goto Error_Handler;
		}
		else {
			if (user_Abort == SAFE_TRUE) {
				goto Error_Handler;
			}
		}
	
		if (Convert_Spin_Object(&params_For_Convert_Spin_Object) != SAFE_TRUE) {
			goto Error_Handler;
		}
		
		
	/* ===	
		Copy_Pascal_String(params_For_Convert_Spin_Object.output_Converted_File.name
				, ((**(dream.spin_Objects.spin_Object[params_For_Convert_Spin_Object.desired_Spin_Object])).spin_Object_Name));

		params_For_Convert_Spin_Object.desired_File = params_For_Convert_Spin_Object.output_Converted_File;
	=== */
	
	}
	
	
Error_Handler:
	;
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Convert_Spin_Object_Using_Controller(void)
{
	Convert_Spin_Object_Rec	params_For_Convert_Spin_Object;
	Safe_Boolean			function_Result;
	Safe_Boolean			user_Abort;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	
	if (Convert_Spin_Object_Control_Preparation(&params_For_Convert_Spin_Object) == SAFE_TRUE) {
	
		params_For_Convert_Spin_Object.output_Converted_File = params_For_Convert_Spin_Object.desired_File;
	
		if (Specify_Spin_Object_To_Save(&(params_For_Convert_Spin_Object.output_Converted_File)
												, &(params_For_Convert_Spin_Object.desired_File.name)
												, &user_Abort) != SAFE_TRUE) {
			goto Error_Handler;
		}
		else {
			if (user_Abort == SAFE_TRUE) {
				goto Error_Handler;
			}
		}
	
	
		if (Convert_Spin_Object(&params_For_Convert_Spin_Object) != SAFE_TRUE) {
			goto Error_Handler;
		}
		
		
	/* ===	
		Copy_Pascal_String(params_For_Convert_Spin_Object.output_Converted_File.name
				, ((**(dream.spin_Objects.spin_Object[params_For_Convert_Spin_Object.desired_Spin_Object])).spin_Object_Name));

		params_For_Convert_Spin_Object.desired_File = params_For_Convert_Spin_Object.output_Converted_File;
	=== */
		
	}
	
	function_Result = SAFE_TRUE;
	goto Normal_Function_Exit;
	
Error_Handler:
	function_Result = SAFE_FALSE;
		
Normal_Function_Exit:

	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Export_Spin_Object_Using_Menu(void)
{
Export_Spin_Object_Rec		params_For_Export_Spin_Object;
/* END VAR */


	if (Export_Spin_Object_Menu_Preparation(&params_For_Export_Spin_Object) == SAFE_TRUE) {
		if (Export_Spin_Object(&params_For_Export_Spin_Object) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Export_Spin_Object_Using_Controller(void)
{
	Export_Spin_Object_Rec	params_For_Export_Spin_Object;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Export_Spin_Object_Control_Preparation(&params_For_Export_Spin_Object) == SAFE_TRUE) {
		if (Export_Spin_Object(&params_For_Export_Spin_Object) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Recompress_Spin_Object_Using_Menu(void)
{
Recompress_Spin_Object_Rec		params_For_Recompress_Spin_Object;
/* END VAR */


	if (Recompress_Spin_Object_Menu_Preparation(&params_For_Recompress_Spin_Object) == SAFE_TRUE) {
		if (Recompress_Spin_Object(&params_For_Recompress_Spin_Object) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Recompress_Spin_Object_Using_Controller(void)
{
	Recompress_Spin_Object_Rec	params_For_Recompress_Spin_Object;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Recompress_Spin_Object_Control_Preparation(&params_For_Recompress_Spin_Object) == SAFE_TRUE) {
		if (Recompress_Spin_Object(&params_For_Recompress_Spin_Object) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Controls_Using_Menu(void)
{
Show_Controls_Rec		params_For_Show_Controls;
/* END VAR */


	if (Show_Controls_Menu_Preparation(&params_For_Show_Controls) == SAFE_TRUE) {
		if (Show_Controls(&params_For_Show_Controls) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Show_Controls_Using_Controller(void)
{
	Show_Controls_Rec	params_For_Show_Controls;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Show_Controls_Control_Preparation(&params_For_Show_Controls) == SAFE_TRUE) {
		if (Show_Controls(&params_For_Show_Controls) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Status_Using_Menu(void)
{
Show_Status_Rec		params_For_Show_Status;
/* END VAR */


	if (Show_Status_Menu_Preparation(&params_For_Show_Status) == SAFE_TRUE) {
		if (Show_Status(&params_For_Show_Status) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Show_Status_Using_Controller(void)
{
	Show_Status_Rec	params_For_Show_Status;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Show_Status_Control_Preparation(&params_For_Show_Status) == SAFE_TRUE) {
		if (Show_Status(&params_For_Show_Status) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Item_List_Using_Menu(void)
{
Show_Item_List_Rec		params_For_Show_Item_List;
/* END VAR */


	if (Show_Item_List_Menu_Preparation(&params_For_Show_Item_List) == SAFE_TRUE) {
		if (Show_Item_List(&params_For_Show_Item_List) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Show_Item_List_Using_Controller(void)
{
	Show_Item_List_Rec	params_For_Show_Item_List;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Show_Item_List_Control_Preparation(&params_For_Show_Item_List) == SAFE_TRUE) {
		if (Show_Item_List(&params_For_Show_Item_List) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Setup_Chromakey_Video_Using_Menu(void)
{
Setup_Chromakey_Video_Rec		params_For_Setup_Chromakey_Video;
/* END VAR */


	if (Setup_Chromakey_Video_Menu_Preparation(&params_For_Setup_Chromakey_Video) == SAFE_TRUE) {
		if (Setup_Chromakey_Video(&params_For_Setup_Chromakey_Video) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Setup_Chromakey_Video_Using_Controller(void)
{
	Setup_Chromakey_Video_Rec	params_For_Setup_Chromakey_Video;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Setup_Chromakey_Video_Control_Preparation(&params_For_Setup_Chromakey_Video) == SAFE_TRUE) {
		if (Setup_Chromakey_Video(&params_For_Setup_Chromakey_Video) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Repostition_For_Broadcast_Using_Menu(void)
{
Repostition_For_Broadcast_Rec		params_For_Repostition_For_Broadcast;
/* END VAR */


	if (Repostition_For_Broadcast_Menu_Preparation(&params_For_Repostition_For_Broadcast) == SAFE_TRUE) {
		if (Repostition_For_Broadcast(&params_For_Repostition_For_Broadcast) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Repostition_For_Broadcast_Using_Controller(void)
{
	Repostition_For_Broadcast_Rec	params_For_Repostition_For_Broadcast;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Repostition_For_Broadcast_Control_Preparation(&params_For_Repostition_For_Broadcast) == SAFE_TRUE) {
		if (Repostition_For_Broadcast(&params_For_Repostition_For_Broadcast) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Setup_Broadcast_Using_Menu(void)
{
Setup_Broadcast_Rec		params_For_Setup_Broadcast;
/* END VAR */


	if (Setup_Broadcast_Menu_Preparation(&params_For_Setup_Broadcast) == SAFE_TRUE) {
		if (Setup_Broadcast(&params_For_Setup_Broadcast) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Setup_Broadcast_Using_Controller(void)
{
	Setup_Broadcast_Rec	params_For_Setup_Broadcast;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Setup_Broadcast_Control_Preparation(&params_For_Setup_Broadcast) == SAFE_TRUE) {
		if (Setup_Broadcast(&params_For_Setup_Broadcast) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Associate_Voices_Using_Menu(void)
{
Associate_Voices_Rec		params_For_Associate_Voices;
/* END VAR */


	if (Associate_Voices_Menu_Preparation(&params_For_Associate_Voices) == SAFE_TRUE) {
		if (Associate_Voices(&params_For_Associate_Voices) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Associate_Voices_Using_Controller(void)
{
	Associate_Voices_Rec	params_For_Associate_Voices;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Associate_Voices_Control_Preparation(&params_For_Associate_Voices) == SAFE_TRUE) {
		if (Associate_Voices(&params_For_Associate_Voices) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Monitor_Remote_Using_Menu(void)
{
Monitor_Remote_Rec		params_For_Monitor_Remote;
/* END VAR */


	if (Monitor_Remote_Menu_Preparation(&params_For_Monitor_Remote) == SAFE_TRUE) {
		if (Monitor_Remote(&params_For_Monitor_Remote) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Monitor_Remote_Using_Controller(void)
{
	Monitor_Remote_Rec	params_For_Monitor_Remote;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Monitor_Remote_Control_Preparation(&params_For_Monitor_Remote) == SAFE_TRUE) {
		if (Monitor_Remote(&params_For_Monitor_Remote) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Monitor_Microphone_Using_Menu(void)
{
Monitor_Microphone_Rec		params_For_Monitor_Microphone;
/* END VAR */


	if (Monitor_Microphone_Menu_Preparation(&params_For_Monitor_Microphone) == SAFE_TRUE) {
		if (Monitor_Microphone(&params_For_Monitor_Microphone) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Monitor_Microphone_Using_Controller(void)
{
	Monitor_Microphone_Rec	params_For_Monitor_Microphone;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Monitor_Microphone_Control_Preparation(&params_For_Monitor_Microphone) == SAFE_TRUE) {
		if (Monitor_Microphone(&params_For_Monitor_Microphone) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Monitor_Sampler_Using_Menu(void)
{
Monitor_Sampler_Rec		params_For_Monitor_Sampler;
/* END VAR */


	if (Monitor_Sampler_Menu_Preparation(&params_For_Monitor_Sampler) == SAFE_TRUE) {
		if (Monitor_Sampler(&params_For_Monitor_Sampler) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Monitor_Sampler_Using_Controller(void)
{
	Monitor_Sampler_Rec	params_For_Monitor_Sampler;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Monitor_Sampler_Control_Preparation(&params_For_Monitor_Sampler) == SAFE_TRUE) {
		if (Monitor_Sampler(&params_For_Monitor_Sampler) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Monitor_Using_Keyboard_Using_Menu(void)
{
Monitor_Using_Keyboard_Rec		params_For_Monitor_Using_Keyboard;
/* END VAR */


	if (Monitor_Using_Keyboard_Menu_Preparation(&params_For_Monitor_Using_Keyboard) == SAFE_TRUE) {
		if (Monitor_Using_Keyboard(&params_For_Monitor_Using_Keyboard) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Monitor_Using_Keyboard_Using_Controller(void)
{
	Monitor_Using_Keyboard_Rec	params_For_Monitor_Using_Keyboard;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Monitor_Using_Keyboard_Control_Preparation(&params_For_Monitor_Using_Keyboard) == SAFE_TRUE) {
		if (Monitor_Using_Keyboard(&params_For_Monitor_Using_Keyboard) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Monitor_Phonebridge_Using_Menu(void)
{
Monitor_Phonebridge_Rec		params_For_Monitor_Phonebridge;
/* END VAR */


	if (Monitor_Phonebridge_Menu_Preparation(&params_For_Monitor_Phonebridge) == SAFE_TRUE) {
		if (Monitor_Phonebridge(&params_For_Monitor_Phonebridge) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Monitor_Phonebridge_Using_Controller(void)
{
	Monitor_Phonebridge_Rec	params_For_Monitor_Phonebridge;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Monitor_Phonebridge_Control_Preparation(&params_For_Monitor_Phonebridge) == SAFE_TRUE) {
		if (Monitor_Phonebridge(&params_For_Monitor_Phonebridge) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Reset_Connection_Using_Menu(void)
{
Reset_Connection_Rec		params_For_Reset_Connection;
/* END VAR */


	if (Reset_Connection_Menu_Preparation(&params_For_Reset_Connection) == SAFE_TRUE) {
		if (Reset_Connection(&params_For_Reset_Connection) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Reset_Connection_Using_Controller(void)
{
	Reset_Connection_Rec	params_For_Reset_Connection;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Reset_Connection_Control_Preparation(&params_For_Reset_Connection) == SAFE_TRUE) {
		if (Reset_Connection(&params_For_Reset_Connection) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Disconnect_Self_Using_Menu(void)
{
Disconnect_Self_Rec		params_For_Disconnect_Self;
/* END VAR */


	if (Disconnect_Self_Menu_Preparation(&params_For_Disconnect_Self) == SAFE_TRUE) {
		if (Disconnect_Self(&params_For_Disconnect_Self) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Disconnect_Self_Using_Controller(void)
{
	Disconnect_Self_Rec	params_For_Disconnect_Self;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Disconnect_Self_Control_Preparation(&params_For_Disconnect_Self) == SAFE_TRUE) {
		if (Disconnect_Self(&params_For_Disconnect_Self) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Show_Zones_Using_Menu(void)
{
Show_Zones_Rec		params_For_Show_Zones;
/* END VAR */


	if (Show_Zones_Menu_Preparation(&params_For_Show_Zones) == SAFE_TRUE) {
		if (Show_Zones(&params_For_Show_Zones) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Show_Zones_Using_Controller(void)
{
	Show_Zones_Rec	params_For_Show_Zones;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Show_Zones_Control_Preparation(&params_For_Show_Zones) == SAFE_TRUE) {
		if (Show_Zones(&params_For_Show_Zones) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Create_Scene_Using_Menu(void)
{
Create_Scene_Rec		params_For_Create_Scene;
/* END VAR */


	if (Create_Scene_Menu_Preparation(&params_For_Create_Scene) == SAFE_TRUE) {
		if (Create_Scene(&params_For_Create_Scene) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Create_Scene_Using_Controller(void)
{
	Create_Scene_Rec	params_For_Create_Scene;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Create_Scene_Control_Preparation(&params_For_Create_Scene) == SAFE_TRUE) {
		if (Create_Scene(&params_For_Create_Scene) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Open_Scene_Using_Menu(void)
{
Open_Scene_Rec		params_For_Open_Scene;
/* END VAR */


	if (Open_Scene_Menu_Preparation(&params_For_Open_Scene) == SAFE_TRUE) {
		if (Open_Scene(&params_For_Open_Scene) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Open_Scene_Using_Controller(void)
{
	Open_Scene_Rec	params_For_Open_Scene;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Open_Scene_Control_Preparation(&params_For_Open_Scene) == SAFE_TRUE) {
		if (Open_Scene(&params_For_Open_Scene) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Close_Scenes_Using_Menu(void)
{
Close_Scenes_Rec		params_For_Close_Scenes;
/* END VAR */


	if (Close_Scenes_Menu_Preparation(&params_For_Close_Scenes) == SAFE_TRUE) {
		if (Close_Scenes(&params_For_Close_Scenes) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Close_Scenes_Using_Controller(void)
{
	Close_Scenes_Rec	params_For_Close_Scenes;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Close_Scenes_Control_Preparation(&params_For_Close_Scenes) == SAFE_TRUE) {
		if (Close_Scenes(&params_For_Close_Scenes) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Close_All_Scenes_Using_Menu(void)
{
Close_All_Scenes_Rec		params_For_Close_All_Scenes;
/* END VAR */


	if (Close_All_Scenes_Menu_Preparation(&params_For_Close_All_Scenes) == SAFE_TRUE) {
		if (Close_All_Scenes(&params_For_Close_All_Scenes) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Close_All_Scenes_Using_Controller(void)
{
	Close_All_Scenes_Rec	params_For_Close_All_Scenes;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Close_All_Scenes_Control_Preparation(&params_For_Close_All_Scenes) == SAFE_TRUE) {
		if (Close_All_Scenes(&params_For_Close_All_Scenes) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Save_Scene_Using_Menu(void)
{
Save_Scene_Rec		params_For_Save_Scene;
/* END VAR */


	if (Save_Scene_Menu_Preparation(&params_For_Save_Scene) == SAFE_TRUE) {
		if (Save_Scene(&params_For_Save_Scene) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Save_Scene_Using_Controller(void)
{
	Save_Scene_Rec	params_For_Save_Scene;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Save_Scene_Control_Preparation(&params_For_Save_Scene) == SAFE_TRUE) {
		if (Save_Scene(&params_For_Save_Scene) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Save_Scene_As_Using_Menu(void)
{
Save_Scene_As_Rec		params_For_Save_Scene_As;
/* END VAR */


	if (Save_Scene_As_Menu_Preparation(&params_For_Save_Scene_As) == SAFE_TRUE) {
		if (Save_Scene_As(&params_For_Save_Scene_As) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Save_Scene_As_Using_Controller(void)
{
	Save_Scene_As_Rec	params_For_Save_Scene_As;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Save_Scene_As_Control_Preparation(&params_For_Save_Scene_As) == SAFE_TRUE) {
		if (Save_Scene_As(&params_For_Save_Scene_As) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Page_Setup_Using_Menu(void)
{
Page_Setup_Rec		params_For_Page_Setup;
/* END VAR */


	if (Page_Setup_Menu_Preparation(&params_For_Page_Setup) == SAFE_TRUE) {
		if (Page_Setup(&params_For_Page_Setup) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Page_Setup_Using_Controller(void)
{
	Page_Setup_Rec	params_For_Page_Setup;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Page_Setup_Control_Preparation(&params_For_Page_Setup) == SAFE_TRUE) {
		if (Page_Setup(&params_For_Page_Setup) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Page_Print_Using_Menu(void)
{
Page_Print_Rec		params_For_Page_Print;
/* END VAR */


	if (Page_Print_Menu_Preparation(&params_For_Page_Print) == SAFE_TRUE) {
		if (Page_Print(&params_For_Page_Print) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Page_Print_Using_Controller(void)
{
	Page_Print_Rec	params_For_Page_Print;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Page_Print_Control_Preparation(&params_For_Page_Print) == SAFE_TRUE) {
		if (Page_Print(&params_For_Page_Print) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Print_Saved_Files_Using_Menu(void)
{
Print_Saved_Files_Rec		params_For_Print_Saved_Files;
/* END VAR */


	if (Print_Saved_Files_Menu_Preparation(&params_For_Print_Saved_Files) == SAFE_TRUE) {
		if (Print_Saved_Files(&params_For_Print_Saved_Files) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Print_Saved_Files_Using_Controller(void)
{
	Print_Saved_Files_Rec	params_For_Print_Saved_Files;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Print_Saved_Files_Control_Preparation(&params_For_Print_Saved_Files) == SAFE_TRUE) {
		if (Print_Saved_Files(&params_For_Print_Saved_Files) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Add_Item_Using_Menu(void)
{
Add_Item_Rec		params_For_Add_Item;
/* END VAR */


	if (Add_Item_Menu_Preparation(&params_For_Add_Item) == SAFE_TRUE) {
		if (Add_Item(&params_For_Add_Item) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Add_Item_Using_Controller(void)
{
	Add_Item_Rec	params_For_Add_Item;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Add_Item_Control_Preparation(&params_For_Add_Item) == SAFE_TRUE) {
		if (Add_Item(&params_For_Add_Item) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Remove_Item_Using_Menu(void)
{
Remove_Item_Rec		params_For_Remove_Item;
/* END VAR */


	if (Remove_Item_Menu_Preparation(&params_For_Remove_Item) == SAFE_TRUE) {
		if (Remove_Item(&params_For_Remove_Item) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Remove_Item_Using_Controller(void)
{
	Remove_Item_Rec	params_For_Remove_Item;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Remove_Item_Control_Preparation(&params_For_Remove_Item) == SAFE_TRUE) {
		if (Remove_Item(&params_For_Remove_Item) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Resposition_Item_Using_Menu(void)
{
Resposition_Item_Rec		params_For_Resposition_Item;
/* END VAR */


	if (Resposition_Item_Menu_Preparation(&params_For_Resposition_Item) == SAFE_TRUE) {
		if (Resposition_Item(&params_For_Resposition_Item) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Resposition_Item_Using_Controller(void)
{
	Resposition_Item_Rec	params_For_Resposition_Item;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Resposition_Item_Control_Preparation(&params_For_Resposition_Item) == SAFE_TRUE) {
		if (Resposition_Item(&params_For_Resposition_Item) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Change_Backdrop_Using_Menu(void)
{
Change_Backdrop_Rec		params_For_Change_Backdrop;
/* END VAR */


	if (Change_Backdrop_Menu_Preparation(&params_For_Change_Backdrop) == SAFE_TRUE) {
		if (Change_Backdrop(&params_For_Change_Backdrop) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Change_Backdrop_Using_Controller(void)
{
	Change_Backdrop_Rec	params_For_Change_Backdrop;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Change_Backdrop_Control_Preparation(&params_For_Change_Backdrop) == SAFE_TRUE) {
		if (Change_Backdrop(&params_For_Change_Backdrop) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Play_Audio_File_Using_Menu(void)
{
Play_Audio_File_Rec		params_For_Play_Audio_File;
/* END VAR */


	if (Play_Audio_File_Menu_Preparation(&params_For_Play_Audio_File) == SAFE_TRUE) {
		if (Play_Audio_File(&params_For_Play_Audio_File) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Play_Audio_File_Using_Controller(void)
{
	Play_Audio_File_Rec	params_For_Play_Audio_File;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Play_Audio_File_Control_Preparation(&params_For_Play_Audio_File) == SAFE_TRUE) {
		if (Play_Audio_File(&params_For_Play_Audio_File) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Swap_Voice_For_Audio_File_Using_Menu(void)
{
Swap_Voice_For_Audio_File_Rec		params_For_Swap_Voice_For_Audio_File;
/* END VAR */


	if (Swap_Voice_For_Audio_File_Menu_Preparation(&params_For_Swap_Voice_For_Audio_File) == SAFE_TRUE) {
		if (Swap_Voice_For_Audio_File(&params_For_Swap_Voice_For_Audio_File) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Swap_Voice_For_Audio_File_Using_Controller(void)
{
	Swap_Voice_For_Audio_File_Rec	params_For_Swap_Voice_For_Audio_File;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Swap_Voice_For_Audio_File_Control_Preparation(&params_For_Swap_Voice_For_Audio_File) == SAFE_TRUE) {
		if (Swap_Voice_For_Audio_File(&params_For_Swap_Voice_For_Audio_File) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Swap_Assumed_Voice_For_Audio_File_Using_Menu(void)
{
Swap_Voice_For_Audio_File_Rec		params_For_Swap_Voice_For_Audio_File;
/* END VAR */


	if (Swap_Assumed_Voice_For_Audio_File_Menu_Preparation(&params_For_Swap_Voice_For_Audio_File) == SAFE_TRUE) {
		if (Swap_Voice_For_Audio_File(&params_For_Swap_Voice_For_Audio_File) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Swap_Assumed_Voice_For_Audio_File_Using_Controller(void)
{
	Swap_Voice_For_Audio_File_Rec	params_For_Swap_Voice_For_Audio_File;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Swap_Assumed_Voice_For_Audio_File_Control_Preparation(&params_For_Swap_Voice_For_Audio_File) == SAFE_TRUE) {
		if (Swap_Voice_For_Audio_File(&params_For_Swap_Voice_For_Audio_File) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Advance_Slide_Using_Menu(INTEGER_16 direction)
{
Advance_Slide_Rec		params_For_Advance_Slide;
/* END VAR */

	params_For_Advance_Slide.desired_Direction = direction;
	params_For_Advance_Slide.async_Task_Desired = SAFE_FALSE;
	if (Advance_New_Slide(&params_For_Advance_Slide) != SAFE_TRUE) {
		/*  */
		/* Ignore error. Design to be benign by default. */
		/*  */
	}
	
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Advance_Slide_Using_Controller(INTEGER_16 direction)
{
Advance_Slide_Rec		params_For_Advance_Slide;
/* END VAR */

	params_For_Advance_Slide.desired_Direction = direction;
	params_For_Advance_Slide.async_Task_Desired = SAFE_FALSE;
	if (Advance_New_Slide(&params_For_Advance_Slide) != SAFE_TRUE) {
		/*  */
		/* Ignore error. Design to be benign by default. */
		/*  */
	}
	
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Select_Slide_Using_Menu(void)
{
Select_Slide_Rec		params_For_Select_Slide;
/* END VAR */


	if (Select_Slide_Menu_Preparation(&params_For_Select_Slide) == SAFE_TRUE) {
		if (Select_New_Slide(&params_For_Select_Slide) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
		
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Select_Slide_Using_Controller(void)
{
Select_Slide_Rec		params_For_Select_Slide;
/* END VAR */


	if (Select_Slide_Control_Preparation(&params_For_Select_Slide) == SAFE_TRUE) {
		if (Select_New_Slide(&params_For_Select_Slide) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
		
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Open_Slide_Using_Menu(void)
{
Open_Slide_Rec		params_For_Open_Slide;
/* END VAR */


	if (Open_Slide_Menu_Preparation(&params_For_Open_Slide) == SAFE_TRUE) {
		if (Open_Slide(&params_For_Open_Slide) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Open_Slide_Using_Controller(void)
{
	Open_Slide_Rec	params_For_Open_Slide;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Open_Slide_Control_Preparation(&params_For_Open_Slide) == SAFE_TRUE) {
		if (Open_Slide(&params_For_Open_Slide) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Close_Slides_Using_Menu(void)
{
Close_Slides_Rec		params_For_Close_Slides;
/* END VAR */


	if (Close_Slides_Menu_Preparation(&params_For_Close_Slides) == SAFE_TRUE) {
		if (Close_Slides(&params_For_Close_Slides) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Close_Slides_Using_Controller(void)
{
	Close_Slides_Rec	params_For_Close_Slides;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Close_Slides_Control_Preparation(&params_For_Close_Slides) == SAFE_TRUE) {
		if (Close_Slides(&params_For_Close_Slides) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Close_All_Slides_Using_Menu(void)
{
Close_All_Slides_Rec		params_For_Close_All_Slides;
/* END VAR */


	if (Close_All_Slides_Menu_Preparation(&params_For_Close_All_Slides) == SAFE_TRUE) {
		if (Close_All_Slides(&params_For_Close_All_Slides) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Close_All_Slides_Using_Controller(void)
{
	Close_All_Slides_Rec	params_For_Close_All_Slides;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Close_All_Slides_Control_Preparation(&params_For_Close_All_Slides) == SAFE_TRUE) {
		if (Close_All_Slides(&params_For_Close_All_Slides) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Change_Window_Size_Using_Menu(void)
{
Change_Window_Size_Rec		params_For_Change_Window_Size;
/* END VAR */


	if (Change_Window_Size_Menu_Preparation(&params_For_Change_Window_Size) == SAFE_TRUE) {
		if (Change_Window_Size(&params_For_Change_Window_Size) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Change_Window_Size_Using_Controller(void)
{
	Change_Window_Size_Rec	params_For_Change_Window_Size;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Change_Window_Size_Control_Preparation(&params_For_Change_Window_Size) == SAFE_TRUE) {
		if (Change_Window_Size(&params_For_Change_Window_Size) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Connect_Remote_Using_Menu(void)
{
Connect_Remote_Rec		params_For_Connect_Remote;
/* END VAR */


	if (Connect_Remote_Menu_Preparation(&params_For_Connect_Remote) == SAFE_TRUE) {
		if (Connect_Remote(&params_For_Connect_Remote) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Connect_Remote_Using_Controller(void)
{
	Connect_Remote_Rec	params_For_Connect_Remote;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Connect_Remote_Control_Preparation(&params_For_Connect_Remote) == SAFE_TRUE) {
		if (Connect_Remote(&params_For_Connect_Remote) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Disconnect_Remote_Using_Menu(void)
{
Disconnect_Remote_Rec		params_For_Disconnect_Remote;
/* END VAR */


	if (Disconnect_Remote_Menu_Preparation(&params_For_Disconnect_Remote) == SAFE_TRUE) {
		if (Disconnect_Remote(&params_For_Disconnect_Remote) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Disconnect_Remote_Using_Controller(void)
{
	Disconnect_Remote_Rec	params_For_Disconnect_Remote;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Disconnect_Remote_Control_Preparation(&params_For_Disconnect_Remote) == SAFE_TRUE) {
		if (Disconnect_Remote(&params_For_Disconnect_Remote) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Select_Remote_Using_Menu(void)
{
Select_Remote_Rec		params_For_Select_Remote;
/* END VAR */


	if (Select_Remote_Menu_Preparation(&params_For_Select_Remote) == SAFE_TRUE) {
		if (Select_Remote(&params_For_Select_Remote) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Select_Remote_Using_Controller(void)
{
	Select_Remote_Rec	params_For_Select_Remote;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Select_Remote_Control_Preparation(&params_For_Select_Remote) == SAFE_TRUE) {
		if (Select_Remote(&params_For_Select_Remote) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Select_Next_Remote_Using_Menu(void)
{
Select_Next_Remote_Rec		params_For_Select_Next_Remote;
/* END VAR */


	if (Select_Next_Remote_Menu_Preparation(&params_For_Select_Next_Remote) == SAFE_TRUE) {
		if (Select_Next_Remote(&params_For_Select_Next_Remote) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Select_Next_Remote_Using_Controller(void)
{
	Select_Next_Remote_Rec	params_For_Select_Next_Remote;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Select_Next_Remote_Control_Preparation(&params_For_Select_Next_Remote) == SAFE_TRUE) {
		if (Select_Next_Remote(&params_For_Select_Next_Remote) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Select_Previous_Remote_Using_Menu(void)
{
Select_Previous_Remote_Rec		params_For_Select_Previous_Remote;
/* END VAR */


	if (Select_Previous_Remote_Menu_Preparation(&params_For_Select_Previous_Remote) == SAFE_TRUE) {
		if (Select_Previous_Remote(&params_For_Select_Previous_Remote) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Select_Previous_Remote_Using_Controller(void)
{
	Select_Previous_Remote_Rec	params_For_Select_Previous_Remote;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Select_Previous_Remote_Control_Preparation(&params_For_Select_Previous_Remote) == SAFE_TRUE) {
		if (Select_Previous_Remote(&params_For_Select_Previous_Remote) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Rescan_Remote_Using_Menu(void)
{
Rescan_Remote_Rec		params_For_Rescan_Remote;
/* END VAR */


	if (Rescan_Remote_Menu_Preparation(&params_For_Rescan_Remote) == SAFE_TRUE) {
		if (Rescan_Remote(&params_For_Rescan_Remote) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Rescan_Remote_Using_Controller(void)
{
	Rescan_Remote_Rec	params_For_Rescan_Remote;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Rescan_Remote_Control_Preparation(&params_For_Rescan_Remote) == SAFE_TRUE) {
		if (Rescan_Remote(&params_For_Rescan_Remote) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Update_Remote_List_Using_Menu(void)
{
Update_Remote_List_Rec		params_For_Update_Remote_List;
/* END VAR */


	if (Update_Remote_List_Menu_Preparation(&params_For_Update_Remote_List) == SAFE_TRUE) {
		if (Update_Remote_List(&params_For_Update_Remote_List) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Update_Remote_List_Using_Controller(void)
{
	Update_Remote_List_Rec	params_For_Update_Remote_List;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Update_Remote_List_Control_Preparation(&params_For_Update_Remote_List) == SAFE_TRUE) {
		if (Update_Remote_List(&params_For_Update_Remote_List) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Kill_Remote_Using_Menu(void)
{
Kill_Remote_Rec		params_For_Kill_Remote;
/* END VAR */


	if (Kill_Remote_Menu_Preparation(&params_For_Kill_Remote) == SAFE_TRUE) {
		if (Kill_Remote(&params_For_Kill_Remote) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Kill_Remote_Using_Controller(void)
{
	Kill_Remote_Rec	params_For_Kill_Remote;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Kill_Remote_Control_Preparation(&params_For_Kill_Remote) == SAFE_TRUE) {
		if (Kill_Remote(&params_For_Kill_Remote) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Select_Scene_Using_Menu(void)
{
Select_Scene_Rec		params_For_Select_Scene;
/* END VAR */


	if (Select_Scene_Menu_Preparation(&params_For_Select_Scene) == SAFE_TRUE) {
		if (Select_Scene(&params_For_Select_Scene) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Select_Scene_Using_Controller(void)
{
	Select_Scene_Rec	params_For_Select_Scene;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Select_Scene_Control_Preparation(&params_For_Select_Scene) == SAFE_TRUE) {
		if (Select_Scene(&params_For_Select_Scene) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Load_Or_Select_Scene_Using_Menu(void)
{
Load_Or_Select_Scene_Rec		params_For_Load_Or_Select_Scene;
/* END VAR */


	if (Load_Or_Select_Scene_Menu_Preparation(&params_For_Load_Or_Select_Scene) == SAFE_TRUE) {
		if (Load_Or_Select_Scene(&params_For_Load_Or_Select_Scene) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Load_Or_Select_Scene_Using_Controller(void)
{
	Load_Or_Select_Scene_Rec	params_For_Load_Or_Select_Scene;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Load_Or_Select_Scene_Control_Preparation(&params_For_Load_Or_Select_Scene) == SAFE_TRUE) {
		if (Load_Or_Select_Scene(&params_For_Load_Or_Select_Scene) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Select_Next_Scene_Using_Menu(void)
{
Select_Next_Scene_Rec		params_For_Select_Next_Scene;
/* END VAR */


	if (Select_Next_Scene_Menu_Preparation(&params_For_Select_Next_Scene) == SAFE_TRUE) {
		if (Select_Next_Scene(&params_For_Select_Next_Scene) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Select_Next_Scene_Using_Controller(void)
{
	Select_Next_Scene_Rec	params_For_Select_Next_Scene;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Select_Next_Scene_Control_Preparation(&params_For_Select_Next_Scene) == SAFE_TRUE) {
		if (Select_Next_Scene(&params_For_Select_Next_Scene) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Select_Previous_Scene_Using_Menu(void)
{
Select_Previous_Scene_Rec		params_For_Select_Previous_Scene;
/* END VAR */


	if (Select_Previous_Scene_Menu_Preparation(&params_For_Select_Previous_Scene) == SAFE_TRUE) {
		if (Select_Previous_Scene(&params_For_Select_Previous_Scene) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Select_Previous_Scene_Using_Controller(void)
{
	Select_Previous_Scene_Rec	params_For_Select_Previous_Scene;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Select_Previous_Scene_Control_Preparation(&params_For_Select_Previous_Scene) == SAFE_TRUE) {
		if (Select_Previous_Scene(&params_For_Select_Previous_Scene) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Select_Transition_Using_Menu(void)
{
Select_Transition_Rec		params_For_Select_Transition;
/* END VAR */


	if (Select_Transition_Menu_Preparation(&params_For_Select_Transition) == SAFE_TRUE) {
		if (Select_Transition(&params_For_Select_Transition) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Select_Transition_Using_Controller(void)
{
	Select_Transition_Rec	params_For_Select_Transition;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Select_Transition_Control_Preparation(&params_For_Select_Transition) == SAFE_TRUE) {
		if (Select_Transition(&params_For_Select_Transition) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Select_First_Transition_Using_Menu(void)
{
Select_First_Transition_Rec		params_For_Select_First_Transition;
/* END VAR */


	if (Select_First_Transition_Menu_Preparation(&params_For_Select_First_Transition) == SAFE_TRUE) {
		if (Select_First_Transition(&params_For_Select_First_Transition) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Select_First_Transition_Using_Controller(void)
{
	Select_First_Transition_Rec	params_For_Select_First_Transition;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Select_First_Transition_Control_Preparation(&params_For_Select_First_Transition) == SAFE_TRUE) {
		if (Select_First_Transition(&params_For_Select_First_Transition) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Activate_Twitch_Using_Menu(void)
{
Activate_Twitch_Rec		params_For_Activate_Twitch;
/* END VAR */


	if (Activate_Twitch_Menu_Preparation(&params_For_Activate_Twitch) == SAFE_TRUE) {
		if (Activate_Twitch(&params_For_Activate_Twitch) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Activate_Twitch_Using_Controller(void)
{
	Activate_Twitch_Rec	params_For_Activate_Twitch;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Activate_Twitch_Control_Preparation(&params_For_Activate_Twitch) == SAFE_TRUE) {
		if (Activate_Twitch(&params_For_Activate_Twitch) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Monitor_Real_MIDI_Using_Menu(void)
{
Monitor_Real_MIDI_Rec		params_For_Monitor_Real_MIDI;
/* END VAR */


	if (Monitor_Real_MIDI_Menu_Preparation(&params_For_Monitor_Real_MIDI) == SAFE_TRUE) {
		if (Monitor_Real_MIDI(&params_For_Monitor_Real_MIDI) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Monitor_Real_MIDI_Using_Controller(void)
{
	Monitor_Real_MIDI_Rec	params_For_Monitor_Real_MIDI;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Monitor_Real_MIDI_Control_Preparation(&params_For_Monitor_Real_MIDI) == SAFE_TRUE) {
		if (Monitor_Real_MIDI(&params_For_Monitor_Real_MIDI) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Record_Titled_AIFF_File_Using_Menu(void)
{
Record_Titled_AIFF_File_Rec		params_For_Record_Titled_AIFF_File;
/* END VAR */


	if (Record_Titled_AIFF_File_Menu_Preparation(&params_For_Record_Titled_AIFF_File) == SAFE_TRUE) {
		if (Record_Titled_AIFF_File(&params_For_Record_Titled_AIFF_File) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Record_Titled_AIFF_File_Using_Controller(void)
{
	Record_Titled_AIFF_File_Rec	params_For_Record_Titled_AIFF_File;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Record_Titled_AIFF_File_Control_Preparation(&params_For_Record_Titled_AIFF_File) == SAFE_TRUE) {
		if (Record_Titled_AIFF_File(&params_For_Record_Titled_AIFF_File) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Record_From_Any_To_Titled_AIFF_Using_Menu(void)
{
Record_From_Any_To_Titled_AIFF_Rec		params_For_Record_From_Any_To_Titled_AIFF;
/* END VAR */


	if (Record_From_Any_To_Titled_AIFF_Menu_Preparation(&params_For_Record_From_Any_To_Titled_AIFF) == SAFE_TRUE) {
		if (Record_From_Any_To_Titled_AIFF(&params_For_Record_From_Any_To_Titled_AIFF) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Record_From_Any_To_Titled_AIFF_Using_Controller(void)
{
	Record_From_Any_To_Titled_AIFF_Rec	params_For_Record_From_Any_To_Titled_AIFF;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Record_From_Any_To_Titled_AIFF_Control_Preparation(&params_For_Record_From_Any_To_Titled_AIFF) == SAFE_TRUE) {
		if (Record_From_Any_To_Titled_AIFF(&params_For_Record_From_Any_To_Titled_AIFF) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Record_From_Any_To_Untitled_AIFF_Using_Menu(void)
{
Record_From_Any_To_Untitled_AIFF_Rec		params_For_Record_From_Any_To_Untitled_AIFF;
/* END VAR */


	if (Record_From_Any_To_Untitled_AIFF_Menu_Preparation(&params_For_Record_From_Any_To_Untitled_AIFF) == SAFE_TRUE) {
		if (Record_From_Any_To_Untitled_AIFF(&params_For_Record_From_Any_To_Untitled_AIFF) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Record_From_Any_To_Untitled_AIFF_Using_Controller(void)
{
	Record_From_Any_To_Untitled_AIFF_Rec	params_For_Record_From_Any_To_Untitled_AIFF;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Record_From_Any_To_Untitled_AIFF_Control_Preparation(&params_For_Record_From_Any_To_Untitled_AIFF) == SAFE_TRUE) {
		if (Record_From_Any_To_Untitled_AIFF(&params_For_Record_From_Any_To_Untitled_AIFF) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Stop_Recording_Any_Open_AIFF_Files_Using_Menu(void)
{
Stop_Recording_Any_Open_AIFF_Files_Rec		params_For_Stop_Recording_Any_Open_AIFF_Files;
/* END VAR */


	if (Stop_Recording_Any_Open_AIFF_Files_Menu_Preparation(&params_For_Stop_Recording_Any_Open_AIFF_Files) == SAFE_TRUE) {
		if (Stop_Recording_Any_Open_AIFF_Files(&params_For_Stop_Recording_Any_Open_AIFF_Files) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Stop_Recording_Any_Open_AIFF_Files_Using_Controller(void)
{
	Stop_Recording_Any_Open_AIFF_Files_Rec	params_For_Stop_Recording_Any_Open_AIFF_Files;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Stop_Recording_Any_Open_AIFF_Files_Control_Preparation(&params_For_Stop_Recording_Any_Open_AIFF_Files) == SAFE_TRUE) {
		if (Stop_Recording_Any_Open_AIFF_Files(&params_For_Stop_Recording_Any_Open_AIFF_Files) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Play_Last_Untitled_AIFF_Using_Menu(void)
{
Play_Last_Untitled_AIFF_Rec		params_For_Play_Last_Untitled_AIFF;
/* END VAR */


	if (Play_Last_Untitled_AIFF_Menu_Preparation(&params_For_Play_Last_Untitled_AIFF) == SAFE_TRUE) {
		if (Play_Last_Untitled_AIFF(&params_For_Play_Last_Untitled_AIFF) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Play_Last_Untitled_AIFF_Using_Controller(void)
{
	Play_Last_Untitled_AIFF_Rec	params_For_Play_Last_Untitled_AIFF;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Play_Last_Untitled_AIFF_Control_Preparation(&params_For_Play_Last_Untitled_AIFF) == SAFE_TRUE) {
		if (Play_Last_Untitled_AIFF(&params_For_Play_Last_Untitled_AIFF) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Stop_Playback_Of_All_AIFFs_Using_Menu(void)
{
Stop_Playback_Of_All_AIFFs_Rec		params_For_Stop_Playback_Of_All_AIFFs;
/* END VAR */


	if (Stop_Playback_Of_All_AIFFs_Menu_Preparation(&params_For_Stop_Playback_Of_All_AIFFs) == SAFE_TRUE) {
		if (Stop_Playback_Of_All_AIFFs(&params_For_Stop_Playback_Of_All_AIFFs) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Stop_Playback_Of_All_AIFFs_Using_Controller(void)
{
	Stop_Playback_Of_All_AIFFs_Rec	params_For_Stop_Playback_Of_All_AIFFs;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Stop_Playback_Of_All_AIFFs_Control_Preparation(&params_For_Stop_Playback_Of_All_AIFFs) == SAFE_TRUE) {
		if (Stop_Playback_Of_All_AIFFs(&params_For_Stop_Playback_Of_All_AIFFs) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
void Rescan_Files_Using_Menu(void)
{
Rescan_Files_Rec		params_For_Rescan_Files;
/* END VAR */


	if (Rescan_Files_Menu_Preparation(&params_For_Rescan_Files) == SAFE_TRUE) {
		if (Rescan_Files(&params_For_Rescan_Files) != SAFE_TRUE) {
			/*  */
			/* Ignore error. Design to be benign by default. */
			/*  */
		}
	}
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
Safe_Boolean Rescan_Files_Using_Controller(void)
{
	Rescan_Files_Rec	params_For_Rescan_Files;
	Safe_Boolean			function_Result;
/* END VAR */
	
	
	function_Result = SAFE_TRUE;
	if (Rescan_Files_Control_Preparation(&params_For_Rescan_Files) == SAFE_TRUE) {
		if (Rescan_Files(&params_For_Rescan_Files) != SAFE_TRUE) {
			function_Result = SAFE_FALSE;
		}
	}
	
	return(function_Result);
}
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* END OF FILE: Command_Redirector.c */
