/* START OF FILE: Command_Redirector.h */


/*=**************************************************************************=*/
/* [---BEGIN---] FILE HEADER COMMENTS */
/**
 ** SCREEN VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** PRINTER VIEW = [Adobe Syntax Black-10, Tabs = 4]
 ** =======================================================================
 ** Written by James Merkle
 ** Command_Redirector.h - Header for Command_Redirector.c
 ** (C) Copyright 1994 James Merkle
 ** =======================================================================
 **
 **
 ** ============
 ** Revision History
 ** ============
 **
 **  Refer to "Command_Redirector.c"
 **						
 **
 ** ====================
 ** OTHER INFORMATION
 ** ====================
 ** 
 **
 **/
/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/



/*=**************************************************************************=*/
#ifndef _H_Command_Redirector

#define _H_Command_Redirector
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #include AREA */

#include "Shell_Globals.h"

/* [----END----] #include AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] #define AREA */

	
/* [----END----] #define AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */


/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */

extern Safe_Boolean Initialize_Command_Redirector(void);

extern Safe_Boolean Destroy_Command_Redirector(void);

extern void Load_Puppet_Using_Menu(void);

extern Safe_Boolean Load_Puppet_Using_Controller(void);

extern void Close_Puppet_Using_Menu(void);

extern Safe_Boolean Close_Puppet_Using_Controller(void);

extern void Save_Puppet_Using_Menu(void);

extern Safe_Boolean Save_Puppet_Using_Controller(void);

extern void Import_Puppet_Using_Menu(void);

extern Safe_Boolean Import_Puppet_Using_Controller(void);

extern void Export_Puppet_Using_Menu(void);

extern Safe_Boolean Export_Puppet_Using_Controller(void);

extern void Import_Prop_Using_Menu(void);

extern Safe_Boolean Import_Prop_Using_Controller(void);

extern void Export_Prop_Using_Menu(void);

extern Safe_Boolean Export_Prop_Using_Controller(void);

extern void Add_Another_Spin_File_To_Puppet_Using_Menu(void);

extern Safe_Boolean Add_Another_Spin_File_To_Puppet_Using_Controller(void);

extern Safe_Boolean Create_Puppet_From_Spin_File_Using_Controller(void);

extern void Create_Puppet_From_Spin_File_Using_Menu(void);

extern void Select_Scene_Using_Menu(void);

extern Safe_Boolean Select_Scene_Using_Controller(void);

extern void Select_Next_Scene_Using_Menu(void);

extern Safe_Boolean Select_Next_Scene_Using_Controller(void);

extern void Select_Previous_Scene_Using_Menu(void);

extern Safe_Boolean Select_Previous_Scene_Using_Controller(void);

extern void Time_Animation_Using_Menu(void);

extern Safe_Boolean Time_Animation_Using_Controller(void);

void Close_Spin_Object_Using_Menu(void);

extern Safe_Boolean Close_Spin_Object_Using_Controller(void);

extern void Load_Spin_Object_Using_Menu(void);

extern Safe_Boolean Load_Spin_Object_Using_Controller(void);

extern void Save_Spin_Object_Using_Menu(void);

extern Safe_Boolean Save_Spin_Object_Using_Controller(void);

extern void Convert_Spin_Object_Using_Menu(void);

extern Safe_Boolean Convert_Spin_Object_Using_Controller(void);

extern void Export_Spin_Object_Using_Menu(void);

extern void Recompress_Spin_Object_Using_Menu(void);

extern Safe_Boolean Export_Spin_Object_Using_Controller(void);

extern void Close_Backdrop_Using_Menu(void);

extern Safe_Boolean Close_Backdrop_Using_Controller(void);

extern void Load_Backdrop_Using_Menu(void);

extern Safe_Boolean Load_Backdrop_Using_Controller(void);

extern void Save_Backdrop_Using_Menu(void);

extern Safe_Boolean Save_Backdrop_Using_Controller(void);

extern void Convert_Backdrop_Using_Menu(void);

extern Safe_Boolean Convert_Backdrop_Using_Controller(void);

extern void Export_Backdrop_Using_Menu(void);

extern Safe_Boolean Export_Backdrop_Using_Controller(void);

extern void Show_Controls_Using_Menu(void);

extern Safe_Boolean Show_Controls_Using_Controller(void);

extern void Show_Status_Using_Menu(void);

extern Safe_Boolean Show_Status_Using_Controller(void);

extern void Show_Item_List_Using_Menu(void);

extern Safe_Boolean Show_Item_List_Using_Controller(void);

extern void Setup_Chromakey_Video_Using_Menu(void);

extern Safe_Boolean Setup_Chromakey_Video_Using_Controller(void);

extern void Repostition_For_Broadcast_Using_Menu(void);

extern Safe_Boolean Repostition_For_Broadcast_Using_Controller(void);

extern void Setup_Broadcast_Using_Menu(void);

extern Safe_Boolean Setup_Broadcast_Using_Controller(void);

extern void Associate_Voices_Using_Menu(void);

extern Safe_Boolean Associate_Voices_Using_Controller(void);

extern void Monitor_Remote_Using_Menu(void);

extern Safe_Boolean Monitor_Remote_Using_Controller(void);

extern void Monitor_Microphone_Using_Menu(void);

extern Safe_Boolean Monitor_Microphone_Using_Controller(void);

extern void Monitor_Sampler_Using_Menu(void);

extern Safe_Boolean Monitor_Sampler_Using_Controller(void);

extern void Monitor_Using_Keyboard_Using_Menu(void);

extern Safe_Boolean Monitor_Using_Keyboard_Using_Controller(void);

extern void Monitor_Phonebridge_Using_Menu(void);

extern Safe_Boolean Monitor_Phonebridge_Using_Controller(void);

extern void Reset_Connection_Using_Menu(void);

extern Safe_Boolean Reset_Connection_Using_Controller(void);

extern void Disconnect_Self_Using_Menu(void);

extern Safe_Boolean Disconnect_Self_Using_Controller(void);

extern void Show_Zones_Using_Menu(void);

extern Safe_Boolean Show_Zones_Using_Controller(void);

extern void Create_Scene_Using_Menu(void);

extern Safe_Boolean Create_Scene_Using_Controller(void);

extern void Open_Scene_Using_Menu(void);

extern Safe_Boolean Open_Scene_Using_Controller(void);

extern void Close_Scenes_Using_Menu(void);

extern Safe_Boolean Close_Scenes_Using_Controller(void);

extern void Close_All_Scenes_Using_Menu(void);

extern Safe_Boolean Close_All_Scenes_Using_Controller(void);

extern void Save_Scene_Using_Menu(void);

extern Safe_Boolean Save_Scene_Using_Controller(void);

extern void Save_Scene_As_Using_Menu(void);

extern Safe_Boolean Save_Scene_As_Using_Controller(void);

extern void Page_Setup_Using_Menu(void);

extern Safe_Boolean Page_Setup_Using_Controller(void);

extern void Page_Print_Using_Menu(void);

extern Safe_Boolean Page_Print_Using_Controller(void);

extern void Print_Saved_Files_Using_Menu(void);

extern Safe_Boolean Print_Saved_Files_Using_Controller(void);

extern void Add_Item_Using_Menu(void);

extern Safe_Boolean Add_Item_Using_Controller(void);

extern void Remove_Item_Using_Menu(void);

extern Safe_Boolean Remove_Item_Using_Controller(void);

extern void Resposition_Item_Using_Menu(void);

extern Safe_Boolean Resposition_Item_Using_Controller(void);

extern void Change_Backdrop_Using_Menu(void);

extern Safe_Boolean Change_Backdrop_Using_Controller(void);

extern void Play_Audio_File_Using_Menu(void);

extern Safe_Boolean Play_Audio_File_Using_Controller(void);

extern void Swap_Voice_For_Audio_File_Using_Menu(void);

extern Safe_Boolean Swap_Voice_For_Audio_File_Using_Controller(void);

extern void Swap_Assumed_Voice_For_Audio_File_Using_Menu(void);

extern Safe_Boolean Swap_Assumed_Voice_For_Audio_File_Using_Controller(void);

extern void Rescan_Files_Using_Menu(void);

extern Safe_Boolean Rescan_Files_Using_Controller(void);

extern void Open_Slide_Using_Menu(void);

extern Safe_Boolean Open_Slide_Using_Controller(void);

extern void Close_Slides_Using_Menu(void);

extern Safe_Boolean Close_Slides_Using_Controller(void);

extern void Close_All_Slides_Using_Menu(void);

extern Safe_Boolean Close_All_Slides_Using_Controller(void);

extern void Select_Slide_Using_Menu(void);

extern void Connect_Remote_Using_Menu(void);

extern Safe_Boolean Connect_Remote_Using_Controller(void);

extern void Disconnect_Remote_Using_Menu(void);

extern Safe_Boolean Disconnect_Remote_Using_Controller(void);

extern void Select_Remote_Using_Menu(void);

extern Safe_Boolean Select_Remote_Using_Controller(void);

extern void Select_Next_Remote_Using_Menu(void);

extern Safe_Boolean Select_Next_Remote_Using_Controller(void);

extern void Select_Previous_Remote_Using_Menu(void);

extern Safe_Boolean Select_Previous_Remote_Using_Controller(void);

extern void Rescan_Remote_Using_Menu(void);

extern Safe_Boolean Rescan_Remote_Using_Controller(void);

extern void Update_Remote_List_Using_Menu(void);

extern Safe_Boolean Update_Remote_List_Using_Controller(void);

extern void Kill_Remote_Using_Menu(void);

extern Safe_Boolean Kill_Remote_Using_Controller(void);

extern void Change_Window_Size_Using_Menu(void);

extern Safe_Boolean Change_Window_Size_Using_Controller(void);

extern void Advance_Slide_Using_Controller(INTEGER_16 direction);

extern void Advance_Slide_Using_Menu(INTEGER_16 direction);

extern void Select_Slide_Using_Controller(void);

extern void Set_Life_Jiggle_Using_Menu(void);

extern Safe_Boolean Set_Life_Jiggle_Using_Controller(void);

extern void Select_Transition_Using_Menu(void);

extern Safe_Boolean Select_Transition_Using_Controller(void);

extern void Select_First_Transition_Using_Menu(void);

extern Safe_Boolean Select_First_Transition_Using_Controller(void);

extern void Activate_Twitch_Using_Menu(void);

extern Safe_Boolean Activate_Twitch_Using_Controller(void);

extern void Load_Or_Select_Scene_Using_Menu(void);

extern Safe_Boolean Load_Or_Select_Scene_Using_Controller(void);

extern Safe_Boolean Recompress_Spin_Object_Using_Controller(void);

extern void Recompress_Spin_Object_Using_Menu(void);

void Monitor_Real_MIDI_Using_Menu(void);

extern Safe_Boolean Monitor_Real_MIDI_Using_Controller(void);

extern void Record_Titled_AIFF_File_Using_Menu(void);

extern Safe_Boolean Record_Titled_AIFF_File_Using_Controller(void);

extern void Record_From_Any_To_Titled_AIFF_Using_Menu(void);

extern Safe_Boolean Record_From_Any_To_Titled_AIFF_Using_Controller(void);

extern void Record_From_Any_To_Untitled_AIFF_Using_Menu(void);

extern Safe_Boolean Record_From_Any_To_Untitled_AIFF_Using_Controller(void);

extern void Stop_Recording_Any_Open_AIFF_Files_Using_Menu(void);

extern Safe_Boolean Stop_Recording_Any_Open_AIFF_Files_Using_Controller(void);

extern void Play_Last_Untitled_AIFF_Using_Menu(void);

extern Safe_Boolean Play_Last_Untitled_AIFF_Using_Controller(void);

extern void Stop_Playback_Of_All_AIFFs_Using_Menu(void);

extern Safe_Boolean Stop_Playback_Of_All_AIFFs_Using_Controller(void);

extern void Rescan_Files_Using_Menu(void);

extern Safe_Boolean Rescan_Files_Using_Controller(void);

/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] extern DECLARATIONS */


/* [----END----] extern DECLARATIONS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */


/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/

/* END OF FILE: Command_Redirector.h */
