/* [Core_Specific.h] START OF FILE */

/* [---BEGIN---] FILE HEADER COMMENTS */

/**
 ** SCREEN VIEW = Adobe Syntax Black-10, Tabs=6
 ** PRINTER VIEW = Adobe Syntax Black -10, Tabs=0.30 inch
 ** ========================================================================
 ** Core_Specific
 ** Written by Jim Merkle
 ** [Core_Specific.h] -  header for Core_Specific.c
 ** (C) Copyright 1991 by Jim Merkle
 ** ========================================================================
 **
 **
 ** =============
 ** Revision History
 ** =============
 **
 ** See Core_Specific.c for revision history and version number.
 **
 **
 **
 **
 ** =================
 ** OTHER INFORMATION
 ** =================
 **
 **
 **
 **/

/* [----END----] FILE HEADER COMMENTS */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#ifndef _H_Core_Specific

#define _H_Core_Specific
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] FILE INCLUDE AREA */

#include <PictUtil.h>
#include "Shell_Globals.h"

/* for stupid window size crud */
#include "Command_Executor.h"


/* [----END----] FILE INCLUDE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] DEFINE AREA */
#pragma mark DEFINE_AREA

#define	ABOUT_PROGRAM_WINDOW_INDEX				0
#define	GENERAL_INFO_WINDOW_INDEX					1
#define	TEST_RECT_WINDOW_INDEX						2
#define	TEST_CIRCLE_INDEX									3
#define	TEST_FILLED_CIRCLE_INDEX						4
#define	TEST_ELIPSE_WINDOW_INDEX						5
#define	TEST_FILLED_ELIPSE_WINDOW_INDEX				6
#define	TEST_LINE_WINDOW_INDEX						7
#define	FRAMED_POLYGONS_WINDOW_INDEX			8
#define	TIME_LINE_SPEED_WINDOW_INDEX				9
#define	TEST_THREE_D_WINDOW_INDEX					10
#define	SHOW_NETWORK_ZONES_WINDOW_INDEX		11
#define	TEST_DREAMING_WINDOW_INDEX				12
#define	MAIN_CONTROLLER_WINDOW_INDEX			13
#define	MAIN_SPINNING_WINDOW_INDEX					14

#define	TOTAL_DEFINED_WINDOW_TYPE					(MAIN_SPINNING_WINDOW_INDEX +1)



/* [----END----] DEFINE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] TYPE AREA */
	
	typedef struct {
		Safe_Boolean			animation_Active;
		CTabHandle			animation_Color_Table;
		Memory_Allocation	animation_Color_Table_In_Use;
		PaletteHandle		animation_Palette;
		INTEGER_16			animation_Rotation_Point;
		INTEGER_16			animation_Color_Increment;
	} Color_Animation, *Color_Animation_Ptr;
	
	typedef struct {
	
	/*=--------------------------------------------------------------------------=*/
	/* The following few variables are meant to be altered externally */
	/*=--------------------------------------------------------------------------=*/
	
		Safe_Boolean		user_Abort_Caution;
		Safe_Boolean		structure_Initialized;
		Safe_Boolean		update_Events_Permissible;
		
		Safe_Boolean		update_Pict_Permissable_To_Use;
		PicHandle			update_Pict;
		CARDINAL_16	type_Of_Window_For_Updates;
		
		Boolean				suspended;
		

	/*=--------------------------------------------------------------------------=*/
	/* 1994.06.04 JAM new features */
	/*=--------------------------------------------------------------------------=*/
		Safe_Boolean			window_Is_Hidden;
		Safe_Boolean			window_NS_Shell_ID_Valid;
		CARDINAL_32		window_NS_Shell_ID;
		
		Color_Animation		flow_Colors;
		
		Safe_Boolean			draw_To_Screen_Direct_Plausable;

		Rect					global_Device_Startup_Max_Rect;
		Safe_Boolean			global_Device_Startup_Max_Rect_Valid;
		Safe_Boolean			global_Device_Startup_Max_Rect_Contains_Menubar;
		
		Rect					window_Starting_Port_Rect_Position;

		
	/*=--------------------------------------------------------------------------=*/
	/* The following variables are NOT meant to be altered externally */
	/* They, sadly, are the overhead globals needed to give the status */
	/* dialog routines the extra speed possible using static globals */
	/*=--------------------------------------------------------------------------=*/
		
		Safe_Boolean			user_Aborted;
		Rect					drag_Rect;
		INTEGER_16			window_Handle_Index;
		
		WindowPtr			status_Window;
		
		GrafPtr				saved_Port_Before_Data_Copy;
		INTEGER_16			geneva_Bold_9_Height;
		INTEGER_16			geneva_Plain_9_Height;
		INTEGER_16			geneva_Plain_10_Height;
		FontInfo				geneva_Bold_9;
		FontInfo				geneva_Plain_9;
		FontInfo				geneva_Plain_10;
		Str255					scratch_String;
		
	} Primary_Status_Record, *Primary_Status_Ptr,**Primary_Status_Hdl;



/* [----END----] TYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] PROTOTYPE AREA */
#pragma mark PROTOTYPE_AREA

extern Safe_Boolean Run_Mac_Version_Of_Program(void);

extern Safe_Boolean Select_Graphics_Window(INTEGER_32 current_Window_Index);

extern void Show_About_Program_Dialog(void);

extern Safe_Boolean Change_Any_Window_Size_BASE(Change_Window_Size_Rec	*params_For_Change_Window_Size);

extern Safe_Boolean Initialize_Set_Spin_Window_Max_Monitor(void);

extern void Square_Desk_Top_Corners(GDHandle device);

extern void Restore_Desk_Top_Curved_Corners(GDHandle device);

extern Safe_Boolean Hide_Menu_Bar(void);

extern Safe_Boolean Restore_Menu_Bar(void);


/* [----END----] PROTOTYPE AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] EXTERN DECLARATION AREA */


extern Primary_Status_Hdl		active_Window_List[TOTAL_DEFINED_WINDOW_TYPE];


/* [----END----] EXTERN DECLARATION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
/* [---BEGIN---] LOCAL STATIC DEFINITION AREA */

/* [----END----] LOCAL STATIC DEFINITION AREA */
/*=**************************************************************************=*/


/*=**************************************************************************=*/
#endif
/*=**************************************************************************=*/
/* END OF FILE: Core_Specific.h */
